
AC MS     Auto Correlation - Masked and normalized           AC MS   
                                                            02/18/98

PURPOSE:  Calculates autocorrelation coefficients for circular     
          mask. Coefficients are normalized. Image is padded with 
          zeros. Works only for real images (not their Fourier
          transforms!).
          Command uses mix-radix FFT - the images need not have
          power-of-two dimensions.

SEE ALSO: AC    (auto correlation)
          AC N  (auto correlation - normalized)

USAGE:    AC MS

          .INPUT FILE: PIC001
          [Enter the name of the file to be autocorrelated.]

          .OUTPUT FILE: MAC001
          [Enter name of the file which will contain AC coeffs.]

          .MASK RADIUS: 25
          [Enter radius of the circular mask which will be centered at
          NSAM/2+1,NROW/2+1]

          .(F)ULL OR (H)ALF OUTPUT FILE: F
          [F results in a autocorrelation function file with dimensions
           2*NSAM,2*NROW (useful for mask radius =>MAX(NSAM/4,NROW/4).
           H results in a autocorrelation function file with dimensions
           NSAM,NROW (enough if one is interested only in lower order
           ACF coeffs. or mask radius is small)]

NOTES:  1.  See documentation on 'AC' for the location of the origin.

        2.  For non-masked autocorrelation function use AC.

        3.  Memory requirements: 2*(NSAM+2)*NROW

        4.  Implemented by Paul Penczek.

SUBROUTINES: MACF, MACF_P, FMRS_2, FMRS_1, FFTMCF, ACRS_2

CALLER:      CORR1
