
AD M      ADd images - using Multipliers                      AD M
                                                            9/02/96

PURPOSE:  Adds two or more images or volumes together.  Apply
          a multiplication factor to each file after first.

SEE ALSO: AD   (Add images - without multiplier)
          AS R (Average images - find & save variance, better)
          PA   (Add images - different sizes)

USAGE:    AD M

          .INPUT FILE: PIC001
          [Enter the name of the first file to be added.]

          .NEXT INPUT FILE: PIC002
          [Enter the name of the second file to be added.]

          .OUTPUT FILE: PIC999
          [Enter the name of output file.]

     A factor is solicited for every file following the initial 
     one (which has a factor of 1.):

          .ENTER FACTOR: 1.2
          [Enter multiplicative factor for the second file.]

     The system continues:

          .NEXT INPUT FILE: PIC004
          [Enter the name of the next file to be added.]

     'AD M' will continue in this manner until an asterisk
     ('*') is given as the name of the added file.

          

NOTES:    1. This routine only works for files with the same 
             dimensions.  To add pictures of different dimensions, 
             use PATCH (see 'PA').

          2.  For adding an entire file series, is is more practical
              to use operation 'AS' which will also produce a variance
              map.

SUBROUTINES: ADD

CALLER:      UTIL2
