
AS AD     Add to an existing average - find variance.            AS AD 
                                                                8/22/96

PURPOSE:  Adds 2 or more (up to 500) pictures together, computing
          several measures of variance (per point, total, etc.).
          The sum and the variance image are stored in separate
          output files. Images are to be added to the existing 
          average and variance file.  
          '<STRONG>' See warning in operation 'AS'  '</STRONG>'

SEE ALSO: AS     (Average images - find & save variance)
          AS DC  (Average images - find & save variance, doc. file)
          AS F   (Average images - find statistics & Q factor map)
          AS R   (Average images - find & save variance, better)      

USAGE:    AS AD X10
          [On input the register has to contain the value of the average 
           offset of existing average file. On output it is to receive 
           the value of the new average offset.]

           FOR IMAGES TO BE AVERAGED
          .ENTER 3 LETTER FILE PREFIX OR TEMPLATE (EG. PIC****): PIC
          [Enter prefix of images to be added.]

          .ENTER FILE NUMBERS: 1-10,12,15-17
          [Enter numbers of files within a series to be added.]

          .ALL, ODD-EVEN (A/O): O
          ['A' - all images will be added,
           'O' - two subaverages will be calculated: one for 
           odd-numbered images and one for even-numbered images. The 
           next two questions will appear twice.]

          .AVERAGE FILE: AVG001
          [Enter name of output file receiving average.]

          .ENTER NO. OF IMAGES ALREADY AVERAGED: 14
          [Enter number of files originally averaged. This number will
           be used as an offset in its computations.]

          .VARIANCE FILE: VAR001
          [Enter name of output file receiving variance map.]

          [Questions for average file, number of images already averaged and 
           variance file are repeated if option O-E was chosen.]


          The following values are then printed out:
          '<PRE>'
          Number of images
          Number of elements
          Total variance         Total std. deviation
          Variance per point     Std. deviation per point
          Average offset
          Variance of average image
          '</PRE>'

NOTES:    The average file will be normalized so that its mean pixel
          value (X5) is equal to 0.  To "restore" MIN and MAX values
          comparable to those of the input files, use 'AR'.  For
          example, if the average offset was 0.00131, you would have
          ((P1*0.00131)+0.), with P1 as the input average file.
          This is important if you intend to contour the average
          using 'FC', since negative values in the file will give a
          nonsense result.

          If you calculate an average in more than one step, each 
          average-offset is independent.  To get the correct average 
          offset of the complete image, the average of the subaverage
          average-offsets has to be used.

          If the old offset in register is not given, a warning is 
          printed and the operation is terminated.

SUBROUTINE: ADDS

CALLER:     UTIL2
