
CA SRP    Correspondence Analysis - PCA reconstitution      CA SRP
                                                           4/03/97
          
PURPOSE:  Reconstitute complete images using PCA reconstitution.

SEE ALSO: CA MAP (Correspondence Analysis - nonlinear mapping)
          CA S   (Correspondence Analysis - find solution)           
          CA SI  (Correspondence AnalysiS - initialize)
          CA SM  (Correspondence Analysis - factor map)
          CA SME (Correspondence Analysis - factor map and Eigen Values)
          CA SR  (Correspondence Analysis - full reconstitution of images)
          CA SRD (Correspondence AnalysiS - reconstitute differential images)
          CA SRI (Correspondence AnalysiS - reconstitute importance images)
          CA VIS (Correspondence Analysis - Create visual map)
    
USAGE:    CA SRP

          .ENTER FILE TEMPLATE (EG. PIC****): TST***
          [Enter the template for the file or file series to be
          created, doesn't have to be the same as original
          file series name.]

          .ENTER FILE NUMBERS (EG. 1-8,12-22,55): 1-80,90-95
          [Numbers are consecutive, and refer to the sequence of
          files specified in 'CA S'. ]

          .SUBTRACT AVERAGE IN PCA RECONSTRUCTION? (N/Y): N
          
          .COORDINATE FILE CODE: 2
          [Enter the number identifying the three sequential files
          used to store the output from the previous 'CA_S' run:
          IMC#, PIX#, EIG#.]

          .ENTER FACTORS TO BE USED: 2-4
          [Enter the factors to be used for image reconstitution.
          note that the numbers have to be less that the number of
          images and less or equal to the number used in 'CA S'.]
          
          [If there is no image with the above given number, then 
          coordinates are solicited for each of the factors specified]  

          .ENTER COORDINATES FOR EACH FACTOR SELECTED: 0.0013, -0.0011,
           0.0004

NOTES: The purpose of this command is threefold:

       1. To reconstitute approximation of original images using chosen 
          factors: use file numbers of the original images in 
          "ENTER FILE NUMBERS";

       2. To create eigenimages - images corresponding to chosen 
          eigenvectors: use file number (one) non-existing in the
          original image series in "ENTER FILE NUMBERS", answer Yes in
          "SUBTRACT AVERAGE IN PCA RECONSTRUCTION", use only one
          (chosen) factor number in "ENTER FACTORS TO BE USED", and
          unswer 1.0 in "ENTER COORDINATES FOR EACH FACTOR SELECTED"
          (or -1.0, since the sign of eigenvector is not determined by 
          the analysis); 

        3. To create non-existing images using chosen factors and 
           arbitrary coordinates: use file numbers non-existing in the
           original image series in "ENTER FILE NUMBERS",  answer No in
          "SUBTRACT AVERAGE IN PCA RECONSTRUCTION", enter (arbitrary)
           factor coordinates in "ENTER COORDINATES FOR EACH FACTOR SELECTED".
         
SUBROUTINES: JPMSK2,RECDUM,RECONS,SRIPE,MSKDEC

CALLER:      UTIL1
