
                                                           
CA VIS    Correspondence Analysis - Create VISual map         CA VIS
                                                             4/4/97

PURPOSE:  Creates a factor map that contains local averages. The 
          coordinates have to be in document files. (use 'SD C' to
          create a document file type copy of factor coordinates)
          (nonlinear mapping still needs document file output 
          option Feb. 91)

SEE ALSO: CA MAP (Correspondence Analysis - nonlinear mapping)
          CA S   (Correspondence Analysis - find solution)           
          CA SI  (Correspondence AnalysiS - initialize)
          CA SM  (Correspondence Analysis - factor map)
          CA SME (Correspondence Analysis - factor map and Eigen Values)
          CA SR  (Correspondence Analysis - full reconstitution of images)
          CA SRD (Correspondence AnalysiS - reconstitute differential images)
          CA SRI (Correspondence AnalysiS - reconstitute importance images)
          CA SRP (Correspondence Analysis - PCA reconstitution)
 
USAGE:    CA VIS

          . DEFAULT OUTPUT IMAGE SIZE 1024 BY 800
          .NEW IMAGE SIZE: X,Y (<RET>=DEF): 256,256
          [Enter the image size of the output map. A rule of thumb
          for the output image size is: (size of the single input
          image)*(number of divisions)+(space for margin between
          averages)]

          .INPUT DOCUMENT FILE: COORDINATE001
          [Enter name of ducument file that contains the image 
          coordinates]

          .OUTPUT DOCUMENT FILE: OUTDOC001
          [Enter name of output document file that will contain
          the list of how many and which image is contained in 
          which average]

          .INPUT FILE: IMA001
          [Enter name of one file out of the series that is to be
          used to calculate the averages. Make sure it exists on
          disk, because program looks up image dimensions in the
          file with the name given here.] 

          .NUMBER OF DIVISIONS IN X,Y: 10,8
          [enter number of fields into which the map is divided.
          averages are placed into these fields that are calculated
          from all images whose coordinates fall within the field 
          border. Note the the program is able to pad or window the
          averages if the size of each single field requires it.]

          .STANDARD DEVIATION (2.3=DEF): 2.0
          [enter standard variation of map (see also 'CA SM')]
 
          .UPPER/LOWER THRESHOLD IN UNITS OF SIGMA: 1.5,2.5
          [enter threshold level for averages in each quadrant. The
          greyvalues of the images in the above example are truncated
          at +1.5*sigma. (suggested
          values: negative stain: 2.5,2.5, vitreous water: 1,1 ] 

          .OUTPUT FILE: VISUALMAP001
          [Enter name of output file containing the map]
           
          .FIRST & LAST KEY=IMAGE NUMBERS: 1,2436
          [Enter first and last key in document file. Key and
          image number need to be the same.]

          .COLUMN #S IN DOC. FILE USED FOR X,Y COORD.: 2,3   
          [Selfexplanatory]

NOTE:     The program contains some inconveniences which still need to 
          be ironed out. M.R.

SUBROUTINES: VISMAP

CALLER:      UTIL1
                                                          
