
CG 3      Center of Gravity - radius of gyration            CG 3
                                                            12/27/93

PURPOSE:  Compute center of gravity and radius of gyration of a 3-D
          density distribution.


SEE ALSO:  CG     (center of gravity)
           CG 3S  (center of gravity - solid body)
           CG PH  (center of gravity - phase approximation)

USAGE:    CG 3 X10,X11,X12,X20

          .THREED FILE: 3DQ003
          [Enter name of file containing the 3-D density 
          distribution.]

          THRESHOLD: 0.53
          [Only data above the threshold will be used in 
          computation.]

NOTES:    The coordinates of the center of gravity, with respect to
          the center at (NSAM/2 + 1, NROW/2 + 1, NSLICE/2 +1), and
          the radius of gyration are printed out and put into the
          first four (optional) registers appearing on the command
          line.

          For the definition of the radius of gyration, see 
          International Tables of Crystallography, vol. III, p327.

SUBROUTINE: CENGR3

CALLER:     UTIL1
