
CG PH     Center of Gravity - PHase approximation           CG PH
                                                            12/27/93

PURPOSE:  Compute center of gravity using phase approximation.
          The command works for a 2-D or 3-D density distribution.

SEE ALSO:  CG    (center of gravity)
           CG 3  (center of gravity - radius of gyration)
           CG 3S (center of gravity - solid body)


USAGE:    CG PH,X10,X11,X21,X22                  2-D data
                -- or
          CG PH,X10,X11,X12,X21,X22,X23          3-D data

          .INPUT FILE: FIL001
          [Enter name of file containing the 2-D or 3-D density 
           distribution.]

NOTES:    Registers X10, X11 (and X12 in 3-D case) contain integer
          approximation of the center of gravity coordinates.
          Registers X21, X22 (and X23 in 3-D case) contain real
          number coordinates of the center of gravity.
          Coordinates are given in the x, y, z order.
          To place the center of gravity ar the origin one has to
          use 'SH' ('SH 3') command and reverse the signs of the shifts.

          Implemented by P. Penczek.

SUBROUTINES: CENT, CENT_3, CENT_D

CALLER:     UTIL1
