
CO        COntours into contour storage file                CO 
                                                        5/21/97

PURPOSE:  Reads SPIDER image file, extracts equi-intensity contours, 
          and transfers contours into a SPIDER contour metafile.

USAGE:    CO 

          .NEW CONTOUR FILE:  CNT000
          [Name for new contour metafile.]

          .ENTER MAX. NUMBER OF CONTOURS EXPECTED: 400
          [Sets aside storage for this number of contours.
           The actual number of contours which are plotted will
           depend on the answers to the next three questions.]

          .FILE PREFIX OR TEMPLATE (EG. PIC****): PIC001
          [Name of first image file which is to be contoured.]

          .ENTER FILE NUMBERS: 1
          [Numbers of file in this image file series to be 
           contoured. In this example it is a single file only.]

        Lists the maximum and minimum values in the first image.

          .STARTING AND ENDING CONTOUR LEVELS: 0.1  10.0
          [Contours are drawn between these values.]

          .CONTOUR LEVEL INCREMENT (USE INCR. > END FOR ONE LEVEL): 1000.0
          [Separation between contour levels.]

        If this is a multiple z-level file the user will be asked 
          the z coordinate for each contour.

          .ENTER Z COORDINATE: 0.1
          [The value for Z can be any size depending upon its meaning
           in your application.]

        As each contour is transferred to the plot file the contour
        level and the length of the contour are listed.

          .SHOW POSTSCRIPT MENU NOW: (Y/N): N
          [A 'Y' answer will immediately show the menu obtained
           with the 'CS DI PO' operation"]
        
NOTES:    1.  To display the plot use "CS DI" for desired device.

          2.  Contours will be thinned to < 600 points if possible.

          3.  Previously this operation was named 'CO CS'

SUBROUTINES: CNFILE, CNOPN, CSRDCT, CNINT3, CNTUR, CNSCAN, CNTRCE, 
             CNCALC, CSPUSH

CALLER:      PLOT1



