
CP        CoPy                                              CP
                                                            8/20/96

PURPOSE:  Copies one SPIDER file into another file.  If the output 
          file does not exist, it will be created.  Otherwise, it will
          be overwritten by the contents of the input file. The input  
          file or/and the output file can also be stack files(a set of 
          images with the same size). SPIDER will find out the file is
          a regular file or a stack file automaticly.

SEE ALSO: 
#include "cp_include.also"

USAGE:    CP

          .INPUT FILE: PIC001 or PIC001@003
          [Enter the name of the file to be copied. If the input 
           filename is PIC001, the whole file will be copied to 
           the new file no mater it is a regular SPIDER file or a
           stack file. If the input filename is PIC001@003, it means
           that PIC001 is a stack file and the third image in the 
           stack will be copied into a new file.]

          .OUTPUT FILE: COP001 or COP001@003
          [Enter the file that will contain the copy.
           If the filename is COP001@003, SPIDER will copy the input
           file into the stack file with name COP001 at the third 
           position. If the stack file COP001 doesn't exist, SPIDER 
           will creat a new stack file with a stack file header and 
           the input image at the 3rd position. The black images will
           be filled in front of this image(001 and 002).]

SUBROUTINES: COPYD, OPENFB, OPENFIL

CALLER:     COPY1

