
CP FROM ASCII   CoPy ASCII text file to SPIDER format     CP FROM ASCII
                                                                10/8/96

PURPOSE:  Copies an ASCII text file into an SPIDER image file.
          Free-format input is used so that any standard number 
          representation is acceptable for the image values.  

SEE ALSO: 
#include "cp_include.also"

USAGE:    CP FROM ASCII

          .EDITABLE IMAGE INPUT FILE:  PIC001
          [Enter name of text file to be copied.]

          .ARE NSAM, NROW AND NSLICE IN FIRST LINE OF FILE? N
          [If answer is "Y", then the first line of the file must 
          contain NSAM, NROW and NSLICE.  Otherwise, the following 
          two questions will appear:

          .ENTER NSAM & NROW: 32

          .ENTER NSLICE: 1

          .OUTPUT FILE:  PIC002
          [Enter name of SPIDER output file.]

NOTE:     The image lines in the input file contain the image values 
          separated by blanks or commas.  
          Free-format input is used so that any normal number 
          representation is acceptable for the image values, e.g.  '<BR>'
          3  5.1  -6.889  -1.089E-01

SUBROUTINE: COPYF

CALLER:  COPY1

