
CP FROM RAW    CoPy RAW Image to SPIDER                   CP FROM RAW
                                                          7/17/96

PURPOSE:  Copies raw 8 or 16 bit integer, or 32 bit floating point
          input image to SPIDER file. You must know the size of the 
          input image.  Can skip a header.

SEE ALSO: 
#include "cp_include.also"

USAGE:    CP FROM RAW

          .ENTER BITS / PIXEL IN INPUT IMAGE (8, 16 OR 32): 16
          [Enter bits used for each pixel in input file.  The
           32 bit input is assumed to be floating point!]
 
          .EXISTING RAW FILE: INP000
          [Enter name of input file.]
      
          .ENTER COLUMNS, ROWS & SLICES:      64 64 64
          [Enter columns, rows, and slices in input file.]

          .ENTER HEADER BYTES TO BE SKIPPED:      512
          [Enter bytes in input file header that should be 
           skipped.]
       
       If the input file has 16 bits / pixel the following
       two questions will appear.  If you are unsure of the
       correct answers try all four possible combinations
       and examine the output images to see which one is
       correct:

          .ENTER MOST SIGNIFICANT BYTE (1 OR 2):    1 
          [Different computers have different byte ordering. For
           SGI files this is usually 1.]

          .FOLD NEGATIVES? (N/Y): N
          [Can compensate for data stored as 2's complement integers.
           Some data saved as unsigned integers may need this.]
 
          .NEW SPIDER IMAGE FILE:  PIC002
          [Enter name for output file.]

SUBROUTINES: RAWTOSPIDER

CALLER:     COPY1

