
CP TO VV  CoPy SPIDER volume to Voxel View format         CP TO VV
                                                            1/9/94

PURPOSE:  Copies a Unix SPIDER 3-D data file to a series
          of Voxel-View format files in specified directory.
          Files normalized over range 0...255 with thresholding
          as specified.  

SEE ALSO: 
#include "cp_include.also"

USAGE:    CP TO VV

          .ENTER UNIX SPIDER INPUT FILE: UNX001
          [Enter the name of 3-D source file to be converted.]

          .ENTER THRESHOLD MIN AND MAX <CR> KEEPS FILE VALUES:: 
          [Enter lower and upper threshold values.  Any value
           outside this range will be given the corresponding
           threshold value.]

          .ENTER OUTPUT DIRECTORY: junk
          [Enter name for Voxel-View directory.  If the directory
           does not exist it will be created.]

NOTES:    1.  Also creates the required _dimensions file.

          2.  Implemented by: A. Leith
        
          3.  This command is for Unix SPIDER only!

SUBROUTINES: COPYU, UNIXTOVV

CALLER:     COPY1

