
CS MV     Contour Storage - MoVie.BYU interface               CS MV
                                                            12/29/93

PURPOSE:  Transfers contours from a contour storage file
          to a file formatted for input into MOVIE.BYU
          MOSAIC subroutine.  Using MOSAIC these contours can
          then be tiled to form a solid model.  If desired the
          contours can be mirrored about the X axis to flip the
          top and bottom of the plot.

SEE ALSO:  CS TH     (Contour storage - thinning)

USAGE:    CS MV

          .CONTOUR FILE: CNT001
          [Enter the name of the contour metafile for input.]

          .ENTER MOVIE FILE NAME: MOV001
          [Enter the name for the MOVIE.BYU output file.]
           
          .DO YOU WANT TO OK EACH CONTOUR TRANSFER: (Y/N): Y
          [Yes allows one to reject any contour.  Answer "Y" 
          if some contours are delimiters of holes.  A lower 
          case answer mirrors contours about Y=0 axis.  IF "Y" then 
          next question appears.]

          .DO YOU WANT TO VIEW EACH CONTOUR? (Y/N): Y
          [Yes will plot each contour on a DEC graphics 
          terminal.  A lower case answer inverts z stack.]

          .INVERT CLOCKWISE DIRECTION? (Y/N): Y
          [Yes will invert handed-ness of each contour.]

    If user has requested to OK each transfer, the
    following question appears for each contour:

          .TRANSFER CONTOUR, HOLE OR ABORT? (C/H/A): C
          [Option:  Hole will invert clockwise direction of 
          this contour.  Option: Abort will stop this 
          transfer.]

SUBROUTINES: CNMOV

CALLER:      PLOT1

