
CV REPL   projection onto ConVex sets - projector Replace     CV REPL
                                                             7/25/97

PURPOSE:  REPLACE projector for the procedure of projections onto
          convex sets. Replaces the Fourier transform in the first
          3D input file by the Fourier transform provided in a second
          input file. The replacement is done excluding a "missing
          wedge" or a "missing cone". The 3D Fourier transforms must
          now be in standard SPIDER Format.

USAGE:    CV REPL

          .WORK FILE: VOLUME001
          [Enter the name of the file to be restored.  This file will
          be overwritten.  File must be in simple format.] 

          .DATA FILE: MEASUREDVOLUME001
          [Enter the name of the file containing the Fourier transform
          of the unadulterated measured data volume.]

          .(S)INGLE AXIS OF (C)ONICAL TILTING: C OR S
          [Enter C if you have a missing cone and S if you have a
          missing wedge.]

       If you specify C: 
     
          .TILT ANGLE: 60
          [Enter fixed tilt angle of conical tilt series.]

       If you specify S:
     
          .LOWER,UPPER TILT ANGLE: -50,+60
          [Enter range of single axis tilt series]

NOTES:       1. Author: M. Radermacher

SUBROUTINES: MRREPLACE

CALLER:      UTIL1
