
DR        Density Reference                                 DR      
                                                            7/1/85

PURPOSE:  Include density reference pixels in 3-D density distribution 
          to assure equal scaling of all slices.

SEE ALSO: DR ERR   (Error Calculation between two volumes
          DR DIFF  (Error and difference calculation between two volumes)
  
USAGE:    DR

          .THREED FILE: 3DR004
          [Enter name of 3-D file to be modified.]

          [Pixels along vertices of the volume (e.g. X=1,Z=1) are
          replaced by the minimum (FMIN) or the maximum (FMAX) of
          the total volume.  Thus, a slice in any direction created
          by 'PS' will contain pixels along the edges with the values 
          FMAX and FMIN relating to the original 3-D distribution.]

NOTES:    The action of 'DR' is irreversible; values in points  
          replaced by FMAX, FMIN are lost.

SUBROUTINE: DENREF

CALLER:     VTIL2
