
EC FILTER  Extract Connected CLusters - FILTER        EC FILTER
							9/11/97

PURPOSE:  Reads a SPIDER document file containing cluster number 
          (index) and number of voxels (1) in the cluster. 
          If the number of voxels < solicited minimum number or > 
          solicited maximum number, then the voxels belonging to 
          this cluster are set to value zero.

SEE ALSO: EC SELECT (Extract connected clusters - selection)
	  EC CLOSE  (Extract connected clusters - merge close)
	  EC CL     (Extract connected clusters)
	  EC STAT   (Extract connected clusters - statistics)
	  
USAGE:    EC FILTER

          .CLUSTER DOC FILE: DOC001
          [Name of document file.  This document file may be
           edited output from the "EC STAT" operation.]
       
          .CLUSTER INPUT FILE:  VVV001
          [Name of input file.] 

          .CLUSTER OUTPUT FILE: VVV002
          [Name of output file.] 
   
          .RANGE OF CLUSTER SIZES RETAINED: -1,30
          [Voxels in clusters having number of voxels outside this
           range will be set to background.]

NOTES:    Document file have number of cluster + 1 as key.  The
          first register should contain number of voxels in the 
          cluster. (The cluster number is incremented by one
          because zero key is not allowed and it is usefull to
          have a measure of the background which has value zero
          in the file).
  

SUBROUTINES:   MAPFILT, MAPIM

CALLER: UTIL6

  
	 
