
EC STAT   Extract Connected CLusters - STATistics          EC STAT
							  9/07/95

PURPOSE:  Finds number of occurances of each integral intensity in a 
          SPIDER 3D file as well as center mass of each intensity value. 
          Creates a SPIDER document file for statistics output 
          containing intensity value; number of voxels with this
          intensity;  

          This operation is normally used on the output volume from 
          the 'EC' operation.   It is meaningless with volumes having
          negative or non-integral voxel values.

SEE ALSO: EC SELECT (Extract connected clusters - selection)
	  EC CLOSE  (Extract connected clusters - merge close)
	  EC FILTER (Extract connected clusters - filter)
	  EC CL     (Extract connected clusters)

USAGE:    EC STAT

          .CLUSTER INPUT FILE: VVV001
          [Name of an existing cluster volume.  This is the normally
           a file created by 'EC CL'].

          .DOCUMENT FILE: DOC001
          [Name of output document file.]
	  
NOTES:    In the document file the key is the  voxel value + 1.  This 
          is followed by then number of voxels having that value; 
          X,Y & Z center of mass for that voxel value; and number of 
          slices which contain that voxel value. 	
          (The cluster number is incremented by one because zero index
          is not allowed and it is usefull to have a measure of the 
          background which has value zero in the file.)

SUBROUTINES: IMSTAT, MAPSTAT

CALLER:      UTIL6
