
FF B      Fourier Filter - Bar, ky direction                  FF B
                                                            1/6/94

PURPOSE:  Removes coefficients along the ky-direction of the
          Fourier transform.

SEE ALSO: FF       (Fourier filter)
          FF BX    (Fourier filter - Bar, kx direction)
          FF S     (Fourier filter - restore surface topography)

USAGE:    FF B -or- FF BY

          .INPUT FILE: FOU001
          [Enter name of input file containing Fourier transform.
          Note that this file will be overwritten by the filtered
          file.]

          .WIDTH OF BAR (KY-BAR,KX-BAR): 3,4
          [Enter width, in Fourier units, of the strip centered on the
          ky-axis that is to be removed from the Fourier transform.]   

NOTE:     'FF B' was developed for the specific purpose of simulating
          dark field imaging (project C. Mannella).

SUBROUTINE: FILTB

CALLER:     FOUR1
