
FF BX     Fourier Filter - Bar, kx direction                  FF BX 
                                                            1/10/94

PURPOSE:  Removes coefficients along the kx-direction of the
          Fourier transform.

SEE ALSO: FF    (Fourier filter)
          FF B  (Fourier filter - bar, ky direction)

USAGE:    FF BX

          .INPUT FILE: FOU001
          [Enter name of input file containing Fourier transform.
          Note that this file will be overwritten by the filtered
          file.]

          .WIDTH OF BAR (KY-BAR,KX-BAR): 3,4
          [Enter width, in Fourier units, of the strip centered on the
          ky-axis that is to be removed from the Fourier transform.]   

NOTE:     Operation 'FF BX' was developed to remove residual noise in the 
          EIKONIX scan data due to insufficient normalization of the
          diode array.

SUBROUTINE: FILTB

CALLER:     FOUR1
