
FS M      Find Statistics - within Mask                       FS M    
                                                            1/10/94

PURPOSE:  To compute and print out the values of the statistical
          parameters of an image within an area defined by a mask.

SEE ALSO:  FS  (Find statistics - whole image)

USAGE:    FS M,XM,XN,XO,XP
          [XM, XN, XO, and XP are optional register parameters, such
          that 10 <= M,N,O,P <= 99.  On completion of the operation,
          XM contains the picture minimum, XN its maximum, XO its
          average, and XP its standard deviation. If register are not
          provided the values are placed in the following registers:
          X3, X4, X5, X6.]

          .INPUT FILE: PIC001
          [Enter name of file to be analyzed.]

          .MASK FILE: MSK003
          [Enter name of file containing mask.]

NOTES:    The values of maximum and minimum density, average, and
          standard deviation are computed for those pixels only
          where the mask has values larger than 0.5.
          Picture can be 2D as well as 3D.
          Mask file has to have exactly the same dimensions as
          input file.

SUBROUTINE: NORMM

CALLER:     UTIL1
