
HI M      HIstogram - masked area                               HI M    
                                                            5/1/96

PURPOSE:  Computes a 128 level histogram of the area of an image which
          has a value >= 0.5  in a second mask image.  Prints 
          histogram in document file, results file, or on the
          terminal.

SEE ALSO: HI    (histogram - output in results file)
          HI T  (histogram - output on terminal)
          HI D  (histogram - output in document file)

USAGE:    HI M

          .INPUT FILE: PIC001
          [Enter the name of the file containing the image.]

          .MASK FILE: MASK01
          [Enter the name of the file containing the mask.]

          .OUTPUT TO RESULTS FILE, DOC. FILE, OR TERMINAL? (R/D/T): T
          [Output location.]

       If ouput is sent to a document file SPIDER asks:
          .DOCUMENT FILE: DOC000
          [Enter the name for the document file that gets the
           histogram output.]

NOTES:    1. A 128 level histogram will be computed.  
          The following information will be printed out at the 
          user's terminal:

          '<PRE>'
          TOTAL PIXELS:        INSIDE MASK:     
          FILE RANGE:          .........    
          HISTOGRAM RANGE:     .........    
          HISTOGRAM MEAN:      MODE:        
          S.D.:                BIN SIZE:    
          '</PRE>'

          2. The histogram is not placed in the image's histogram
          records.

SUBROUTINE: HISTM

CALLER:     UTIL1
