
LD T      List Document file - on Terminal                     LD T
                                                            1/13/97

PURPOSE:  Lists elements of document file on terminal.

SEE ALSO: LD (list document file - in results file)

USAGE:    LD T 'MIN','AVG'

          [For each heading given after the "LD T" command, one column 
          from the doc. file is listed in chart form, aligned below
          the heading.  The headings may be up to 8 letters in length.
          The keys are arranged in ascending order.]

          .DOCUMENT FILE: DOC001
          [Enter name of document file.]

          [For example, if DOC001 looks like]:
          '<PRE>'
              1  16.41    8.32    12.43
              2   6.21    1.17     4.36
              1   8.25    3.08
          '</PRE>'
          [The following chart wii be printed on the terminal screen]:
          '<PRE>'
              KEY     MIN     AVG
                1    8.25    3.08
                2    6.21    1.17
          '</PRE>'

NOTE:     1. Do not use "X" in any of your headings. SPIDER will try to
          interpret the "X" as a register!  
          2. This routine lists only as 
          many columns of the document file as there are headings.

SUBROUTINES: LISTDC

CALLER:      DRIV3

