
LI RD     LIst Registers - in Document file                  LI RD
                                                           1/15/97

PURPOSE:  To list the contents of the SPIDER registers in a document
          file. 

SEE ALSO: LI RT         (List registers - on terminal)
          LI R          (List registers - in results file)
          LI X11,x12..  (List specified SPIDER registers)
         
USAGE:    LI RD                                                     

          .OUTPUT DOC FILE: DOC000
          [Enter name for output document file.]         

          [Registers are listed from X0 to X102. The system         
          registers X0 ... X9 are separately listed. Their meaning  
          is:
                                   
          '<PRE>'
          X0    DO-Loop index of the current loop                   
          X1    NSAM = number of samples of the last image accessed                                         
          X2    NROW = number of rows of that image                  
          X3    FMAX = its maximum pixel value                       
          X4    FMIN = its minimum pixel value                       
          X5    AV   = its average value                             
          X6    SIG  = its standard deviation                        
          X9    ERRFL = error flag                                   
          '</PRE>'

NOTES: 1. This operation is useful for debugging SPIDER procedures  
          as it allows the transfer of registers to be monitored.   

SUBROUTINES: LISTREGS

CALLER:      UTIL1

