
LI T       List image values - on terminal                   LI T
                                                           1/15/97

PURPOSE:   Lists specified elements of a given file at user's terminal.

SEE ALSO:  LI T   (List image values - on terminal)
           LI D   (List image values - in doc file)
           LI R   (List SPIDER registers)
           LI X11,X12..  (List specified SPIDER registers)

USAGE:    LI T

          .INPUT FILE: PIC001
          [Enter name of file.]

          .HEADER, PIXEL, ROW, COLUMN, IMAGE, OR WINDOW (H/P/R/C/I/W) W
          [Enter 'H' for image header, 'P' for listing a pixel,
          'R' for listing row(s), 'C' for listing column(s), 
          'I' for listing a whole image, or 'W' for listing window 
          from an image]

       If "H" is chosen, SPIDER will ask:
          .ENTER HEADER POSITION(S): 1,2,3

       If "P" is chosen, SPIDER will ask:
          .ENTER COLUMN & ROW: 34 56

       If "R" is chosen, SPIDER will ask:
          .ENTER ROW(S): 1-4

       If "C" is chosen, SPIDER will ask:
          .ENTER COLUMN(S): 1-4

       If "I" is chosen and the input file is a volume, SPIDER will ask:
          .ENTER SLICE(S): 55

       If "W" is chosen, SPIDER will ask:
          .ENTER COLUMN(S): 20-30
          .ENTER ROW(S):    20-30

       If "H" is not chosen, SPIDER will ask:
          .FLOATING POINT OR INTEGER FORMAT OUTPUT (F/I): F 
          ['I' for integer format is usually only useful for images
          which have integral values. The integer format is I8.]

       If "H" is not chosen, and the input file contained 2-D Fourier 
       data, SPIDER will ask:

          .PHASE / MOD LISTING(Y/N)?: N
          [Enter 'N' for straight listing, 'Y' for phase/modulus
          listing.]

       If "H" is not chosen, and the input file contained 3-D Fourier 
       data, SPIDER will ask:

          .PICK INDIVIDUAL COEFFICIENTS? (Y/N)',NULL,IRTFLG)

       If the answer to this question is 'Y' , SPIDER will ask:
          .KX, KY: 15 15
          .KZ: 15

       If the answer to this question is 'N' , SPIDER will ask:
          .PHASE / MOD LISTING(Y/N)?: N
          [Enter 'N' for straight listing, 'Y' for phase/modulus
          listing.]

          [The corresponding rows of PIC001 will then be listed,
          putting the information in the RESULTS file.  In the case
          of Fourier data, listed values are alternately real and
          imaginary parts of Fourier coefficients unless the phase/
          mod option is chosen, in which case listed values are
          alternately phases and moduli of the coefficients.]

NOTES: 1. Hyphens can be used to specify the row numbers.

SUBROUTINES: LISTIT

CALLER:      UTIL1

