
ME        MEnu                                                     ME
                                                             02/19/98

PURPOSE:  Prints out the mnemonic for each operation.
          A listing  of about 15 operations will be displayed at the 
          terminal at one time. Type <Return> to continue listing or '*'
          to return to ".OPERATION". 

USAGE:    ME
          '<PRE>'
                                                                 
 Operation      Description                                         
 
 AC             Auto-Correlation (mp)
 AC MS          Auto-Correlation, Masked and normalized (mp)
 AC N           Auto-Correlation - Normalized (mp)
 AD             ADd images
 AD M           ADd images using Multipliers
 AP CA          Alignment Program - Classification and Alignment
 AP MD          Alignment Program - 3D projection alignment. (mp)
 AP MQ          Alignment Program - 3D projection/Multi-reference alignment.
 AP MR          Alignment Program - Multi-reference alignment
 AP RA          Alignment Program - Rotational Alignment (mp)
 AP SA          Alignment Program - Shift Alignment (mp)
 AP SR          Alignment Program - Shift and Rotational alignment (mp)
 AR             ARithmetic operation
 AS             Average images, find & save variance
 AS AD          Add to an existing average, find variance.
 AS DC          Average images, find & save variance, from doc. file
 AS F           Average images, find statistics & Q factor map
 AS R           Average images, find & save variance, better
 AT IT          Automatic particle picking, intermediate program.
 AT PK          Automatic particle picking, peak search
 AT SA          Automatic particle picking, statistical parameters.
 AT WN          Automatic particle picking, Windowing.
 
 BC             Box Convolution
 BL             BLank
 BP 3           iterative (ART) Back Projection--3D
 BP 3D          Back-Projection - 3D using three Eulerian angles (mp)
 BP 3E          Calculate Back Projection using 3 Euler angles
 BP CTF         3D Reconstruction with CTF correction ||
 BP GW          Weighting of projections for weighted Back Projection
 BP GW3         Weighting of projections for weighted Back Projection
 BP MEM2        2D Maximum Entropy Method Reconstruction
 BP R2          R**2 weighting of the series of 2D images
 BP RP          3D Iterative Reconstruction With Constraints ||
 BP S2          2D Single-tilt Iterative Reconstruction With Constraints
 BP W2          2D Filtered Weighted Back Projection
 BP WX          Weighted Back Projection
 BP WY          Weighted Back Projection
 BP XY          Simple Back Projection for single axis & conical tilting.
 
 CA MAP         Correspondence Analysis--nonlinear MAPping
 CA S           Correspondence Analysis--find Solution
 CA SI          Correspondence AnalysiS -- Initialize
 CA SM          Correspondence Analysis, Factor Map
 CA SME         Correspondence Analysis, Factor Map and Eigen Values
 CA SR          Correspondence Analysis -- full Reconstitution of images
 CA SRD         Correspondence AnalysiS -- Reconstitute Differential images
 CA SRI         Correspondence AnalysiS -- Reconstitute Importance images
 CA SRP         Correspondence Analysis PCA reconstitution
 CA VIS         Correspondence Analysis, Create VISual map
 CC             Cross-Correlation (mp)
 CC C           Correlation Coefficient and Euclidean distance
 CC N           Cross-Correlation, Normalized
 CE             Contrast Enhancement
 CE FIT         Contrast Enhancement, FIT the histogram
 CE GNC         Contrast Enhancement using Graduated Non-Convex
 CE MED         Contrast Enhancement using Median Filtering
 CE OD          Contrast Enhancement, adjust Optical Densities
 CF             Construct Fourier
 CF 3           Construct 3-D Fourier
 CG             Center of Gravity
 CG 3           Center of Gravity / radius of gyration
 CG 3S          Center of Gravity/Solid body option
 CG PH          Center of Gravity / PHase approximation (mp)
 CI             Confidence Interval
 CL CLA         Correspondence Analysis -- CLAssification
 CL HC          CLassification -- Hierarchical Clustering
 CL HD          CLassification -- Hierarchical clustering, calculate classes
 CL HE          CLassification -- Hierarchical clustering, create docfiles
 CL KM          CLassification -- K-Means clustering
 CN             CoNvolution (mp)
 CN N           CoNvolution - Normalized (mp)
 CO             COntours into contour storage file
 CP             CoPy
 CP FROM ASCII  CoPy FROM ASCII text file to SPIDER File
 CP FROM MRC    CoPy MRC format File to SPIDER File
 CP FROM PDB    Copy a PDB file to SPIDER format
 CP FROM PE     Copies Perkin Elmer disk file to SPIDER
 CP FROM RAW    CoPy RAW Image to SPIDER
 CP FROM SF3    Copies a 3D simple Fourier file to SPIDER format
 CP FROM SHORT  CoPy SHort header file to SPIDER file
 CP FROM TERM   CoPy terminal input to SPIDER file
 CP FROM TR     Copy old TR file to SPIDER format
 CP FROM VAX    CoPy VAX SPIDER file to a Unix SPIDER file
 CP TO ASCII    CoPy into Editable file
 CP TO BRIX     CoPy SPIDER volume to BRIX file for O input
 CP TO MRC      CoPy SPIDER file TO MRC format file
 CP TO POST     CoPy SPIDER file to a POSTscript file
 CP TO RAW      CoPy SPIDER file to a 8-bit raw image
 CP TO SF3      Copies a 3D SPIDER Fourier file to simple format
 CP TO SGI      CoPy a SPIDER file to SGI format
 CP TO TARGA    CoPy a Spider file to Targa format
 CP TO TIFF     CoPy to a TIFF file
 CP TO VAX      CoPy a Unix file to Vax SPIDER
 CP TO VV       CoPy 3D file to Voxel-View format
 CS DI GD       Plot Contour Storage File on Gould Plotter
 CS DI PL       Convert Contour Storage Metafile to HPGL
 CS DI PO       Converts Contour Storage File to Postsript
 CS DI TX       Plots Contour Storage File on Tektronix Plotter
 CS DI VT       Display Contour Storage File on VT125/240
 CS MV          Contour Storage MoVie.BYU interface
 CS MVVT        Contour Storage MoVie.BYU interface
 CS TH          Contour Storage THinning
 CV REPL        projection onto ConVex sets, projector Replace
 
 DE             DElete
 DE A           DElete
 DF             Density Foldover
 DO             start of DO loop
 DR             Density Reference
 DR DIFF        Difference and error calculation between two volumes
 DR ERR         Error Calculation Between Two 3D Volumes
 DU             DUst
 DU V           DUst with Value
 
 EC CL          Extract Connected CLusters
 EC CLOSE       Extract Cluster -- merge CLOSE
 EC FILTER      Extract Clusters - FILTER
 EC SELECT      Extract Clusters - SELECTion
 EC STAT        Extract Cluster - STATistics
 ED             Edge Detection
 EF             Extract Fourier
 EN             ENd
 EN D           ENd and Delete RESULTS file
 EP             Error Probability
 EP TT          T-test
 
 FC             File Contouring
 FC E           File Contour--External contour levels
 FD             Filter according to a Document file
 FF             Fourier Filter (mp)
 FF B           Fourier Filter/Bar (ky direction)
 FF BX          Fourier filter (kx direction)
 FF PLOT        Design of Filter
 FF S           Fourier Filter--restore Surface topography
 FI             File Information
 FI A           File Information (Multiple files)
 FI N           File Information - No stop if file not found
 FI X23,X24     place FIle header values in specified registers
 FP             Fourier interPolation (mp)
 FQ             Filter Quick (mp)
 FQ NP          Filter Quick, No Padding (mp)
 FR             File Read
 FS             Find Statistics
 FS M           Find Statistics within Mask
 FT             Fourier Transform (mp)
 
 GF             General Filter for quasi-optical Fourier Filtration
 GF C           General Filter (Condensed Fourier)
 GOTO           unconditional jumping command
 GR             GRaph
 GR T           GRaph, plot file on Terminal
 
 HF             Helical Fourier
 HI             HIstogram
 HI D           HIstogram--output in Document file
 HI M           HIstogram masked area
 HI T           HIstogram--display on Terminal
 
 IF             conditional jump in batch mode
 IN             INsert
 IN S           INsert and contrast Stretch
 IP             InterPolate
 IP T           Triangular InterPolation
 
 LB#            end of DO-loop
 LD             List Document file
 LD T           List Document file - on Terminal
 LI             LIst image values - in results file
 LI D           List image values - in doc. file
 LI R           LIst Registers -- in results file
 LI RD          LIst Registers - in Document file
 LI RT          List Registers - on Terminal
 LI T           List image values - on terminal
 LI X11,X12..   List pixel values in registers
 
 MA             MAsk using circular radii
 MA L           Mask a line
 MA X           1-D MAsking in sample direction
 MA Y           1-D MAsking in row direction
 MD             MoDe
 ME             MEnu
 MK             MarKer
 MK 3           MarKer 3D
 MM             Mask Multiplication
 MM C           Mask Multiply--Continuous
 MN             MoNtage
 MN S           MoNtage with individual Scaling
 MO             MOdel
 MO 3           3-D MOdel creation
 MR             MiRror
 MS             Make Stack
 MU             MUltiply real or complex files
 MU D           Divide real or complex files
 MU M           Multiply 1st complex file by 2nd conjugated file
 MU O           MUltiply with arithmetic Or
 
 NC             New Code
 NK             shriNK
 NK M           shriNK to Mask
 
 OR 2           Orientation search for rotation angles in 2D. (mp)
 OR 2M          Orientation search - 2D, multiple peaks. (mp)
 OR 3A          ORientation Search in 3D (Eulerian Angles), arbitrary center
 OR 3Q          ORientation Search in 3D (Eulerian Angles) (mp)
 
 PA             PAtch
 PD             PaD
 PF             ProFile image
 PJ 3           ProJect 3D volume
 PJ 3E          ProJect 3D volume using Eulerian angles, fast
 PJ 3Q          ProJect 3D volume using Eulerian angles
 PJ 3T          ProJect 3D volume using internal Threshold
 PJ COL         COLour surface representation
 PJ CYL         ProJect onto CYLinder
 PJ INTER       ProJect -- INTERlace two surface representations
 PJ SHAD        ProJect -- cosine SHADing of surface representation
 PJ ST          ProJect -- Surface represenTation
 PK             PeaK search
 PK 3           PeaK search in 3D
 PK 3D          PeaK search in 3d. stores output in Document file
 PK C           PeaK search--Center of gravity
 PK D           PeaK search using Document file
 PK DC          PeaK search + Center of gravity + Document file
 PL             Plot doc. file data into CNT meta-file
 PL FIT         FIT PoLynomial to document file data
 PL HI          PLot HIstogram from document file
 PP L           Put Points in image from doc. file Listing
 PP LL          Put Lines in image from doc file
 PP P           Put Points in image from doc file -- alters neighbors
 PP V           Put height image into Volume
 PR             overPRint image to results file
 PR P           overPRint Power spectrum to results file
 PR T           overPRint image to Terminal
 PS             Pick Slice -- xz planes
 PS A           Pick Slice -- Arbitrary direction
 PS X           Pick Slice X -- yz planes
 PS Z           Pick Slice -- xy planes
 PT             create PaTtern or Mask file
 PW             PoWer spectrum
 PW L           PoWer spectrum Log10
 
 RA             RAmp
 RC             Real Convolution
 RD             ReDuce transform
 RD D           Reduce transform -- use reflection files
 RD L           ReDuce transform - List only
 RE             REturn
 RF             R-Factor
 RF 3           Phase Residual & Fourier Shell correlation in 3D (mp)
 RF SN          Spectral SNR of Images
 RM             Radon transforM suite of programs.
 RO             ROtational average (single line output)
 RO I           ROtational average 2-D Image output
 RR             Read Register
 RT             RoTate, use average as background
 RT 3           RoTate a volume, slow
 RT 3A          RoTate a volume around an arbitrary center
 RT 3D          RoTate a volume, fast
 RT 90          RoTate volume by 90, 180, or 270 degrees
 RT B           RoTate, supply Background
 RT C           Rotate, center selected by user (for small files)
 RT M           Rotate, use minimum as background
 RT SQ          RoTate and Shift (use Quadratic interpolation)
 
 SA             Sum Alignment
 SA P           Sum Alignment, Positive rotation and shift
 SD             Save Document
 SD C           Save Document from Cluster file
 SD E           Save Document -- End
 SD NLM         Save Document from NonLinear Mapping
 SD S           Sort Document file according to one column
 SD SHUFFLE     Shuffle Document file
 SE             SEed fill an image
 SH             SHift -- using bilinear interpolation
 SH F           SHift -- using Fourier interpolation (mp)
 SK             StacK
 SK R           StacK--Replace
 SL             SLice image series
 SP             find the intensity of a SPot
 SQ             SQuare
 SR             Save/unsave Registers
 ST             SeT
 SU             SUbtract
 SZ             SqueeZes (Shears) an Image
 
 TF             Transfer Function (defocus-dependent)
 TF C           Transfer Function -- Complex
 TF C3          Transfer Function -- Complex 3D
 TF CT          Transfer Function for phase flipping -- Complex, Ternary
 TF CT3         Transfer Function -- Complex, Ternary 3D
 TF CTF         Transfer Function -- CTF correction
 TF D           Transfer Function -- Display
 TF DDF         Determine DeFocus and amplitude contrast
 TF DEV         Transfer Function -- Determine EnVelope function
 TF DNS         Transfer Function -- determine and Delete NoiSe background
 TF FL          Flip the sign of Fourier transform according to CTF
 TF MFL         Transfer Function -- Make FiLter file for TF FL
 TH             THreshold
 TH C           THreshold--Change a value
 TH F           THreshold--Fixup constant
 TH M           THreshold and create Mask
 TM             TiMe
 TP             Three-dimensional Plot
 TT             TiTle
 
 UD             Unsave Document
 UD E           Unsave Document -- End
 UD IC          Unsave Document In-Core
 UD ICE         Unsave Document In-Core -- End
 UD N           Unsave Document key numbers
 UD S           Unsave Document--Sequential search
 
 VM             VMS spawn or Unix system call
 VO EA          Vector Operation -- Even Angles docfile
 VO MD          Vector Operation -- angular docfile from AP MD output
 VO RA          Vector Operation -- Rotate Angular document file
 
 WI             WIndow
 WI B           WIndow using specified background
 WT             Lattice indexing
 WT TV          Lattice Indexing
 WU             square root (WUrzel)
 WV             Window aVeraging
 WV P           Window aVeraging over Patches
 WV S           Window aVeraging -- Sequential document search
          '</PRE>'

NOTES: 1. Operations marked by '(mp)' use parallel code on multiprocessor
          SGI computers.
 
       2. '<STRONG>'For a more up-to-date listing use your WWW viewer on the
          HTML documentation.'</STRONG>'.
 
SUBROUTINE: NUMENU

CALLER:     DRIV1
