
MM C      Mask Multiplication - Continuous                    MM C    
                                                            4/19/97

PURPOSE:  Apply mask with soft edges to images or volumes according 
          to a reference file.

SEE ALSO: MA   (mask)
          MM   (mask multiplication)

USAGE:    MM C

          .MASK REFERENCE FILE: MAS002
          [Enter mask reference file containing values between 0.0
           and 1.0 (inclusive)]

          .IMAGE (OVERWITTEN!) FILE: PIC001
          [Enter name of image/volume file to be masked.]

NOTES: 1. The image/volume will be overwritten by the masked one.

       2. Effects of the mask:  Values in the file are
          A.  Unchanged wherever the mask file has the value 1.0 '<BR>'
          B.  Changed to the file average "AV" wherever the
              mask file has the value 0.0                        '<BR>'
          C.  Altered at the mask edges wherever the value is
              between 0 and 1, according to the following
              formula:                                          '<BR>'
              NEW(K,I) = [OLD(K,I) - OLDAV] * MASK(K,I) + OLDAV '<BR>'
              where: "NEW" is the masked image/volume           '<BR>'
                     "OLD" is the unmasked image/volume         '<BR>'
                     "MASK" is the continuous-valued mask 
                            function                            '<BR>'
                     "OLDAV" is the average value of the old,
                             unmasked image/volume.             '<BR>'

SUBROUTINES: MASKMU

CALLER:      UTIL2
