
OR 2M     ORientation search for rotation angles in 2D,        OR 2M
          multiple peaks .                                   2/19/98

PURPOSE:  Determines rotational orientation between two images.
          Mutliple peaks are found and stored in the document file,
          

SEE ALSO:  OR 2   (Orientation search for rotation angles in 2D)
           OR 3A  (Orientation search - 3D, arbitrary center)
           OR 3Q  (Orientation search - 3D, Eulerian angles)

USAGE:    OR 2M,X10

          [The optional output parameter X10 specify register
          position for the actual number of peaks found.]

          .INPUT FILE: UUU001
          [Enter name of the file.]

          .REFERENCE FILE: GGG002
          [Enter the name of the file containing the reference
          picture; dimensions must correspond to those of the first
          picture.]

          .FIRST AND LAST RING: 5,15
          [Only  rings with the radii in the range 5-15 (in pixel units)
           will be used.]
  
          .SKIP: 1
          [If skip=0 or 1 then each ring between 5 and 15 will be taken;
          for skip=2 every second, and so on.]

          .(F)ULL OR (H)ALF CIRCLE:F
          [F - full ring (360 degrees) will be used; H - half ring
           (180 degrees) will be used.  Option H is appropriate
           for rotational search using autocorrelation functions.]

          .Number of peaks: 10
          [Maximum number of peaks to be found.  The actual number
           of peaks found is returned in the optional register.]

          .DOCUMENT FILE: peaks001
          [Enter the name of the document file.  First column
           contains rotation angles found, second column contains
           corresponding peak values.  The entries are sorted according
           to the peak value in a descending order.]

NOTES: 1. Implemented by: Paul Penczek

SUBROUTINES: ORMD, ORMD_P, ALPRBS, NORMAS, ALRQ, FOURING, CROSRNG, 
             PRB1D, ANGMOR

CALLER:      UTIL3
