
OR P      ORientation search - not Power of two                 OR P
                                                            8/22/97

PURPOSE:  Determines rotational orientation between two images.
          Image dimensions do not have to be powers of two.

SEE ALSO:  OR     (Orientation search - half circle used)
           OR 3A  (Orientation search - 3D, arbitrary center)
           OR 3Q  (Orientation search - 3D, Eulerian angles)
           OR F   (Orientation search - full circle used)
           OR FM  (Orientation search - full circle used, find > one peak)
           OR M   (Orientation search - find > one peak)

USAGE:    OR P,X10,X11

          [The optional output parameters X10,X11 specify register
          positions for the rotation angle and the value of the
          angular correlation peak found in this operation.]

          .INPUT FILE: UUU001
          [Enter name of the file.]

          .REFERENCE FILE: GGG002
          [Enter the name of the file containing the reference
          picture; dimensions must correspond to those of the first
          picture.]

          .FIRST AND LAST RING: 5,15
          [Only  rings with the radii in the range 5-15 (in pixel units)
           will be used.]
  
          .SKIP: 1
          [If skip=0 or 1 then each ring between 5 and 15 will be taken;
          for skip=2 every second, and so on.]

NOTES: 1. Images do not have to have power-of-two dimensions.

       2. Implemented by: Paul Penczek

SUBROUTINES: ORMD, ORMD_P, ANGMOR

CALLER:      UTIL3
