
PD        PaD                                               PD      
                                                            7/19/96

PURPOSE:  To embed a picture or a volume in a larger array with 
          specified background constant and at a specified position.

USAGE:    PD X10

          .INPUT FILE: H_PIC001
          [Enter the name of the file containing image to be padded.]

          .OUTPUT FILE: H_IMG041
          [Enter the name for the output file.]

          .ENTER DIMS NSAM, NROW: 64,64
          [Enter the dimensions of the output file.  Each dimension
          has to be equal to or larger than the corresponding
          input file dimension.]

       If the input file is a 3D volume the following question will appear:

          .NSLICE: 64
          [Enter the slice number.]

          .AVERAGE?(Y/N), (B)ORDER, (M)INIMUM, (C)IRCULAR: YC
          [Enter 'Y' if you want the background value of the output
          picture to be equal to the input file's average. Enter 'B'
          if you want the background value to be equal to the average
          density value of the perimeter pixels in the input file. Enter 
          'M' if you want the background to be equal to the minimum 
          density value in the input file. 
          
	  If the 'B' option is selected , the optional register
          X10 will receive the value used for the padding, i.e., the border 
          value of the input file.
         
          For images of periodic arrays enter 'C' in the second
          position so that the padding will be circularly continuous
          as required in Fourier filtering of lattices; i.e., the parts
          of the small image that extend beyond the border of the large
          image will be wrapped around. (Without the 'C' option these
          parts would just be left out.) 
          IMPORTANT: The option 'C' only works on 2D images. 

       If 'N' was specified for the average option, SPIDER will ask 
       for the background constant to fill in]: 
          
          .BACKGROUND: 1.2

          .TOP LEFT COOS: 10,15
          [Enter the coordinates of the output picture where the top
          left corner of the input picture is to be put.]

       If the file is a 3D volume the following question will appear:

          .TOP Z COORDINATE: 10
          [This question will only appears if the input file was a volume.
          It refers to the third coordinate necessary to define the 
          translational position of the input volume inside the output one.]

SUBROUTINES: PATCH

CALLER:      UTIL2
          
