
PJ COL    ProJected surface - COLoring                         PJ COL   
                                                              1/15/97

PURPOSE:  Creates a 2-colour surface image by combining representations
          of two objects (created with 'PJ ST', followed by 'PJ SHAD'), using 
          the z-buffer (image after only 'PJ ST') as lookup for hidden surface
          removal.

SEE ALSO: PJ INTER (ProJected surface - interlace 2 surface representations)
          PJ SHAD  (ProJected surface - cosine shading)
          PJ ST    (ProJected surface - creation)

USAGE:    PJ COL

          .CREATE (I)MAGES, (C)OLORTABLE, (B)OTH (=DEFAULT): B
          [Enter if you want to create the images, colortable
          or both.]

          .NUMBER OF COLORS OR IMAGES IN IMAGE (MAX 10): 5
          [Enter how many pieces you want to combine, or how many colors
          should be in the colortable.]

       If 'I' or 'B' was answered:

          .OUTPUT FILE: COMBI001
          [output image, this image is split into N (her 5) density
          ranges . Image 1 will be stored in the lowest range, image 2 
          in the second lowest .. image N in the highest range. 
          When this image is viewed with a colour table as created by 
          this program.

       Next the program asks N times the two questions:

          .Z-BUF FILE: BACKZ001
          [Enter name of z-buffer image of object 1]

          .SHADE- FILE: BACKSHAD001
          [Enter name of shaded image of object 1]

       If 'C' or 'B' was answered:

          .COLOR TABLE FILE: fivecol
          [Enter name of the file for the color table. Will get the
           extension .RGB.]

          ENTER COLOUR INTENSITIES IN ARBITRARY UNITS.
          THE HIGHEST INTENSITY WILL BE SET TO 1 AND THE OTHERS
          NORMALIZED ACCORDINGLY

       The program will ask N times:    
          .COLOR 1:                     
          .RED, GREEN: 1.,0.8           
          .BLUE: 0.5

          .COLOR 2:                     
          ......etc.                    

          [Each time enter the mixture of red/green/blue, which will be
          used to create a ramp-type color table for each desity range.]

SUBROUTINES:  MRNCOLOR

CALLER:      VTIL2

