
PJ CYL    ProJect - 3D volume onto CYLinder                    PJ CYL    
                                                             09/09/96
                                                                    
PURPOSE:  Computes a projection of a 3D density distribution onto
          a cylinder surrounding the volume. The axis of the cylinder
          is assumed to be the Y axis. The origin is specified for each
          plane perpendicular to Y using a document file that contains
          the X,Z coordinates of the projection centers (intended for 
          curved fibers).  The cylinder is then unrolled into a 2D
          image.

SEE ALSO: PJ 3    (ProJect - 3D volume)
          PJ 3E   (ProJect - 3D volume using Eulerian angles, fast)
          PJ 3Q   (ProJect - 3D volume using Eulerian angles)
          PJ 3T   (ProJect - 3D volume using internal Threshold)
          PJ AT   (ProJect - 3D volume using exponential ATtenuation)
   
USAGE:    PJ CYL 

          .THREED FILE: PIC001
          [Enter the name of the file whose projection is to be
          computed.]
       
          .OUTPUT FILE: CYL001
          [Enter name for the output file]
   
          .STARTING ANGLE: 90
          [Enter starting angle.  Zero is at 3 o'clock on cylinder.]
                                
          .INNER, OUTER RADIUS: 5, 32
          [Enter inner and outer radius of cylinder. From the outer radius 
          the X-dimension of the output image is calculated as 
          YDIM=Radius*2*PI, and the angular increment as 360/YDIM.
          If inner radius < 0, the program does a maximum projection 
          instead of regular summation.  If outer radius < 0, the program
          finds the distance of the last positive pixel along the radius 
          from the center of the projection.]
          
          The program prints out: 
          ANGULAR INCREMENT: 3.75 DEGREES,   X DIMENSION: 91
                                                                    
          .NEW INCREMENT OR <RET>: 4.5
          [Enter a new angular increment if you want to overwrite 
          the one calculated. The file dimensions are automatically
          adjusted.]

          .COLUMNS FOR X-CENTER, Z-CENTER: 1,2
          [Enter the column numbers for the center coordinates in the
          document file.]

          .DOCUMENT FILE: DOC001
          [Enter the document file that contains the projection centers.]

SUBROUTINES: MRCP

CALLER:      VTIL2
                 







