
PP L      Put Points in image - from doc. file Listing       PP L
                                                         07/07/97

PURPOSE:  Reads locations from a document file and places a pixel 
          into the specified image or volume file at that location.  
          The pixel value (intensity) can be read from the document 
          file or set to a solicited value.

SEE ALSO: PP P   (Put points in image - alters neighbors also)
          PP LL  (Put lines in image  - from doc. file listing)

USAGE:    PP L

          .INPUT FILE: CCF001
          [Enter the name of the existing image file to be marked]

          .DOCUMENT FILE: DOC001
          [Enter name of document file where values to be interpreted
          as coordinates are located.]

       If the input file is a 3-D volume the following question appears:
          .X-COL, Y-COL, Z-COL: 1,2,3

       If the input file is an image the following question appears:
          .X-COL, Y-COL: 1,3

          [Enter the columns of the document file where the values
          are stored that are to be interpreted as x, y, & z coordinates,
          respectively.  Note that a 0 specification for X-COL will
          cause the doc file keys to be used as x-positions. ]

          .INTENSITY COL. (& INTENSITY IF NOT IN COL. OF DOC FILE): 4
          [Enter the column of the document file where the values
          of the point intensity are stored.  If zero is entered,
          then the the intensity for points is set to the second input.]

       If the input file is a 3-D volume the following question appears:
          .X-FACTOR, Y-FACTOR, Z-FACTOR: 1., 1., 1.

       If the input file is an image the following question appears:
          .X-FACTOR, Y-FACTOR: 1., 1.

          [Enter scaling factors to be applied in x, y & z directions.
          If the output dimensions specified are equal to the
          dimensions of the file where the coordinates originated,
          X-FACTOR=1, Y-FACTOR=1 & Z-FACTOR=1 would be the common 
          specification.   A minus sign for the second scale factor 
          inverts the y-direction so that a plot with conventional 
          axes directions  is obtained.]

       If the input file is a 3-D volume the following question appears:
          .X-OFFSET, Y-OFFSET, Z-OFFSET: 0.,0.,0.

       If the input file is an image the following question appears:
          .X-OFFSET, Y-OFFSET: 0,20

          [Enter offset (after scaling) for x, y & z values.  
           X-OFFSET=0, Y-OFFSET=0 & Z-OFFSET=0 are common inputs where 
           doc. file coordinates correspond to image file size.]

          .KEYS TO BE USED:  1-25,28
          [Enter the keys of the document records you wish to use.

NOTES:    1. As of June 1996 the file statistics are now correct 
          following this operation. (al)

SUBROUTINES: PUTPT2

CALLER:      UTIL2

