
PP LL     Put Lines in image - from doc. file Listing                  PP LL
                                                             6/15/95

PURPOSE:  Reads coordinates from document file and draws continuous
          line into image connecting these coordinates.

SEE ALSO: PP L (Put points in image - from doc file listing)
          PT   (Create pattern or mask file)

USAGE:    PP LL

          .COORDINATE DOCUMENT FILE: DOC001
          [Enter the name of the existing doc file.]

          .OUTPUT IMAGE FILE: OUT001
          [Enter the name of the existing or new image file where
           output is placed.]

      If the file is new the following question appears.
          .ENTER DIMS NSAM,NROW'): 1024, 1024
          [Enter size of output image.]
     
          .X-COL., Y-COL.:  1,2
          [Enter the number of the col. in the doc file for the 
           x and y coordinates.  A zero means the key is used
           for the coordinate.]

          .LINE INTENSITY COL. (< 0 ASKS FOR INTENSITY INPUT): -1
          [Enter intensity for line in image file.]
 
      If the Line intensity col. is < 0 the following appears.
          .LINE INTENSITY: 1.2 
          [Enter intensity for line in image file.]

      If the file is empty (new)  the following question appears.
          .BACKGROUND INTENSITY: 0.0 
          [Enter background intensity in image file.]

          .CONTOUR NO. COL. (= 0 FOR NONE): 4
          [Enter doc. file column where the contour number is given.]
 
          .X-FACTOR, Y-FACTOR: 1.0, -1.0
          [Enter scaling factors to be applied in x and y directions.
          If the output dimensions specified are equal to the
          dimensions of the file where the coordinates originated,
          XFACT=1 and YFACT=1 would be the normal specification.
          A minus sign for the second scale factor inverts the
          y-direction so that a plot with conventional axes directions
          is obtained.]
          
          .X-OFFSET, Y-OFFSET: 0, 0
          [Enter offset (after scaling) for x and y values]

SUBROUTINES: PUTLIN, UNSDAL

CALLER:      UTIL2
