
PP V      Put height image into Volume                        PP V
                                                             7/17/96

PURPOSE:  Converts a height image to a binary volume.

SEE ALSO:  

USAGE:    PP V

          .INPUT FILE: DOC001
          [Enter the name of the existing 2D image file.]

          .ENTER NUMBER OF SLICES IN OUTPUT VOLUME: 10
          [The input image intensity range which is considered to 
           represent height will be spread over this many slices.]

          .OUTPUT FILE: VOL001
          [Enter the name of the new volume image file where
           output is placed.]

NOTES:    1.  The output volume has values 0 and 1 only.  The
              lowest value in the image is put on highest numbered 
              slice.  

          2.  This volume can now be viewed as a surface using WEB.

SUBROUTINES: IMTOVOL

CALLER:      UTIL2
