
PR        overPRint image - to results file                       PR      
                                                             8/16/97

PURPOSE:  Prints an image into the results file.  The image
          can be viewed by printing the results file on a line
          printer capable of overprinting (e.g. LA34) controlled by
          carriage control characters at first position of
          output line.

SEE ALSO: PR P    (Overprint power spectrum - to RESULTS file)
          PR T    (Overprint image - on terminal)
    
USAGE:    PR

          .INPUT FILE: PIC001
          [Enter the name of the file of interest.]

          .CONTOURING? (Y/N): Y
          [Enter whether or not contouring is desired.]

       If 'Y' is answered, the following question appears:

          .NUMBER OF LEVELS: 5
          [Enter number of contour levels.]

          [The file will then be printed (with overprinting) to the
          results file, with 5 levels of contouring.  If contouring
          is not desired, then an 'N' should be entered.  Note that
          as in all SPIDER contouring programs, the levels of maximum 
          and minimum OD are counted as contour levels.  In the above 
          example, only three contours would
          be visible, plus the two points where the maximum and 
          minimum of the image are assumed.]

SUBROUTINES: OPRINT

CALLER:      UTIL1
