
PS A      Pick Slice - Arbitrary direction                 PS A
                                                         1/27/94

PURPOSE:  Pick a slice from a volume in arbitrary direction.
          The pixels in the output image are computed by 
          bilinear 3D interpolation.

SEE ALSO: PS          (Pick slice - Y, xz planes)
          PS X        (Pick slice - X, yz planes)
          PS Z        (Pick slice - Z, xy planes)

USAGE:    PS A

          .INPUT FILE: THR001
          [Enter name of 3-D file.]

          .OUTPUT FILE: CSL001
          [Enter name of file to hold the 2-D slice.]

          .AZIMUTH: 45.
          [Enter azimuth angle in degrees.]

          .INCLINATION: 85.
          [Enter inclination angle in degrees.]
          [With given angles, the plane is uniquely defined by a
          point of the volume.]

          .ENTER X,Y POSITION: 33,33
          [Give the x,y coordinates of the point.]

          .ENTER Z POSITION: 20
          [Give z coordinate of the point.]

NOTES:    EXAMPLE:  A central slice of a 64x64x64 volume is
          obtained by entering 33,33 for the x,y coos, 33 for
          the z coordinate, and any combination of angles.

SUBROUTINE: CSLICE

CALLER:     VTIL2
