
RA        RAmp                                              RA      
                                                            4/17/97

PURPOSE:  Fits a least-squares plane to the picture, and subtracts
          the plane from the picture.  A wedge-shaped overall 
          density profile can thus be removed from the picture.

SEE ALSO:  RA GN    (Gaussian contrast Normalization)

USAGE:    RA

          .INPUT FILE: H_PIC001
          [Enter the name of the file that needs to be corrected.]

          .OUTPUT FILE: H_IMG043
          [Output file name.]

NOTES: 1. This operation should be used for pre-processing
          whenever the autocorrelation function has a "rooftop"
          appearance.

       2. The result of the statistical F-test of the multiple
          correlation coefficient is calculated.

SUBROUTINES: RAMP, RAMP_P, BETAI, BETACF, GAMMLN

CALLER:      UTIL1
