
RE        REturn                                            RE      
                                                            3/22/96

PURPOSE:  Returns control from a procedure or batch file.

USAGE:    RE

          [This command can only be used within a batch or procedure
          file.  Upon encountering 'RE', control will return to the
          batch or procedure file that called the current batch or
          procedure file.  For example, consider the following
          procedure files:

          '<PRE>'
          Procedure file SH1    Procedure file RT1
            SH                    RT
            PIC001                SHI001
            SHI001                ROT001
            5,6                   90.0
            RT1                   RE
            MO
            .
            .
            .
          '</PRE>'

          Upon processing of SH1, SPIDER will shift PIC001, put the
          shifted image into SHI001, and then perform procedure RT1.
          Procedure RT1 will rotate the shifted image, and put the
          rotated image in ROT001.  SPIDER will then encounter the
          'RE' command, and return to procedure SH1 where it left
          off (i.e., it will process the 'MO' command, and continue
          with processing SH1).

          If procedure RT1 were called directly by the user in
          interactive mode, SPIDER will return to the interactive
          mode upon encountering the 'RE' command.]

SUBROUTINES: SPIDER

CALLER:      SPIDER
