
RM        Radon transforM suite of programs.                        RM
                                                                7/24/96

PURPOSE:  Under the command 'RM' all programs for handling Radon 
          transforms are found. 

USAGE:    RM 

          [RM is a suite of programs to handle Radon transforms. Currently 
          Radon transforms do not have a separate file type and neither do
          their Fourier transforms. The user has to make sure that the 
          correct type of data are used.
          2D Radon transforms (also called Sinograms) are stored with each 
          line corresponding to one projection angle. The file header 
          contains the information about the angular sampling in positions 
          54-56, in the order: (from, to, increment).
          3D Radon transforms also are stored with each line belonging
          to one angle. Phi increases with the line number, theta with the
          slice.
          The Fourier transforms of 2D and 3D Radon transforms are stored
          line by line in the same position as the real space transform.
          Each line is two numbers longer than in real space Radon transform. 
          Also peak files are used. For alignment of 2D to 3D radon transforms
          the angular range of the peakfiles is kept in header positions
          48 to 56. 
          Programs in this suite all transfer the header information. Other
          programs in SPIDER may not. If this is the case, you have to use
          'FI' x.. to extract the header information from one file and 
          'ST' to set it in the output file (this problem is under discussion
          and will be removed).

NOTE:     1. These programs are under development. If you 
          desire to use them please contact M. Radermacher 
          (michael@alpha.biophys.mpg.de)
          to obtain most recent programs, they are not distributed
          with SPIDER.

          2. Developed by M. Radermacher. 

SUBROUTINES:

CALLER:      UTIL5






