
RO        ROtational average - single line output                RO      
                                                          01/8/97

PURPOSE:  Computes the radial distribution function of a 
          two  or three  dimensional density distribution stored 
          in a square array.
          Center assumed at (NSAM/2+1, NROW/2+1).

SEE ALSO: RO I  (Rotational average - 2D image output)
  
USAGE:    RO

          .INPUT FILE: PIC001
          [Enter the name of the file to be rotationally averaged.]

          .OUTPUT FILE: ROT001
          [Enter the name of the file to store averages.]

          [The output file will contain the azimuthally averaged
          density distribution as a function of radius. The
          dimensions of the output file will be NSAM/2.]

NOTES: 1. Display of the 1D array may be done with 'GR' or
          'GR T', specifying row #1 to be displayed.
          Alternatively, the values may be listed using 'LI T'.

SUBROUTINES: RADAV, CRCSE1,CRCSE3

CALLER:      UTIL3
