
RO I      ROtational average - 2D Image output                RO I     
                                                          03/25/96

PURPOSE:  Computes the radial distribution function of a 
          two-dimensional density distribution stored in a square array.
          Center assumed at (NSAM/2+1, NROW/2+1).

SEE ALSO: RO  (Rotational average - single line output)
  
USAGE:    RO I

          .INPUT FILE: PIC001
          [Enter the name of the file to be rotationally averaged.]

          .OUTPUT FILE: ROT001
          [Enter the name of the file to store averages.]

          [The output file will contain the azimuthally averaged
          density distribution as a function of radius. The
          dimensions of the output file will be identical to input 
          image.]

SUBROUTINES: RADAV, RADAVI, CRCSE1

CALLER:      UTIL3
