
RT 90     RoTate - image or volume, by 90, 180, or 270 degrees    RT 90
                                                               8/25/97

PURPOSE:  To rotate an image 90, 180, or 270 about Z axis or rotate
          a 3-D volume 90, 180, or 270 degrees about either the
          X, Y, or Z axis.

SEE ALSO: RT     (RoTate - image or volume, use average as background)
          RT 3   (RoTate - volume, slow)
          RT 3A  (RoTate - volume, around arbitrary center)
          RT 3D  (RoTate - volume, fast)
          RT B   (RoTate - image or volume, supply background)
          RT C   (Rotate - image, around arbitrary center, for small files)
          RT M   (Rotate - image or volume, use minimum as background)
          RT SQ  (RoTate - image or volume, shift, use quadratic interpolation)

USAGE:    RT 90

          .INPUT FILE:  IMG000
           [Enter the name of the file to be rotated.]

          .OUTPUT FILE:  OUT000
           [Enter the name of the file where the rotated volume is to
           be kept.]
 
           FOLLOWING THREE QUESTIONS REFER TO ORIGINAL VOLUME DIMENSIONS.

          .ENTER FIRST AND LAST X COLUMN NUMBER (OR <CR> FOR ALL): <CR>

          .ENTER FIRST AND LAST Y ROW NUMBER (OR <CR> FOR ALL): 1,50

          .ENTER FIRST AND LAST Z SLICE NUMBER (OR <CR> FOR ALL): <CR>

          .ENTER ROTATION AXIS (X,Y,Z) (<CR> IS Z):  X
           [Uses a right-handed coordinate system.]

          .ENTER ROTATION ANGLE (90,180, OR 270):  90
          [All rotations are clockwise when looking along axis facing
          greater values.  X axis points to right, Y axis points 
          down screen, and Z axis is coming out of the screen.]

NOTES: 1. The time required will depend on the axis and angle.

       2. Any aspect ratio of image or volume is allowed (the
          volume does not have to be padded to a cube).

       3. The maximum size of image or volume which can be
          rotated depends upon the axis and angle.  The smallest 
          size limit is for rotations arond Y or Z axis by 90 or 
          270 degrees.  These rotations are limited to an output 
          slice of (MAXDIM - 16000) pixels.

SUBROUTINES: REFORM0, REFORM

CALLER:      UTIL3


