
SD C      Save Document - from Cluster file                   SD C    
                                                            3/22/96

PURPOSE:  Transfer image coordinates along factors from 
          correspondence analysis cluster file (IMC00#) into a document file.
          This can subsequently be picked up by 'UD' to perform 
          subset averaging or rotation correction.

SEE ALSO:  SD         (Save document)
           SD S       (Sort document file according to column)
           SD NLM     (Save document - from non-linear mapping)
	   SD SHUFFLE (Shuffle document file)
    
USAGE:    SD C

          .CLUSTER FILE CODE, NUMBER OF FACTORS: 3,2
          [Enter the file code that has been used in the 'CA S' run,
          and the number of factors for which coordinates are to be
          transferred.  All coordinates are transferred up to the
          factor specified.]

          .DOCUMENT FILE: DOC003
          [Enter name for new document file.]

NOTES:    The coordinate tupels are transferred in the order the
          images were centered in 'CA S'.  The image number is used
          as key.

          Example for retrieval of the position of image number 51
          along factor 2:                                  '<BR>'
               UD 51,X10,X20                               '<BR>'
               DOC003                                      '<BR>'
          After execution of this command, X20 contains the desired
          value.

          This operation is compatible only with the new CORAN85
          operations 'CA S...'.

SUBROUTINES: RDCLUS, SAVD, OPENDOC

CALLER:      DRIV3
