
ST        SeT                                               ST      
                                                            04/22/97

PURPOSE:  Allows the user to:                                       '<BR>'
          1.  Put image tilt angles into header.                    '<BR>'
          2.  Alter any specified buffer position in the file header.'<BR>'
          3.  Clear the statistical values in header of a file.     '<BR>'
          4.  Put maximum and minimum into header if known a priori.'<BR>'

USAGE:    ST

          .INPUT FILE: PIC001
          [Enter the name of the file to be manipulated.]

          .(A)NGLES, (B)UF, (C)LEAR, OR (F)IX:
          [Option A : Angles. Put new angles into header.

           Option B : Buffer. Put new values into specified locations 
                      in the header.  (Can be any location)

           Option C : Clear.  Unsets the flag indicating that 
                      the MAX and MIN have been stored in the header.

           Option F : Fix.  Puts MINIMUM, MAXIMUM,  AVERAGE & S.D.
                      statistical values into header, if known a priori.
                    
    For '<B>'"A"'</B>' SPIDER will ask:

          .ANGLE SET 1, 2,OR 3: 1
          [There are three sets of angles that can be stored in the 
           file header. Normally set: 1 should be used. For details of 
           the other two sets see manual chapter for operation "VO CEUL" 
           (combine Euler rotations)]

          .ENTER PHI AND THETA:  30.0,60.0

          .ENTER PSI:            90.0


    For '<B>' "B"'</B>'  SPIDER will ask:

          .ENTER NUMBER(S) OF HEADER LOCATION TO BE CHANGED:  17

          .ENTER NEW VALUE FOR EACH HEADER LOCATION CHANGED:  75.0

    For '<B>' "F"'</B>' SPIDER will ask:

           .ENTER IMAGE MAXIMUM: 5.0

           .ENTER IMAGE MINIMUM: 0.0

           .AVERAGE AND STANDARD DEVIATION AVAILABLE (Y/N)': Y
          [These values are now required otherwise they may be 
           inconsistent with the min. and max.]

           .ENTER AVERAGE, STANDARD DEVIATION:  2.0, 1.0

NOTES: 1. If a file is write-protected, the file cannot be  
          overwritten by any operation.  Any attempt to overwrite
          the file will result in an error message.

       2. Option 'C' is useful if an operation such as
          histogram 'HI' was attempted, but not completed successfully,  
          resulting in inaccurate label information.

       3. Option 'B' is usually used to correct damaged
          file headers.

       4. Option 'T' removed as it did not work with all
          Fourier file formats, use option 'Buf' instead.

SUBROUTINES: UTIL1, SETVAL, SETLAB

CALLER:      UTIL1

