
VO RA     Vector Operation - Rotate Angular document file        VO RA
                                                               09/03/96

PURPOSE:  Rotate projection directions according to three rotation angles
          supplied. The original projection directions are provided in
          the input angular document file. The modified projection 
          directions are stored in the output angular document file. 
          If this output angular docfile is used in a subsequent
          3D reconstruction, the resulting structure will be rotated in
          3D space in agreement with the three rotation angles given.
          This command is provided to calculate "merged" 3D reconstructions.

SEE ALSO: VO       (Vector operation)
          VO CEUL  (Vector operation - combine Euler rotations)
          VO EA    (Vector operation - even angles doc. file) 
          VO MD    (Vector operation - angular doc. file from 'AP MD' output)
   
USAGE:    VO RA

          .ANGULAR DOCUMENT FILE NAME: ANGLES001
          [Enter name of input angular document file containing the three 
          Eulerian angles (in the order psi, theta, phi) to be modified.]
 
          .ROTATION ANGLES PSI, THETA: 12.2,75.76

          .ROTATION ANGLES PHI: 128.22

          .DOCUMENT FILE NAME: ANGFULL
          [Enter the name of the output angular document file. The file
          will contain the Eulerian angles psi, theta, phi as required by 
          the 3D reconstruction program 'BP RP'.]

NOTES: 1. Implemented by P. Penczek.

SUBROUTINE: VORA, CALD, BLDR

CALLER:     DRIV1
