
WT TV     Lattice Indexing                                     WT TV
                                                               8/10/95

PURPOSE:  1.  Automatic indexing of reciprocal lattice from 2 or
              more reflections.
          2.  Creation of a filter file for quasi-optical 
              crystal-line Fourier filtration.

SEE ALSO: WT  (Lattice Indexing)
 
USAGE:    WT TV  

          .POWER SPECTRUM FILE: POW001
          [Enter the name of the power spectrum file.]

          .FOURIER FILE: FOU001
          [Enter the name of the Fourier file.]

          .REFLECTIONS DOC. FILE: DOC001
          [Enter the name of the Document file containing the 
          reflection indicies and locations.  This file can
          be created using the REFLECTIONS menu in WEB.]

          .WINDOW SIZES (SEARCH,FILT): 7,5
          [Enter the dimensions of square windows to be used in the
          search for maxima and filtration (2nd not presently
          used).]

          .MAXIMUM RESOLUTION DISTANCE: 120
          [Enter the radius of a circle in Fourier space within
          which reflections on the indexed lattice are being 
          determined.]

          [The initial and the refined lattice parameters will be
          listed along with x and y components of each.  A list of
          the reflections found, and their energies, is recorded in
          the RESULTS file.]

          .FILTER FILE: FIL001
          [Enter the name of the file that will contain the 
          coordinates of the refined lattice for use in filtration. 
          See 'GF' and 'RD' for details.]

NOTES:    A detailed description of quasi-optical filtration using
          SPIDER is found in the document FILTER.DOC.  See the
          manual chapter for WT for an explanation of lattice 
          indices.

SUBROUTINES: TVWN3, LATCEN, MAXF

CALLER:      DRIV2

