	SUBROUTINE  ALPRBS(NUMR,NRING,LCIRC,MODE)
C
C  NUMR(1,I) - ring number
C  NUMR(2,I) - beginning in CIRC
C  NUMR(3,I) - length in CIRC
C  LCIRC - total length of CIRC
C
	INTEGER*2  NUMR(3,NRING)
	REAL*8  PI
	CHARACTER*1  MODE
CNO_SAVE
C
C  PREPARATION OF PARAMETERS
C
	PI=4.0*DATAN(1.0D0)
	IF(MODE.EQ.'F')  PI=2*PI
	LCIRC=0
	DO I=1,NRING
	JP=PI*NUMR(1,I)
	IP=2**LOG2_P(JP)
	IF(I.LT.NRING.AND.JP.GT.IP+IP/2)  IP=MIN0(1024,2*IP)
C
C  Last ring should be oversampled to allow higher accuracy
C  of peak location (?).
C
	IF(I.EQ.NRING.AND.JP.GT.IP+IP/5)  IP=MIN0(1024,2*IP)
	NUMR(3,I)=IP
	IF(I.EQ.1)  THEN
	NUMR(2,1)=1
	ELSE
	NUMR(2,I)=NUMR(2,I-1)+NUMR(3,I-1)
	ENDIF
	LCIRC=LCIRC+IP
	ENDDO 
c 1	CONTINUE
	END
