C++************************************************************************
C
C $$ ALROSF.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ ALROSF.FOR
C
         SUBROUTINE  ALROSF(A,ATMP,B,C,REFER,NSAM,NROW,NSI,
     &   WRK,PARA,NOCHANGE,
     &   A_CIRC,REFER_CIRC,LCIRC,JACUP,NUMR,NRING,MAXRIN,TEMP,MODE)
         DIMENSION   A(NSAM,NROW),B(NSAM,NROW),C(NSAM,NROW)
         DIMENSION   REFER(NSAM,NROW),ATMP(NSAM,NROW),PARA(3),WRK(*)
         INTEGER*2  NUMR(3,NRING),MAXRIN
         DOUBLE PRECISION  TEMP(MAXRIN,2),TOTMIN
         DIMENSION  A_CIRC(LCIRC),REFER_CIRC(LCIRC)
         LOGICAL  NOCHANGE
         CHARACTER*1 MODE
CNO_SAVE
C
         NSNR=NSAM*NROW
C
         CALL  ALRQ
     &   (REFER,NSAM,NROW,NUMR,REFER_CIRC,LCIRC,NRING,MODE,IPIC)
         CALL  FOURING
     &   (REFER_CIRC,LCIRC,NUMR,NRING,TEMP,MODE)
         INS=1
         CALL  FMR_2(REFER,NSAM,NROW,WRK,INS)
C
C  atmp has to be updated before the call
C     call  rtqs(a,atmp,nsam,nrow,para(1),para(2),para(3))
C
         ITER=0
         NOCHANGE=.FALSE.
101      ITER=ITER+1
         CALL  ALRQ
     &   (ATMP,NSAM,NROW,NUMR,A_CIRC,LCIRC,NRING,MODE,IPIC)
         CALL  FOURING
     &   (A_CIRC,LCIRC,NUMR,NRING,TEMP,MODE)

         CALL  CROSRNG_F
     &   (REFER_CIRC,A_CIRC,LCIRC,NRING,TEMP,TEMP(1,2),
     &   MAXRIN,JACUP,NUMR,TOTMIN,TOT,MODE)
C
         ROTMP=ANG(TOT,MODE)
         CALL  RTQ(ATMP,B,NSAM,NROW,ROTMP)
C
         INS=1
         CALL  FMR_2(B,NSAM,NROW,WRK,INS)
         CALL  CRSM_2(REFER,B,C,NSAM,NROW,WRK)
         CALL  FINDMX_F(C,NSAM,NROW,NSI,CMX1,SX1,SY1,JACUP)
C
         DD=((COSD(ROTMP)-1.0)*NUMR(1,NRING)+SX1)**2
     &   +(SIND(ROTMP)*NUMR(1,NRING)+SY1)**2
         IF(DD.LT.0.25) THEN
         IF(ITER.EQ.1)  NOCHANGE=.TRUE.
         RETURN
         ENDIF
C
         CALL  SUMAP(PARA(1),PARA(2),PARA(3),ROTMP,SX1,SY1,P1,P2,P3)
         PARA(1)=P1
         PARA(2)=P2
         PARA(3)=P3
         CALL  RTQS(A,ATMP,NSAM,NROW,PARA(1),PARA(2),PARA(3))
         IF(ITER.GT.25)  RETURN
         GOTO 101
         END
