
C++************************************************************************
C
C AUXFIL.FOR -- CREATED JUNE 87
C
C **************************************************************************
C    AUTHOR :  ArDean Leith
C *  COPYRIGHT (C)1987, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C $$ AUXFIL(FILNAM,NLET,PROMPT,DISP,EXTEN,LUN,IRTFLG)
C
C    PURPOSE:        GETS NAME FOR AN AUXILIARY FILE (NOT .SSR OR .CNT)
C                    AND OPENS THE FILE ON LUN
C
C    PARAMETERS:     FILNAM = WHOLE FILE NAME WITH EXTENSION
C                    PROMPT = PROMPT WHICH SOLICTS FILE NAME
C                    DISP   = TYPE OF FILE ( 'U' IS UNKNOWN, 'N' IS NEW,
C                             'O' IS OLD)
C                    NLET   = IS NUMBER OF LETTERS IN FILE NAME
C                    LUN    = UNIT NUMBER TO OPEN FILE ON
C                    IRTFLG = ERROR RETURN FLAG
C
C    CALLED BY:      SSSTOR
C
C    CALLS:          FILERD   AUXOPN
C
C--*******************************************************************

        SUBROUTINE AUXFIL(FILNAM,NLET,PROMPT,DISP,EXTEN,LUN,IRTFLG)

        COMMON /UNITS/ LUNDOC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
 
        CHARACTER *(*) FILNAM,PROMPT,DISP,EXTEN

C..     ASK FOR FILE NAME, ACCEPT AN EXTENSION IF IT IS GIVEN
30      IRTFLG = 9
        CALL FILERD(FILNAM,NLET,EXTEN,PROMPT,IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN

C       OPEN THE FILE
        CALL AUXOPN(FILNAM,DISP,LUN,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 30

        RETURN
        END

