
C++*************************************************************************
C
C BAPI.FOR            CHANGED BY NAIK 8/16/86 LOGICAL*1 TO CHARACTER*1
C                     LONG FILENAMES JAN89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  BAPI(JJ)
C
C--*******************************************************************

      SUBROUTINE    BAPI(JJ)
 
      INCLUDE      'CMBLOCK.INC' 
      COMMON        BUF(1024),A0(1)
      COMMON /COMMUN/ FNTD,FNPR,FNPR2,FILPAT,FILDUM

      CHARACTER *81 FNTD,FNPR,FNPR2,FILPAT,FILDUM
      CHARACTER *1  FSTAT(3),YN,NULL
      DIMENSION     IR(10),FR(10),IP(10),FF(2)

      NULL=CHAR(0)

      FSTAT(1) = 'O'

10    CALL FILERD(FNTD,NLET,NULL,'3D',IRTFLG)
      IF (IRTFLG .NE. 0) RETURN

11    CALL RDPRMC(YN,NA,.TRUE.,'IS THIS A NEW 3D? (Y/N)',NULL,IRT)
      IF (IRT .EQ. -1) GOTO 10
      IF (YN .EQ. 'Y') THEN 
        CALL RDPRMI(IX,IY,NLOOP,ILOOP,'X- Y- DIMENSIONS')
        NSAM = IX
        CALL RDPRMI(IZ,II,NLOOP,ILOOP,'Z-DIMENSION')
        FSTAT(1)='N'
      ENDIF
      CALL RDPRMI(IA,IE,NLOOP,ILOOP,
     &     'ENTER FIRST,LAST SLICE TO BE RECONSTRUCTED')
      CALL RDPRMI(ISTEP,II,NLOOP,ILOOP,'SLICE INTERVAL')
      CALL RDPRM(ENL,NLOOP,ILOOP,'ENLARGEMENT-FACTOR')
      IF (IA .EQ. 0) IA = 1
      IF (IE .EQ. 0) IE = IZ
      NSL = IZ
      IFORM = 3
      CALL OPENF(FNTD,10,IX,IY,FSTAT,NF,NSL)
      IF (FSTAT(1) .EQ. 'O') THEN
        IZ=NSL
      ELSE
        DO 1 I=1,NSL
        DO 1 K=1,IY
          DO 2 L=1,NSAM
2         A0(L) = 0.0
          CALL WRTLIN(10,A0,IX,(I-1)*IY+K)
1       CONTINUE
      ENDIF     
      IR(1) = IX
      IR(2) = IY
      IR(3) = IZ
      IR(4) = IA
      IR(5) = IE
      IR(6) = ISTEP
      CALL FILERD(FNPR,NLETP,NULL,'FIRST PROJECTION',IRTFLG)
      CALL FILERD(FNPR2,NLET,NULL,'LAST PROJECTION',IRTFLG)
      CALL FILCAD(FNPR,FILPAT,N1,IRTFLG)
      CALL FILCAD(FNPR2,FILDUM,N2,IRTFLG)
      DO 1000 K = N1, N2
        CALL FILGET(FILPAT,FNPR,NLETP,K,IERR)
        IF (IERR .EQ. 2) THEN
           CLOSE(10)
           RETURN
        ENDIF
c	In batch mode, this will stop at errt.f if a file is missing
c	create a new format, ZOLD
c        CALL OPENF(FNPR,11,NSAM,NROW,'OLD',NF,NDUM)
        CALL OPENF(FNPR,11,NSAM,NROW,'ZOLD',NF,NDUM)
        IF (NF .NE. 2 .OR. IFORM .LT. 0) THEN
           WRITE (NOUT,50) FNPR(1:20)
   50      FORMAT(' *** ',A20,' DOES NOT EXIST, OR ARRAY NOT REAL ***')
           GOTO 1000
        ENDIF

C*****************NOV 87 al
C       CALL REDLIN(11,BUF,NSAM,0)
C       READ ANGLES CONTAINED IN THE TITLE OF THE IMAGE
C       CALL RDPRMT(FF,NN,BUF)

        IP(1) = NSAM
        IP(2) = NROW
        IP(3) = IFORM

C       READ ANGLES CONTAINED IN THE IMAGE LABEL 
        NN = 2
        CALL GETANG(11,NSAM,BUF,15,NN,FF,IRTFLG)
        FR(1) = ENL
        FR(4) = FF(2)
        FR(5) = FF(1)
C******************************

        WRITE(NOUT,500) FR(4),FR(5)
  500   FORMAT('  THETA=',F10.2,'   PHI=',F10.2)
        DO 800 J = 1, NROW
          CALL REDLIN(11,BUF,NSAM,J)
          IND = (J-1)*NSAM
          DO 600 J1 = 1, NSAM
             INDI = IND + J1
             A0(INDI)=BUF(J1)
  600     CONTINUE
  800   CONTINUE
        CLOSE(11)
        CALL MIRQBXS(A0,10,BUF,IR,FR,IP,0)
        CALL FILCAD(FNPR,FILDUM,NC,IRTFLG)
1000  CONTINUE

      CLOSE (10)
      RETURN
      END

  

