
	SUBROUTINE BCQ(MAXMEM)
C                                                    02/06/97
	PARAMETER  (NILMAX=20000)
        INCLUDE 'CMBLOCK.INC'
	COMMON /F_SPEC/  FINPAT,NLET,FINPIC
	CHARACTER*80  FINPIC,FINFO
	CHARACTER*80  FINPAT
	CHARACTER*1   NULL
	COMMON        DUMMY(80),BUF(1024),ILIST(NILMAX),BAF(1)
        DIMENSION     Q(1)
        POINTER       (IPQ,Q) 
        LOGICAL       RUNTIME
	COMMON /PAR/  LDPX,LDPY,LDPZ,LDPNMX,LDPNMY,NZ1

	DATA  IOPIC/98/,INPIC/99/
CNO_SAVE
	NULL=CHAR(0)

C       N - linear dimension of projections and restored cube
C       NANG - number of angles (projections)

	IUNIT=NOUT
 	CALL  FILERD(FINPAT,NLET,NULL,
     &	   'ENTER TEMPLATE FOR 2-D IMAGE NAME',IRTFLG)
 	CALL  FILERD(FINPic,NLETi,NULL,'SELECTION DOC',IRTFLG)
	K=0
	K2=1
	NANG=0
778	LERR=-1
	IF (NANG.EQ.NILMAX)  THEN
           WRITE(NOUT,*) '  TOO MANY IMAGES, LIST TRUNCATED'
           GOTO  779
	ENDIF
	KP1=K+1
	CALL  UNSAV(FINPIC,K,INPIC,KP1,BUF,1,LERR,K2)
	IF (LERR.EQ.0)  THEN
	   NANG=NANG+1
	   ILIST(NANG)=BUF(1)
	   K=K+1
	   GOTO  778
	ENDIF

779	CLOSE(INPIC)
	WRITE(NOUT,2001) NANG
2001	FORMAT('  NUMBER OF IMAGES =',i5)
C       NANG - total number of images
	CALL  FILERD(FINFO,NLET1,NULL,'ANGLES DOC',ITRFLG)
	FINFO=FINFO(1:NLET1)//'.'//DATEXC(1:3)
	OPEN(77,FILE=FINFO,STATUS='OLD')
	CALL  RDPRMI(NX3D,NY3D,NLOOP,ILOOP,'3D VOLUME: X,Y DIMENSIONS')
	CALL  RDPRMI(NZ3D,IDUM,NLOOP,ILOOP,'3D VOLUME: Z DIMENSION')
	CALL  RDPRMI(NZ1,NZ2,NLOOP,ILOOP,
     &		'FIRST,LAST SLICE TO BE RECONSTRUCTED')
	IF (NZ1.EQ.0)  NZ1=1
	IF (NZ2.EQ.0)  NZ2=NZ3D
	CALL  RDPRM(SNR,NLOOP,ILOOP,'SNR/DIAMETER')
	IF (SNR.GT.0.0)  SNR=1.0/SNR
	NZC=NZ2-NZ1+1
	CALL  FILERD(FINPIC,NLETI,NULL,'RECONSTRUCTED 3-D',ITRFLG)
	IF (IRTFLG.EQ.-1)  GOTO 9999
	IFORM=3
 	CALL  OPENFB(BUF,FINPIC,IOPIC,NX3D,NY3D,'UNKNOWN',NF,NZC)
	IF (NF.NE.2)  GOTO 9999

 	CALL FILGET(FINPAT,FINPIC,NLET,ILIST(1),INTFLG)
 	CALL OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
 	IF (NF .NE. 2)  THEN
	   WRITE(NOUT,*) ' FILE NOT FOUND'
	   RETURN
	ENDIF
	CLOSE(INPIC)

	LDPX=NX3D/2+1
	LDPY=NY3D/2+1
	LDPZ=NZ3D/2+1
	LDPNMX=NSAM/2+1
	LDPNMY=NROW/2+1

	NMAT=NX3D*NY3D*NZC
	NNNN=NSAM+2-MOD(NSAM,2)

 	K_DM=1
	K_SS=IPALIGN64(K_DM+9*NANG)
	K_PROJ=IPALIGN64(K_SS+6*NANG)
	K_CB=IPALIGN64(K_PROJ+NNNN*NROW)
	K_WORK=IPALIGN64(K_CB+NMAT)
	K_CW=K_WORK
	MEMTOT=IPALIGN64(K_CW+NNNN*NROW/2)

	IRTFLG=-9
        CALL CHKMEM(MEMTOT,BAF,MAXMEM,RUNTIME,IPQ,IRTFLG)
	IF (IRTFLG.EQ.0)  THEN
	   WRITE(NOUT,1001)  MEMTOT
1001	   FORMAT(//'  3-D back-projection, volume in the memory',/,
     1              '   you have reserved ',I9,/)
	   CALL  REANG(ILIST,Q(K_DM),Q(K_SS),NANG,NOUT)
	   CALL  BPCQP
     &	      (Q(K_PROJ),Q(K_CW),NNNN,NSAM,NROW,Q(K_CB),NX3D,NY3D,NZC,
     &		ILIST,Q(K_DM),Q(K_SS),NANG,SNR,NOUT)
	   DO   K=1,NY3D*NZC
	      MI=(K-1)*NX3D
	      CALL  WRTLIN(IOPIC,Q(K_CB+MI),NX3D,K)
	   ENDDO
	ELSE
	   K_CB=IPALIGN64(K_SS+6*NANG)
	   K_WORK=IPALIGN64(K_CB+NX3D*NY3D)
	   K_CW=K_WORK
	   K_PROJ=IPALIGN64(K_CW+NNNN*NROW/2)
C	   K_PROJ=K_CW+NSAM*NROW
C	   MTM=MAXMEM-K_PROJ
C	   LPRJ=MIN0(NANG,MTM/(NSAM*NROW)
	   DO  LPRJ=NANG,1,-1
	      MEMTOT=IPALIGN64(K_PROJ+LPRJ*NNNN*NROW)
	      IRTFLG=-9
              CALL CHKMEM(MEMTOT,BAF,MAXMEM,RUNTIME,IPQ,IRTFLG)
	      IF (IRTFLG .EQ. 0)  GOTO  505
	   ENDDO

           CALL  ERRT(6,'BP 3D',NE)
           RETURN

505	   WRITE(NOUT,1002)  LPRJ
1002	   FORMAT(//'  3-D back-projection, ',I4,
     &              ' projections in the memory',/)
	   CALL  REANG(ILIST,Q(K_DM),Q(K_SS),NANG,NOUT)
	   CALL  BPCMP
     &	      (Q(K_PROJ),Q(K_CW),NNNN,NSAM,NROW,LPRJ,Q(K_CB),
     &	      NX3D,NY3D,NZC,ILIST,
     &        Q(K_DM),Q(K_SS),NANG,SNR,NOUT,IOPIC)
        ENDIF
        IF (RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'BP 3D',IRTFLG)
	CLOSE(IOPIC)

9999	CONTINUE
        RETURN
	END
