C++*********************************************************************
C
C $$ BITRV.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************


      SUBROUTINE      BITRV(D,NPREV,N,NREM)
      DIMENSION       D(1)
      IP0  = 2
      IP1  = IP0*NPREV
      IP4  = IP1*N
      IP5  = IP4*NREM
      I4REV= 1

      DO 60 I4 = 1, IP4, IP1
      IF(I4-I4REV) 10,30,30
   10 I1MAX = I4 + IP1 - IP0

      DO 20 I1 = I4, I1MAX, IP0
      DO 20 I5 = I1, IP5,   IP4
      I5REV =I4REV + I5 - I4
      TEMPR = D(I5)
      TEMPI = D(I5+1)
      D(I5) = D(I5REV)
      D(I5+1) = D(I5REV+1)
      D(I5REV)= TEMPR
   20 D(I5REV+1)=TEMPI

   30 IP2 = IP4/2
   40 IF(I4REV-IP2)60,60,50
   50 I4REV = I4REV - IP2
      IP2 = IP2/2
      IF(IP2-IP1)60,40,40
   60 I4REV = I4REV + IP2
      RETURN
      END
