
C++************************************************************************
C
C $$ BLANK.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ BLANK:  CREATE A CONSTANT PICTURE
C
C      THIS SUBROUTINE CREATES A CONSTANT PICTURE WITH A GIVEN
C      BACKGROUND VALUE.
C
C      CALL BLANK(LUN,NSAM,NROW,B)
C        LUN          LOGICAL UNIT NUMBER OF OUTPUT PICTURE
C        NSAM,NROW    DIMENSIONS OF OUTPUT PICTURE
C        B            BACKGROUND CONSTANT TO BE USED
C
C--********************************************************************

      SUBROUTINE BLANK(LUN,NSAM,NROW,B)

      COMMON BUF(1)

      INCLUDE 'CMBLOCK.INC'
CNO_SAVE
      DO  I = 1,NROW
         DO K = 1,NSAM
	  BUF(K) = B
	 ENDDO
	 CALL WRTLIN(LUN,BUF,NSAM,I)
      ENDDO
      CALL SETPRM(LUN,NSAM,NROW,B,B,B,'R')
      END
