

C                                     LONG FILE NAMES JAN 89 al
	
C	PROGRAM TO DISPLAY CORRESPONDENCE ANALYSIS MAPS ON VT125
C	TERMINAL. DISPLAY CODE CAN OPTIONALLY BE STORED IN AN OUTPUT FILE.

	SUBROUTINE CAMVT(LUNS)

        INCLUDE 'CMBLOCK.INC'
        COMMON /COMMUN/CLUSTI,CLUST,MAPI,MAP,NME,TXT,SYMB
        COMMON /SPI_BUF/ XZ,YZ,ZZ

        INTEGER         IBUF(10)
	DIMENSION       XZ(500),YZ(500),ZZ(500),AR(2)

        CHARACTER *2000 NME
        CHARACTER *500  SYMB
        CHARACTER *81   CLUSTI,CLUST,MAPI,MAP
	CHARACTER *80   TXT1,TXT
	CHARACTER *4    AX1,AX2,FC,NOMZ
	CHARACTER *1    APO,ESC,CH,NULL,MARK,MARK2,NEWLIN,P

	EQUIVALENCE (FC(4:4),MARK)
	EQUIVALENCE (CH,MARK2)

	DATA TXT1/'MAP AXES     VERSUS      '/

        NULL   = CHAR(0)
        NEWLIN = CHAR(92)

      CALL FILERD(CLUSTI,NLETC,NULL,'CLUSTER',IRTFLG)
      IF (IRTFLG .NE. 0) RETURN
      CALL FILCAN(CLUST,NF,NULL,NULL,CLUSTI,DATEXC,IER)
      OPEN(FILE=CLUST,UNIT=LUNS,STATUS='OLD',FORM='FORMATTED')

      CALL RDPRMI(IFF,IDUM,NLOOP,ILOOP,
     &            'CLUSTER FILE (1)OLD,(2)NEW,(3)NLM')
      NFCT1=1
      NFCT2=2

      IF (IFF.NE.3) THEN
        CALL RDPRMI(NFREAD,IDUM,NLOOP,ILOOP,'NUMBER OF FACTORS')
81      CALL RDPRMI(NFCT1,NFCT2,NLOOP,ILOOP,'FACTOR NUMBERS')
        IF (NFCT1.EQ.0 .OR. NFCT2 .EQ. 0) THEN
           WRITE (NOUT,*) '*** ERROR IN FACTOR NUMBERS, PLEASE REPEAT'
           GOTO 81
        ENDIF
      ENDIF

      CALL RDPRMI(ISYM,IDUM,NLOOP,ILOOP,
     &     '(0)POINTS, (1)NORM. CHAR, (2)SMALL CHAR')
      CALL RDPRMI(IMD,IDUM, NLOOP,ILOOP,
     &     'OUTPUT (0)TERMINAL, (1)FILE, (2)BOTH')
      IF (IMD .NE. 0) THEN
         CALL FILERD(MAPI,NLETM,NULL,'MAP',IRTFLG)
         CALL FILCAN(MAP,NF,NULL,NULL,MAPI,DATEXC,IER)
         OPEN(FILE=MAP,UNIT=12,STATUS='NEW',FORM='FORMATTED')
      ENDIF

      CALL RDPRM(FIS,NLOOP,ILOOP,'SIZE FACTOR ( <1 )') 
      IF (FIS.EQ.0)FIS=1.
      NALPH=80
      CALL RDPRMC(TXT,NALPH,.TRUE.,'TITLE',NULL,IRTFLG)
      CALL RDPRMI(IMANY,IDUM,NLOOP,ILOOP,'RECORD NUMBER OF FIRST IMAGE')
      IF (IMANY.EQ.0) GOTO 13
      NREC=IMANY
      GOTO 1234

C     LOOK FOR THE FIRST IMAGE IN CLUSTER-FILE. (MARKED BY *)

13    NREC=0
1000  CONTINUE
      NREC=NREC+1
      READ(LUNS,100) FC
100   FORMAT(A4)
C**   IF ((MARK.GT."040.AND.MARK.LT."060).OR.(MARK.GT."071)) GOTO 2000
      IF ((MARK.GT.' ' .AND. MARK.LT.'0') .OR. (MARK.GT.'9')) GOTO 2000
      GOTO 1000
2000  REWIND (LUNS)

C     FIRST IMAGE FOUND IN RECORD NREC. REWIND CLUSTER-FILE
C     AND READ IMAGES BEGINNING IN NREC

C IF NOT FIRST RUN CONTINUE HERE:
C**1234	ENCODE(4,90,AX1) NFCT1
C**     ENCODE(4,90,AX2) NFCT2

1234    WRITE(AX1,90)NFCT1
        WRITE(AX2,90)NFCT2
90	FORMAT(I4)

	TXT1(9:12)  = AX1
	TXT1(20:23) = AX2 
C**	MARK = "065
	MARK = '5'
      NRECC = NREC-1
      DO  K=1,NRECC
      READ (LUNS,100) FC
      ENDDO
      NIM = 0
      DO   K=1,10000
      IF (IFF.NE.1) GOTO 96
      READ (LUNS,101,END=98) NOMZ(1:4),(IBUF(J),J=1,NFREAD)
101   FORMAT(A4,8I5)
      XZ(K)=IBUF(NFCT1)
      YZ(K)=IBUF(NFCT2)
      GOTO 97

96     READ(LUNS,190,END=98) NOMZ(1:4),AR
190    FORMAT(A4,2E14.6)
       XZ(K)=AR(1)
       YZ(K)=AR(2)
97      NIM=NIM+1
	NME((K-1)*4+1:K*4) = NOMZ(1:4)
	CH = NOMZ(4:4)
        IF (IMANY.NE.0) GOTO 104

C**     IF ((MARK2 .GE. "060.AND.MARK2.LE."071).OR.MARK2.LE."040)
        IF ((MARK2 .GE. '0'.AND.MARK2 .LE. '9') .OR. MARK2 .LE. ' ')
     &      WRITE(NOUT,103)K

103	FORMAT(' * WARNING * NONSTANDARD NAME FOUND',I4,'TH PICTURE')

104	SYMB(K:K) = MARK2
	ENDDO
98      CONTINUE
        WRITE(NOUT,166) NIM
166     FORMAT(' CAMAP   NUMBER OF IMAGES:',I5)
C       WRITE(NOUT,167) ((XZ(K),YZ(K)),K=1,NIM)
167     FORMAT(1X,4E14.6)
	APO = CHAR(39)
	ESC = CHAR(27)
	XMAX=-1000
	XMIN=1000
	YMAX=-1000
	YMIN=1000
	DO  I=1,NIM
           IF (XMAX.LT.XZ(I)) XMAX=XZ(I)
           IF (XMIN.GT.XZ(I)) XMIN=XZ(I)
           IF (YMIN.GT.YZ(I)) YMIN=YZ(I)
           IF (YMAX.LT.YZ(I)) YMAX=YZ(I)
	ENDDO
	R    = 1
	FAC1 = 730./(XMAX-XMIN)
	FAC2 = 400./(YMAX-YMIN)
	FAC  = AMIN1(FAC1,FAC2)
	FAC  = FAC*FIS
	OFFX = 0
	OFFY = 0
	IBRANCH=ISYM+1
	GOTO(201,202,203),IBRANCH	

202     OFFX = 5
	OFFY = 11
	GOTO 201

203	OFFX = 5
	OFFY = 6

201	IURC=(XMAX-XMIN)*FAC+30
	ILRC=(YMAX-YMIN)*FAC+30
	ITR1=ILRC+10
	ITR2=ILRC+25
	DO  I=1,NIM
          XZ(I)=(XZ(I)-XMIN)*FAC-OFFX
          YZ(I)=(YZ(I)-YMIN)*FAC-OFFY
	ENDDO

91	FORMAT(' ',A1,'P0p')
87	FORMAT(' ','S(E) P[10,10]V[' ,I4, ',10]V[' ,I4, ',' ,I4, 
     &         ']V[10,' ,I4,']V[10,10]' )
66      FORMAT(' ','P[10,',I4,']T',A1,A80,A1)
966     FORMAT(' ','P[10,',I4,']T',A1,A80,A1)
69      FORMAT(' ','P[10,',I4,']T',A1,A80,A1)
6 	FORMAT(' ','P[',I4,',',I4,']','V[]')
7	FORMAT(' ','P[',I4,',',I4,']','T',A1,A1,A1)
92	FORMAT(' ',A1,A1)
8	FORMAT(' ','T[9,0] (S[9,10] M[1,1])')

c	IF(IMD.EQ.1) GOTO 89
	IF(IMD.EQ.1) GOTO 32
	NWR=NOUT
88	CONTINUE
	WRITE(NWR,91)  ESC
	WRITE(NWR,87)  IURC,IURC,ILRC,ILRC
	WRITE(NWR,66)  ITR1,APO,TXT,APO
	WRITE(NWR,966) ITR2,APO,TXT1,APO
	
c	IF(ISYM.EQ.0) GOTO 30
	IF(ISYM.NE.0) THEN
	  IF(ISYM.EQ.2) WRITE(NWR,8)
	  DO  I=1,NIM
	     IXX=XZ(I)+20
	     IYY=YZ(I)+20
	     RC =R
	     IX2=IXX+RC
	     WRITE(NWR,7) IXX,IYY,APO,SYMB(I:I),APO
	  ENDDO
C	  GOTO 32
	ELSE
30	  DO 89 I=1,NIM
             IXX=XZ(I)+20
             IYY=YZ(I)+20
             RC=R
             IX2=IXX+RC
             WRITE(NWR,6) IXX,IYY
89	  CONTINUE
        END IF
	
32	CONTINUE
	WRITE(NWR,92) ESC,NEWLIN
	IF(IMD.EQ.0.OR.NWR.EQ.12) GOTO 33
        NWR=12
	GOTO 88

33	CONTINUE
	CALL RDPRMC(P,NCHAR,.TRUE.,'PRINT MAP (Y/N)',NULL,IRTFLG)
	IF (P .NE. 'Y') GOTO 9999
	NWR=NOUT
	IF(IMD.EQ.1) NWR=12
34	WRITE(NWR,177) ESC
177    	FORMAT(' ',A1,'P0pS(S1,H[0,0][767,504],S1)')
	WRITE(NWR,92) ESC,NEWLIN
	IF(IMD.LT.2.OR.NWR.EQ.12) GOTO 9999
	NWR=12
	GOTO 34 

9999	CONTINUE
	CALL RDPRMI(NFCT1,NFCT2,NLOOP,ILOOP,'FACTOR NUMBERS')
	IF (NFCT1.EQ.0.OR.NFCT2.EQ.0) GOTO 8888
        REWIND(LUNS)
        GOTO 1234

8888	CLOSE(LUNS)
	IF(IMD.GT.0) CLOSE(12)
	END
