	SUBROUTINE CCC(MAXDIM)
	INCLUDE 'CMBLOCK.INC'
	COMMON BUF(1)
        COMMON /COMMUN/ FILNAM1,FILNAM2,FILNAMM
        CHARACTER *81 FILNAM1,FILNAM2,FILNAMM
        CHARACTER     NULL
	DOUBLE PRECISION      SUM,DAV1,DVAR1,DAV2,DVAR2,DCC
	DATA LUN1,LUN2,LUNM/21,22,23/
CNO_SAVE
        NULL=CHAR(0)
C
	CALL FILERD(FILNAM1,NLET1,NULL,'INPUT1',IRTFLG)
	IF(IRTFLG .NE. 0) RETURN
	CALL OPENF(FILNAM1,LUN1,NSAM1,NROW1,'OLD',NF,NSLICE1)

	CALL FILERD(FILNAM2,NLET2,NULL,'INPUT2',IRTFLG)
	IF(IRTFLG .NE. 0) RETURN
	CALL OPENF(FILNAM2,LUN2,NSAM2,NROW2,'OLD',NF,NSLICE2)
	IF (NSAM2.NE.NSAM2 .OR. 
     &      NROW2.NE.NROW1 .OR. NSLICE1.NE.NSLICE2) THEN
		CALL ERRT(101,'INCONSISTENT PICTURE DIMENSIONS',NE)
		CLOSE(LUN1)
		RETURN
	ENDIF

	CALL FILERD(FILNAMM,NLETM,NULL,'MASK',IRTFLG)
	IF (IRTFLG .NE. 0) THEN
		CLOSE(LUN1)
		CLOSE(LUN2)
		RETURN
	ENDIF
	CALL OPENF(FILNAMM,LUNM,NSAMM,NROWM,'OLD',NF,NSLICEM)
	IF (NSAMM.NE.NSAM1 .OR. 
     &       NROWM.NE.NROW1 .OR. NSLICEM.NE.NSLICE1) THEN
		CALL ERRT(101,'INCONSISTENT PICTURE DIMENSIONS',NE)
		GOTO  999
	ENDIF
C
	NTOT=NSAM1*NROW1*NSLICE1
	NOFFS1=1
	NOFFS2=NOFFS1+NSAM1
	NOFFSM=NOFFS2+NSAM1
	IF(NOFFSM+NSAM1.GT.MAXDIM)  THEN
		CALL  ERRT(6,'CCC ',NE)
		GOTO 999
	ENDIF
C
	DAV1=0.D0
	DVAR1=0.D0
	DAV2=0.D0
	DVAR2=0.D0
	DCC=0.D0
	N=0
	SUM=0.0
C
	DO  I=1,NROW1*NSLICE1
		CALL REDLIN(LUN1,BUF(NOFFS1),NSAM1,I)
		CALL REDLIN(LUN2,BUF(NOFFS2),NSAM1,I)
		CALL REDLIN(LUNM,BUF(NOFFSM),NSAM1,I)
	DO  K=0,NSAM1-1
	IF(BUF(NOFFSM+K).GT.0.5) THEN
		DAV1=DAV1+BUF(NOFFS1+K)
		DVAR1=DVAR1+BUF(NOFFS1+K)*DBLE(BUF(NOFFS1+K))
		DAV2=DAV2+BUF(NOFFS2+K)
		DVAR2=DVAR2+BUF(NOFFS2+K)*DBLE(BUF(NOFFS2+K))
		DCC=DCC+BUF(NOFFS1+K)*DBLE(BUF(NOFFS2+K))
		N=N+1
                SUM=SUM+(BUF(NOFFS1+K)-BUF(NOFFS2+K))*
     &              DBLE(BUF(NOFFS1+K)-BUF(NOFFS2+K))
	ENDIF
	ENDDO
	ENDDO
	DAV1=DAV1/FLOAT(N)
	DVAR1=DVAR1/FLOAT(N)-DAV1**2
	DAV2=DAV2/FLOAT(N)
	DVAR2=DVAR2/FLOAT(N)-DAV2**2
	DCC=DCC/FLOAT(N)-DAV1*DAV2
	DCC=DCC/SQRT(DVAR1*DVAR2)
C
	DVAR1=DSQRT(DVAR1)
	DVAR2=DSQRT(DVAR2)
C
	IF (NSEL(1).NE.0.) PARAM(NSEL(1))=DCC
	IF (NSEL(2).NE.0.) PARAM(NSEL(2))=DAV1
	IF (NSEL(3).NE.0.) PARAM(NSEL(3))=DVAR1
	IF (NSEL(4).NE.0.) PARAM(NSEL(4))=DAV2
	IF (NSEL(5).NE.0.) PARAM(NSEL(5))=DVAR2
	IF (NSEL(6).NE.0.) PARAM(NSEL(6))=SUM
C
	WRITE(NOUT,501) (FILNAM1(K:K),K=1,NLET1)
501	FORMAT(' ** IMAGE NO. 1: ',80A1)
	WRITE(NOUT,502) DAV1,DVAR1
502	FORMAT('          AV = ',G12.5,'  S.D. = ',G12.5)
        WRITE(NOUT,*) ' '

	WRITE(NOUT,503) (FILNAM2(K:K),K=1,NLET2)
503	FORMAT(' ** IMAGE NO. 2: ',80A1)
	WRITE(NOUT,502) DAV2,DVAR2
        WRITE(NOUT,*) ' '

	WRITE(NOUT,504) (FILNAMM(K:K),K=1,NLETM)
504	FORMAT(' **  MASK USED:   ',80A1)
	WRITE(NOUT,505) DCC
505	FORMAT('0**       CROSS-CORRELATION COEFFICIENT = ',F10.5//)
	WRITE(NOUT,508) SUM
508	FORMAT('0**       EUCLIDEAN DISTANCE = ',G10.3//)
C
999	CLOSE(LUN1)
	CLOSE(LUN2)
	CLOSE(LUNM)
	END
