C  Translation search of multiple volumes with forbiden zone.
C
        SUBROUTINE CCFN(MAXMEM)
        INCLUDE 'CMBLOCK.INC'
	PARAMETER (MAXVOL=10)
	COMMON  BUF(2048),ncoll(MAXVOL),nrowl(MAXVOL),nslil(MAXVOL),
     &		ixull(MAXVOL),iyull(MAXVOL),izull(MAXVOL),
     &          ncolr(MAXVOL),nrowr(MAXVOL),nslir(MAXVOL),
     &		maxcol(MAXVOL),maxrow(MAXVOL),maxsli(MAXVOL),
     &	        rmm(MAXVOL),KAF(1)
        DIMENSION    Q(1)
        POINTER      (IPQ,Q) 
        LOGICAL      RUNTIME

       CHARACTER *80 FILNAM
       CHARACTER *1  NULL
       DATA  LUN1,LUN2/8,9/
CNO_SAVE

        NULL   = CHAR(0) 
	CALL FILERD(FILNAM,NLETI,NULL,'Texture',IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 5
        CALL OPENFB(BUF,FILNAM,LUN1,NSAM,NROW,'O',NF,NSLICE)
        IF (NF.EQ.1)  THEN
           CALL ERRT(4,'CC M ',NE)
           GOTO 6
	ELSEIF(IFORM.NE.3)  THEN
           CALL ERRT(2,'CC M ',NE)
           GOTO 5
	ENDIF
	CALL  RDPRMI(NVOL,NROWL,NLOOP,ILOOP,'Number of template volumes')
	IF(NVOL.GT.MAXVOL) THEN
           CALL ERRT(31,'CC M ',NE)
           GOTO 5
	ENDIF
	NSRC=0
	DO    LL=1,NVOL
	LT=LL
	WRITE(NOUT,502)  LL
502	FORMAT('  Template volume ',I2)
	CALL FILERD(FILNAM,NLETI,NULL,'Template',IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 5
        CALL OPENFB(BUF,FILNAM,LUN2+LL-1,NSAM1,NROW1,'O',NF,NSLICE1)
        IF(NF.EQ.1)  THEN
	   LT=LL-1
           CALL ERRT(4,'CC M ',NE)
           GOTO 4
	ELSEIF(IFORM.NE.3)  THEN
           CALL ERRT(2,'CC M ',NE)
           GOTO 4
	ELSEIF(NSAM.NE.NSAM1 .OR. NROW.NE.NROW1 
     &		.OR. NSLICE.NE.NSLICE1) THEN
           CALL ERRT(1,'CC M ',NE)
           GOTO 4
	ENDIF
	CALL RDPRMI(NCOLL(LL),NROWL(LL),NLOOP,ILOOP,
     &		'Window size NSAM, NROW')
	CALL RDPRMI(NSLIL(LL),J,NLOOP,ILOOP,'Window size NSLICE')
	CALL RDPRMI(IXULL(LL),IYULL(LL),NLOOP,ILOOP,
     &		'Window position (corner) IX, IY')
	CALL RDPRMI(IZULL(LL),J,NLOOP,ILOOP,
     &		'Window position (corner) IZ')
	CALL RDPRMI(NCOLR(LL),NROWR(LL),NLOOP,ILOOP,
     &		'Search range (+/-) NX, NY')
	CALL RDPRMI(NSLIR(LL),J,NLOOP,ILOOP,'Search range (+/-) NZ')
 
	NSRC=MAX0(NSRC,NCOLR(LL),NROWR(LL),NSLIR(LL))
 
	ENDDO

C       Buffer address
	K1=1
	K2=K1+NSAM*NROW*NSLICE
	K3=K2+NSAM*NROW*NSLICE*NVOL
	K4=K3+NSAM*NROW*NSLICE
	MEMWANT=K4+NVOL*(2*NSRC+1)**3
        
	CALL CHKMEM(MEMWANT, KAF ,MAXMEM,RUNTIME,IPQ,IRTFLG)
        IF(IRTFLG.NE.0)  THEN  
C 	   Not enough memory
	   CALL ERRT(6,'CC M ',NE)
	   GOTO 4
	ENDIF
	
        DO  J=1,NROW*NSLICE
          CALL REDLIN(LUN1,Q(K1+(J-1)*NSAM),NSAM,J)
        ENDDO	
	CLOSE(LUN1)
	DO  LL=1,NVOL
           DO  J=1,NROW*NSLICE
              CALL REDLIN(LUN2+LL-1,
     &	            Q(K2+NSAM*NROW*NSLICE*(LL-1)+(J-1)*NSAM),NSAM,J)
           ENDDO
	   CLOSE(LUN2+LL-1)
	ENDDO
	CALL FILERD(FILNAM,NLETI,NULL,'Forbidden zone',IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 5
        CALL OPENFB(BUF,FILNAM,LUN2,NSAM1,NROW1,'O',NF,NSLICE1)
        IF (NF.EQ.1)  THEN
           CALL ERRT(4,'CC M ',NE)
           GOTO 6
	ELSEIF(IFORM.NE.3)  THEN
	   CLOSE(LUN2)
           CALL ERRT(2,'CC M ',NE)
           GOTO 5
	ELSEIF(NSAM.NE.NSAM1 .OR. NROW.NE.NROW1 
     &		.OR. NSLICE.NE.NSLICE1) THEN
           CALL ERRT(1,'CC M ',NE)
	   CLOSE(LUN2)
           GOTO 5
	ENDIF
        DO  J=1,NROW*NSLICE
        CALL REDLIN(LUN2,Q(K3+(J-1)*NSAM),NSAM,J)
        ENDDO
	CLOSE(LUN2)
	CALL  RDPRM2(AAA,BBB,NLOOP,ILOOP,
     &	'Relative weight for template overlap and forbiden zone')
	CALL  CCFR(Q(K2),Q(K1),Q(K3),NVOL,NSAM,NROW,NSLICE,
     &		   Q(K4),NSRC,
     &		   NCOLL,NROWL,NSLIL,IXULL,IYULL,IZULL,
     &             NCOLR,NROWR,NSLIR,MAXCOL,MAXROW,MAXSLI,
     &		   EXCLM,MEXL,FBDM,RM,RMM, 
     &		   AAA,BBB)
	DO  LL=1,NVOL
	
C          SHIFT TEMPLATE BY (+MAXCOL,+MAXROW,+MAXSLI) TO
C          MATCH THE TEXTURE.
	   WRITE(NOUT,551) LL,MAXCOL(LL),MAXROW(LL),MAXSLI(LL),RMM(LL)
551	   FORMAT(' Template #',I2,'  matched at ',3I4,'  CCC=',F7.4)
	ENDDO
	WRITE(NOUT,552)  exclm,mexl,fbdm,rm
552	FORMAT(' Exclusion ',1PE10.3,1x,i4,' Forbidden zone ',1PE10.3,
     &		'  Global ',1PE10.3)
C        IF (NSEL(1).NE.0.) PARAM(NSEL(1))=MAXCOL
C        IF (NSEL(2).NE.0.) PARAM(NSEL(2))=MAXROW
C        IF (NSEL(3).NE.0.) PARAM(NSEL(3))=MAXSLI
C        IF (NSEL(4).NE.0.) PARAM(NSEL(4))=RM
C        IF (NSEL(5).NE.0.) PARAM(NSEL(5))=EX
C        IF (NSEL(6).NE.0.) PARAM(NSEL(6))=FO
C
 
        IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'CC M',IRTFLG)
 
	GOTO 5
4	CLOSE(LUN1)
	DO  LL=1,LT
	   CLOSE(LUN2+LL-1)
	ENDDO
5	CONTINUE
6       FCHAR(1:1) = ';'
        END
