C  here it is assumed that fbdz is binary.
C  furthermore,  the definition of overlap is modified.
	subroutine  ccfr(lef,rit,fbdz,nvol,ncol,nrow,nslice,
     &			rem,nsrc,
     &		       ncoll,nrowl,nslil,ixull,iyull,izull,
     &                 ncolr,nrowr,nslir,maxcol,maxrow,maxsli,
     &			exclm,mexl,fbdm,rm,rmm,
     &			a,b)
c
c  lef(ncol,nrow,nslice),  rit(ncol,nrow,nslice) input arrays
c  ncoll, nrowl, nslil - window size, taken from rit
c                        and crosscorrelated with lef
c  ixull, iyull, izull   upper left coordinates of the window
c  ncolr, nrowr, nslir is range of search 
c      in rit (-ncolr .. +ncolr; -nrowr .. +nrowr; -nslicr .. +nslicr)
c  maxcol, maxrow, maxsli  position found
c  rm      maximum correlation coefficient
	parameter  (maxvol=10)
	real*4      lef(ncol,nrow,nslice,nvol),rit(ncol,nrow,nslice)
	dimension	fbdz(ncol,nrow,nslice)
	dimension   rem(-nsrc:nsrc,-nsrc:nsrc,-nsrc:nsrc,nvol)
	dimension   ncoll(NVOL),nrowl(NVOL),nslil(NVOL),
     &		ixull(NVOL),iyull(NVOL),izull(NVOL),
     &           ncolr(NVOL),nrowr(NVOL),nslir(NVOL),
     &		maxcol(NVOL),maxrow(NVOL),maxsli(NVOL)
	dimension  ixulls(MAXVOL),iyulls(MAXVOL),izulls(MAXVOL),
     &	nsrelgo(MAXVOL),nsrelend(MAXVOL),
     &	nrrelgo(MAXVOL),nrrelend(MAXVOL),
     &	ncrelgo(MAXVOL),ncrelend(MAXVOL),
     &	icolrr(MAXVOL),irowrr(MAXVOL),islirr(MAXVOL),nnn(MAXVOL),
     &  	rmm(MAXVOL)
c     &  ,nfbdz(-nsrc:nsrc,-nsrc:nsrc,-nsrc:nsrc,nvol)

	double precision  sx(MAXVOL),sy,
     &		sqx(MAXVOL),sqy,sxy,sx2(MAXVOL),
     &		sxt,sqxt,qt
CNO_SAVE
c maybe don't need it ?
c	do  1  iz=-nsrc:nsrc
c	do  1  iy=-nsrc:nsrc
c	do  1  ix=-nsrc:nsrc
c	nfbdz(ix,iy,iz)=0
c	enddo
c	enddo
c	enddo
c
	do  ll=1,nvol
        ixulls(ll)  = ixull(ll) + ncoll(ll) - 1
        iyulls(ll)  = iyull(ll) + nrowl(ll) - 1
        izulls(ll)  = izull(ll) + nslil(ll) - 1

        nsrelgo(ll) = -nslir(ll)
        if (izull(ll) .le. nslir(ll)) nsrelgo(ll) = 1 - izull(ll)

        nsrelend(ll) = nslir(ll)
        if ((izull(ll) + nslil(ll) + nslir(ll)).gt. nslice) 
     &       nsrelend(ll) = nslice - izull(ll) - nslil(ll)

        nrrelgo(ll) = -nrowr(ll)
        if (iyull(ll) .le. nrowr(ll)) nrrelgo(ll) = 1 - iyull(ll) 

        nrrelend(ll) = nrowr(ll)
        if ((iyull(ll) + nrowl(ll) + nrowr(ll)).gt. nrow) 
     &       nrrelend(ll) = nrow - iyull(ll) - nrowl(ll)

	ncrelgo(ll) = -ncolr(ll)
	if(ixull(ll) .le. ncolr(ll))  ncrelgo(ll) = 1 - ixull(ll)

        ncrelend(ll) = ncolr(ll)
        if ((ixull(ll) + ncoll(ll) + ncolr(ll)) .ge. ncol) 
     &       ncrelend(ll) = ncol - ixull(ll) - ncoll(ll)  

	nnn(ll)=ncoll(ll)*nrowl(ll)*nslil(ll)
	enddo
c....
	do  ll=1,nvol
	sxt=0.0
	sqxt=0.0
c$doacross  local(irowl,icoll,islil),reduction(sxt,sqxt)
	   do  islil =izull(ll),izulls(ll)
	     do  irowl =iyull(ll),iyulls(ll)
       	  	do  icoll = ixull(ll),ixulls(ll)
		sxt=sxt+lef(icoll,irowl,islil,ll)
	    sqxt=sqxt+
     &	lef(icoll,irowl,islil,ll)*dble(lef(icoll,irowl,islil,ll))
		enddo
	     enddo
           enddo

	sx(ll)=sxt
	sqx(ll)=sqxt
	sx2(ll)=sqxt-sxt*sxt/nnn(ll)
	enddo
c
	do  ll=1,nvol
c
        do  isliri = nsrelgo(ll),nsrelend(ll)
        do  irowri = nrrelgo(ll),nrrelend(ll)
        do  icolri = ncrelgo(ll),ncrelend(ll)
c
c  correlation with the texture
 	sy=0.0
	sqy=0.0
	sxy=0.0
c$doacross local(islil,irowl,icoll,islirp,irowrp,qt),
c$& reduction(sy,sqy,sxy)
	   do  islil =izull(ll),izulls(ll)
           islirp=isliri+islil
	     do  irowl =iyull(ll),iyulls(ll)
             irowrp=irowri+irowl
       	  	do  icoll = ixull(ll),ixulls(ll)
			qt  = rit(icoll + icolri,irowrp,islirp)
			sy=sy+qt
			sqy=sqy+qt*qt
			sxy=sxy+qt*lef(icoll,irowl,islil,ll)
                enddo
             enddo
           enddo


	rt = (sxy-sx(ll)*sy/nnn(ll))/
     &		dsqrt(sx2(ll) * (sqy - sy*sy/nnn(ll)))
c  forbidden zone
	fbd=0.0
c	ibi=0
c$doacross local(islil,irowl,icoll,islirp,irowrp),
c$& reduction(fbd)
	   do  islil =izull(ll),izulls(ll)
           islirp=isliri+islil
	     do  irowl =iyull(ll),iyulls(ll)
             irowrp=irowri+irowl
       	  	do  icoll = ixull(ll),ixulls(ll)
		fbd=fbd+
     &	fbdz(icoll + icolri,irowrp,islirp)*lef(icoll,irowl,islil,ll)
c		ibi=ibi+jnint(fbdz(icoll + icolri,irowrp,islirp))
                enddo
             enddo
           enddo
c	print *,(icolrr(ll),ll=1,nvol),(irowrr(ll),ll=1,nvol),
c     &		(islirr(ll),ll=1,nvol),(r(ll),ll=1,nvol),excl,fbd
c951	format(10i3)
c
	rem(icolri,irowri,isliri,ll)=-rt/nvol+b*fbd
c	nfbdz(icolri,irowri,isliri,ll)=ibi
c
	enddo
	enddo
	enddo
c
	enddo
c
	rm=1.e20
	do  ll=1,nvol
        islirr(ll) = nsrelgo(ll)
        irowrr(ll) = nrrelgo(ll)
        icolrr(ll) = ncrelgo(ll)
	enddo
c
801	continue
c        do  islirr = nsrelgo(ll),nsrelend(ll)
c        do  irowrr = nrrelgo(ll),nrrelend(ll)
c        do  icolrr = ncrelgo(ll),ncrelend(ll)
c   exclusions
	excl=0.0
	nexl=0
	if(nvol.gt.1)  then
c$doacross local(l1,l2,izb,ize,iyb,iye,ixb,ixe,iz,iy,ix,templef),
c$& reduction(excl,nexl)
	do  l1=1,nvol-1
	 do  l2=l1+1,nvol
	  if(izulls(l1)+islirr(l1).lt.izull(l2)+islirr(l2)
     &	.or. izull(l1)+islirr(l1).gt.izulls(l2)+islirr(l2) ) then
	  goto  777
	  else
	  izb=max0(izull(l1)+islirr(l1),izull(l2)+islirr(l2))
	  ize=min0(izulls(l1)+islirr(l1),izulls(l2)+islirr(l2))
          endif
	  if(iyulls(l1)+irowrr(l1).lt.iyull(l2)+irowrr(l2)
     &	.or. iyull(l1)+irowrr(l1).gt.iyulls(l2)+irowrr(l2) ) then
	  goto  777
	  else
	  iyb=max0(iyull(l1)+irowrr(l1),iyull(l2)+irowrr(l2))
	  iye=min0(iyulls(l1)+irowrr(l1),iyulls(l2)+irowrr(l2))
          endif
	  if(ixulls(l1)+icolrr(l1).lt.ixull(l2)+icolrr(l2)
     &	.and. ixull(l1)+icolrr(l1).gt.ixull(l2)+icolrr(l2) ) then
	  goto  777
	  else
	  ixb=max0(ixull(l1)+icolrr(l1),ixull(l2)+icolrr(l2))
	  ixe=min0(ixulls(l1)+icolrr(l1),ixulls(l2)+icolrr(l2))
          endif
		   do  iz=izb,ize
		   do  iy=iyb,iye
		   do  ix=ixb,ixe
	templef=
     &	lef(ix-icolrr(l1),iy-irowrr(l1),iz-islirr(l1),l1)
     &		*lef(ix-icolrr(l2),iy-irowrr(l2),iz-islirr(l2),l2)
		if(templef.ne.0.0)  then
		   nexl=nexl+1
	 	   excl=excl+
     &	lef(ix-icolrr(l1),iy-irowrr(l1),iz-islirr(l1),l1)
     &		+lef(ix-icolrr(l2),iy-irowrr(l2),iz-islirr(l2),l2)
		endif
		   enddo
		   enddo
		   enddo
777	continue
         enddo
	enddo
	endif
c
	rt=1.0+a*excl
	do  ll=1,nvol
	 rt=rt+rem(icolrr(ll),irowrr(ll),islirr(ll),ll)
	enddo
c
                if (rt .lt. rm)  then
                   rm   = rt
		   exclm=excl
		   mexl=nexl
		   do  ll=1,nvol
                   maxcol(ll) = icolrr(ll)
                   maxrow(ll) = irowrr(ll)
                   maxsli(ll) = islirr(ll)
		   enddo
                endif
	do  ll=1,nvol
	icolrr(ll)=icolrr(ll)+1
	if(icolrr(ll).le.ncrelend(ll))  then
	goto  801
	else
        icolrr(ll) = ncrelgo(ll)
	endif
	enddo
c
	do  ll=1,nvol
	irowrr(ll)=irowrr(ll)+1
	if(irowrr(ll).le.nrrelend(ll))  then
	goto  801
	else
        irowrr(ll) = nrrelgo(ll)
	endif
	enddo
c
	print  *,(islirr(ll),ll=1,nvol)
	do  ll=1,nvol
	islirr(ll)=islirr(ll)+1
	if(islirr(ll).le.nsrelend(ll))  then
	goto  801
	else
        islirr(ll) = nsrelgo(ll)
	endif
	enddo
c        enddo
c        enddo
c        enddo
c recover individual ccfs and fbdm
	fbdm=0.0
	do  ll=1,nvol
c
c  correlation with the texture
 	sy=0.0
	sqy=0.0
	sxy=0.0
c$doacross local(islil,irowl,icoll,islirp,irowrp,qt),
c$& reduction(sy,sqy,sxy)
	   do  islil =izull(ll),izulls(ll)
           islirp=maxsli(ll)+islil
	     do  irowl =iyull(ll),iyulls(ll)
             irowrp=maxrow(ll)+irowl
       	  	do  icoll = ixull(ll),ixulls(ll)
			qt  = rit(icoll + maxcol(ll),irowrp,islirp)
			sy=sy+qt
			sqy=sqy+qt*qt
			sxy=sxy+qt*lef(icoll,irowl,islil,ll)
                enddo
             enddo
           enddo


	rmm(ll) = (sxy-sx(ll)*sy/nnn(ll))/
     &		dsqrt(sx2(ll) * (sqy - sy*sy/nnn(ll)))
	fbdm=fbdm+
     &	(rem(maxcol(ll),maxrow(ll),maxsli(ll),ll)+rmm(ll)/nvol)/b
	enddo
c
c	do  ll=1,nvol
c	print  *,maxcol(ll),maxrow(ll),maxsli(ll),rmm(ll)
c	enddo
c	print  *,rm,exclm,fbdm
c
	end


