C++************************************************************************
C
C $$ CENT.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ CENT.FOR
C
         SUBROUTINE CENT(MAXMEM)
         INCLUDE 'CMBLOCK.INC'
         COMMON  Q(1)
         CHARACTER *81 FILNAM
         CHARACTER *1  NULL

         NULL=CHAR(0)
         DATA  LUN1/21/
CNO_SAVE
         CALL FILERD(FILNAM,NLETI,NULL,'INPUT',IRTFLG)
         IF (IRTFLG .EQ. -1) GOTO 5
         CALL OPENF(FILNAM,LUN1,NSAM,NROW,'O',NF,NSLICE)
         GOTO (130,110),NF
110      IF(IFORM.NE.1) GOTO 501
         K1=1
         K2=K1+NSAM*NROW
C
         DO    J=1,NROW
         CALL  REDLIN(LUN1,Q(K1+(J-1)*NSAM),NSAM,J)
	 ENDDO
         CLOSE(LUN1)
C
         CALL  CENT_D(Q(K1),NSAM,NROW,SNS,SNR)
         M=NSAM/2+1
         SNS=SNS-M
         M=NROW/2+1
         SNR=SNR-M
         NS=INT(SNS)
         NR=INT(SNR)
         WRITE(NOUT,2222)  NS,NR,SNS,SNR
2222     FORMAT(//'    Approximated center of gravity',/,
     &   '              x                y',/,
     &   '          ', i5,'            ',i5,/,
     &   '          ',f8.3,'         ',f8.3,/)
         IF(NSEL(1).NE.0)  PARAM(NSEL(1))=NS
         IF(NSEL(2).NE.0)  PARAM(NSEL(2))=NR
         IF(NSEL(3).NE.0)  PARAM(NSEL(3))=SNS
         IF(NSEL(4).NE.0)  PARAM(NSEL(4))=SNR
5        RETURN
501      IF(IFORM.NE.3)  GOTO  145
         K1=1
         K2=K1+NSAM
         K3=K2+NSAM
         K4=K3+NROW
         K5=K4+NSLICE
C
         CALL  CENT_3
     &   (LUN1,Q(K1),Q(K2),Q(K3),Q(K4),NSAM,NROW,NSLICE,SNS,SNR,SNC)
         CLOSE(LUN1)
         M=NSAM/2+1
         SNS=SNS-M
         M=NROW/2+1
         SNR=SNR-M
         M=NSLICE/2+1
         SNC=SNC-M
         NS=INT(SNS)
         NR=INT(SNR)
         NC=INT(SNC)
         WRITE(NOUT,3333)  NS,NR,NC,SNS,SNR,SNC
3333     FORMAT(//'    Approximated center of gravity',/,
     &   '              x                y                z',/,
     &   '          ', i5,'            ',i5,'            ',i5,/,
     &   '          ',f8.3,'         ',f8.3,'         ',f8.3,/)
         IF(NSEL(1).NE.0)  PARAM(NSEL(1))=NS
         IF(NSEL(2).NE.0)  PARAM(NSEL(2))=NR
         IF(NSEL(3).NE.0)  PARAM(NSEL(3))=NC
         IF(NSEL(4).NE.0)  PARAM(NSEL(4))=SNS
         IF(NSEL(5).NE.0)  PARAM(NSEL(5))=SNR
         IF(NSEL(6).NE.0)  PARAM(NSEL(6))=SNC
         RETURN
130      CALL ERRT(4,'CENT  ',NE)
         GOTO 505
145      CALL ERRT(2,'CENT  ',NE)
505      CLOSE(LUN1)
         END
