C++************************************************************************
C
C $$ CENT_D.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ CENT_D.FOR
C
         SUBROUTINE  CENT_D(X,NSAM,NROW,SNS,SNR)
         DIMENSION  X(NSAM,NROW)
CNO_SAVE
C
         C=0.0
         S=0.0
         P=8*DATAN(1.0D0)/NSAM
c$doacross local(i,t,j),reduction(c,s)
         DO    I=1,NSAM
         T=0.0
         DO    J=1,NROW
         T=T+X(I,J)
	 ENDDO
         C=C+COS(P*(I-1))*T
         S=S+SIN(P*(I-1))*T
	 ENDDO
         FI=ATAN2(S,C)
         IF(FI.LT.0.0)  FI=FI+8*DATAN(1.0D0)
         SNS=FI/P+1.0
C
         C=0.0
         S=0.0
         P=8*DATAN(1.0D0)/NROW
c$doacross local(i,t,j),reduction(c,s)
         DO    J=1,NROW
         T=0.0
         DO    I=1,NSAM
         T=T+X(I,J)
	 ENDDO
         C=C+COS(P*(J-1))*T
         S=S+SIN(P*(J-1))*T
	 ENDDO
C
         FI=ATAN2(S,C)
         IF(FI.LT.0.0)  FI=FI+8*DATAN(1.0D0)
         SNR=FI/P+1.0
         END
