C++*************************************************************************
C
C    CHANGEVAL.F  
C                
C **************************************************************************
C *  COPYRIGHT (C)1985 & 1995, WADSWORTH CENTER FOR LABORATORIES AND       *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    CHANGEVAL
C
C    PURPOSE:  TO CHANGE A SPECIFIC VALUE IN AN IMAGE FILE
C
C    CALLED BY:   UTIL2
C
C--********************************************************************

	SUBROUTINE CHANGEVAL(LUN1,LUN2,NSAM,NROW,NSLICE)

	COMMON BUF(1)

	INCLUDE 'CMBLOCK.INC'

	REAL        NEWVAL
CNO_SAVE
	CALL RDPRM2S(OLDVAL,NEWVAL,NLOOP,ILOOP,
     &     'OLD AND NEW VALUES',IRTFLG)
	IF (IRTFLG .LT. 0)  RETURN

        IRECT = 0
        DO J=1, NSLICE    
	   DO I=1,NROW
              IRECT = IRECT + 1
	      CALL REDLIN(LUN1,BUF,NSAM,IRECT)
	      DO K=1,NSAM
	         IF (BUF(K) .EQ. OLDVAL)  BUF(K) = NEWVAL
              ENDDO
              CALL WRTLIN(LUN2,BUF,NSAM,IRECT)
           ENDDO
        ENDDO

        CALL SETPRM(LUN2,NSAM,NROW,0.,0.,0.,'U')
	END
