
C++*************************************************************************
C
C $$ CHKINPQ.FOR                         
C                        MODIFIED FOR CHAR. FROM CHKINP.FOR AUG 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  $$ CHKINPQ(SMENU,WHICH,IOUT)
C
C     PARAMETERS:    SMENU         MENU TO BE SEARCHED
C                    WHICH         STRING BEING SEARCHED FOR
C                    IOUT          LOCATION OF STRING IN MENU (RETURNED)
C
C--*******************************************************************

       SUBROUTINE CHKINPQ(SMENU,WHICH,IOUT)

       CHARACTER *(*) SMENU,WHICH
       CHARACTER *80 TEMP

       IOUT   = 1
       LENMEN = LEN(SMENU)
       LENDOL = INDEX(SMENU,'$')
       IF (LENDOL .GT. 0 .AND. LENDOL .LE. LENMEN) LENMEN = LENDOL - 1
       DO  LENUSE = LENMEN,1,-1
          IF (SMENU(LENUSE:LENUSE) .NE. ' ' ) GOTO 5
       ENDDO

C      MENU IS ALL BLANK
       RETURN

5      IF (WHICH .NE. ' ') THEN
C         SEARCH STRING IS NOT BLANK, FIND USED LENGTH OF SEARCH STRING 
          LENS   = LEN(WHICH)
          IBLANK = INDEX(WHICH,' ')
          IF (IBLANK .EQ. 0) IBLANK = LENS + 1
          ICOMMA = INDEX(WHICH,',')
          IF (ICOMMA .EQ. 0) ICOMMA = LENS + 1
          LENGTH = MIN(IBLANK-1,ICOMMA-1,LENS)

C         FIND LOCATION OF SEARCH STRING IN MENU
          IGO  = 1
          IOUT = 1

8         IOUT = IOUT + 1

C         FIND RANGE OF NEXT MENU CHOICE
          IEND = INDEX(SMENU(IGO:),',')
          IF (IEND .EQ. 0) THEN
C            LAST MENU CHOICE IN THE LIST
             IEND = LENMEN
          ELSE
             IEND = IGO + IEND - 2
          ENDIF

C         DO UPPER CASE COMPARISON TO MENU...
          TEMP(1:LENGTH) = WHICH(1:LENGTH)
          CALL SSUPCAS(TEMP)
          IF (SMENU(IGO:IEND) .EQ. WHICH(1:LENGTH)) THEN
C            HAVE FOUND WHICH IN SMENU
             RETURN
          ELSE
C            THIS MENU CHOICE IS NOT WHICH, TRY NEXT MENU CHOICE, IF ANY
             IGO = IEND + 2
             IF (IGO .LE. LENUSE) GOTO 8
          ENDIF
       ENDIF

C      WHICH NOT FOUND IN SMENU
       IOUT = 1
       RETURN
       END

