
	FUNCTION COOROT(ICOL,IROW,ANGLE,NEULER)

C	COOROT RETURNS THE COEFFICIENTS OF A 3 BY 3 EULERIAN
C	ROTATION MATRIX. 
C	  NEULER -- 1,2, OR 3 -- DEFINES WHICH EULERIAN ANGLE
C	  ANGLE  -- EULERIAN ANGLE IN RAD
C	  ICOL, IROW -- COLUMN AND ROW INDICES OF THE MATRIX


        COOROT=0.
	IF (NEULER .NE. 0) GOTO 50
	COSA=COS(ANGLE)
	SINA=SIN(ANGLE)
	RETURN

50	GOTO (100,200,100),NEULER

100	NUNITY=3
	NSINUS=3
	GOTO 250

200	NUNITY=2
	NSINUS=4

250	IF(ICOL.NE.IROW)GOTO 300
	COOROT=1
	IF(ICOL.NE.NUNITY)COOROT=COSA
	RETURN

300	IF(IROW+ICOL.NE.NSINUS)RETURN
	COOROT=SINA
	IF(ICOL.EQ.1)COOROT=-COOROT

	RETURN
	END
