
C ++********************************************************************
C
C	MODIFIED FOR F90 -- liy 	/10/22/97
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1995, WADSWORTH CENTER FOR LABORATORIES AND          *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C   NOTE: THIS IS "CP FROM EM"  I CAN NOT FIND ANY MANUAL CHAPTER FOR
C         THIS OPERATION al Jan 98
C                                                                 *
C***********************************************************************

	SUBROUTINE COPYEM(LUNJP,LUN)

        INCLUDE 'CMBLOCK.INC' 

	COMMON         BUF(1)

        COMMON /COMMUN/FILNAM,FILIN

	INTEGER*1     BZ(512)
        INTEGER       IHEAD(128)
        REAL          FLINE(128)
        CHARACTER *81 FILNAM,FILIN
        CHARACTER     NULL
        EQUIVALENCE   (IHEAD,BZ)
CNO_SAVE

        NULL   = CHAR(0)
        MRECL  = 128
        IRTFLG = 9
	CALL FILERD(FILIN,NLET,NULL,'INPUT',IRTFLG)
	IF (IRTFLG .NE. 0)RETURN

c       OPEN (UNIT=LUNJP,FILE=FILNAM,FORM='SYSTEM',
#ifdef SP_SUN4
        OPEN (UNIT=LUNJP,FILE=FILNAM,
     $        STATUS='OLD',
     $        ERR=701,IOSTAT=NIO)
#else
        OPEN (UNIT=LUNJP,FILE=FILNAM,
C     $        STATUS='OLD',CARRIAGECONTROL='NONE',READONLY,
     $        STATUS='OLD', ERR=701,IOSTAT=NIO)
#endif

C       READ HEADER
        READ (LUNJP,ERR=703,IOSTAT=NIO,END=705) BZ
        NSAM=IHEAD(2)
        NROW=IHEAD(3)
        NSLICE=IHEAD(4)
        NPXY=NSAM*NROW
        
        IF(NSLICE.LE.1) THEN
           IFORM=1
        ELSE
           IFORM=3
        ENDIF

        MAXIM = 0
        CALL OPFIL(.TRUE.,FILNAM,LUN,'U',NSAM,NROW,NSLICE,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 999

        ICOUNT=1
        DO J=1,NSLICE
           NPMAX=NPXY
           NPIX=MIN(MRECL,NPMAX)
           DO WHILE (NPIX.GT.0) 
              READ (LUNJP,ERR=703,IOSTAT=NIO,END=705) FLINE
              DO I=1,NPIX
                 BUF(ICOUNT)=FLINE(I)
                 ICOUNT=ICOUNT+1
              END DO
              NPMAX=NPMAX-NPIX
              NPIX=MIN(MRECL,NPMAX)
           ENDDO
        ENDDO
        ICOUNT=1
	DO I=1,NSLICE
           DO K=1,NROW
              CALL WRTLIN(LUN,BUF,NSAM,I)
              ICOUNT=ICOUNT+NSAM
	   ENDDO
	ENDDO

701     WRITE(NOUT,*) '** OPEN ERROR ***'
        GOTO 999

703     WRITE(NOUT,*) '** READ ERROR ***'
        GOTO 999

705     WRITE(NOUT,*) '** END OF FILE ***'

999     CLOSE (LUNJP)
        CLOSE (LUN)

	RETURN
	END

