C++************************************************************************
C
C $$ CRCSE1.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ CRCSE1.FOR
C
         SUBROUTINE CRCSE1(LUN,BUF,NSAM,NROW,SEC,SNO,IR)
         DIMENSION BUF(NSAM),SEC(IR),SNO(IR)
         DO    I=1,IR
         SEC(I)=0.0
         SNO(I)=0.0
	 ENDDO
C
         DO  1  J=1,NROW
         KJ=J-NROW/2-1
         IF(IABS(KJ).GT.IR-1)  GOTO  1
         CALL REDLIN(LUN,BUF,NSAM,J)
         DO  2  I=1,NSAM
         KI=I-NSAM/2-1
         R=SQRT(FLOAT(KJ*KJ)+FLOAT(KI*KI))+1.0
         L=R
         IF(L.GT.IR-1)  GOTO  2
         XD=R-L
         SEC(L)=SEC(L)+BUF(I)*(1.0-XD)
         SEC(L+1)=SEC(L+1)+BUF(I)*XD
         SNO(L)=SNO(L)+1.0-XD
         SNO(L+1)=SNO(L+1)+XD
2        CONTINUE
1        CONTINUE
C
         DO    I=1,IR
         SEC(I)=SEC(I)/AMAX1(1.0,SNO(I))
	 ENDDO
         END
