
C ++********************************************************************
C
C DENREF.FOR  3/5/81                             LONG FILNAMES JAN 89 al
C 
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)    , WADSWORTH CENTER FOR LABORATORIES AND          *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C
C  PURPOSE:  CREATE DENSITY REFERENCE ELEMENTS IN 3-D VOLUME
C
C **********************************************************************

	SUBROUTINE DENREF(LUN,NSAM,NROW,NSLICE)

CNO_SAVE
	INCLUDE 'CMBLOCK.INC'

	COMMON BUF(1)

	IF (IMAMI .NE. 1) CALL NORM3(LUN,NSAM,NROW,NSLICE,FMAX,FMIN,AV)

	DO  I=1,NSAM
          BUF(I) = FMAX
        ENDDO
	CALL WRTLIN(LUN,BUF,NSAM,1)

	DO  I = 1,NSAM
           BUF(I)=FMIN
        ENDDO
	CALL WRTLIN(LUN,BUF,NSAM,NROW)

	DO  I=1,NROW
	   CALL REDLIN(LUN,BUF,NSAM,I)
	   BUF(1)    = FMAX
	   BUF(NSAM) = FMIN
	   CALL WRTLIN(LUN,BUF,NSAM,I)
        ENDDO

        CLOSE (LUN)

	RETURN
	END
