
C++************************************************************************
C
C    DIST3                                   LONG FILE NAMES FEB 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1993, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C   DIST3
C
C   PURPOSE:  FINDS HISTOGRAM OF PEAK DISTANCES FROM PEAK DOC FILE
C
C   PARAMETERS: 
C
C   NOTE:        CAN NOT FIND ANY MANUAL CHAPTER FOR THIS UNDOCUMENTED
C                OPERATION (' PK 3S') al Jan 97
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

	SUBROUTINE DIST3(LUN)

	INCLUDE 'CMBLOCK.INC' 

        CHARACTER *81 DOCNAM
        COMMON /COMMUN/ DOCNAM

	REAL          X, Y, Z, P(5)
	INTEGER       NDIST, NO
        COMMON        DUM(2000),X(500),Y(500),Z(400),NDIST(104),NO(504)
        CHARACTER * 1 NULL,CDUM
	
        NULL = CHAR(0)

	CALL FILERD(DOCNAM,NLET,NULL,'DOCUMENT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
	
        N    = 500
	ILOW = 0
	IHI  = 500
        CALL RDPRAI(NO,500,N,ILOW,IHI,
     $    '.ENTER PEAK NUMBERS (I.E., 2-12,15-54,60):',CDUM,IRTFLG)	
     
	CALL RDPRMI(NBIN,NCOL,NLOOP,ILOOP,
     $     'NUMBER OF BINS, STARTING COL.')

	CALL RDPRM(D,NLOOP,ILOOP,'DISTANCE INCREMENT')
	IF (NBIN .GT. 100) NBIN=100

	NOPEN=0
C       MARKS FILE AS NOT OPEN FOR UNSAV
	DO  I=1,N
           CALL UNSAV(DOCNAM,NOPEN,LUN,NO(I),P,NCOL+3-1,LERR,1)
C          1 = SEQUENTIAL READ !
           X(I) = P(NCOL)
           Y(I) = P(NCOL+1)
           Z(I) = P(NCOL+2)
C          WRITE(NDAT,21)I,X(I),Y(I),Z(I)
C21        FORMAT(1X,I3,3F8.1)
        ENDDO

C       CLEAR HISTOGRAM
	DO I=1,NBIN
           NDIST(I)=0
        ENDDO

        DO 150 I=1,N-1
           X0=X(I)
           Y0=Y(I)
           Z0=Z(I)
           DO 100 K=I+1,N
             DIST=SQRT((X0-X(K))**2+(Y0-Y(K))**2+(Z0-Z(K))**2)
C            WRITE(NOUT,51)I,K,DIST
C51          FORMAT(1X,2I5,F8.1)
             IBIN=DIST/D+1
             IF(IBIN.GT.NBIN)GOTO 100
             NDIST(IBIN)=NDIST(IBIN)+1
100        CONTINUE
150     CONTINUE
C
	WRITE(NDAT,199)N,DOCNAM(1:NLET)
199	FORMAT('1 ** PK 3S -- DISTANCE STATISTICS BASED ON ',I5,
     &         ' PEAKS IN DOCUMENT FILE ',A)

	WRITE(NDAT,1199)
1199	FORMAT('0   BIN    DISTANCE    ABS.FREQUENCY  REL.FREQUENCY'/)
	SC = 100. / FLOAT(N)

	DO  IBIN=1,NBIN
           WRITE(NDAT,201)IBIN,(IBIN-1)*D,NDIST(IBIN),
     &     FLOAT(NDIST(IBIN))*SC
201        FORMAT(1X,I6,F12.1,I20,F20.1)
        ENDDO

	RETURN
	END
 
