C++************************************************************************
C
C $$ DIST_P.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ DIST_P.FOR
C
         SUBROUTINE  DIST_P(D,MDIM,PK,IDK,NKLA,W,INUM,COO,COB,
     &   MAXFA,NFAC)
         DIMENSION  D(MDIM),PK(NKLA)
         DIMENSION  IDK(NKLA)
C NFAC   - number of parameters in one record
C MAXFA - actual number of parameters used
         DIMENSION  W(MAXFA),INUM(MAXFA),COO(NFAC),COB(NFAC)
         DOUBLE PRECISION  Q
C
         MONO(K1,K2)=MIN0(K1,K2)+((MAX0(K1,K2)-1)*(MAX0(K1,K2)-2)/2)
C
CNO_SAVE
         DO    I=1,NKLA
         PK(I) = 1.0
	 ENDDO
         DO    I=1,MDIM
         D(I) = 0.0
	 ENDDO
C
         REWIND 111
         READ(111)
         DO    I=1,NKLA
         READ(111)  (COB(J),J=1,NFAC),RWGT,DIO,IDK(I)
	 ENDDO
C
         DO    K1=1,NKLA-1
         KK=NKLA-K1+1
         REWIND 111
         READ(111)
         DO    K2=1,NKLA-K1
         READ(111)  (COO(J),J=1,NFAC)
         Q = 0.0D0
         DO  L=1,MAXFA
         LL = INUM(L)
         Q = Q + (DBLE(W(L)) * (COO(LL) - COB(LL)))**2
	 ENDDO
         M = MONO(K2,KK)
         D(M) = Q
	 ENDDO
         DO   J=1,NFAC
         COB(J)=COO(J)
	 ENDDO
	 ENDDO
         CLOSE(111)
         END
