
C ++********************************************************************
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)    , WADSWORTH CENTER FOR LABORATORIES AND          *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************

      SUBROUTINE DISTLST(DH,DL,NIM,NDAT)

C     UPDATED TO I4 6/88 M.R.

      INTEGER   NIM,NDAT
      DIMENSION DH(1),DL(1)

      IF (NIM.GT.10) RETURN
      I4=1
      IG=I4*NIM*(NIM-1)/2
      IOFF=0
      IOF2=0
      DO  I=1,NIM-1
         IND1=(I-1)*NIM-IOFF+1
         IND2=IND1+NIM-IOF2-2
         IOFF=IOFF+I
         IOF2=IOF2+1
         NUM=IND2-IND1+1
         WRITE(NDAT,10)(DH(K),K=IND1,IND2)
10       FORMAT(' DH:',10E12.4)
         WRITE(NDAT,11)(DL(K),K=IND1,IND2)
11       FORMAT(' DL:',10E12.4)
      ENDDO

      WRITE(NDAT,12)(DH(K),K=1,IG)
12    FORMAT(' 2.DH:',10E12.4)

      WRITE (NDAT,13)(DL(K),K=1,IG)
13    FORMAT(' 3.DL:',10E12.4)

      RETURN
      END
