C++*************************************************************************
C
C DIVCR3.FOR                        
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C  Divide complex by real (+const)
C
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************
C
        SUBROUTINE DIVCR3(A1,OUT,H2,S,NN2,NROW,NSLICE)
        COMPLEX  A1(NN2,NROW,NSLICE),OUT(NN2,NROW,NSLICE)
        COMPLEX  H2(NN2,NROW,NSLICE)
CNO_SAVE
C
        DO    K=1,NSLICE
        DO    J=1,NROW
	DO    I=1,NN2
	OUT(I,J,K)=A1(I,J,K)/(REAL(H2(I,J,K))+S)
	ENDDO
	ENDDO
	ENDDO
	END
