
C++*************************************************************************
C
C $$ ERRI2.FOR-- CREATED JULY 15 1987
C
C **************************************************************************
C *  AUTHOR:  ARDEAN LEITH
C *  PART OF SPIDER - MODULAR IMAGE PROCESSING SYSTEM.                     *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ ERRI2(NUM1,NUM2,NVAL,ILOW1,IHI1,ILOW2,IHI2)
C
C    PARAMETERS:    NVAL         NUMBER OF VALUES TO BE CHECKED
C                   NUM1         FIRST INTEGER
C                   NUM2         SECOND INTEGER
C                   ILOW1        LOWEST VALUE FOR  NUM1
C                   IHI1         HIGHEST VALUE FOR NUM1
C                   ILOW2        LOWEST VALUE FOR  NUM2
C                   IHI2         HIGHEST VALUE FOR NUM2
C
C    CALLED BY:     LEXI
C
C--*******************************************************************

       LOGICAL FUNCTION  ERRI2(NUM1,NUM2,NVAL,ILOW1,IHI1,ILOW2,IHI2)

       COMMON /UNITS/ LUNDOC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
        
        ERRI2 = .FALSE.
        IF (NUM1 .LT. ILOW1 .OR. NUM1 .GT. IHI1) THEN
            WRITE(NOUT,92) ILOW1,IHI1
   92       FORMAT(' ERROR, FIRST INPUT RANGE: (',I6,'....',I6,')',/)
            ERRI2 = .TRUE.
        ENDIF
        IF (NVAL .GE. 2 .AND. (NUM2 .LT. ILOW2 .OR. NUM2 .GT. IHI2)) 
     &      THEN
            WRITE(NOUT,97) ILOW2,IHI2
   97       FORMAT(' ERROR, SECOND INPUT RANGE: (',I6,'...',I6,')',/)
            ERRI2 = .TRUE.
        ENDIF

        RETURN
        END
