	SUBROUTINE  F3OD_P(LUN,A,B,H1,H2,NDIM,NROW,NSLICE,INV)
	DIMENSION  A(NDIM,NROW),B(NDIM,NSLICE),H1(NROW,NSLICE),H2(NROW,NSLICE)
CNO_SAVE
C
C  MATRICES A AND B CAN BE THE SAME
C
	MDIM=LOG2(NDIM)
	MROW=LOG2(NROW)
	MSLICE=LOG2(NSLICE)
	IF(INV.GT.0)  THEN
C 
C  FORWARD
C
C  SLICES
C
	DO   I=1,NSLICE
	    DO   I1=1,NROW
	    K=(I-1)*NROW+I1
 	    CALL  REDLIN(LUN,A(1,I1),NDIM,K)
	    ENDDO
	    CALL  FFTR2_P(A,NDIM,NROW,1)
	    DO    I1=1,NROW
	    K=(I-1)*NROW+I1
 	    CALL  WRTLIN(LUN,A(1,I1),NDIM,K)
	    ENDDO
c$doacross  local(i1)
	    DO    I1=1,NROW
	    H1(I1,I)=A(1,I1)
 	    H2(I1,I)=A(2,I1)
	    ENDDO
 	ENDDO
C
C  ALONG Z-AXIS
C
c$doacross  local(j)
	DO    J=3,NROW,2
	CALL  FFTC_Q(H1(J,1),H1(J+1,1),MSLICE,NROW)
 	CALL  FFTC_Q(H2(J,1),H2(J+1,1),MSLICE,NROW)
	ENDDO
	CALL  FFTRS_Q(H1,MSLICE,NROW)	
	CALL  FFTRS_Q(H1(2,1),MSLICE,NROW)	
	CALL  FFTRS_Q(H2,MSLICE,NROW)	
	CALL  FFTRS_Q(H2(2,1),MSLICE,NROW)	
C
	DO    I=1,NROW
	    DO    I1=1,NSLICE
	    K=(I1-1)*NROW+I
 	    CALL  REDLIN(LUN,B(1,I1),NDIM,K)
	    ENDDO
c$doacross  local(i1)
	    DO    I1=3,NDIM,2
 	    CALL  FFTC_Q(B(I1,1),B(I1+1,1),MSLICE,NROW)
	    ENDDO
c$doacross  local(i1)
	    DO    I1=1,NSLICE
	    B(1,I1)=H1(I,I1)
 	    B(2,I1)=H2(I,I1)
	    ENDDO
	    DO    I1=1,NSLICE
	    K=(I1-1)*NROW+I
 	    CALL  WRTLIN(LUN,B(1,I1),NDIM,K)
	    ENDDO
	ENDDO
C END
	ELSE
C
C  INVERSE
C
C  ALONG  Z-AXIS
C
	DO    I=1,NROW
	    DO    I1=1,NSLICE
	    K=(I1-1)*NROW+I
 	    CALL  REDLIN(LUN,B(1,I1),NDIM,K)
	    ENDDO
c$doacross  local(i1)
	    DO    I1=3,NDIM,2
 	    CALL  FFTC_Q(B(I1,1),B(I1+1,1),MSLICE,-NROW)
	    ENDDO
c$doacross  local(i1)
	    DO    I1=1,NSLICE
	    H1(I,I1)=B(1,I1)
 	    H2(I,I1)=B(2,I1)
	    ENDDO
	    DO    I1=1,NSLICE
	    K=(I1-1)*NROW+I
 	    CALL  WRTLIN(LUN,B(1,I1),NDIM,K)
	    ENDDO
	ENDDO
c$doacross  local(j)
	DO   J=3,NROW,2
	CALL  FFTC_Q(H1(J,1),H1(J+1,1),MSLICE,-NROW)
 	CALL  FFTC_Q(H2(J,1),H2(J+1,1),MSLICE,-NROW)
	ENDDO
	CALL  FFTRS_Q(H1,-MSLICE,NROW)
	CALL  FFTRS_Q(H1(2,1),-MSLICE,NROW)	
	CALL  FFTRS_Q(H2,-MSLICE,NROW)	
	CALL  FFTRS_Q(H2(2,1),-MSLICE,NROW)	
C
C  SLICES
C
	DO    I=1,NSLICE
	    DO    I1=1,NROW
	    K=(I-1)*NROW+I1
 	    CALL  REDLIN(LUN,A(1,I1),NDIM,K)
	    ENDDO
c$doacross  local(i1)
	    DO    I1=1,NROW
	    A(1,I1)=H1(I1,I)
 	    A(2,I1)=H2(I1,I)
	    ENDDO
	    CALL  FFTR2_P(A,NDIM,NROW,-1)
	    DO    I1=1,NROW
	    K=(I-1)*NROW+I1
 	    CALL  WRTLIN(LUN,A(1,I1),NDIM,K)
	    ENDDO
	ENDDO
C
	ENDIF
	END
