C  B-spline interpolation introduced 09/21/89
C  Restriction of the interpolation field 10/13/89
C  Subtraction of one image 03/27/91   -  FALB
C  Quadratic interpolation used as an option. 06/24/91
C  Scratch file on the disk   08/01/91
c
c	SUBROUTINE FALB(MAXMEM)
c   	SUBROUTINE  FALB_P(BUF,ILIST,NSAM,NROW,LSAM,LROW,NIMA,
c	FUNCTION  ANG(RKK,MODE)
c	DOUBLE PRECISION FUNCTION  ENER(CIRC,LCIRC,NRING,NUMR,MODE)
c	SUBROUTINE  ALPRBS(NUMR,NRING,LCIRC,MODE)
c 	SUBROUTINE  ALRQ
c	SUBROUTINE  UPDTC(CIRC1,CIRC2,LCIRC,NRING,NUMR,TOT,MAXRIN,IS)
c	SUBROUTINE  OUTRNG
c	SUBROUTINE  CROSRNG
c	SUBROUTINE  FOURING(CIRC,LCIRC,NUMR,NRING,E,MODE)
c	FUNCTION  LOG2_P(N)
c	SUBROUTINE PRB1D(B,NPOINT,POS)
c 	SUBROUTINE  FFTR_D(X,NV)   
c	SUBROUTINE  FFTC_D(BR,BI,LN,KS)
c
	SUBROUTINE FALB(MAXMEM)
	PARAMETER  (NILMAX=10000) 
        INCLUDE 'CMBLOCK.INC'   
        COMMON  DUMMY(80),BUF(1024),ILIST(NILMAX),KAF(1)
        EQUIVALENCE  (KAF,NUMR) 
        DIMENSION Q(1)
        POINTER   (IPQ,Q) 
        LOGICAL   RUNTIME
 
	 
	COMMON  /F_SPEC/  FINPAT,NLET,FINPIC
	CHARACTER*80  FINPIC
	CHARACTER*80  FINPAT
	INTEGER*2  MAXRIN
	INTEGER*2  NUMR(3,480)
	CHARACTER*1  MODE,NULL,ASK
	DATA  INPIC/77/
CNO_SAVE

 
C       ASK FOR DATA FILE
        NULL=CHAR(0)
	NMAX=NILMAX
 	CALL  FILSEQP(FINPAT,NLET,ILIST,NMAX,NIMA,
     &	  'Enter template for 2-D image name',IRTFLG)
     
C       NIMA - total number of images
 	CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(1),INTFLG)
 	CALL  OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
 	IF(NF.NE.2)  THEN
           CALL ERRT(4,'AP RA ',NE)
	   RETURN
	ENDIF
	CLOSE(INPIC)
 
	CALL  RDPRMI(MR,NR,NLOOP,ILOOP,'FIRST AND LAST RING')
	CALL  RDPRMI(ISKIP,NDUMP,NLOOP,ILOOP,'SKIP')
	ISKIP=MAX0(1,ISKIP)
7981	NA=1
        CALL  RDPRMC(ASK,NA,.TRUE.,'(F)ULL OR (H)ALF CIRCLE',NULL,IRT)
	IF(ASK.EQ.'F')  THEN
	MODE='F'
	ELSEIF(ASK.EQ.'H')  THEN
	MODE='H'
	ELSE
	RETURN
	ENDIF
C	CALL  RDPRMI(JACUP,NDUMP,NLOOP,ILOOP,
C     &		'Precision of peak location (0..100)')
C	JACUP=MAX0(0,MIN0(100,JACUP))
        JACUP=0
C
	NRING=0
	DO    I=MR,NR,ISKIP
	NRING=NRING+1
	NUMR(1,NRING)=I           
	ENDDO
 
C       Calculation of actual dimension of an image to be interpolated
C       2*(# of rings)+(0'th element)+2*(margin of 1)
	NRA=MIN0(((NSAM-1)/2)*2+1,((NROW-1)/2)*2+1,2*NR+3)
	LSAM=NSAM
	LROW=NROW
	NSAM=NRA
	NROW=NRA
	CALL  ALPRBS(NUMR,NRING,LCIRC,MODE)
C
C   memory division
C	NUMR	       1
C	CIRC	       2
C       EC             7  ! Double precision !
C A: X     B: ROT      3
C    BUFIN    CIROLD   4
C    WORK     CIRNEW   5
C             CIRTMP   0
C             TEMP     6
C             DIST     7
C
	MAXRIN=NUMR(3,NRING)
        K1=-1
        K2=1
	K7=IPALIGN64(K2+LCIRC*NIMA)
	K3A=IPALIGN64(K7+NIMA*2)
	K41A=IPALIGN64(K3A+NSAM*NROW)
	K4A=IPALIGN64(K41A+LSAM)
	K5A=K4A
	K3B=K3A
	K4B=IPALIGN64(K3B+NIMA)
	K5B=IPALIGN64(K4B+LCIRC)
	K0B=IPALIGN64(K5B+LCIRC)
	K6B=IPALIGN64(K0B+LCIRC)
	K7B=IPALIGN64(K6B+MAXRIN*4)
	K8B=IPALIGN64(K7B+NIMA)
	MEMTOT=MAX0(K5A,K8B)
	
        CALL CHKMEM(MEMTOT, KAF, MAXMEM-(NILMAX+1200), 
     &	            RUNTIME,IPQ,IRTFLG)
	IF(IRTFLG.EQ.0) THEN
           IF (.NOT.RUNTIME)  THEN  
	   
c	      not enougth memory can be allocated, check common block
              K1=1
              K2=IPALIGN64(K1+(3*NRING+3)/2)
	      K7=IPALIGN64(K2+LCIRC*NIMA)
	      K3A=IPALIGN64(K7+NIMA*2)
	      K41A=IPALIGN64(K3A+NSAM*NROW)
	      K4A=IPALIGN64(K41A+LSAM)
	      K5A=K4A
	      K3B=K3A
	      K4B=IPALIGN64(K3B+NIMA)
	      K5B=IPALIGN64(K4B+LCIRC)
	      K0B=IPALIGN64(K5B+LCIRC)
	      K6B=IPALIGN64(K0B+LCIRC)
	      K7B=IPALIGN64(K6B+MAXRIN*4)
	      K8B=IPALIGN64(K7B+NIMA)
	      MEMTOT=MAX0(K5A,K8B)
              CALL CHKMEM(MEMTOT, KAF, MAXMEM-(NILMAX+1200), 
     &	            RUNTIME,IPQ,IRTFLG)
	      IF(IRTFLG.NE.0) THEN
	         WRITE(NOUT,*)  '  Sorry, not enough memory !'
	      ENDIF
	   ELSE
	      WRITE(NOUT,*)  '  Sorry, not enough memory !'
	   ENDIF
 
           WRITE (NOUT,2500)  MAXMEM , MEMTOT
    	   CALL  FALB_P(BUF,ILIST,NSAM,NROW,LSAM,LROW,NIMA,
     &	                NRING,LCIRC,MAXRIN,JACUP,NUMR,
     &	                Q(K2),Q(K3A),Q(K4A),Q(K41A),Q(K3B),
     &	                Q(K4B),Q(K5B),Q(K0B),
     &	                Q(K6B),Q(K7),Q(K7B),MODE,NOUT)
           WRITE (NOUT,2600)
	
           IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'FALB',IRTFLG)
	ELSE
	    WRITE(NOUT,*)  '  Sorry, not enough memory !'
	ENDIF
	
 2500   FORMAT (/,'  MEMORY RESERVATION: YOU HAVE',              
     #       ' RESERVED ',I8,',  YOU NEED  ',I8 / )
 2600   FORMAT (/ ' ',80('-')//' ',' Rotational alignment,  ',
     #      'end of computation',//' ',80('-')/)
        END
