	SUBROUTINE  FFTR2_Q(A,NDIM,NROW,INV)
C
C  2-D  FFT OF THE REAL A MATRIX
C       COMPLEX FORMAT - FULL HALF OF COMPLEX MATRIX
C       COMPLEX A((NDIM+2)/2,NROW) 
C
C  INV<0 - INVERSE
C
	DIMENSION  A(NDIM+2,NROW)
CNO_SAVE
C
	MDIM=LOG2(NDIM)
	MROW=LOG2(NROW)
        IF(INV.GT.0)  THEN
C  ALONG COLUMNS
C$doacross  local(i)
	DO    I=1,NROW
	CALL  FFTR_Q(A(1,I),MDIM)
	A(NDIM+1,I)=A(2,I)
	A(2,I)=0.0
	A(NDIM+2,I)=0.0
	ENDDO
C
C  ALONG ROWS
	if(nrow.eq.1)  return
C$doacross  local(i)
	DO    I=1,NDIM+2,2
	CALL  FFTC_Q(A(I,1),A(I+1,1),MROW,NDIM+2)
	ENDDO
        ELSE
C
C  NOW - INVERSE!!!!
C  ALONG ROWS
	if(nrow.gt.1)  then
C$doacross  local(i)
	DO    I=1,NDIM+2,2
	CALL  FFTC_Q(A(I,1),A(I+1,1),MROW,-NDIM-2)
	ENDDO
	endif
C
C  ALONG COLUMNS
C$doacross  local(i)
	DO    I=1,NROW
	A(2,I)=A(NDIM+1,I)
 	CALL  FFTR_Q(A(1,I),-MDIM)
	ENDDO
	ENDIF
	END
