C++*************************************************************************
C
C $$ FILTPLOT.FOR                         
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  $$ FILTPLOT(MAXMEM)
C
C  PARAMETERS:     MAXMEM      MAXIMUM MEMORY IN UNLABELED COMMON
C
C--*******************************************************************


	SUBROUTINE FILTPLOT(MAXMEM)
        INCLUDE 'CMBLOCK.INC'
        CHARACTER*1 ANS,NULL
CNO_SAVE
        NULL=CHAR(0)
        CALL RDPRMC(ANS,NC,.TRUE.,
     &  '(F)ERMI,(G)AUSS,(B)UTER,(R)EMEZ FILTER?(F/G/B/R)',NULL,IRT)
C
        IF (ANS .EQ. 'F') THEN
           CALL FERMP
        ELSEIF (ANS .EQ. 'G') THEN
           CALL GAUSSP
	ELSEIF (ANS.EQ.'B')THEN
	   CALL BUTERP
        ELSEIF (ANS .EQ. 'R')  THEN
           CALL  REMEZP(MAXMEM)
        ENDIF
        END
