C++************************************************************************
C
C $$ FINDMX_F.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ FINDMX_F.FOR
C
         SUBROUTINE  FINDMX_F(D,NSAM,NROW,NSI,CMX,SX,SY,JACUP)
         DIMENSION  D(NSAM,NROW),Z(-1:1,-1:1)
         LOGICAL  FOUND
CNO_SAVE
         FOUND=.FALSE.
         JC=NROW/2+1
         IC=NSAM/2+1
         CMX=D(IC,JC)
         SX=0.0
         SY=0.0
         DO    JT=-NSI,NSI
         J=JT+JC
         DO    IT=-NSI,NSI
         I=IT+IC
         IF(CMX.LT.D(I,J))  THEN
         CMX=D(I,J)
         IX=I
         IY=J
         FOUND=.TRUE.
         ENDIF
	 ENDDO	 
	 ENDDO
         IF(.NOT.FOUND)  RETURN
         SX=IX-IC
         SY=IY-JC
         IF(IY.LT.2.OR.IY.GT.NROW-1.OR.IX.LT.2.OR.IX.GT.NSAM-1) RETURN
         DO    J=-1,1
         DO    I=-1,1
         Z(I,J)=D(IX+I,IY+J)
	 ENDDO
	 ENDDO
         CALL  PARABL(Z,XSH,YSH,CMX)
         SX=SX+XSH
         SY=SY+YSH
         END
