	SUBROUTINE  FINT3(F1,F2,NDIM,NROW,NSLICE,NDIMN,NROWN,NSLICEN,WORK)
	DIMENSION  F1(NDIM,NROW,NSLICE),F2(NDIMN,NROWN,NSLICEN),WORK(*)
CNO_SAVE
C
C  Interpolation using Fourier zero padding
C  F1 and F2 can be the same
C
	INV=1
	CALL  F3MR(F1,NDIM,NROW,NSLICE,INV,WORK)
	IF (INV.EQ.0) THEN
	CALL ERRT(38,'FP ',NE)
	RETURN
	ENDIF
C  If you prefer exact values on an old grid replace:
C       SQ2=2.0
C       D2=4.0
C	D4=8.0
C  Warning! It will cause an error in total energy.
C
	SQ2=SQRT(2.0)
	D2=SQRT(4.0)
	D4=SQRT(8.0)
C
	FM=FLOAT(NDIMN*NROWN*NSLICEN)/FLOAT(NDIM*NROW*NSLICE)
	NS21=NSLICE/2+1
	NR21=NROW/2+1
	DO    K=NSLICE,1,-1
	DO    J=NROW,1,-1
	DO    I=NDIM,1,-1
	F2(I,J,K)=F1(I,J,K)*FM
	ENDDO
	ENDDO
	ENDDO
	DO    K=1,NSLICEN
	DO    J=NROW+1,NROWN
	DO    I=1,NDIMN
	F2(I,J,K)=0.0
	ENDDO
	ENDDO
	ENDDO
	DO    K=1,NSLICEN
	DO    J=1,NROW
	DO    I=NDIM+1,NDIMN
	F2(I,J,K)=0.0
	ENDDO
	ENDDO
	ENDDO
	DO    K=NSLICE+1,NSLICEN
	DO    J=1,NROW
	DO    I=1,NDIMN
	F2(I,J,K)=0.0
	ENDDO
	ENDDO
	ENDDO
C  Blocks
	DO    K=1,NSLICE/2
	DO    J=2,NROW/2
	DO    I=3,NDIM
	F2(I,NROWN-J+2,K)=F2(I,NROW-J+2,K)
	F2(I,NROW-J+2,K)=0.0
	ENDDO
	ENDDO
	ENDDO
	DO    K=1,NSLICE/2
	DO    I=3,NDIM
	F2(I,NROWN-NROW+NR21,K)=F2(I,NR21,K)/SQ2
	F2(I,NR21,K)=F2(I,NR21,K)/SQ2
	ENDDO
	ENDDO
	DO    J=2,NROW/2
	DO    I=3,NDIM
	F2(I,NROWN-J+2,NS21)=F2(I,NROW-J+2,NS21)/SQ2
	ENDDO
	ENDDO
C...
	DO    K=2,NSLICE/2
	DO    J=1,NROW/2
	DO    I=3,NDIM
	F2(I,J,NSLICEN-K+2)=F2(I,J,NSLICE-K+2)
	F2(I,J,NSLICE-K+2)=0.0
	ENDDO
	ENDDO
	ENDDO
	DO    J=1,NROW/2
	DO    I=3,NDIM
	F2(I,J,NSLICEN-NSLICE+NS21)=F2(I,J,NS21)/SQ2
	F2(I,J,NS21)=F2(I,J,NS21)/SQ2
	ENDDO
	ENDDO
	DO    K=2,NSLICE/2
	DO    I=3,NDIM
	F2(I,NR21,NSLICEN-K+2)=F2(I,NR21,NSLICE-K+2)/SQ2
	ENDDO
	ENDDO
C...
	DO    K=2,NSLICE/2
	DO    J=2,NROW/2
	DO    I=3,NDIM
	F2(I,NROWN-J+2,NSLICEN-K+2)=F2(I,NROW-J+2,NSLICE-K+2)
	F2(I,NROW-J+2,NSLICE-K+2)=0.0
	ENDDO
	ENDDO
	ENDDO
	DO    J=2,NROW/2
	DO    I=3,NDIM
	F2(I,NROWN-J+2,NSLICEN-NSLICE+NS21)=F2(I,NROW-J+2,NS21)/SQ2
	F2(I,NROW-J+2,NS21)=0.0
	ENDDO
	ENDDO
	DO    K=2,NSLICE/2
	DO    I=3,NDIM
	F2(I,NROWN-NROW+NR21,NSLICEN-K+2)=F2(I,NR21,NSLICE-K+2)/SQ2
	F2(I,NR21,NSLICE-K+2)=0.0
	ENDDO
	ENDDO
C...
	DO    I=3,NDIM
	F2(I,NR21,NS21)=F2(I,NR21,NS21)/D2
	F2(I,NR21,NSLICEN-NSLICE+NS21)=F2(I,NR21,NS21)
	F2(I,NROWN-NROW+NR21,NS21)=F2(I,NR21,NS21)
	F2(I,NROWN-NROW+NR21,NSLICEN-NSLICE+NS21)=F2(I,NR21,NS21)
	ENDDO
C...
C Two planes
C. 
	DO    K=2,NSLICE/2
	DO    J=3,NROW
	F2(1,J,NSLICEN-K+2)=F2(1,J,NSLICE-K+2)
 	F2(1,J,NSLICE-K+2)=0.0
	ENDDO
	ENDDO
	DO    J=3,NROW
	F2(1,J,NS21)=F2(1,J,NS21)/SQ2
 	F2(1,J,NSLICEN-NSLICE+NS21)=F2(1,J,NS21)
	ENDDO
	DO    K=1,NS21
	IF(K.EQ.NS21)  THEN
	FM=D2
	ELSE
	FM=SQ2
	ENDIF
	DO    J=3,NROW,2
	F2(NDIM+1,(J+1)/2,K)=F2(2,J,K)/FM
	F2(NDIM+2,(J+1)/2,K)=F2(2,J+1,K)/FM
	F2(NDIM+1,NROWN-(J-3)/2,K)=F2(2,J,K)/FM
 	F2(NDIM+2,NROWN-(J-3)/2,K)=-F2(2,J+1,K)/FM
	ENDDO
	ENDDO
	DO    K=NS21,NSLICE
	IF(K.EQ.NS21)  THEN
	FM=D2
	ELSE
	FM=SQ2
	ENDIF
	DO    J=3,NROW,2
	F2(NDIM+1,(J+1)/2,NSLICEN-NSLICE+K)=F2(2,J,K)/FM
	F2(NDIM+2,(J+1)/2,NSLICEN-NSLICE+K)=F2(2,J+1,K)/FM
	F2(NDIM+1,NROWN-(J-3)/2,NSLICEN-NSLICE+K)=F2(2,J,K)/FM
 	F2(NDIM+2,NROWN-(J-3)/2,NSLICEN-NSLICE+K)=-F2(2,J+1,K)/FM
	ENDDO
	ENDDO
	DO    K=1,NSLICE
	DO    J=3,NROW
	F2(2,J,K)=0.0
	ENDDO
	ENDDO
C.  Lines
	DO    K=3,NSLICE,2
	F2(NDIM+1,1,(K+1)/2)=F2(2,1,K)/SQ2
	F2(NDIM+2,1,(K+1)/2)=F2(2,1,K+1)/SQ2
	F2(NDIM+1,1,NSLICEN-(K-3)/2)=F2(2,1,K)/SQ2
	F2(NDIM+2,1,NSLICEN-(K-3)/2)=-F2(2,1,K+1)/SQ2
	F2(2,1,K)=0.0
	F2(2,1,K+1)=0.0
	ENDDO
	F2(NDIM+1,1,1)=F2(2,1,1)/SQ2
	F2(2,1,1)=0.0
	F2(NDIM+1,1,NS21)=F2(2,1,2)/D2
	F2(NDIM+1,1,NSLICEN-NSLICE+NS21)=F2(2,1,2)/D2
	F2(2,1,2)=0.0
C.
	DO    K=3,NSLICE,2
	F2(NDIM+1,NR21,(K+1)/2)=F2(2,2,K)/D2
	F2(NDIM+2,NR21,(K+1)/2)=F2(2,2,K+1)/D2
	F2(NDIM+1,NROWN-NROW+NR21,(K+1)/2)=F2(2,2,K)/D2
	F2(NDIM+2,NROWN-NROW+NR21,(K+1)/2)=-F2(2,2,K+1)/D2
	F2(NDIM+1,NR21,NSLICEN-(K-3)/2)=F2(2,2,K)/D2
	F2(NDIM+2,NR21,NSLICEN-(K-3)/2)=-F2(2,2,K+1)/D2
	F2(NDIM+1,NROWN-NROW+NR21,NSLICEN-(K-3)/2)=F2(2,2,K)/D2
	F2(NDIM+2,NROWN-NROW+NR21,NSLICEN-(K-3)/2)=F2(2,2,K+1)/D2
	F2(2,2,K)=0.0
	F2(2,2,K+1)=0.0
	ENDDO
	F2(NDIM+1,NR21,1)=F2(2,2,1)/D2	
	F2(NDIM+1,NROWN-NROW+NR21,1)=F2(2,2,1)/D2	
	F2(NDIM+1,NR21,NS21)=F2(2,2,2)/D4	
	F2(NDIM+1,NR21,NSLICEN-NSLICE+NS21)=F2(2,2,2)/D4	
	F2(NDIM+1,NROWN-NROW+NR21,NS21)=F2(2,2,2)/D4
	F2(NDIM+1,NROWN-NROW+NR21,NSLICEN-NSLICE+NS21)=F2(2,2,2)/D4
	F2(2,2,1)=0.0
	F2(2,2,2)=0.0	
C.
	DO    K=3,NSLICE,2
	F2(1,NROW+1,(K+1)/2)=F2(1,2,K)/SQ2
	F2(1,NROW+2,(K+1)/2)=F2(1,2,K+1)/SQ2
	F2(1,NROW+1,NSLICEN-(K-3)/2)=F2(1,2,K)/SQ2
	F2(1,NROW+2,NSLICEN-(K-3)/2)=F2(1,2,K+1)/SQ2
	F2(1,2,K)=0.0
	F2(1,2,K+1)=0.0
	ENDDO
	F2(1,NROW+1,1)=F2(1,2,1)/SQ2	
	F2(1,2,1)=0.0
	F2(1,NROW+1,NS21)=F2(1,2,2)/D2	
	F2(1,NROW+1,NSLICEN-NSLICE+NS21)=F2(1,2,2)/D2	
	F2(1,2,2)=0.0
	F2(1,1,NSLICE+1)=F2(1,1,2)/SQ2
	F2(1,1,2)=0.0	
C
	INV=-1
	CALL  F3MR(F2,NDIMN,NROWN,NSLICEN,INV,WORK)
	IF (INV.EQ.0)   CALL ERRT(38,'FP ',NE)
	END
