
C++*********************************************************************
C
C FLIPBYTES 
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C    FLIPBYTES(CLINE,NCHAR,IRTFLG) 
C
C    PURPOSE: FLIP BYTES IN A CHARACTER STRING      
C
C    PARAMETERS:  CSTRING  STRING                  (SENT & RETURNED) 
C                 NSAM     STRING LENGTH *4        (SENT)
C                 IRTFLG   ERROR FLAG (O = OK)     (RETURNED)    
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

	SUBROUTINE  FLIPBYTES(CLINE,NCHART4,IRTFLG)

CNO_SAVE

        CHARACTER *(*) CLINE
        CHARACTER      TDAT

C       NOTE THAT THE ALPHA-NUMERICAL DATA (ABCD) WILL BE WRITTEN 
C       IN INVERTED ORDER (DCBA)
        DO K = 1, NCHART4, 4
           TDAT           = CLINE(K:K)
           CLINE(K:K)     = CLINE(K+3:K+3)
           CLINE(K+3:K+3) = TDAT
           TDAT           = CLINE(K+1:K+1)
           CLINE(K+1:K+1) = CLINE(K+2:K+2)
           CLINE(K+2:K+2) = TDAT
        ENDDO

        IRTFLG = 0

        RETURN
        END
