C++************************************************************************
C
C $$ FMRS_3D.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C  For order of elements see fmr_1.
C
C
C--************************************************************************
C
C $$ FMRS_3D.FOR
C
	SUBROUTINE FMRS_3D(LUN1,LUN2,A,NSAM,NROW,NSLICE,INV)	
C  A HAS TO BE NNNN*MAX0(NROW,NSLICE)+MAX0(NSAM,2*NROW)
	DIMENSION A(*)
CNO_SAVE
	NNNN=NSAM+2-MOD(NSAM,2)
	LT1=NNNN*MAX0(NROW,NSLICE)
	LT2=LT1+NROW*NSLICE
	IF(MOD(NSAM,2).EQ.0)  THEN
	LT3=LT2+NROW*NSLICE
	ELSE
	LT3=LT2
	ENDIF
C	MAXMEM=LT3+MAX0(NSAM,2*NROW)
C	IF(LT1+MAX0(NSAM,2*NROW).GT.MAXMEM)  THEN
C	CALL  ERRT(6,'FMRS_2D',NE)
C	ELSE
C Have to change NSAM
	CALL FMRS_3DR(LUN1,LUN2,A,A,A,A(1+LT1),A(1+LT2),A(1+LT3),
     &		NNNN,NSAM,NROW,NSLICE,INV)
C	ENDIF
	END
