	COMPLEX  FUNCTION  GET_P(A,NDIM,NROW,IX,IY)
	DIMENSION  A(NDIM,NROW)
CNO_SAVE
C
C  THIS FUNCTION TAKES ONE COMPLEX ELEMENT
C  OF THE 2-D FOURIER TRANSFORM PRODUCED
C  BY THE FFT2D_P SUBROUTINE
C
C  0 <= IX <= NDIM/2
C  -NROW/2+1 <= IY <= NROW/2
C
	IF(IX.EQ.0)  THEN
		IF(IY.EQ.0)  THEN
		GET_P=CMPLX(A(1,1),0.0)
		RETURN
		ELSEIF(IY.EQ.NROW/2)  THEN
		GET_P=CMPLX(A(1,2),0.0)
		RETURN
		ELSEIF(IY.LT.0)  THEN
		PRINT  *,' OUT OF BOUNDERY, IX=0'
		STOP
		ELSE
		IROW=2*IY+1
		GET_P=CMPLX(A(1,IROW),A(1,IROW+1))
		RETURN
		ENDIF
	ELSEIF(IX.EQ.NDIM/2)  THEN
		IF(IY.EQ.0)  THEN
		GET_P=CMPLX(A(2,1),0.0)
		RETURN
		ELSEIF(IY.EQ.NROW/2)  THEN
		GET_P=CMPLX(A(2,2),0.0)
		RETURN
		ELSEIF(IY.LT.0)  THEN
		PRINT  *,' OUT OF BOUNDERY, IX=NDIM/2'
		STOP
		ELSE
		IROW=2*IY+1
		GET_P=CMPLX(A(2,IROW),A(2,IROW+1))
		RETURN
		ENDIF
	ELSEIF(IX.LT.0)  THEN
	PRINT *,' OUT OF BOUNDARY, IX<0'
	ELSE
	IROW=IY+1
	IF(IY.LT.0)  IROW=IROW+NROW
	IDIM=2*IX+1
	GET_P=CMPLX(A(IDIM,IROW),A(IDIM+1,IROW))
	ENDIF
	RETURN
	END
