C++************************************************************************
C
C  GETIMA.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************

         SUBROUTINE  GETIMA(X,NSAM,NROW,IMI,Q)
         INCLUDE 'CMBLOCK.INC'
         PARAMETER  (NILMAX=10000)
         COMMON  DUMMY(80),BUF(1024),ILIST(NILMAX)
         COMMON  /FISPEC/
     &   FINPAT,FINPIC,DOCFIL,OUTIMA,OUTDOC,NLET,NLETI,NLIMA,NLDOC
         CHARACTER*80  FINPAT,FINPIC,DOCFIL,OUTIMA,OUTDOC
         CHARACTER*1  NULL
         DIMENSION  X(NSAM,NROW),Q(1)
         COMMON  /CORE/  INCORE
         LOGICAL  INCORE
         DATA  INPIC/77/
CNO_SAVE

         IF(INCORE)  THEN
         LBASE=NSAM*NROW*(IMI-1)
c$doacross local(i,j)
         DO  J=1,NROW
         DO  I=1,NSAM
         X(I,J)=Q(I+(J-1)*NSAM+LBASE)
         ENDDO
         ENDDO
         ELSE
         L=ILIST(IMI)
         NULL=CHAR(0)
         CALL  FILGET(FINPAT,FINPIC,NLET,L,INTFLAG)
         CALL  OPENFB(BUF,FINPIC,INPIC,NSAMT,NROWT,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,*)  ' FILE NOT FOUND:',FINPIC
         RETURN
         ENDIF
         DO    J=1,NROW
         CALL  REDLIN(INPIC,X(1,J),NSAM,J)
	 ENDDO
         CLOSE(INPIC)
         ENDIF
         END
