
      SUBROUTINE GKTEST (DLIS,IN,INF,INC,NOUP,LFACT,KV)

C     X  =MATRIX OF (ITEMS/IMAGES, FEATURES/FACTORS) 
C     IN =NUMBER OF ITEMS/IMAGES                     !
C     INF =NUMBER OF FACTORS                         ! ACTUAL VALUES
C     INC =NUMBER OF CLUSTERS                        !
C     NOUP= OUTPUT FILE LOGICAL NAME
    
      INCLUDE 'CMBLOCK.INC'
CNO_SAVE

C     DLIS IS IN COMMON IOBUF FROM SCLASF.F
      PARAMETER (IIN=999,IINC=10,IINF=10)
      INTEGER   DLIS(IIN),KV(IINF)

C     GKSM USES RDUM,X,Y, & V
      REAL      ISF
      COMMON    RDUM(80),X(IIN,IINF),U(IINC,IIN),V(IINC,IINF),
     &          SF(IINF,IINF),ISF(IINF,IINF),KLAS(IIN)

      REAL      ACK(IINC),R(IINC),PK(IINC)
      CHARACTER NAME*14,ANS*1,NAM*4

       NN=2*INF

       CALL RDPRM2 (AM,EPSIL,NLOOP,ILOOP,
     &        ' FUZZY EXPONENT (1, INF.), EPSILON TO STOP ITERATION')
       CALL RDPRMI(MAXIT,JDUM,NLOOP,ILOOP,
     &             ' MAXIMUM NUMBER OF ITERATIONS ANYWAY')
       CALL RDPRM  (RTHR,NLOOP,ILOOP, 
     &             ' THRESHOLD FOR HARD-PARTITION TRANSFORMATION')

      N=IN
      M=INF
      NC=INC

1052  WRITE (NOUT,1040) N,M,LFACT,(KV(I),I=1,IINF),
     * AM,EPSIL,MAXIT,NC,RTHR

      WRITE (NDAT,1040) N,M,LFACT,(KV(I),I=1,IINF),
     * AM,EPSIL,MAXIT,NC,RTHR

1040  FORMAT (//,1X,'NUMBER OF ITEMS/IMAGES = '
     * ,I5,/,' TOTAL NUMBER OF FACTORS IN CLAS.= ',I2,
     * ' , NUMBER IN IMC= ',I2,/,
     * ' FACTORS USED= ',10I2,/,
     * ' FUZZY PARAMETER = ',F3.1,2X
     * ,' , EPSILON = ',F10.7,2X,/,
     * ' MAXIMUM ITERATIONS = ',I4,/
     * ,' NUMBER OF CLUSTERS = ',I2,' , THRESHOLD = ',F10.7)

C-jmc
C     inizialization of the "cluster volumen" vector"
C-end jmc

      DO  I=1,NC
         R(I)=1.0
      ENDDO

      CALL GKSM (R,N,M,NC,AM,MAXIT,EPSIL,ITER)

C------------------------------------------------------

      IF (EPSIL.EQ.0.) THEN
         WRITE (NOUT,*) ' ONE MATRIX IS SINGULAR '
         WRITE (NDAT,*) ' ONE MATRIX IS SINGULAR '
         GOTO 9999
      ENDIF
      WRITE (NDAT,110)
110   FORMAT (/,' THE MEMBERSHIP MATRIX ',//,
     * '     ELEMENT, PERTENENCE, DECISSION, MAX.PERTENENCE',//)
      DO  I=1,N
         RMAXC=0
         RCCOUNT=0
         DO  J=1,NC
            ACK(J)=U(J,I)
            IF (ACK(J).GT.RMAXC) THEN
               RMAXC=ACK(J)
               RCCOUNT=J
            ENDIF
	 ENDDO
            IF (RMAXC.LT.RTHR) RCCOUNT=0
            KLAS(I)=RCCOUNT+0.5
            WRITE (NDAT,7000) DLIS(I), (ACK(KK), KK=1,NC),RCCOUNT,RMAXC
7000        FORMAT (3X,I4,3X,30(F5.2,2X))
      ENDDO

      WRITE (NDAT,120) 
120   FORMAT (/,' THE CLUSTER CENTRES ',//)
      DO  I=1,NC
        WRITE (NDAT,'(I3,30(3X,F10.8))') I,(V(I,J),J=1,M)
      ENDDO
C
      WRITE (NDAT,121)
121   FORMAT (/,' NUMBER OF ELEMENTS PER CLUSTER (WEIGHT)',//)

      DO I=1,NC
         PK(I)=0.0
         DO  J=1,N
            IF (KLAS(J).EQ.I) PK(I)=PK(I)+1.
	 ENDDO
      ENDDO

      DO  I=1,NC
        WRITE (NDAT, '(I3,F10.5)') I,PK(I)
      ENDDO

C     WRITTING OF THE CLUSTER FILE TO BE USED BY OTHER PROGRAMS

      WRITE (NOUP) IN, LFACT, INC, INF, (KV(K), K=1, INF)
      WRITE (NOUP) (KLAS(I), I=1,IN), (DLIS(I), I=1,IN),
     1             (PK(L), L=1, INC), ((V(L,J),L=1,INC), J=1,INF)


      WRITE (NOUT,*) 
      WRITE (NOUT,*) ' THE NUMBER OF ITERATIONS WAS = ',ITER
      WRITE (NDAT,*) 
      WRITE (NDAT,*) ' THE NUMBER OF ITERATIONS WAS = ',ITER

9999  CONTINUE
      END

