
C++*****************************************************************1/17/81
C
C GRAPHP.F
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  GRAPHP(LUN1,NSAM,NROW)
C
C  PURPOSE:    TO PRINT/TYPE SINGLE IMAGE ROW
C
C **************************************************************************

	SUBROUTINE GRAPHP(LUN1,NSAM,NROW)

	INCLUDE 'CMBLOCK.INC' 

	COMMON IPLOT(128),BUF(1)
C       IPLOT SAVES SPACE FOR GRAPH !

5	CALL RDPRMI(NLINE,NDUM,NLOOP,ILOOP,
     $           'ROW TO BE DISPLAYED, SCALE FACTOR')
	IF (NLINE.LE.0 .OR. NLINE.GT.NROW) GOTO 20
	IF (NDUM.EQ.0) NDUM=1

	CALL REDLIN(LUN1,BUF,NSAM,NLINE)
	IF (FCHAR(4:4) .NE.'T') GOTO 10

C       SWITCH OUTPUT STREAM; SAVE ORIGINAL LUN FOR LATER
	NSAV = NDAT
	NDAT = NOUT

C       IPRTT IS BEING USED TO SWITCH BETWEEN
C       TERMINAL FORMAT (IPRTT>=10) AND LINE PRINTER FORMAT
C       (IPRTT<10).  AT THE SAME TIME, THE VALUE OF IPRTT
C       INDICATES THE SCALING FACTOR TO BE USED.

  	IPRTT=10* NDUM
        GOTO 11

10      IPRTT=NDUM
11  	CALL GRAPH(BUF,NSAM,1)
	GOTO 5


C       UPON COMPLETION, RESTORE THE LUN OF THE PRINTER OUTPUT.

20	IF (FCHAR(4:4) .EQ. 'T') NDAT = NSAV
	IPRTT = 0

	RETURN
	END
