
C        RESTRICTION OF THE INTERPOLATION FIELD 10/13/89
C        QUADRATIC INTERPOLATION  07/09/93

    	SUBROUTINE HALI(MAXMEM)
	
	PARAMETER  (NILMAX=20000)
	INCLUDE 'CMBLOCK.INC'
        DIMENSION QB(1)
        POINTER   (IPQ,QB) 
        LOGICAL   RUNTIME
	COMMON  DUMMY(80),BUF(1024),ILIST(NILMAX),Q(1)
	INTEGER*2  NUMR(3,480)
	EQUIVALENCE  (Q,NUMR)
	COMMON  /F_SPEC/  FINPAT,FINPIC,NLET
	CHARACTER*80  FINPIC
	CHARACTER*80  FINPAT
	INTEGER*2  MAXRIN
	CHARACTER*1  MODE,ASK,NULL
        LOGICAL*1  NORM
	DATA  INPIC/77/
CNO_SAVE
	NULL=CHAR(0)
C       ASK FOR DATA FILE

	NMAX=NILMAX
 	CALL  FILSEQP(FINPAT,NLET,ILIST,NMAX,NIMA,
     &	  'ENTER TEMPLATE FOR 2-D IMAGE NAME',IRTFLG)
 	CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(1),INTFLG)
 	CALL  OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
 	IF( NF.NE.2)  THEN
	   WRITE(NOUT,2032)  FINPIC
2032	   FORMAT(' FILE NOT FOUND: ',A,/,' OPERATION ABANDONED')
	   RETURN
	ENDIF
	CLOSE(INPIC)

	CALL  RDPRMI(MR,NR,NLOOP,ILOOP,'FIRST AND LAST RING')
	CALL  RDPRMI(ISKIP,NDUMP,NLOOP,ILOOP,'SKIP')
	ISKIP=max0(1,iskip)
7981	NA=1
        CALL  RDPRMC(ASK,NA,.TRUE.,'(F)ULL OR (H)ALF CIRCLE',NULL,IRT)
	IF (ASK.EQ.'F')  THEN
	   MODE='F'
	ELSEIF(ASK.EQ.'H')  THEN
	   MODE='H'
	ELSE
	   RETURN
	ENDIF

        NA=1
	CALL  RDPRMC(ASK,NA,.TRUE.,'NORMALIZE UNDER MASK? (Y/N)',
     &               NULL,IRT)
	IF (ASK.EQ.'Y')  THEN
	   NORM=.TRUE.
	ELSE
	   NORM=.FALSE.
	ENDIF
C	CALL  RDPRMI(JACUP,NDUMP,NLOOP,ILOOP,
C     &	'PRECISION OF PEAK LOCATION (0..100)')
C	JACUP=MAX0(0,MIN0(100,JACUP))
        JACUP=0
	CALL  RDPRMI(NKMAX,MAXIT,NLOOP,ILOOP,
     &	'NUMBER OF GROUPS, MAX. NUMBER OF ITERATIONS')
C	CALL  RDPRMI(KXORD,KYORD,NLOOP,ILOOP,'X,Y ORDER OF SPLINES')
C	KXORD=MAX0(2,KXORD)
C	KYORD=MAX0(2,KYORD)
C	IF(KXORD.EQ.0) WRITE(NOUT,*)  
C     &	'  QUADRATIC INTERPOLATION WILL BE USED !'
C
	NRING=0
	DO    I=MR,NR,ISKIP
	NRING=NRING+1
	NUMR(1,NRING)=I
	ENDDO
 
C CALCULATION OF ACTUAL DIMENSION OF AN IMAGE TO BE INTERPOLATED
C 2*(# OF RINGS)+(0'TH ELEMENT)+2*(MARGIN OF 1)

	NRA=MIN0(((NSAM-1)/2)*2+1,((NROW-1)/2)*2+1,2*NR+3)
	LSAM=NSAM
	LROW=NROW
	NSAM=NRA
	NROW=NRA
	CALL  ALPRBS(NUMR,NRING,LCIRC,MODE)

C   memory division
C	NUMR	       1
C	CIRC	       2
C       EC             7  ! Double precision !
C
C A: X       B: ROT      3
C    BUFIN      CIRNEW   4
C    WORK       TEMP     5  !Double precision!
C               DIST     6
C               CIROLD   7   C:  CIRSEED  1
C                                ES       2  ! Double precision !
C                                E        3  ! Double precision !
C                                IP*2     4
C                                IQ*2     5



	MAXRIN=NUMR(3,NRING)
	K1=1
	K2=IPALIGN64(K1+(3*NRING+1)/2)
	MEMBUF=LCIRC*NIMA
C	DYNAMIC MEMORY ONLY FOR A PORTION.
        CALL CHKMEM(MEMBUF, Q, MAXMEM-(NILMAX+1200), 
     &	            RUNTIME,IPQ,IRTFLG)	
      
	IF (IRTFLG.EQ.0) THEN
	   IF(RUNTIME) THEN
	      K7=K2
	   ELSE
	      K7=IPALIGN64(K2+LCIRC*NIMA)
	      IPQ  = %LOC(Q(K2))
	   END IF
	ELSE
	   WRITE(NOUT,*)  '  SORRY, NOT ENOUGH MEMORY !'
	   RETURN
	END IF  
	
	K3A=IPALIGN64(K7+NIMA*2)
	K41A=IPALIGN64(K3A+NSAM*NROW)
	K4A=IPALIGN64(K41A+LSAM)
	K5A=K4A
	K3B=K3A
	K4B=IPALIGN64(K3B+NIMA)
	K5B=IPALIGN64(K4B+LCIRC)
	K6B=IPALIGN64(K5B+MAXRIN*4)
	K7B=IPALIGN64(K6B+NIMA)
	K8B=IPALIGN64(K7B+LCIRC)
	K1C=K7B
	K2C=IPALIGN64(K1C+LCIRC*NKMAX)
	K3C=IPALIGN64(K2C+2*NKMAX)
	K4C=IPALIGN64(K3C+2*NKMAX)
	K5C=IPALIGN64(K4C+(NIMA+1)/2)
	K6C=IPALIGN64(K5C+(NKMAX+1)/2)
	MEMTOT=NILMAX+1200+MAX0(K5A,K8B,K6C)
        WRITE (NOUT,2500)  MAXMEM , MEMTOT
	 
        IF (MEMTOT .LE. MAXMEM)  THEN 
    	  CALL  HALI_P(BUF,ILIST,NSAM,NROW,LSAM,LROW,NIMA,
     &	               NRING,LCIRC,MAXRIN,JACUP,NUMR, 
     &                 QB, 
     &                 Q(K3A),Q(K4A),Q(K41A),Q(K3B),Q(K4B),
     &	               Q(K5B),Q(K6B),Q(K7),Q(K7B),
     &	               Q(K1C),Q(K2C),Q(K3C),Q(K4C),Q(K5C),
     &		       NKMAX,MAXIT,MODE,NORM,NOUT) 
     
           IF(RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'HALI',IRTFLG) 
	   WRITE (NOUT,2600)
	ELSE 
           IF(RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'HALI',IRTFLG)  
	   WRITE(NOUT,*)  '  SORRY, NOT ENOUGH MEMORY !'
	ENDIF
 2500   FORMAT (/,'  MEMORY RESERVATION: YOU HAVE',              
     #    ' RESERVED ',I8,',  YOU NEED  ',I8 / )
 2600   FORMAT (//' ',80('-')//' ',
     #      'END OF COMPUTATION',//' ',80('-'))
        END
