
C++************************************************************************
C
C HCLP.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C    HCLP.FOR
C
C--************************************************************************

         SUBROUTINE  HCLP(NKLA,MDIM,JFIN,WD,INUM,COO,COB,MAXFAC,NFAC,
     &                    D,PK,VAL,IDK,LA,LB,NT,NO,NUM,IV,IW,V,W)

         DIMENSION  D(MDIM),PK(JFIN),VAL(JFIN),IDK(NKLA)
         DIMENSION  NT(JFIN),NO(JFIN),LA(NKLA),LB(NKLA)
C  WARNING !  ARRAYS  NUM, IV, IW, V, W  ARE PLACED ON ARRAY D
         DIMENSION  NUM(NKLA),IV(NKLA),IW(NKLA),V(NKLA),W(NKLA)
         DIMENSION  WD(MAXFAC),INUM(MAXFAC),COO(NFAC),COB(NFAC)
         CHARACTER*1  NULL,ANS
         DATA  NDOC/10/,NGRI/12/
CNO_SAVE
         NULL=CHAR(0)

         CALL  DIST_P
     &          (D,MDIM,PK,IDK,NKLA,WD,INUM,COO,COB,MAXFAC,NFAC)
         CALL  RDPRMI(MODE,IDUM,NLOOP,ILOOP,
     &        ' CLUSTERING CRITERION (1-5)')
C
         OPEN(NGRI,FILE='SCRATCH.SCR',STATUS='SCRATCH',
     &        FORM='UNFORMATTED')
         CALL CHAVA (NKLA, MDIM, JFIN,
     #             D, IDK, PK, VAL, LA, LB, NT, NO, NGRI, MODE,1)
C.......... CLASSIFICATION TREE OF THE NKLA CENTERS

         CALL RDPRMC(ANS,NA,.TRUE.,
     &       'DO YOU WANT DENDROGRAM PLOT FILE? (Y/T/N)',NULL,IRT)
         IF (ANS .EQ. 'Y'.OR. ANS.EQ.'y') THEN
            CALL DENDRO(NKLA, JFIN, VAL, LA, LB, PK, IDK,
     #            NO,NUM,NT,IV,IW,V,W,VMIN,VMAX)
         ELSEIF (ANS .EQ. 'T'.OR. ANS.EQ.'t') THEN
            CALL DENDRO2(NKLA, JFIN, VAL, LA, LB, PK, IDK,
     #           NO,NUM,NT,IV,IW,V,W,VMIN,VMAX)
         ELSE
            CALL ARBRE(NKLA, JFIN, VAL, LA, LB, PK, IDK,
     #          NO,NUM,NT,IV,IW,V,W,VMIN,VMAX)
         ENDIF
C        CAN LIST THE DENDORGRAM IN DOCUMENT FILE IF DESIRED
         CALL RDPRMC(ANS,NA,.TRUE.,
     &       'DO YOU WANT DENDROGRAM DOC FILE? (Y/N)',NULL,IRT)

         IF (ANS .NE. 'N' .AND. ANS .NE. 'n')
     &      CALL DENLST(NDOC,VMIN,VMAX,NKLA,V,NUM,IRTFLG)

#ifdef SP_SUN4
         CLOSE(NGRI)
         CALL CSVMS('\rm SCRATCH.SCR',IER)
#else
         CLOSE(NGRI)
C,DISPOSE='DELETE')
#endif
         END
