C++************************************************************************
C
C $$ HDLS.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ HDLS.FOR
C
        SUBROUTINE HDLS(MAXMEM)

        INCLUDE 'CMBLOCK.INC'
        COMMON  DUMMY(1024),Q(1)
	integer  totel
        CHARACTER*81  DOCFIL
        CHARACTER*1  NULL
	DATA  NDOC,NDOUT/55,56/
CNO_SAVE
        NULL=CHAR(0)


        CALL  RDPRM(X51,NLOOP,ILOOP,'Threshold (0-1)')
	CALL  FILERD(DOCFIL,NLETI,NULL,'Dendrogram document',IRTFLG)
	IF(IRTFLG.EQ.-1)  RETURN
C # OF OBJECTS IN A GROUP
	X41=0.0
	totel=0.0
C; # OF GROUPS
	X42=1.0
C
	NLIST=2
	K=0
	K2=1
778	LERR=-1
	KP1=K+1
	CALL  UNSAV(DOCFIL,K,NDOC,KP1,Q,2,LERR,K2)
	IF(LERR.EQ.0)  THEN
	IF(K.EQ.0)  THEN
C	X31=Q(1)
	X32=Q(2)
	K=K+1
	X41=X41+1.0
        GOTO  778
	ENDIF
C	X21=Q(1)
	X22=Q(2)
	K=K+1
C	IF(X22.GT.X32 .OR. X32.LT.X51) THEN
	IF(X32.LT.X51) THEN
	X41=X41+1.0
	X32=X22
        ELSE
	IF(X42.EQ.1.0)  WRITE(NOUT,122)
122	FORMAT(1X,'Group number      ','Number of elements')
C
	Q(1)=X42
	Q(2)=X41
        CALL  SAVD(NDOUT,Q,NLIST,IRTFLG)
	IF(IRTFLG.EQ.-1) GOTO  5
	WRITE(NOUT,123)  X42,X41
123	FORMAT(1X,F5.0,14X,2F10.0)
	totel=totel+x41
	X42=X42+1.0
	X41=1.0
	X32=X22
	ENDIF
	GOTO  778
        ENDIF
	Q(1)=X42
	Q(2)=X41
        CALL  SAVD(NDOUT,Q,NLIST,IRTFLG)
	IF(IRTFLG.EQ.-1) GOTO  5
	WRITE(NOUT,123)  X42,X41
	totel=totel+x41
	write(nout,33)  totel,x42
33       FORMAT('   Total number of objects =',i10,
     &   ' Number of classes =',f10.0)
5       CALL  SAVDC
        CLOSE(NDOUT)
        CLOSE(NDOC)
	END
