 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT USED AT UNIX SITES
 
       SUBROUTINE inilunb
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: inilunb'
       RETURN
       END
 
#else

C ++************************************************************************
C
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1993, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C                                                                          *
C  INILUN(NIN,NOUT,NECHO,ITI,ITIN,NTERM,NDAT,MAXDIM)
C
C  PURPOSE:  DEFINES IO UNITS AND BUFFER SIZE USED FOR BATCH RUNS OF 
C            SPIDER 
C          
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C***************************************************************************

	SUBROUTINE INILUN(NIN,NOUT,NECHO,ITI,ITIN,NTERM,NDAT,MAXDIM)
       
C       SUBROUTINE TO INITIALIZE THE INPUT OUTPUT LOGICAL UNIT NUMBERS
C       FOR BATCH USE OF DRIVER

C       PARAMETER  (MAXDI = 5000000)
C       PARAMETER  (MAXDI = 6000000) used before 18 aug 95, al
        PARAMETER  (MAXDI = 7400000)
        COMMON BUF(MAXDI)

C       SET SIZE OF COMMON BUFFER
	MAXDIM = MAXDI

C       DEFINE LOGICAL UNIT NUMBERS FOR BATCH JOB:

	NIN   = NTERM
	NOUT  = NDAT
	NECHO = NDAT
	ITI   = NDAT
        ITIN  = NDAT

        RETURN
	END

 
#endif
 
