 
 
#ifdef SP_VMS 
 
C   THIS ROUTINE SPECIFIC TO UNIX SPIDER AND IS NOT 
C       USED AT VAX SITES
 
       SUBROUTINE initunix
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: initunix'
       RETURN
       END
 
#else
 

C ++********************************************************************
C
C INITUNIX.F
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)    , WADSWORTH CENTER FOR LABORATORIES AND          *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C
C       CONTAINS UNIX ONLY CODE                                        *
C                                                                      *
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C***********************************************************************

        SUBROUTINE INITUNIX(NUMARG,FCHART,NALPHT)

        INCLUDE 'CMBLOCK.INC'

        LOGICAL ONSUN,ONUNIX,ONSGI,ONOSF
        COMMON /OPSYS/ ONSUN,ONUNIX,ONSGI,ONOSF,MEMALLOCABLE

        CHARACTER *(*)     FCHART
        INTEGER FUNCTION   NICE,IARGC
        CHARACTER * 30     ENVIR

C       DO NOT USE FOR DEC OSF/1 OR SUN OR R8000
#ifndef __osf__
#ifndef SP_SUN4
#ifndef SP_R8000
C       LOWER THE PRIORITY FOR THIS PROCESS
        INCR = 19
        I    = NICE(INCR)
#endif
#endif
#endif

C       CHECK FOR DATA CODE (EXTENSION) ON COMMAND LINE           
        NUMARG = 0
        NUMARG = IARGC() 

        IF (NUMARG .GT. 0) THEN
           CALL GETARG(1,FCHART)
           PRJEXC(1:3) = FCHART(1:3)

           IF (FCHART(4:4) .NE. '/') THEN
              DATEXC(1:3) = PRJEXC(1:3)
           ELSE
              DATEXC(1:3) = FCHART(5:7)
           ENDIF
           IF (DATEXC(1:1) .EQ. ' ' .OR. DATEXC(2:2) .EQ. ' ' .OR.
     &         DATEXC(3:3) .EQ. ' ') 
     &        STOP '*** INVALID DATA CODE ON COMMAND LINE!'
        ENDIF

C       CHECK FOR FIRST OPERATION ON COMMAND LINE
        IF (NUMARG .GT. 1) THEN
C          FIRST OPERATION GIVEN ON COMMAND LINE (ARG. 2)
           CALL GETARG(2,FCHART)
           NALPHT = lnblnk(FCHART)
        ENDIF

#ifdef SP_ALLOC
C       READ IN THE ENVIRONMENT VARIABLE 'SP_MEMALLOC'.
        MEMALLOCABLE = 50
        CALL GETENV('SP_MEMALLOC',ENVIR)
        NCHAR = lnblnk(ENVIR)
        IF (NCHAR .GT. 0) THEN
           READ(ENVIR,8000,IOSTAT=IER) MEMALLOCABLE
8000       FORMAT(I)
           IF (IER .NE. 0) THEN
C             ENVIRONMENT VARIABLE 'SP_MEMALLOC' IS NOT SET?
C             DEFAULT TO 50 MB
              MEMALLOCABLE = 50
           ENDIF 
        ENDIF

        WRITE(NOUT,90) MEMALLOCABLE
90      FORMAT(' YOU HAVE REQUESTED ',I5,' MB OF RUN_TIME MEMORY'/)
#else
        MEMALLOCABLE = 0
#endif

        RETURN
        END

#endif


CCC        IF (NUMARG .GT. 2) THEN
CCCC          SCHEDULING TIME GIVEN ON COMMAND LINE
CCC           COMMAND = ' 
CCC           DO I = 3,NUMARG
CCCC             RECOVER SCHEDULING STRING
CCC              CALL GETARG(I,CTEMP)
CCC              COMMAND = COMMAND // ' ' // CTEMP
CCC           ENDDO
CCC        ENDIF




