
	SUBROUTINE INPROJ(NUMIMP,NPIX,NFAC,NINACTP,LUNS,LUN,LUNP,
     1                    LUNM,LUNSC,S,W,U,D,LUV,IVAR,OFF)

C This routine projects any data set stored on a sequential file into
C the factor space spanned by another data set on which CORAN was
C previously performed.
C Original version 1/18/88. Transferred to Tethys 5/3/89 JF

	REAL S(NPIX,NFAC),W(NFAC),U(NPIX),D(NFAC)
	INTEGER LUV(NUMIMP)

C	SEQ IMAGE DATA FILE
	CALL REW(LUNS,1)	
C	EIGENVALUE FILE
	CALL REW(LUNM,0)
	READ(LUNM) NFAC,SOM,TRACE
	READ(LUNM) (D(K),K=1,NFAC)
C       PIXEL COO FILE
	CALL REW(LUNP,1)	
C       IMAGE COO FILE
	CALL REW(LUN,0)

C COPY FILE HEADER FROM OLD TO NEW IMC* FILE
	READ(LUN) NUMIM,NFAC,NSAM,NROW,NINACT
	NINACT=NINACT+NINACTP
	WRITE(LUNSC) NUMIM+NINACTP,NFAC,NSAM,NROW,NINACT

C COPY ENTIRE FILE, RECORD BY RECORD
	DO  I=1,NUMIM
           READ(LUN) (W(K),K=1,NFAC),PI,CO,ID,LUVOLD
           WRITE(LUNSC) (W(K),K=1,NFAC),PI,CO,ID,LUVOLD
	ENDDO

C READ IN OLD PIXEL COOS, DIVIDE BY SQRT(EIGENVALUES) TO OBTAIN EIGENVECTORS 

	DO  J=1,NPIX
          READ(LUNP) (S(J,K),K=1,NFAC)
          DO  K=1,NFAC
            S(J,K)=S(J,K)/SQRT(D(K))
	  ENDDO
	ENDDO

C READ IN IMAGE DATA AND COMPUTE PROJECTIONS

	DO 400 I=1,NUMIMP
           READ(LUNS) (U(J),J=1,NPIX),PIA,PVAR,INO
           IF(LUV(I).NE.0) GOTO 400
           IF(IVAR.EQ.2) THEN
             OFF1=OFF-PIA/FLOAT(NPIX)
             DO  J=1,NPIX
	     U(J)=U(J)+OFF1
	     ENDDO
           ENDIF

           DO  K=1,NFAC
            W(K)=0
	   ENDDO

           DO  J=1,NPIX
             DO  K=1,NFAC
               W(K)=W(K)+U(J)*S(J,K)/PIA
	     ENDDO
	   ENDDO

           WRITE(LUNSC) (W(K),K=1,NFAC), PIA,CO,INO,LUV(I)

 400	CONTINUE

	RETURN
	END
