C++*********************************************************************
C
C  INQUIREIF.F                                  NEW ROUTINE  SEPT 97 al
C                                
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C   INQUIREIF    DETERMINES IF A FILE EXISTS
C
C--*********************************************************************

        SUBROUTINE INQUIREIF()
CNO_SAVE

        INCLUDE 'CMBLOCK.INC' 
 
        COMMON         BUF(1)

        CHARACTER *81  FILNAM
        CHARACTER      NULL
        LOGICAL        EX,ISOPEN

        NULL = CHAR(0)

        CALL FILERD(FILNAM,NLET,NULL,'QUERY EXISTANCE OF',IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN

C       MERGE FILNAM WITH DATEXC IF NECESARY
        ILOCAT = INDEX(FILNAM,'@')
        IF (FILNAM(1:1) .NE. '_' .AND. ILOCAT .EQ. 0) THEN
           CALL FILCAN(FILNAM,NLET,NULL,NULL,FILNAM,DATEXC,IRTFLG)
           IF (IRTFLG .NE. 0) RETURN
        ENDIF

C       FIND IF IT EXISTS
        CALL INQUIREIF1(33,FILNAM,BUF,640000,EX,ISOPEN,LUNOP,
     &                  INLNED,IMGNUM,IRTFLG)

        IF (NSEL(1) .GT. 0) THEN
C          ONE REGISTER SPECIFIED ON COMMAND LINE

           PARAM(NSEL(1)) = 0.0
           IF (EX) PARAM(NSEL(1)) = 1.0
        ENDIF

        IF (NSEL(2) .GT. 0) THEN
C          TWO REGISTERS SPECIFIED ON COMMAND LINE

           PARAM(NSEL(2)) = 0.0
           IF (ISOPEN) PARAM(NSEL(2)) = 1.0
        ENDIF

        IF (EX) THEN
           WRITE(NOUT,*)' FILE EXISTS: ',FILNAM(1:NLET)
        ELSE          
           WRITE(NOUT,*)' FILE DOES NOT EXIST: ',FILNAM(1:NLET)
        ENDIF
        WRITE(NOUT,*) ' '

        RETURN
        END





