C ++************************************************************************
C
C $$ INTERP3
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1988, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C                                                                          *
C                                                                          *
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C***************************************************************************

      SUBROUTINE INTERP3
     &	(LUN1,LUN2,NSAM,NROW,NSLICE,NSAM1,NROW1,NSLICE1,MAXMEM)
 
      INCLUDE 'CMBLOCK.INC' 
      COMMON       KAF(1)
      DIMENSION    Q(1)
      POINTER      (IPQ,Q) 
      LOGICAL      RUNTIME 
CNO_SAVE
	MEMWANT=NSAM*NROW*NSLICE+NSAM1
	CALL CHKMEM( MEMWANT, KAF, MAXMEM, RUNTIME,IPQ,IRTFLG)
	IF(IRTFLG.NE.0) THEN 
          CALL ERRT(6,'INTERP3  ',NE)
          RETURN
	ENDIF

	DO  J=1,NROW*NSLICE
          CALL REDLIN(LUN1,Q(1+(J-1)*NSAM),NSAM,J)
        ENDDO

	KK = 1+NSAM*NROW*NSLICE
	CALL IRP3(Q,Q(KK),NSAM,NROW,NSLICE,NSAM1,NROW1,NSLICE1,LUN2)
 
        IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'IP',IRTFLG) 
	RETURN
        END
