
C++********************************************************* 1/28/81   VAX
C                                   LONG FILE NAMES FEB 89 al
C
C      JP:   CREATE A SEQUENTIAL FILE CONTAINING IMAGES 
C	     IN TRANSPOSED FORMAT TO BE USED AS INPUT TO JP'S
C	     CLUSTER ANALYSIS PROGRAM
C 	MSK VERSION : USE MASK FILE TO DECIDE WHICH POINTS TO INCLUDE
C
C	CALL JPMSK(LUN,LUNS1,LUNS2,LUNM,MAXDIM,OPTIN)
C	  LUN		LOGICAL UNIT NUMBER OF  INPUT FILE
C	  LUNS1	LOGICAL UNIT NUMBER OF SEQUENTIAL OUTPUT FILE
C	  LUNS2 LOGICAL UNIT NUMBER OF SEQUENTIAL SCRATCH FILE
C	  LUNM  LOGICAL UNIT NUMBER OF MASK FILE
C	  MAXDIM  MAXIMUM BUFFER LENGTH TO BE USED BY PROGRAM
C	  OPTIN   SWITCH TO ALLOW DIRECT IMAGE CODING
C
C--*******************************************************************

	SUBROUTINE JPMSK(LUN,LUNS1,LUNS2,LUNM,MAXDIM,OPTIN)

        INCLUDE 'CMBLOCK.INC'
	PARAMETER (MAXIM=500)

	COMMON BUFM(100),BUF(1)

        COMMON /COMMUN/ FILNM1,FILNM2,FILENM,FILNAM,MSK,MSKNAM,
     1                  FILPAT,FILDUM,FISEQ

        CHARACTER *(*) OPTIN
        CHARACTER *81  FILNM1,FILNM2,FILENM,FILNAM,MSK,MSKNAM
        CHARACTER *81  FILPAT,FILDUM,FISEQ
        CHARACTER *4   FCODE
        CHARACTER      NULL,OPT
	CHARACTER*1	ZERO
	DIMENSION      BUFNEW(MAXIM),MISS(250)

	DOUBLE PRECISION  DAV
  
	DATA ZERO/'0'/
CNO_SAVE
C
C	CA I, CA R, & CA D are not used anymore.
C	also: use old image format.
C
	WRITE(NOUT,*) ' '
	WRITE(NOUT,*) ' WARNING WARNING WARNING WARNING WARNING WARNING'
	WRITE(NOUT,*) ' '
	WRITE(NOUT,*) '      You are using an old routine that is '
	WRITE(NOUT,*) '      not supported any more. Better use the '
	WRITE(NOUT,*) '      CA S* serie of spider commands'
	WRITE(NOUT,*) ' '
	WRITE(NOUT,*) ' WARNING WARNING WARNING WARNING WARNING WARNING'
	WRITE(NOUT,*) ' '
			
        NULL=CHAR(0)

	OPT = OPTIN(1:1)
	IF (OPT .EQ. 'D') GOTO 200
C
	CALL FILERD(FILNM1,NLET,NULL,'FIRST',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	CALL FILERD(FILNM2,NLET,NULL,'LAST',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
C
	CALL FILERD(MSKNAM,NLET,NULL,'MASK',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	CALL RDPRMI(IUPDT,IR,NLOOP,ILOOP,'ENTER NUMBER OFFS.')
	CALL RDPRM(OFF,NLOOP,ILOOP,'ENTER BACKGROUND CORRECTION')

        CALL FILCAD(FILNM1,FILPAT,N1,IRTFLG)
        NLET1 = INDEX(FILPAT,NULL) - 1
        IF (IRTFLG .NE. 0) RETURN

        CALL FILCAD(FILNM2,FILDUM,N2,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	NUMIM=N2-N1+1
	IF (NUMIM.LE.MAXIM)GOTO 25
	WRITE(NOUT,2599)
2599	FORMAT(' *** WARNING: NUMBER OF IMAGES EXCEEDS BUFFER')

25	CALL FILERD(FILNAM,NLET,NULL,'SEQUENCE',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
C
	NULL=CHAR(0)
	CALL FILCAN(MSK,NMSK,NULL,NULL,MSKNAM,DATEXC,IER)
        IF (IRTFLG .NE. 0) RETURN
	CALL OPENF(MSK,LUNM,NSAM,NROW,'OLD',NF,NDUM)
	IF (NF.NE.2) GOTO 9300
C
C DETERMINE MINROW, MAXROW OF MASK UNLESS 'S' OPTION SELECTED
	IF (OPTIN(2:2) .EQ. 'S')GOTO 20
	MINROW=NROW
	MAXROW=0
	DO  I=1,NROW
	CALL REDLIN(LUNM,BUF,NSAM,I)
	DO 10 K=1,NSAM
	IF (BUF(K).LT.0.5)GOTO 10
	MINROW=I
	GOTO 16
10	CONTINUE
	ENDDO
16	DO  I=NROW,1,-1
	CALL REDLIN(LUNM,BUF,NSAM,I)
	DO 17 K=1,NSAM
	IF (BUF(K).LT.0.5)GOTO 17
	MAXROW=I
	GOTO 20
17	CONTINUE
	ENDDO
20	CONTINUE
C
	CALL FILCAN(FILENM,NFN,NULL,NULL,FILNAM,DATEXC,IER)
	OPEN(FILE=FILENM,UNIT=LUNS2,STATUS='UNKNOWN',
     1     FORM='UNFORMATTED')
	OPEN(FILE='SCR999.DAT',UNIT=LUNS1,STATUS='UNKNOWN',
     1     FORM='UNFORMATTED')
C  CALL OPEN TO FIND VALUES FOR NSAM,NROW

	IFOUND=-4
	CALL OPENF(FILNM1,LUN,NSAM,NROW,'OLD',NF,NDUM)
	IF (NF.NE.2)GOTO 9300
	IF (IFORM.NE.1)GOTO 9100
	IF (NTRACE.EQ.1)IFOUND=0
	CLOSE(LUN)
	KC=NSAM/2+1
	IC=NROW/2+1
  	LUN1 = LUNS2
	LUN2 = LUNS1
C I.E., THE COMPLETE FILE WILL WIND UP ON THE SPECIFIED FILE
C IF THE NUMBER OF IMAGES IS EVEN!
	NMISS=0
	IMACT=0

	DO 100 IM=1,NUMIM
        CALL FILGET(FILNM2,FILPAT,NLET1,N1+IM-1,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9000
	CALL OPENF(FILNM2,LUN,NSAM,NROW,'OLD',NF,NDUM)
	IF (IFORM.NE.1.AND.IFORM.NE.3)GOTO 9100
	IF (NF.EQ.2)GOTO 30
C
C GAP IN FILE SERIES FOUND. SKIP
	NMISS=NMISS+1
	MISS(NMISS)=IM
	GOTO 100
C
C IMAGE FOUND - PROCEED
30	IMACT=IMACT+1
C IMACT IS THE COUNT OF IMAGES FOUND
	OFF1=0.
	IF (OPTIN(2:2) .EQ.'S') GOTO 40
C	IF (IMAMI.EQ.0)CALL NORM(LUN,NSAM,NROW,FMAX,FMIN,AV)
C	OFF1=OFF-AV
	NCOUNT=0
	DAV=0.
	DO  I=MINROW,MAXROW
	CALL REDLIN(LUN,BUF(NSAM+1),NSAM,I)
	CALL REDLIN(LUNM,BUF,NSAM,I)
	DO 32 K=1,NSAM
	IF (BUF(K).LT.0.5)GOTO 32
	NCOUNT=NCOUNT+1
	DAV=DAV+BUF(NSAM+K)
32	CONTINUE
	ENDDO
	DAV=DAV/(FLOAT(NCOUNT))
	OFF1=OFF-DAV
C	IF (OFF1.LT.0.0) GOTO 400
40	CONTINUE
	IF (IM.GT.1)REWIND LUNS1
	IF (IM.GT.1)REWIND LUNS2
	NBUF=0
	DO  I=1,NROW
	NADDR = NBUF+1
	CALL REDLIN(LUNM,BUFM,NSAM,I)
	CALL REDLIN(LUN,BUF(NADDR),NSAM,I)
	DO 70 K=1,NSAM
	IF (BUFM(K).LT.0.5)GOTO 70
	NBUF=NBUF+1
	IF (IM.GT.1.OR.IUPDT.NE.0)GOTO 45
C*	ENCODE(4,71,FCODE)K,I
	WRITE(FCODE(1:4),71)K,I
71	FORMAT(2I2)
	IF (I.LT.10) FCODE(3:3)='0'
	IF (K.LT.10) FCODE(1:1)='0'
	GOTO 50
45	CONTINUE
C	WRITE(NOUT,33)IM,I,K,IMACT,IMACT-1+IUPDT
C33	FORMAT(1X,'READING ---- IM,I,K=',5I5)
	CALL READS(LUN1,FCODE,BUFNEW,IMACT-1+IUPDT)
50	CONTINUE
	IF (IMACT+IUPDT.GT.MAXIM)GOTO 9800
	BUFNEW(IMACT+IUPDT)=BUF(NADDR+K-1)+OFF1
C NOTE THERE WAS "OFF" BEFORE !!!
	IF (BUF(NADDR+K-1)+OFF1.LT.0.0)GOTO 400
C CHANGED 2/26/85 JF. CONDITION LESS STRINGENT THAN THE ONE 
C IMPLEMENTED PREVIOUSLY.
	CALL WRITS(LUN2,FCODE,BUFNEW,IMACT+IUPDT)
C60	FORMAT(4A1,(15F5.3))
70	CONTINUE
	ENDDO
	CLOSE(LUN)
C NOW SWAP LUNS
	LUNT = LUN2
	LUN2 = LUN1
	LUN1 = LUNT
100	CONTINUE

	WRITE(NOUT,101)IMACT
101	FORMAT(' ** TOTAL NUMBER OF IMAGES ',I3)
	WRITE(NOUT,102)(MISS(I),I=1,NMISS)
102	FORMAT(' ** MISSING IMAGES : ',(1X,20I3))

	WRITE(NOUT,109)NCOUNT
109	FORMAT(' ** NUMBER OF POINTS IN MASK ',I3)
C MPI 14-FEB-80: IMACT  E V E N: FILNM ALREADY CONTAINS SEQ FILE

	IF (MOD(IMACT,2).EQ.0)GOTO 9911

	WRITE(NOUT,*) ' ** DATA IN SCR999.DAT'

	CLOSE(LUN1)
	CLOSE(LUN2)
	RETURN


9000	IER=19
	GOTO 9900
9100	IER=2
	GOTO 9900
9300	IER =4
	GOTO 9900
9800	WRITE(NOUT,9801)
9801	FORMAT(' *** PROGRAM STOPPED DUE TO BUFFER OVERFLOW')
9900	CALL ERRT(IER,'JPMSK ',NE)
9910	CLOSE(LUN1)
	GOTO 300
9911	CLOSE(LUNS1)
	CLOSE(LUNS2)
	WRITE(NOUT,9912) (FILENM(II:II),II=1,NFN)
9912	FORMAT(' ** DATA ON ',80A1)
	GOTO 300
C
200	CALL FILERD(FILNM1,NLET,NULL,'INPUT',IRTFLG)
	CALL OPENF(FILNM1,LUN,NSAM,NROW,'OLD',NF,NDUM)

	CALL FILERD(FISEQ,NLET,NULL,'SEQUENCE',IRTFLG)
        OPEN(LUNS2,FILE=FISEQ,STATUS='UNKNOWN')

	DO  I = 1,NROW
	   CALL REDLIN(LUN,BUFNEW,NSAM,I)
	   WRITE(FCODE(1:4),201) I
C**	   ENCODE(4,201,FCODE)I
201	   FORMAT('0',I2,'0')
	   WRITE(LUNS2) FCODE,BUFNEW
	ENDDO
	CLOSE(LUN)
	CLOSE(LUNS2)
300	WRITE(NOUT,301)NBUF
301	FORMAT(' ** NO. OF POINTS IN MASK = ',I4)
	RETURN

400	WRITE(NOUT,401)
401	FORMAT(' *** NEGATIVE IMAGE VALUES FOUND. INCREASE OFFSET')
	END
