
C++*************************************************************************
C
C $$ LASTOCCUR.FOR -- CREATED JULY 92 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  $$ LASTOCCUR(STRING,NCHART,PATTERN)
C
C     PURPOSE:   FINDS LAST OCCURANCE OF THE PATTERN CHAR IN STRING
C
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

      INTEGER FUNCTION LASTOCCUR(STRING,NCHART,PATTERN)

      CHARACTER *(*) STRING
      CHARACTER *(*) PATTERN
     
  
      NCHAR = NCHART
      IF (NCHART .EQ. 0) NCHAR = LEN(STRING)

      NC = LEN(PATTERN)

C     FIND LAST OCCURENCE OF PATTERN IN THE LINE

      DO K = NCHAR-NC+1,1,-1
        IF (STRING(K:K+NC-1) .EQ. PATTERN) THEN
            LASTOCCUR = K
            RETURN
        ENDIF
      ENDDO

      LASTOCCUR = 0

      RETURN
      END

