
C++************************************************************************
C
C    LISTREGS.FOR                        REMOVED FROM OPNPIC AUG 96 al
C                                             
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    LISTREGS()
C
C    PURPOSE:   TO DUMP CONTENTS OF ALL REGISTERS
C
C    PARAMETERS:
C
C        0         2         3         4         5         6         7     
C--*********************************************************************

	SUBROUTINE LISTREGS()

	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

	COMMON           IROW(200)
        CHARACTER *81    DOCNAM
        COMMON /COMMUN/  DOCNAM

        CHARACTER *1     NULL
        LOGICAL          INTPRINT, DOCPRNT, TERMPRNT
        REAL             DLIST(10)

        DATA NDOC   /76/

        NULL = CHAR(0)

C       DETERMINE OUTPUT OPTION

	NLIS = NDAT
	IF (FCHAR(5:5) .EQ. 'T') NLIS = NOUT

        DOCPRNT = .FALSE.
	IF (FCHAR(5:5) .EQ. 'D') DOCPRNT = .TRUE.

        INTPRINT = .FALSE.
	IF (FCHAR(6:6) .EQ. 'I') INTPRINT = .TRUE.

C       DUMP REGISTERS EITHER INTO THE RESULTS FILE (DEFAULT)
C       OR ONTO THE TERMINAL ('LI RT') OR DOC FILE ('LI RD'

        IF (DOCPRNT) THEN
C           GET NAME FOR DOC FILE
            CALL FILERD(DOCNAM,NLETD,NULL,'OUTPUT DOC FILE',IRTFLG)
            DLIST(1) = 0
C           OPEN THE DOC FILE NOW
            NRUN  = 0
            CALL SAVDN1(NDOC,DOCNAM,DLIST,0,NRUN,0)
            NRUN  = 1

            WRITE(NDOC,91)
 91         FORMAT(' ;  X0 ... X9 (SYSTEM REGISTERS) ----')

            DO J = 1, 10 
               DLIST(1) = J
               DLIST(2) = PARAM(I)
               CALL SAVDN1(NDOC,DOCNAM,DLIST,2,NRUN,0)
            ENDDO

            WRITE(NDOC,99)
 99         FORMAT(' ;  X10 ... X102  -------------------')
            DO J = 10, 102
               DLIST(1) = J
               DLIST(2) = PARAM(I)
               CALL SAVDN1(NDOC,DOCNAM,DLIST,2,NRUN,0)
            ENDDO
            CLOSE(NDOC)
        ELSE
	  IF (INTPRINT) THEN 
C            INTEGER OUTPUT
             DO I=1,103
                IROW(I) = PARAM(I)
             ENDDO

	    WRITE(NLIS,*) 
     &         'INTEGER VALUES OF   X0 ... X9 (SYSTEM REGISTERS):'

	    WRITE(NLIS,92) (IROW(I),K=1,10)
92	    FORMAT(' DO-LP',I10,' NSAM ',I10,' NROW ',I10,
     &      ' FMAX ',I10/
     &      ' FMIN ',I10,' AVRG ',I10,' SIGM ',I10,' X7   ',I10/
     &      ' X8   ',I10,' ERRFL',I10/)

            WRITE(NLIS,*)   
     &          'INTEGER VALUES OF X10 ... X102 ---------------'
            WRITE(NLIS,94) (IROW(I),I=11,103)
94          FORMAT(5(1X,I10))

          ELSE
C           REAL OUTPUT
	    WRITE(NLIS,*) 
     &         'VALUES OF   X0 ... X9 (SYSTEM REGISTERS)-------'

	    WRITE(NLIS,97) (PARAM(K),K=1,10)
97 	    FORMAT(' DO-LP',G12.4,' NSAM ',G12.4,' NROW ',G12.4,
     &      ' FMAX ',G12.4/
     &      ' FMIN ',G12.4,' AVRG ',G12.4,' SIGM ',G12.4,' X7   ',G12.4/
     &      ' X8   ',G12.4,' ERRFL',G12.4/)

            WRITE(NLIS,*)   
     &          'VALUES OF X10 ... X102 -----------------------'

	     WRITE(NLIS,98) (PARAM(K),K=11,103)
 98          FORMAT(5G12.4)
           ENDIF
        ENDIF

        RETURN
	END


