
C++************************************************************************
C
C $$ LOOKUP.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C $$ LOOKUP(X,XTBL,J)
C
C  PURPOSE:    THIS SUBROUTINE PERFORMS A TABLE LOOK UP
C
C  PARAMETERS:   X       X VALUE TO BE LOOKED UP
C                XTBL    ARRAY CONTAINING TABLE
C                J       INDEX FOR THE TABLE
C
C  CALLED BY:    DHIDE
C
C  NOTE:         BECAUSE OF PRECAUTIONS TAKEN IN DHIDE, A TEST TO
C                SEE IF X IS OUTSIDE THE TABLE IS UNNECESSARY.
C
C--********************************************************************

      SUBROUTINE LOOKUP(X,XTBL,J)

      DIMENSION XTBL(1)

      J = 2

    4 IF (XTBL(J) - X) 1,2,3

    1 J = J+1
      GO TO 4

    3 J = J - 1

    2 RETURN
      END
