C++************************************************************************
C
C $$ MIRROR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ MIRROR.FOR
C
	SUBROUTINE MIRROR(LUN1,LUN2,NSAM,NROW,NSLICE)
	COMMON DUM(80),BUF(1)
	CHARACTER  XY,NULL
	LOGICAL  EVEN
CNO_SAVE
	NULL=CHAR(0)
C
	IF(NSLICE.LE.1)  THEN
         CALL RDPRMC(XY,NCHAR,.TRUE.,
     &   'MIRROR AT (Y) OR (X) AXIS (DEF=Y)',NULL,IRTFLG)
	ELSE
         CALL RDPRMC(XY,NCHAR,.TRUE.,
     &   'MIRROR AT (Z), (Y) OR (X) AXIS (DEF=Y)',NULL,IRTFLG)
	ENDIF
C
	IF (XY.EQ.'X') THEN
	EVEN=MOD(NROW,2).EQ.0
	DO  K=1,NSLICE
	IF(EVEN)  THEN
	DO  I=1,NROW
	  CALL REDLIN(LUN1,BUF,NSAM,I+(K-1)*NROW)
	  CALL WRTLIN(LUN2,BUF,NSAM,MOD(NROW+1-I,NROW)+1+(K-1)*NROW)
	ENDDO
	ELSE
	DO  I=1,NROW
	  CALL REDLIN(LUN1,BUF,NSAM,I+(K-1)*NROW)
	  CALL WRTLIN(LUN2,BUF,NSAM,NROW-I+1+(K-1)*NROW)
	ENDDO
	ENDIF
	ENDDO
C
	ELSEIF(XY.EQ.'Z')  THEN
	EVEN=MOD(NSLICE,2).EQ.0
	DO   K=1,NSLICE
	IF(EVEN)  THEN
	DO    I=1,NROW
	  CALL REDLIN(LUN1,BUF,NSAM,I+(K-1)*NROW)
	  CALL WRTLIN(LUN2,BUF,NSAM,I+MOD(NSLICE+1-K,NSLICE)*NROW)
	ENDDO
	ELSE
	DO    I=1,NROW
	  CALL REDLIN(LUN1,BUF,NSAM,I+(K-1)*NROW)
	  CALL WRTLIN(LUN2,BUF,NSAM,I+(NSLICE-K)*NROW)
	ENDDO
	ENDIF
	ENDDO
	ELSE
	EVEN=MOD(NSAM,2).EQ.0
	DO  I=1,NROW*NSLICE
	 CALL REDLIN(LUN1,BUF,NSAM,I)
	 IF(EVEN)  THEN
	DO  J=1,NSAM
	  BUF(NSAM+MOD(NSAM+1-J,NSAM)+1)=BUF(J)
	ENDDO
	 ELSE
	DO  J=1,NSAM
	  BUF(NSAM+NSAM+1-J)=BUF(J)
	ENDDO
	 ENDIF
	 CALL WRTLIN(LUN2,BUF(NSAM+1),NSAM,I)
	ENDDO
	ENDIF
	END
