C ++********************************************************************
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C SUBROUTINE MPOINT TO SET CERTAIN POINTS IN A FILE
C
C	MPOINT(LUN,NSAM,NROW,RP)
C
C	LUN :       LOGICAL UNIT NUMBER
C	NSAM,NROW : FILE DIMENSIONS
C	RP:         VALUE TO BE SUBSTITUTED OR USED
C
C*******************************************************************************

	SUBROUTINE MPOINT(LUN,NSAM,NROW,RP)

        COMMON /BATCH/IBCNT,NLOOP,IABSLP,ILOOP
	COMMON BUF(1)

	CALL RDPRMI(NPT,NDUM,NLOOP,ILOOP,'NUMBER OF POINTS')
	IF (NPT .LT. 1) RETURN

	DO 100 I=1,NPT
	   CALL RDPRMI(IX,IY,NLOOP,ILOOP,
     &             'ENTER COORDINATES FOR EACH POINT')
	   IF (IX.LE.0 .OR. IX.GT.NSAM) GOTO 100
	   IF (IY.LE.0 .OR. IY.GT.NROW) GOTO 100

	   CALL REDLIN(LUN,BUF,NSAM,IY)
	   BUF(IX) = RP
	   CALL WRTLIN(LUN,BUF,NSAM,IY)
100	CONTINUE
        RETURN
	END
