      SUBROUTINE MRCG3D(P3D)
C **************************************************************
C  INPUT:
C     NTPT= TOTAL NUMBER OF MARKERS
C     P3D(3,LS)= COORDS OF POINTS IN 3-D SPACE
C  OUTPUT:
C     P3D(3,LS)= centered COORDS OF POINTS IN 3-D SPACE
C


        PARAMETER (LV=300)
        PARAMETER (LS=100)
        PARAMETER (MAXREG=7)
        PARAMETER (MAXKEY=100)
        PARAMETER (MAXLOOP=999)
        REAL MAXPER
        PARAMETER (MAXPER=1.0e-6)
      LOGICAL*1   PTACTIVE(LS,LV),PARAMQ(4)
      COMMON /GENERAL/PTACTIVE,NUMPTS(LV),NTVW,NTPT,CIR(2),PARAMQ
      DIMENSION   P3D(3,LS)
CNO_SAVE
C
c  go over x-y-z
	do    j=1,3
	cg=0.0
		DO  I=1,NTPT
	     	cg=cg+P3D(j,I)
		ENDDO
	cg=cg/ntpt
c subtract center of gravity
		DO  I=1,NTPT
	     	P3D(j,I)=P3D(j,I)-cg
		ENDDO
	enddo
      END
