      SUBROUTINE MRDOC(SCALE,SHIFT,ANGLE,NUMBER,P3D)
C ********************************************************
C
C RECORDS THE ROTATIONS, SCALE, AND SHIFTS OF THE IMAGES
C
      INCLUDE 'CMBLOCK.INC'

        PARAMETER (LV=300)
        PARAMETER (LS=100)
        PARAMETER (MAXREG=7)
        PARAMETER (MAXKEY=100)
        PARAMETER (MAXLOOP=999)
        REAL MAXPER
        PARAMETER (MAXPER=1.0e-6)

      LOGICAL*1   PTACTIVE(LS,LV),PARAMQ(4)
      COMMON /GENERAL/PTACTIVE,NUMPTS(LV),NTVW,NTPT,CIR(2),PARAMQ
      CHARACTER   *80   SERNAME
      COMMON /FILEN/SERNAME

      CHARACTER   *80   CORDOC,ZDOC
      DIMENSION         SCALE(LV),SHIFT(2,LV),ANGLE(3,LV)
      DIMENSION         P3D(3,LS)
      DIMENSION         BUFLOC(7)
      DIMENSION         NUMBER(LV)
      CHARACTER   *1    NULL
      INTEGER     *4    IRTFLG,IER
      INTEGER           IVIEW
      INTEGER           NCOR,NXYZ

      DATA PI/3.141592654/,NCOR/12/,NXYZ/13/
CNO_SAVE
	NULL=CHAR(0)
C
      NA=80
	CALL  FILERD(CORDOC,NA,NULL,
     &      'ENTER DOC FILE TO HOLD CORRECTIONS', IRTFLG)
c      CALL RDPRMC(CORDOC,NA,.TRUE.,
c     &      'ENTER DOC FILE TO HOLD CORRECTIONS$', NULL, IRTFLG)
c      NLETC=NA
c      CORDOC(NLETC+1:NLETC+1)=CHAR(0)
c      CALL FILCAN(CORDOC,NLET,NULL,NULL,CORDOC,DATEXC,IER)
Cc      CORDOC(NLET:NLET)=NULL
      NA=80
	CALL  FILERD(ZDOC,NA, NULL,
     &      'ENTER DOC FILE TO HOLD 3-D COORDS$', IRTFLG)
C      CALL RDPRMC(ZDOC,NA,.TRUE.,
C     &      'ENTER DOC FILE TO HOLD 3-D COORDS$', NULL, IRTFLG)
C      NLETZ=NA
C      ZDOC(NLETZ+1:NLETZ+1)=CHAR(0)
C      CALL FILCAN(ZDOC,NLET,NULL,NULL,ZDOC,DATEXC,IER)
Cc      ZDOC(NLET:NLET)=NULL
C
      IF(IRTFLG.NE.0) WRITE(NOUT,*)'ERROR IN FILENAMES'
      NLIST=6
C      NRUN=1
C      OPEN(NCOR,FILE=CORDOC,STATUS='NEW',ACCESS='SEQUENTIAL')
      DO  IVIEW=1,NTVW
        BUFLOC(1)=NUMBER(IVIEW)
        BUFLOC(2)=SCALE(IVIEW)
        BUFLOC(3)=ANGLE(2,IVIEW)*180/PI
        BUFLOC(4)=ANGLE(1,IVIEW)*180/PI
        BUFLOC(5)=SHIFT(1,IVIEW)
        BUFLOC(6)=SHIFT(2,IVIEW)
	NRUN=IVIEW-1
        CALL SAVDN1(NCOR,CORDOC,BUFLOC,NLIST,NRUN,0)
        NRUN=1
      ENDDO
C
      WRITE(NCOR,123)
 123  FORMAT(' ;VIEW   SCALE',7X,'THETA',6X,'PSI',9X,
     &      'XSHIFT',6X,'YSHIFT')
      WRITE(NCOR,124)SERNAME
 124  FORMAT(' ; FOR IMAGE SERIES ',A20)
      CLOSE(NCOR,STATUS='KEEP')
      NLIST=4
C      NRUN=1
C      OPEN(NXYZ,FILE=ZDOC,STATUS='NEW',ACCESS='SEQUENTIAL')
      DO  IPOINT=1,NTPT
        BUFLOC(1)=IPOINT
        BUFLOC(2)=P3D(1,IPOINT)
        BUFLOC(3)=P3D(2,IPOINT)
        BUFLOC(4)=P3D(3,IPOINT)
	NRUN=IPOINT-1
        CALL SAVDN1(NXYZ,ZDOC,BUFLOC,NLIST,NRUN,0)
      ENDDO
      WRITE(NXYZ,125)
 125  FORMAT(' ;POINT    XCOOR       YCOOR       ZCOOR')
      WRITE(NXYZ,126)SERNAME
 126  FORMAT(' ; FOR IMAGE SERIES ',A20)
      CLOSE(NXYZ,STATUS='KEEP')
      END
