C ++********************************************************************
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C   MRECTL(LUN,NSAM,NROW,RP,IDIM)
C
C****************************************************************************

	SUBROUTINE MRECTL(LUN,NSAM,NROW,RP,IDIM)

	COMMON ADUM(80),BUF(1)
        COMMON    /BATCH/IBCNT,NLOOP,IABSLP,ILOOP
        INTEGER          IBCNT,NLOOP,IABSLP,ILOOP
	
	CALL RDPRMI(IX,IY,NLOOP,ILOOP,
     $      'ENTER COORDINATES OF UPPER LEFT POINT')

	CALL RDPRMI(IXOFF,IYOFF,NLOOP,ILOOP,
     $      'ENTER  X & Y OFFSETS')
	IF (IXOFF .LT. 0 .OR. IYOFF .LT. 0) GOTO 9000

	IYSTRT = MAX0(1,IY)
	IYEND  = MIN0(NROW,IY+IYOFF)
	IF (IYSTRT.GT.NROW .OR. IYEND.LE.0) GOTO 9000

	IXSTRT=MAX0(1,IX)
	IXEND=MIN0(NSAM,IX+IXOFF)
	IF (IXSTRT.GT.NSAM.OR.IXEND.LE.0) GOTO 9000

	DO I=IYSTRT,IYEND
	   CALL REDLIN(LUN,BUF,NSAM,I)
	   IF (IDIM.EQ.2) GOTO 9
	   IF (I  .EQ.IYSTRT.AND.IYSTRT.EQ.IY) GOTO 9
	   IF (I  .EQ.IYEND.AND.IYEND.EQ.(IY+IYOFF)) GOTO 9
	   IF (IX .EQ.IXSTRT) BUF(IX)=RP
	   IF ((IX+IXOFF) .EQ. IXEND) BUF(IX+IXOFF) = RP
	   GOTO 12

9          CONTINUE
           DO J=IXSTRT,IXEND
              BUF(J) = RP
           ENDDO

12	   CALL WRTLIN(LUN,BUF,NSAM,I)
        ENDDO
	RETURN

9000	CALL ERRT(14,'MRECTL',NF)

	RETURN
	END
