#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE mrfei2
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: mrfei2'
       RETURN
       END
 
#else
 

c--*********************************************************************

C                                     LONG FILE NAMES FEB 89 al
c--*********************************************************************
C     
C     PEAK INTERPOLATION BY LINEAR LEAST SQUARE FIT
C     INTERPOLATION FUNCTION: SYMMETRICAL TWO DIMENSIONAL
C     GAUSS FUNCTION.
C
C     SEPT , 1980, M.RADERMACHER
C
c--*********************************************************************

      SUBROUTINE MRFEI2(A0,S,A,X0,Y0)

#ifdef SP_UNIX
      INCLUDE 'CMBLOCK.INC' 
#else
      INCLUDE 'COMMON1:CMBLOCK.INC' 
#endif
      COMMON /COMMUN/ DOCFIL
      COMMON /LSQG2/ ISTOP,W(100),X(100),Y(100),AR(5,100),R(5),B(5,100),
     $FL(100),ERG(5),FFF(100)

      DIMENSION     PLIST(10)
      CHARACTER *81 DOCFIL
      CHARACTER     NULL,ANS

      NULL=CHAR(0)

      CALL FILERD(DOCFIL,NLET,NULL,'DOCUMENT',IRTFLG)
      IF(IRTFLG .NE. 0) RETURN

      CALL FILCAN(DOCFIL,NLET,NULL,NULL,DOCFIL,DATEXC,IRTFLG)
      IF(IRTFLG .NE. 0) RETURN

      NOPEN=0
      LUN3=15
      NNUM=3
      ICOUNT=0
      WMAX=0
      CMAX=0
751   CONTINUE
      IKEY=ICOUNT+1
      CALL UNSAV(DOCFIL,NOPEN,LUN3,IKEY,PLIST,NNUM,LERR,1)
      IF(LERR.NE.0) GOTO 750
      ICOUNT=ICOUNT+1
      X(ICOUNT)=PLIST(1)
      Y(ICOUNT)=PLIST(2)
      W(ICOUNT)=PLIST(3)
      IF(W(ICOUNT).LT.WMAX) GOTO 740
      X0=X(ICOUNT)
      Y0=Y(ICOUNT)
      WMAX=W(ICOUNT)
      IW=ICOUNT
740   IF(CMAX.LT.X(ICOUNT)) CMAX=X(ICOUNT)
      IF(CMAX.LT.Y(ICOUNT)) CMAX=Y(ICOUNT)      
      WRITE(NOUT,752) X(ICOUNT),Y(ICOUNT),W(ICOUNT)
752   FORMAT(1H ,'INPUT: X=',F8.2,' Y=',F8.2,' W=',E10.4)
      GOTO 751
750   IG=ICOUNT
      CLOSE(LUN3)
      A0=WMAX
      A=1
      S=CMAX
      EPS=0.0000001*A0
      WRITE(NOUT,753) A0,X0,Y0,S,A
753   FORMAT(1H ,'START VALUES: A0',10X,'X0',8X,'Y0',8X,
     $'SIG',8X,'A',9X,'EPS'/E10.4,2X,4(F8.2,2X))
      ISTOP=0
      CALL RDPRM(ANS,NCR,.TRUE.,
     &   'STOP AT INCREASING SQ-SUM (Y/N)',NULL,IRTFLG)
      IF (ANS .EQ. 'Y') ISTOP=1
      CALL RDPRMC(ANS,NCR,.TRUE.,
     &   'OVERWRITE START VALUES? (Y/N)',NULL,IRTFLG)
      IF (ANS .NE. 'Y') GOTO 754
      CALL RDPRM2(A0,S,NLOOP,ILOOP,'A0,S')
      CALL RDPRM2(X0,Y0,NLOOP,ILOOP,'X0,Y0')
      CALL RDPRM(A,NLOOP,ILOOP,'A')
      CALL RDPRM(EPS,NLOOP,ILOOP,'EPS')
754   CONTINUE
C
C     COMPUTATION OF THE LINEAR LEAST SQUARE FIT
C
      IAUS=0
      CALL MRMAT2(IG,X0,Y0,A0,A,S,EPS,IAUS)
      WRITE(NOUT,20) A0,A,S,X0,Y0
 20   FORMAT(1H ,//'GAUSS APPROXIMATION: AMPLITUDE;  ',
     $'ELLIPTICITY;','HALFWIDTH;  ','CENTER X0,Y0;'/21X,5(E10.4,2X))
      RETURN
      END
 
#endif
 
