      SUBROUTINE MRGET3D(P3D)
C *****************************************
C     READS IN ALREADY CALCULATED 3-D INTO THE ARRAY P3D.
C
C  LS = MAX NUMBER OF ALLOWED MARKERS
C  P3D(3,LS) = ARRAY OF X,Y,Z COORD'S OF MARKERS IN VOLUME
C 
      INCLUDE 'CMBLOCK.INC'

        PARAMETER (LV=300)
        PARAMETER (LS=100)
        PARAMETER (MAXREG=7)
        PARAMETER (MAXKEY=100)
        PARAMETER (MAXLOOP=999)

      COMMON /DOCLAB/DOCTIT
      COMMON /GENERAL/NTPT,CIR(2)

      DIMENSION         P3D(3,LS)

      DIMENSION         DBUF(MAXREG,MAXKEY)
      DIMENSION         PLIST(MAXREG)
      CHARACTER   * 1   NULL, ANSW
      INTEGER     * 4   IRTFLG,IRT2
      CHARACTER   * 81  THDIN, THDIN1
CNO_SAVE
      NULL = CHAR(0)
      NA = 80
      CALL FILERD(THDIN1, NA, NULL,
     &      'ENTER NAME OF 3-D MODEL FILE', IRTFLG)
      IF(IRTFLG.NE.0) RETURN
      
c      THDIN1(NA+1:NA+1)=CHAR(0)
      NULL = CHAR(0)
      IOPEN = 0
      NLET = 0
      IKEY = 1
      CALL FILCAN(THDIN,NLET,NULL,NULL,THDIN1,DATEXC,IER)
      CALL UNSDAL(THDIN,IOPEN,LUN1,IKEY,PLIST,3,DBUF,
     &      MAXKEY,MAXREG,NTPT,IRT2)
c unsdal closes the file
c      CLOSE(LUN1)
C           IRT2 WILL BE 1 IF KEY 1 IS MISSING, SO OK IF IRT2=0 OR 1
      IF(IRT2 .NE. 0 .AND. IRT2 .NE. 1) THEN
        WRITE(NOUT,*)' NO SUCH 3-D FILE.'
	RETURN
      ENDIF
      DO  J=1,NTPT
        P3D(1,J) = DBUF(2,J)
        P3D(2,J) = DBUF(3,J)
        P3D(3,J) = DBUF(4,J)
      ENDDO
      END
