      subroutine mrgetzd(lun1,lun2)
      parameter (maxkey=5000,maxreg=7)
c calculate z-coordinates of points in a plane.
c 9/95, M.Radermacher
        INCLUDE 'CMBLOCK.INC'
      common dummy(1024),plist(7),dbuf(maxreg,maxkey)
      character*81 filn1,filn2
      character*1 nul
c input docfile
      CALL FILERD(FILn1,NLET,NUL,'input document$',IRTFLG)
      CALL FILCAN(FILN1,NLET,NUL,NUL,FILn1,DATEXC,IER)
c columns in input docfile
      call rdprmi(ixcol,iycol,nloop,iloop,
     $'columns containing x,y coordinates$')
      call rdprmi(inum,idum,nloop,iloop,
     $'column containing image number (0=key)$')
c output docfile
      CALL FILERD(FILN2,NLET2,NUL,'output document$',IRTFLG)
      CALL FILCAN(FILN2,NLET2,NUL,NUL,FILn2,DATEXC,IER)
c columns in output docfile
      call rdprmi(ionum,iodf,nloop,iloop,
     $'Column for image number,scaled z-value$')
      call rdprmi(ioz,idum,nloop,iloop,
     $'column number for non-scaled z-value$')
      write(nout,*)
c find highest output register number.
      irout=0
      if(irout.lt.ioz) irout=ioz
      if(irout.lt.iodf) irout=iodf
      if(irout.lt.ionum) irout=ionum
c index of plist has to be 1 higher
      irout=irout+1
c get the rest of the imput parameters:
      write(nout,*)
     $'The equation used is: z=ax+by+c'
      call rdprM2(a,b,nloop,iloop,'enter a,b$')
      call rdprM2(c,p,nloop,iloop,'enter c,pixel size$')
      if(p.eq.0) p=1.
c find highest input register number:
      ihigh=0
      if(iycol.gt.ihigh) ihigh=iycol
      if(ixcol.gt.ihigh) ihigh=ixcol
      if(inum.gt.ihigh) ihigh=inum
c index of plist has to be 1 higher
      ihigh=ihigh+1
c read document file (even if key1 does not exist, the content of the
c document file will be in dbuf):
      key=1
      nrun=0
      CALL UNSDAL(filn1,NOPEN,lun1,key,PLIST,ihigh,
     $DBUF,MAXKEY,MAXREG,NKEY,LERR)
c nkey now contains the number of keys in the document file
c clear plist for output:
      do  i=1,7
       plist(i)=0.
      enddo
c loop through document file
      do  i=1,nkey
      x=dbuf(ixcol+1,i)
      y=dbuf(iycol+1,i)
      num=dbuf(inum+1,i)+0.5
c this is the real "work":
      z1=a*x+b*y+c
      Z2=Z1*P
c store results:
      plist(inum+1)=num
      if(inum.ge.1) plist(1)=i
      plist(iodf+1)=z2
      plist(ioz+1)=z1
      IAP=1
      CALL SAVDN1(LUN2,FILN2,PLIST,irout,NRUN,IAP)
      NRUN=1
      enddo
      CLOSE(lun1)
      close(lun2)
      return
      end
