#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE mrgnorm
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: mrgnorm'
       RETURN
       END
 
#else
 

C                                 LONG FILE NAMES FEB 89 al

      SUBROUTINE MRGNORM(LUN1,NSAM,NROW)

#ifdef SP_UNIX
      INCLUDE 'CMBLOCK.INC' 
#else
      INCLUDE 'COMMON1:CMBLOCK.INC' 
#endif
      COMMON NX,NY,CX,A0(1)
      COMMON /COMMUN/ FNAM

      CHARACTER *81 FNAM
      CHARACTER     NULL,ANS

      NULL=CHAR(0)

      CALL RDPRMC(ANS,NCHAR,.TRUE.,
     &  '(F)IT, (C)ORRECT, (B)OTH (F/C/B),NULL,IRTFLG$')
      IF (ANS.EQ.'F') KCALL=1
      IF (ANS.EQ.'C') KCALL=2
      IF (ANS.EQ.'B') KCALL=3
      IF (ANS.EQ.'C') GOTO 971
      CALL MRFEI2(AMP,HALF,ELLI,X0,Y0)
      IF (ANS.EQ.'F') GOTO 223
      GOTO 975
971   CALL RDPRM2(AMP,HALF,NLOOP,ILOOP,'AMPLITUDE,HALFWIDTH$')
      CALL RDPRM(ELLI,NLOOP,ILOOP,'ELLIPTICITY$')
      CALL RDPRM2(X0,Y0,NLOOP,ILOOP,'X-,Y-ORIGIN$')
975   CALL RDPRMI(IOLD,INEW,NLOOP,ILOOP,
     &      'OLD(DOCFILE), NEW(IMAGE) DIMENSIONS$')
      FINT=FLOAT(INEW)/FLOAT(IOLD)
      WRITE (NOUT,800) FINT
800   FORMAT(' MULTIPLIER USED:',F8.4)
      HALF=HALF*FINT
      X0=X0*FINT
      Y0=Y0*FINT
      CALL FILERD(FNAM,NLET,NULL,'OUTPUT',IRTFLG)
      IDIM=1
      LUN2=21
      CALL OPENF(FNAM,LUN2,NSAM,NROW,'UNKNOWN',NF,IDIM)
      FD2=0
      DO 972 I=1,NROW
      CALL REDLIN(LUN1,A0,NSAM,I)
      DO 973 K=1,NSAM
      X=FLOAT(K)
      Y=FLOAT(I)
      CALL MRGAUS2(AMP,HALF,ELLI,X0,Y0,X,Y,FD1,FD2,FUN,A0(NSAM+1),0,0)
      A0(K)=(A0(K)-FUN)/FUN
973   CONTINUE
972   CALL WRTLIN(LUN2,A0,NSAM,I)
      GOTO 222

200	CONTINUE
C     CALL SETPRM(LUN1,NSAM,NROW,FMAX,FMIN,AV,'R')
222     CLOSE(LUN2)
223     CLOSE(LUN1)
	RETURN
	END
 
#endif
 
