#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE mrkur2
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: mrkur2'
       RETURN
       END
 
#else
 

      SUBROUTINE MRKUR2(Y,N,Y0,IAUS)

C***** AUSDRUCKEN DES GRAPHEN VON Y, MAXIMALE HOEHE=100******

C      OCTOBER 1980 M.RADERMACHER

      DIMENSION A(110),Y(1)
      COMMON /UNITS/LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
      DATA BLK,ST,SI,PLU/' ','*','I','+'/

      LY0=0
      IF(IAUS.GT.0) WRITE(NOUT,100) Y
100   FORMAT(' *KURVE*'/20((1X,5E11.4)/))
      WRITE(NOUT,102) N,Y0
102   FORMAT(' '///1X,'N=',I5,'  Y0=',E11.4)
      DO 5 K=1,100
5     A(K)=PLU
      K=0
      WRITE(NOUT,3) K,(A(LL),LL=1,100)
      IF(Y0.GE.0.) GOTO 4
      LY0=-INT(Y0)
4     DO1 K=1,N
      DO2 KK=1,100
    2 A(KK)=BLK
      IF(LY0.GE.1.AND.LY0.LE.100) A(LY0)=SI
      L=INT(Y(K)-Y0)
      IF(L.GT.100) GOTO1
      IF(L.LT.1) GOTO 1
      A(L)=ST
   3  FORMAT('-',I3,' ',100A1)
   1  WRITE(NOUT,3) K,(A(LL),LL=1,100)
      DO 6 K=1,100
6     A(K)=PLU
      K=0
      WRITE(NOUT,3) K,(A(LL),LL=1,100)
      RETURN
      END



      SUBROUTINE MRNRM2(Y,N,X,Y0,I0,IAUS)

      COMMON /UNITS/LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
      DIMENSION Y(N)

      IF(IAUS.GT.0) WRITE(NOUT,100) Y
100   FORMAT(' Y VOR NORMIERUNG'/20((1X,5E11.4)/))
      WRITE(NOUT,103) N,X,Y0,I0
      FMAX=0.
      Y0=0.
      IF(I0.EQ.0) GOTO 10
      FMIN=0.
      DO 3 K=1,N
3     IF(Y(K).LT.FMIN) FMIN=Y(K)
      DO 4 K=1,N
4     Y(K)=Y(K)-FMIN
      Y0=FMIN
10    DO 1 K=1,N
      IF(FMAX.LT.Y(K)) FMAX=Y(K)
1     CONTINUE
      IF(FMAX.GT.0) GOTO 110
      WRITE(NOUT,120)
120   FORMAT(' ** MRNRM2 **  MAXIMUM <=0')
      GOTO 130
110   DO 2 K=1,N
         Y(K)=Y(K)/FMAX*X
2     CONTINUE
      Y0=Y0/FMAX*X
      DO 5 K=1,N
5     Y(K)=Y(K)+Y0
      WRITE(NOUT,7) Y0
7     FORMAT(' NORM**KLEINSTER WERT DER FUNKTION:',E11.4)
      IF(IAUS.GT.0) WRITE(NOUT,101) Y
101   FORMAT(' Y NACH NORMIERUNG'/20((1X,5E11.4)/))
      WRITE(NOUT,103) N,X,Y0,I0
103   FORMAT(' N=',I5,'  X=',E11.4,'  Y0=',E11.4,'  I0=',I5)

130   RETURN
      END
 
#endif
 
