      SUBROUTINE MRPUTINFO(XYPTS,PRJ,ANGLE,P3D,NUMBER,SHIFT,SCALE,ERVW,
     &            ERPT,FULL)
C ************************************************************
C RECORDS THE CALCUTED VALUES TO A FILE
C

        PARAMETER (LV=300)
        PARAMETER (LS=100)
        PARAMETER (MAXREG=7)
        PARAMETER (MAXKEY=100)
        PARAMETER (MAXLOOP=999)
        REAL MAXPER
        PARAMETER (MAXPER=1.0e-6)
        PARAMETER (NLIST=6)
      INCLUDE     'CMBLOCK.INC'
      LOGICAL*1   PTACTIVE(LS,LV),PARAMQ(4),FULL
      COMMON /GENERAL/PTACTIVE,NUMPTS(LV),NTVW,NTPT,CIR(2),PARAMQ
C
      DIMENSION         XYPTS(2,LS,LV),PRJ(2,LS,LV),SHIFT(2,LV)
      DIMENSION         ANGLE(3,LV),P3D(3,LS)
      DIMENSION         SCALE(LV),ERVW(LV),ERPT(LS)
      CHARACTER * 81    XYIN1,XYIN2
	CHARACTER*1  NULL
      INTEGER           NUMBER(LV)
	DIMENSION DLIST(NLIST)
C
	DATA  NDOC/55/
      DATA PI/3.141592654/
      DATA DTOR/0.017453292/
CNO_SAVE
c
	IF(FULL)  THEN
C
C           WILL PUT ALL OBSERVATIONS INTO .DAT FILE.
      WRITE(NOUT,*)'                 VIEW POINTS'
      DO  I=1,NTVW
        DTHETA=ANGLE(2,I)*180.0/PI
        DPSI=ANGLE(1,I)*180.0/PI
        WRITE(NOUT,720)NUMBER(I),DTHETA,DPSI,SHIFT(1,I),SHIFT(2,I),
     &      SCALE(I),ERVW(I)
 720    FORMAT(' VIEW:',I2,'  TILT=',F6.1,'  PSI=',F5.1,
     &      '  SHFT(',F5.1,1X,F5.1,')  SCL:',F5.3,'  ER:',E10.4)
        WRITE(NOUT,721)
721     FORMAT
     &  (' PT#        XYPTS                     PROJ            ERROR')
        WRITE(NOUT,*)('-',J=1,60)
        DO  J=1,NTPT
          WRITE(NOUT,740)J,XYPTS(1,J,I)+CIR(1),XYPTS(2,J,I)+CIR(2),
     &      PRJ(1,J,I)+CIR(1),PRJ(2,J,I)+CIR(2)
     &  ,SQRT((XYPTS(1,J,I)-PRJ(1,J,I))**2+(XYPTS(2,J,I)-PRJ(2,J,I))**2)
c     &  ,XYPTS(1,J,I)-PRJ(1,J,I)
 740      FORMAT(1X,I2,5(2X,1PE10.3))
	ENDDO
        WRITE(NOUT,*)
      ENDDO
	ENDIF
C
      WRITE(NOUT,*)'     3D POINTS'
      WRITE(NOUT,*)' PT#       X      Y      Z     ERR OF POINT'
      DO  I=1,NTPT
        WRITE(NOUT,710)I,P3D(1,I),P3D(2,I),P3D(3,I),ERPT(I)
 710    FORMAT(1X,I2,6X,F6.1,1X,F6.1,1X,F6.1,1X,F10.6)
      ENDDO
      WRITE(NOUT,*)
C
	IF(FULL)  THEN
C
C  Files with predicted marker positions ...
C
      NA=80
	NMAX=0
 	CALL  FILSEQP(XYIN1,NA,NUMBER,NMAX,NVW,
     &	  'ENTER PREFIX OF X,Y PREDICTED COORD FILES',IRTFLG)
      DO 503 IVIEWT=1,NTVW
C           GO THROUGH AND PUT ALL X,Y COORDS INTO DOC FILES
C           NULL IS RESET EACH TIME BECAUSE CORRUPTION HAPPENS
        NULL=CHAR(0)
        NLETP=NA
        CALL FILGET(XYIN1,XYIN2,NLETP,NUMBER(IVIEWT),IRT2)
        XYIN2(NLETP+1:NLETP+1)=CHAR(0)
C           IRT2=0 MEANS ALL OKAY
        IF(IRT2 .NE. 0) GOTO 503
c
	IAP=0
	NRUN=0
	do    J=1,NTPT
	IF(PTACTIVE(J,IVIEWT))  THEN
	DLIST(1)=J
	DLIST(2)=XYPTS(1,J,IVIEWT)+CIR(1)
	DLIST(3)=XYPTS(2,J,IVIEWT)+CIR(2)
	DLIST(4)=PRJ(1,J,IVIEWT)+CIR(1)
	DLIST(5)=PRJ(2,J,IVIEWT)+CIR(2)
	DLIST(6)=
     &	SQRT((XYPTS(1,J,IVIEWT)-PRJ(1,J,IVIEWT))**2
     &      +(XYPTS(2,J,IVIEWT)-PRJ(2,J,IVIEWT))**2)
        call  SAVDN1(NDOC,XYIN2,DLIST,NLIST,NRUN,IAP)
	NRUN=1
	ENDIF
	enddo
c  this doesn't work in Spider yet ...
c	DO  505  J=1,3
c505	DLIST(J+1)=ANGLE(J,IVIEWT)/DTOR
c	DLIST(1)=-1.0
c	NLST=4
c        call  SAVDN1(NDOC,XYIN2,DLIST,NLST,NRUN,IAP)
503    CLOSE(NDOC)
	ENDIF
      END
