C++************************************************************************
C
C $$ MRRT.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ MRRT.FOR
C
         SUBROUTINE MRRT(MAXMEM)
C  Rotate and scale 3D coordinates stored in a document file  06/12/96
         INCLUDE 'CMBLOCK.INC'
         COMMON  DUMMY(1024),FI1(3),B(4)
         DOUBLE PRECISION R(3,3)
         CHARACTER*81  DOCFIL
         CHARACTER*1  NULL
         DATA  NDOC,NDOUT/55,56/
CNO_SAVE
         NULL=CHAR(0)
C
         CALL  FILERD(DOCFIL,NLETI,NULL,
     &	 '3D coordinates document',IRTFLG)
         IF(IRTFLG.EQ.-1)  RETURN
C
         CALL  RDPRM2
     &   (FI1(1),FI1(2),NLOOP,ILOOP,'Rotation angles psi, theta')
         CALL  RDPRM(FI1(3),NLOOP,ILOOP,'Rotation angle phi')
         CALL  RDPRM(SCALE,NLOOP,ILOOP,'Scale')
         CALL BLDR(R,FI1(1),FI1(2),FI1(3))
C
         NLIST=4
         K=0
         K2=1
778      LERR=-1
         KP1=K+1
         CALL  UNSAV(DOCFIL,K,NDOC,KP1,FI1,3,LERR,K2)
         IF(LERR.EQ.0)  THEN
         K=K+1
         do    kkk=1,3
            B(kkk+1)=0.0
            do    l=1,3
               B(kkk+1)=B(kkk+1)+FI1(l)*r(kkk,l)
	    enddo
	 enddo
         do    kkk=1,3
            B(kkk+1)=B(kkk+1)*SCALE
	 enddo
         B(1)=K
         CALL  SAVD(NDOUT,B,NLIST,IRTFLG)
         IF(IRTFLG.EQ.-1) GOTO  5
         GOTO  778
         ENDIF
5        CALL  SAVDC
         CLOSE(NDOUT)
         CLOSE(NDOC)
         END
