
C $$ MULFI3.FOR
C
         SUBROUTINE MULFI3(LUN1,A1,B1,B2,NSAM,NROW,NSLICE)
C LUN2*CONJG(LUN1)
         DIMENSION  A1(NSAM,NROW,NSLICE),B1(NSAM),B2(NSAM)
         COMPLEX  QT,FQ
        LOGICAL IFNS,IFNR,IFND
CNO_SAVE
C
        PI=4.0*ATAN(1.0)
        IFNR=MOD(NROW,2).EQ.0
        IFND=MOD(NSAM,2).EQ.0
        IFNS=MOD(NSLICE,2).EQ.0
        IF(IFND)  THEN
        LBD=2
        ELSE
        LBD=1
        ENDIF
        IF(IFNR)  THEN
        LBR=2
        ELSE
        LBR=1
        ENDIF
        IF(IFNS)  THEN
        LBS=2
        ELSE
        LBS=1
        ENDIF
        ND2=NSAM/2
        NR2=NROW/2
        NS2=NSLICE/2
         LNS=(NSAM-2)/2
C
         DO    K=1,LBS
	IZ=(K-1)*NS2
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
         DO    J=1,LBR
	IY=(J-1)*NR2
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	NR1=J+(K-1)*NROW
         CALL  REDLIN(LUN1,B1,NSAM,NR1)
	DO  I=1,LBD
	IX=(I-1)*ND2
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
        QT=CMPLX(A1(I,J,K),0.0)*CMPLX(B1(I),0.0)*FQ
	A1(I,J,K)=REAL(QT)
	ENDDO
         CALL  MLC(A1(3,J,K),B1(3),A1(3,J,K),LNS)
         DO    I=3,NSAM-1,2
	IX=I/2
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
        QT=CMPLX(A1(I,J,K),A1(I+1,J,K))*FQ
	A1(I,J,K)=REAL(QT)
	A1(I+1,J,K)=AIMAG(QT)
	ENDDO
	IF(.NOT.IFND)THEN
	IX=ND2
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
        QT=CMPLX(A1(NSAM,J,K),A1(2,J,K))*
     &  CMPLX(B1(NSAM),-B1(2))*FQ
	A1(NSAM,J,K)=REAL(QT)
	A1(2,J,K)=AIMAG(QT)
	ENDIF
	ENDDO
	ENDDO
C
         DO    J=1,LBR
	IY=(J-1)*NR2
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
         DO    K=3,NSLICE-1,2
	IZ=K/2
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
	NR1=J+(K-1)*NROW
	NR3=J+K*NROW
         CALL  REDLIN(LUN1,B1,NSAM,NR1)
         CALL  REDLIN(LUN1,B2,NSAM,NR3)
         DO    I=1,LBD
	IX=(I-1)*ND2
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,J,K),A1(I,J,K+1))*
     &  CMPLX(B1(I),-B2(I))*FQ
         A1(I,J,K)=REAL(QT)
         A1(I,J,K+1)=AIMAG(QT)
	 ENDDO
         CALL  MLC(A1(3,J,K),B1(3),A1(3,J,K),LNS)
         CALL  MLC(A1(3,J,K+1),B2(3),A1(3,J,K+1),LNS)
         DO    I=3,NSAM-1,2
	IX=I/2
	iz=(k-1)
	if(iz.gt.ns2)iz=iz-nslice
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,J,K),A1(I+1,J,K))*FQ
         A1(I,J,K)=REAL(QT)
         A1(I+1,J,K)=AIMAG(QT)
	iz=iz+1
	if(iz.gt.ns2)iz=iz-nslice
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
	QT=CMPLX(A1(I,J,K+1),A1(I+1,J,K+1))*FQ
         A1(I,J,K+1)=REAL(QT)
         A1(I+1,J,K+1)=AIMAG(QT)
	 ENDDO
	IF(.NOT.IFND)THEN
	IX=ND2
	iz=(k-1)
	if(iz.gt.ns2)iz=iz-nslice
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
        QT=CMPLX(A1(NSAM,J,K),A1(2,J,K))*
     &  CMPLX(B1(NSAM),-B1(2))*FQ
	A1(NSAM,J,K)=REAL(QT)
	A1(2,J,K)=AIMAG(QT)
	iz=iz+1
	if(iz.gt.ns2)iz=iz-nslice
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
        QT=CMPLX(A1(NSAM,J,K+1),A1(2,J,K+1))*
     &  CMPLX(B2(NSAM),-B2(2))*FQ
	A1(NSAM,J,K+1)=REAL(QT)
	A1(2,J,K+1)=AIMAG(QT)
	ENDIF
	ENDDO
	IF(.NOT.IFNS)THEN
	IZ=NS2
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
	NR1=J+(NSLICE-1)*NROW
	NR3=J+NROW
         CALL  REDLIN(LUN1,B1,NSAM,NR1)
         CALL  REDLIN(LUN1,B2,NSAM,NR3)
         DO    I=1,LBD
	IX=(I-1)*ND2
	 XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,J,NSLICE),A1(I,J,2))*
     &  CMPLX(B1(I),-B2(I))*FQ
         A1(I,J,NSLICE)=REAL(QT)
          A1(I,J,2)=AIMAG(QT)
	 ENDDO
         CALL  MLC(A1(3,J,NSLICE),B1(3),A1(3,J,NSLICE),LNS)
         CALL  MLC(A1(3,J,2),B2(3),A1(3,J,2),LNS)
         DO    I=3,NSAM-1,2
	IX=I/2
	iz=-1
	 XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,J,NSLICE),A1(I+1,J,NSLICE))*FQ
         A1(I,J,NSLICE)=REAL(QT)
         A1(I+1,J,NSLICE)=AIMAG(QT)
	iz=1
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,J,2),A1(I+1,J,2))*FQ
         A1(I,J,2)=REAL(QT)
          A1(I+1,J,2)=AIMAG(QT)
	 ENDDO
	IF(.NOT.IFND)THEN
	IX=ND2
	iz=-1
	 XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
        QT=CMPLX(A1(NSAM,J,NSLICE),A1(2,J,NSLICE))*
     &  CMPLX(B1(NSAM),-B1(2))*FQ
	A1(NSAM,J,NSLICE)=REAL(QT)
	A1(2,J,NSLICE)=AIMAG(QT)
	iz=1
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
        QT=CMPLX(A1(NSAM,J,2),A1(2,J,2))*
     &  CMPLX(B2(NSAM),-B2(2))*FQ
	A1(NSAM,J,2)=REAL(QT)
	A1(2,J,2)=AIMAG(QT)
	ENDIF
	ENDIF
	ENDDO
C
         DO    K=1,NSLICE
	IZ=(K-1)
	IF(IZ.GT.NS2)IZ=IZ-NSLICE
	ZZ=2.0*PI*FLOAT(IZ)*FLOAT(NS2)/FLOAT(NSLICE)
         DO    J=3,NROW-1,2
	IY=J/2
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	NR1=J+(K-1)*NROW
	NR3=J+1+(K-1)*NROW
         CALL  REDLIN(LUN1,B1,NSAM,NR1)
         CALL  REDLIN(LUN1,B2,NSAM,NR3)
         DO    I=1,LBD
	IX=(I-1)*ND2
	 XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,J,K),A1(I,J+1,K))*
     &  CMPLX(B1(I),-B2(I))*FQ
         A1(I,J,K)=REAL(QT)
         A1(I,J+1,K)=AIMAG(QT)
	 ENDDO
         CALL  MLC(A1(3,J,K),B1(3),A1(3,J,K),LNS)
         CALL  MLC(A1(3,J+1,K),B2(3),A1(3,J+1,K),LNS)
         DO    I=3,NSAM-1,2
	IX=I/2
	iy=(j-1)
	if(iy.gt.nr2)iy=iy-nrow
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,J,K),A1(I+1,J,K))*FQ
         A1(I,J,K)=REAL(QT)
         A1(I+1,J,K)=AIMAG(QT)
	iy=iy+1
	if(iy.gt.nr2)iy=iy-nrow
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,J+1,K),A1(I+1,J+1,K))*FQ
         A1(I,J+1,K)=REAL(QT)
         A1(I+1,J+1,K)=AIMAG(QT)
	 ENDDO
	IF(.NOT.IFND)THEN
	IX=ND2
	iy=(j-1)
	if(iy.gt.nr2)iy=iy-nrow
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
        QT=CMPLX(A1(NSAM,J,K),A1(2,J,K))*
     &  CMPLX(B1(NSAM),-B1(2))*FQ
	A1(NSAM,J,K)=REAL(QT)
	A1(2,J,K)=AIMAG(QT)
	iy=iy+1
	if(iy.gt.nr2)iy=iy-nrow
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
        QT=CMPLX(A1(NSAM,J+1,K),A1(2,J+1,K))*
     &  CMPLX(B2(NSAM),-B2(2))*FQ
	A1(NSAM,J+1,K)=REAL(QT)
	A1(2,J+1,K)=AIMAG(QT)
	ENDIF
	ENDDO
	IF(.NOT.IFNR)THEN
	IY=NR2
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	NR1=NROW+(K-1)*NROW
	NR3=2+(K-1)*NROW
         CALL  REDLIN(LUN1,B1,NSAM,NR1)
         CALL  REDLIN(LUN1,B2,NSAM,NR3)
         DO    I=1,LBD
	IX=(I-1)*ND2
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,NROW,K),A1(I,2,K))*
     &  CMPLX(B1(I),-B2(I))*FQ
         A1(I,NROW,K)=REAL(QT)
          A1(I,2,K)=AIMAG(QT)
	  ENDDO
         CALL  MLC(A1(3,NROW,K),B1(3),A1(3,NROW,K),LNS)
         CALL  MLC(A1(3,2,K),B2(3),A1(3,2,K),LNS)
         DO    I=3,NSAM-1,2
	IX=I/2
	iy=-1
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,NROW,K),A1(I+1,nrow,K))*FQ
         A1(I,NROW,K)=REAL(QT)
         A1(I+1,nrow,K)=AIMAG(QT)
	iy=1
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c 	fq=cmplx(1.0,0.0)
         QT=CMPLX(A1(I,2,K),A1(I+1,2,K))*FQ
         A1(I,2,K)=REAL(QT)
         A1(I+1,2,K)=AIMAG(QT)
	ENDDO
	IF(.NOT.IFND)THEN
	IX=ND2
	iy=-1
	XX=2.0*PI*FLOAT(IX)*FLOAT(ND2)/FLOAT(NSAM)
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c 	fq=cmplx(1.0,0.0)
       QT=CMPLX(A1(NSAM,NROW,K),A1(2,NROW,K))*
     &  CMPLX(B1(NSAM),-B1(2))*FQ
	A1(NSAM,NROW,K)=REAL(QT)
	A1(2,NROW,K)=AIMAG(QT)
	iy=1
	YY=2.0*PI*FLOAT(IY)*FLOAT(NR2)/FLOAT(NROW)
	FQ=CMPLX(COS(XX+YY+ZZ),SIN(XX+YY+ZZ))
c	fq=cmplx(1.0,0.0)
        QT=CMPLX(A1(NSAM,2,K),A1(2,2,K))*
     &  CMPLX(B2(NSAM),-B2(2))*FQ
	A1(NSAM,2,K)=REAL(QT)
	A1(2,2,K)=AIMAG(QT)
	ENDIF
	ENDIF
	ENDDO
         END
