
C++*************************************************************************
C
C $$ NUMDIG.FOR -- CREATED OCT 88 ArDean Leith
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ NUMDIG(IVALUE,MINVAL)
C
C    PURPOSE:  FIND NUMBER OF DIGITS IN IVALUE
C
C    PARAMETERS:  
C         IVALUE    INPUT NUMBER
C         MINVAL    MIN. VALUE RETURNED FOR IVALUE
C
C ************************************************************************

          FUNCTION NUMDIG(IVALUE,MINVAL)

          LENI  = 1
          LENT  = 9
 3        IF (IVALUE .GT. LENT) THEN
             LENT = 9 * (10**LENI) + LENT
             LENI = LENI + 1
             GOTO 3
          ENDIF

          NUMDIG = MAX(MINVAL,LENI)         
C         MINVAL IS MINIMUM LENGTH
          RETURN
          END

       
