
C++*********************************************************************
C
C OPENFB.F    -- ADAPTED FROM OPEN3.FOR OCT 88 al
C             -- LONG FILENAMES al
C             -- STACKS ADDED 96 al
C             -- REWRITTEN WITH OPENFIL 96 al
C             -- REWRITTEN WITH OPENINSTK 97 al
C             -- REWRITTEN WITH OPENSTK 98 al
C             -- ABANDONED, SPLIT OUT OPENALL JAN 98 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C    OPENFB(BUF,FILNAM,LUN,NSAM,NROW,DISP,NF,NSLICE)
C
C    PURPOSE:       TO OPEN A NEW OR  EXISTING DATA FILE FOR RANDOM 
C                   ACCESS READING/WRITING.
C
C    PARAMETERS:
C        DUM        UNUSED                                        (----)
C        FILNAM     CHARACTER ARRAY, CONTAINING FILE NAME         (SENT)
C        LUN        LOGICAL UNIT NUMBER FOR FILNAM.               (SENT)
C        NSAM,NROW  DIMENSIONS OF FILE                       (SENT/RET.)
C        DISP       SEE OPFIL                                     (SENT) 
C        NF         ERROR RETURN FLAG.                       (SENT/RET.)
C                   NF = 2    NORMAL RETURN
C                   NF = 1    ERROR RETURN
C        NSLICE     NUMBER OF PLANES                         (SENT/RET.)
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

C       NOTE: DO NOT USE THIS ROUTINE ANY MORE, USE OPFIL


	SUBROUTINE OPENFB(DUM,FILNAM,LUN,NSAM,NROW,DISP,NF,NSLICE)

CNO_SAVE

        CHARACTER *(*) FILNAM,DISP
 
C       PASS ANY NF INPUT VALUE TO OPFIL ALSO     
        IRTFLG = NF 

C       BARE STACKS NOT ALLOWED
        MAXIM  = 0  
        CALL OPFIL(.FALSE.,FILNAM,LUN,DISP,NSAM,NROW,NSLICE,
     &             MAXIM,'XXX',.TRUE.,IRTFLG)

C       MODERN NO ERROR RETURN IS ZERO
        NF = IRTFLG
        IF (IRTFLG .EQ. 0) NF = 2             

        RETURN
        END


