C****************************************************************************
C
C **************************************************************************
C *  AUTHOR :  mahieddine ladjadj                                          *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C
C	READS IN THE IMAGE, PIXEL COORDINATES AND THE EIGENVALUES
c	reads the files imc****, eig**** and pix****
C
C****************************************************************************
C 
	SUBROUTINE PCA_SRIPE( NIMA, NPIX, NFAC, LUNI, LUNP, LUND, BUF,
     &                        IOFF, NOC, NOR, SUMP, LCI, LIDI, LCP,
     &                        LIDP, LD, LPJ, JIM, MEMTOT, PCA_ERR)

	DIMENSION BUF(1)
        DIMENSION Q(1)
        POINTER   (IPQ,Q) 
        LOGICAL   RUNTIME
        INTEGER PCA_ERR,MEMTOT 
	INTEGER  NOUT,JIM,LCI,LIDI,LCP,LIDP,LD,LPJ
CNO_SAVE
        NOUT=6
	CALL REW(LUNI,0)
	READ(LUNI) NIMA, NFAC, NOC, NOR
	CALL REW(LUNP,0)
	READ(LUNP) NPIX, NFAC, NOC, NOR
	CALL REW(LUND,0)
	READ(LUND) NFAC, SUMP, TRACE

	LCI	= IOFF
	LIDI	= LCI 	+ NIMA * NFAC
	LCP	= LIDI	+ NIMA
	LIDP	= LCP 	+ NPIX * NFAC
	LD	= LIDP	+ NPIX
	LPJ     = LD	+ NFAC
        JIM     = LPJ   + NPIX

	
        CALL CHKMEM(JIM, BUF,MEMTOT, RUNTIME,IPQ,PCA_ERR)
	IF(PCA_ERR .EQ. 0) THEN  
	   CALL PCA_SRIP2( NIMA, NPIX, NFAC, LUNI, LUNP, LUND,
     &                  BUF(LCI), BUF(LIDI), BUF(LCP), BUF(LIDP),
     &                  BUF(LD), BUF(LPJ), PCA_ERR)
           IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'PCA_SRIPE',IRTFLG)
	ELSE
	   WRITE(NOUT,10) JIM, MEMTOT 	 
10         FORMAT(' NOT ENOUGH MEMORY; NEEDED: ',I12,
     &            '     AVAILABLE: ',I12) 
        END IF
	
	RETURN
	END
