C
C++************************************************************************
C
C       SUBROUTINE PCAXPOSE   
C
C **************************************************************************
C *  AUTHOR :                                                              *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C
C	AUTHOR: MAHIEDDINE LADJADJ          11/1/93
C
C
C
C	THE DATA STORED IS FOR ONE IMAGE AT THE TIME.
C	TRANSPOSE THIS DATA TO STORE IT ONE PIXEL FOR EACH IMAGE PER LINE.
C	SUBSTRACT AVERAGE PIXEL VALUE FOR EACH PIXEL AS IT IS STORED.
C	AV. PIX. VALUE = SUM (SAME PIXEL) FOR J=1,NUMIN (FOR ALL IMAGES).
C	SDV() = STANDARD DEVIATION
C         
C--*********************************************************************

        SUBROUTINE PCAXPOSE(T, PJ, NPIX, NACT, NUMIM,
     $                            LUV, LSAV, LTRANSP)


        DIMENSION T(NPIX, NACT), PJ(NPIX),LUV(NUMIM)
        DATA  LTMP /78/, LAC /1/  
CNO_SAVE

        CALL  REW(LSAV, 1)
        JA = 0
        DO  I = 1, NUMIM
          IF(LUV(I) .EQ. 1)  THEN
            JA = JA + 1
            READ(LSAV)  (T(J, JA), J = 1, NPIX), dav, var, luv(i)
          ELSE
            READ(LSAV)
          END IF
        END DO
C
C       COMPUTE AV. PIXEL VALUE AND SUBSTRACT IT.
C 
        WRITE(LTRANSP)  NPIX, NACT
        DO   I = 1, NPIX
          PJ(I) = 0.0
          DO  J = 1, NACT
             PJ(I) =  PJ(I) + T(I, J)
          END DO
           PJ(I) =  PJ(I)/NACT
          DO  J = 1, NACT
            T(I, J) = T(I, J) -  PJ(I) 
          END DO
          VAR=0.
          WRITE(LTRANSP)  (T(I, J), J = 1, NACT),  PJ(I), VAR, LAC
        END DO
        END
