
C++************************************************************************
C
C $$ PLNEDG.FOR
c
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.                             *
C *  COPYRIGHT (C)1981,1992, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ PLNEDG(X,Y,B)
C
C    CALLED BY:    SPOTWT
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C***********************************************************************

	SUBROUTINE PLNEDG(X,Y,B)

	COMMON/EDGSUM/PN(3,4)
	COMMON/UNITS/LUN,MIN,NOUT

C	WRITE(NOUT,522)(PN(1,I),I=1,4)
C522	FORMAT( ' PN(1,I)BEFORE,I=1,4 :  ',4(F8.3,1X))
C513	FORMAT( ' PN(1,I)AFTER,I=1,4 : ',4(F8.3,1X))

	PN(1,4)=B*X+PN(1,4)
	PN(2,4)=B*Y+PN(2,4)
	PN(3,4)=B+PN(3,4)
	PN(1,1)=X*X+PN(1,1)
	PN(1,2)=X*Y+PN(1,2)
	PN(1,3)=X+PN(1,3)
	PN(2,1)=PN(1,2)
	PN(2,2)=Y*Y+PN(2,2)
	PN(2,3)=Y+PN(2,3)
	PN(3,1)=PN(1,3)
	PN(3,2)=PN(2,3)
	PN(3,3)=1.+PN(3,3)

C	WRITE(NOUT,513)(PN(1,I),I=1,4)
	RETURN
	END
