 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE poem
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: poem'
       RETURN
       END
 
#else
 
C++*************************************************************************
C
C $$ POEM.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ POEM:
C
	SUBROUTINE POEM
	COMMON /UNITS/LUN,NIN,NOUT
        COMMON    /BATCH/IBCNT,NLOOP,IABSLP,ILOOP
        INTEGER          IBCNT,NLOOP,IABSLP,ILOOP
	
	INTEGER*2 IDAT(5),ITIM(4)
	INTEGER*4 KST,IST
	LOGICAL*1 FOURLW(4,320),BLANK,LINE(80),
	1 TITLE(8)
        LOGICAL*1 D1(320),D2(320)
        EQUIVALENCE (FOURLW(1,1),D1(1))
        EQUIVALENCE (FOURLW(1,76), D2(1))
	DATA D1/'A','C','I','D', 'A','G','E','D',
     1  'A','B','L','E', 'A','I','M','S', 'A','I','N','T',
	2 'A','D','A','M', 'B','A','N','D', 'B','I','R','D', 
	3 'B','A','L','L', 'B','E','L','L', 'B','U','C','K',
	4 'C','O','A','L', 'C','U','T','E', 'C','O','V','E',
	5 'C','O','O','L', 'C','O','L','D', 'D','A','W','N',
	6 'D','U','S','T', 'F','I','R','E', 'F','R','O','M',
	7 'F','A','L','L',  'F','U','L','L', 
	8 'F','I','L','L', 'F','O','U','L', 'F','A','R','T',
	9 'F','I','Z','Z', 'F','A','I','R', 
	1 'F','O','N','D', 
	2 'G','U','L','L', 'G','I','F','T', 'G','I','L','L',
	3 'G','E','N','E', 
	4 'H','U','L','L', 'H','O','N','K', 'H','E','L','M',
	5 'H','I','N','T', 'H','A','R','E','H','I','S','S',
	6 'I','G','L','U', 'K','I','N','G', 'K','N','E','E',
	7 'K','I','S','S', 'K','I','N','D', 'K','O','N','G',
	8 'K','I','L','N', 
	9 'L','A','M','P', 'L','I','N','T', 'L','U','S','T',
	1 'L','E','A','P', 'L','A','R','K', 'L','I','M','P',
	2 'L','E','A','K', 'L','I','F','T', 'L','U','M','P',
	3 'L','O','A','N', 'L','A','R','D', 'L','U','N','A',
	4 'L','O','G','O', 'L','E','G','O', 
	5 'M','O','S','S', 'M','I','N','D', 'M','O','L','E',
	6 'M','U','L','E', 'M','U','D',' ', 'M','E','S','S',
	7 'M','I','L','L', 'M','U','F','F', 'M','I','S','T',
	8 'M','E','S','A', 
	9 'N','U','M','B', 'N','U','K','E', 'N','E','S','T',
	6 'M','U','L','E', 'M','U','D',' ', 'M','E','S','S',
	7 'M','I','L','L', 'M','U','F','F', 'M','I','S','T',
	8 'M','E','S','A','M','E','S','A'/ 
        DATA D2/
	1 'N','E','M','O', 'N','E','L','Y', 'N','E','S','S',
	2 'N','I','C','E', 'N','E','R','O', 'N','O','D','E',
	3 'N','U','L','L', 'N','O','R','D', 'N','E','A','R',
	4 'O','R','K',' ', 
	5 'P','I','N','K', 'P','I','L','L', 'P','I','S','S',
	6 'P','U','N',' ', 'P','A','N',' ', 'P','E','S','T',
	7 'P','O','N','D', 'P','U','N','K', 'P','I','E','R',
	8 'P','U','L','L', 'P','U','S','H', 'P','E','E','R',
	9 'P','E','A','R', 'P','O','L','O', 'P','E','E','K',
	1 'R','A','I','N', 'R','I','M',' ', 'R','A','N','K',
	2 'R','U','L','E', 'R','I','B',' ', 'R','A','F','T',
	3 'R','I','F','T', 'R','O','M','E', 'R','U','B',' ',
	4 'R','I','S','K', 'R','O','L','L', 
	5 'S','I','L','K', 'S','A','N','D', 'S','U','N',' ',
	6 'S','I','N','K', 'S','E','N','D', 'S','U','C','K',
	7 'S','E','L','F', 'S','U','N','K', 'S','A','W',' ',
	8 'S','O','U','L', 'S','I','N',' ', 'S','E','A','T',
	9 'S','O','F','T', 'S','I','N','G', 'S','A','N','G',
	1 'S','O','M','E', 'S','E','T',' ', 'S','E','L','L',
	2 'T','U','R','D', 'T','I','L','T', 'T','I','C','K',
	3 'T','E','L','L', 'T','A','N','K', 'T','I','N',' ',
	4 'T','W','I','N', 'T','A','N',' ', 'T','E','N','D',
	5 'T','E','S','T', 'T','A','L','K', 'T','O','L','L',
	6 'T','R','I','M', 'T','O','R','N',
	7 'V','A','N',' ', 'V','O','I','D', 'V','E','S','T',
	8 'W','I','N','D', 'W','A','N','D', 'W','I','L','L',
	9 'W','A','L','K', 'W','O','R','K', 'W','I','N','K',
	1 'W','A','R','M', 'W','O','O','L', 'Z','I','N','K'/
	DATA BLANK/' '/
	DATA NWORD/151/
C
	CALL DATE(IDAT)
	CALL TIME(ITIM)
C		WRITE(NOUT,99)IDAT,ITIM
C99	FORMAT(40X,'ALBANY, NY ',5A2,' AT ',4A2//)
C101	FORMAT(' ** THIS PROGRAM GENERATES',
C	1' MORE FOUR LETTER POEMS THAN THERE ARE ATOMS IN THE',/
C	2 ' UNIVERSE. ')
C	WRITE(NOUT,102)
C102	FORMAT('   NOTE THAT YOUR CREATIVE CONTRIBUTION IS RESTRIC
C	1TED TO THE TASK ',/' OF ENTERING THREE NUMBERS INTO THE
C	2 COMPUTER. BASED ON THE ',/,' DATE AND THE TIME OF THE
C	3 DAY, RANDOM NUMBERS ARE GENERATED WHICH DETERMINE THE'
C	4 ,/,' SEQUENCE OF FOUR-LETTER WORDS STORED IN THE 
C	5PROGRAM.'/)
	CALL RDPRMI(NWPL,NLPV,NLOOP,ILOOP,
     $             'NO. OF WORDS PER LINE, LINES PER VERSE')
	CALL RDPRMI(NV,NDUM,NLOOP,ILOOP,'NO. OF VERSES')

	DO 50 I = 1,4
	IST = IDAT(I)+IST
	KST = ITIM(I)+KST
50	CONTINUE
	IWORD = RAN(IST)*NWORD+0.5
	DO 100 L = 1,4
100	TITLE(L) = FOURLW(L,IWORD)
	IWORD = RAN(IST)*NWORD+0.5
	DO 120 L = 1,4
120	TITLE(L+4) = FOURLW(L,IWORD)
	WRITE(NOUT,111) TITLE
111	FORMAT(/5X,8A1/)
	DO 500 IV = 1,NV
	DO 400 ILPV = 1,NLPV
	K = 1
	DO 300 IWPL = 1,NWPL
	IWORD = RAN(IST)*NWORD+0.6
C	WRITE(NOUT,900)IWORD
900	FORMAT(I8)
	DO 250 L = 1,4
	LINE(K) = FOURLW(L,IWORD)
250	K = K+1
	LINE(K) = BLANK
	K = K+1
300	CONTINUE
400	WRITE(NOUT,401)(LINE(L),L=1,(K-1))
	WRITE(NOUT,402)
401	FORMAT(5X,80A1)
402	FORMAT(' ')
500	CONTINUE
	RETURN
	END
 
#endif
 
