      SUBROUTINE PUTRM                                                  
     $(A,B,C,PHI,THETA,PSI,TFROM,TTO,TINC,PFROM,PTO,PINC,               
     $NSAM3,NROW3,NSL3,NSAM2,NROW2,PSFROM,PSTO,PSINC,                   
     $LUN1,ICFLAG,VORZ)                                                 
C AUTHOR: M.RADERMACHER                                                 
      INCLUDE 'CMBLOCK.INC'                                             
        DIMENSION A(NSAM2*NROW2),B(*),C(NSAM2*NROW2)                    
        DIMENSION R(10)                                                 
        LOGICAL MIRR,DEBFLAG,ICFLAG                                     
        DOUBLE PRECISION VAR,VARI                                       
        DEBFLAG=.FALSE.                                                 
       PI=3.1415927                                                     
       DTOR=PI/180.                                                     
       RTOD=180./PI                                                     
                                                                        
        BET=THETA                                                       
        GAM=PHI                                                         
                                                                        
        SB=SIN(BET)                                                     
        CB=COS(BET)                                                     
        SG=SIN(GAM)                                                     
        CG=COS(GAM)                                                     
                                                                        
        IACOUNT=NROW2                                                   
        A3START=PSFROM+PSI                                              
        A3INC=PSINC                                                     
                                                                        
        DO 4 L=1,IACOUNT                                                
                                                                        
        MIRR=.FALSE.                                                    
        ALP=(L-1)*A3INC+A3START                                         
        SA=SIN(ALP)                                                     
        CA=COS(ALP)                                                     
                                                                        
                                                                        
        XX = (CB*SA*CG + CA*SG)                                         
        YY = (CA*CG-CB*SA*SG)                                           
        ZZ = SB*SA                                                      
                                                                        
402     FORMAT(1X,'BETA,GAMMA,ALPHA,SIN AND COS:',9(G10.4,1X),/1X,      
     $  'XX,YY,ZZ=',3(G10.4,1X))                                        
                                                                        
                                                                        
        YI=YY                                                           
        IF(YI.GT.1.) THEN                                               
        WRITE(NOUT,201) YI                                              
201     FORMAT(1X,'COSINE = ',E10.4, ' SET TO +-1')                     
        YI=1.                                                           
        ENDIF                                                           
        IF(YI.LT.-1.) THEN                                              
        WRITE(NOUT,201) YI                                              
        YI=-1.                                                          
        ENDIF                                                           
        PHI=ACOS(YI)                                                    
        SPHI=SIN(PHI)                                                   
        IF(SPHI.NE.0) THEN                                              
        CT=XX/SPHI                                                      
        ST=ZZ/SPHI                                                      
        ELSE                                                            
        CT=1                                                            
        ST=0                                                            
        ENDIF                                                           
        IF(CT.NE.0) THEN                                                
        THET=ATAN2(ST,CT)                                               
        ELSE                                                            
        IF(ST.GT.0) THET=PI/2.                                          
        IF(ST.LT.0) THET=-PI/2                                          
        ENDIF                                                           
                                                                        
        ST=SIN(THET)                                                    
        CT=COS(THET)                                                    
        SP=SIN(PHI)                                                     
        CP=COS(PHI)                                                     
        XNEW=CT*SP                                                      
        YNEW=CP                                                         
        ZNEW=ST*SP                                                      
        R(1)=L                                                          
        R(2)=XX                                                         
        R(3)=YY                                                         
        R(4)=ZZ                                                         
        R(5)=ALP*RTOD                                                   
        R(6)=BET*RTOD                                                   
        R(7)=GAM*RTOD                                                   
        IF(DEBFLAG) WRITE(NDAT,101) (R(LL),LL=1,7)                      
101     FORMAT(1X,'L,XX,YY,ZZ,ALPHA,BETA,GAMMA',7(1X,F12.4))            
        R(2)=XNEW                                                       
        R(3)=YNEW                                                       
        R(4)=ZNEW                                                       
        R(5)=THET/PI*180.                                               
        R(6)=PHI/PI*180.                                                
        IF(DEBFLAG) WRITE(NDAT,102) (R(LL),LL=1,6)                      
102     FORMAT(1X,'XNEW,YNEW,ZNEW,THETA,PHI',6(1X,F12.4))               
                                                                        
        T=ABS(THET)                                                     
        ITET=T/TINC+.5                                                  
                                                                        
        IF(THET.LT.0) THEN                                              
         THET=-ITET*TINC                                                
        ELSE                                                            
         THET=ITET*TINC                                                 
        ENDIF                                                           
                                                                        
        P=ABS(PHI)                                                      
        IPHI=P/PINC+.5                                                  
                                                                        
        IF(PHI.LT.0) THEN                                               
         PHI=-IPHI*PINC                                                 
        ELSE                                                            
         PHI=IPHI*PINC                                                  
        ENDIF                                                           
                                                                        
        IF(THET.GT.TTO+0.01)THEN                                        
         THET=THET-PI                                                   
          IF(THET.LT.TFROM-.01) THEN                                    
           GOTO 4                                                       
          ENDIF                                                         
         PHI=-PHI                                                       
        ENDIF                                                           
                                                                        
        IF(THET.LT.TFROM-0.01)THEN                                      
         THET=THET+PI                                                   
          IF(THET.GT.TTO+.01) THEN                                      
           GOTO 4                                                       
          ENDIF                                                         
         PHI=-PHI                                                       
        ENDIF                                                           
                                                                        
        IF(PHI.GT.PTO+0.01)THEN                                         
         PHI=PHI-2*PI                                                   
        ENDIF                                                           
                                                                        
        IF(PHI.LT.PFROM-0.01)THEN                                       
         PHI=PHI+2*PI                                                   
          IF(PHI.GT.PTO+.01) THEN                                       
           MIRR=.TRUE.                                                  
           PHI=PHI-PI                                                   
          ENDIF                                                         
        ENDIF                                                           
                                                                        
        R(2)=XNEW                                                       
        R(3)=YNEW                                                       
        R(4)=ZNEW                                                       
        R(5)=THET/PI*180.                                               
        R(6)=PHI/PI*180.                                                
        IF(DEBFLAG) WRITE(NDAT,103) (R(LL),LL=1,6)                      
103     FORMAT(1X,'XNEW,YNEW,ZNEW,THETA,PHI',6(1X,F12.4))               
                                                                        
                                                                        
        IPLANE=(THET-TFROM)/TINC+1.5                                    
        IROW=(PHI-PFROM)/PINC+1.5                                       
        IREC=(IPLANE-1)*NROW3+IROW                                      
                                                                        
        INB3=(L-1)*NSAM3                                                
                                                                        
        IF(.NOT.ICFLAG) THEN                                            
         CALL REDLIN(LUN1,A(INB3+1),NSAM3,IREC)                         
        ELSE                                                            
                                                                        
         INDIC=(IREC-1)*NSAM3                                           
         DO  IJK=1,NSAM3                                              
         A(INB3+IJK)=B(INDIC+IJK)                                       
	 ENDDO
        ENDIF                                                           
        IF(MIRR) THEN                                                   
        DO  I=4,NSAM3,2                                                
        C(INB3+I)=-C(INB3+I)                                            
	ENDDO
        ENDIF                                                           
        IOLD=A(INB3+NSAM3)+0.5                                          
        INEW=IOLD+VORZ+0.2                                              
        IF(INEW.LT.0) INEW=0                                            
        A(INB3+NSAM3)=INEW                                              
        DO  IJK=1,NSAM3-1                                             
        X=A(INB3+IJK)*IOLD+VORZ*C(INB3+IJK)                             
        IF(INEW.NE.0) THEN                                              
        A(INB3+IJK)=X/FLOAT(INEW)                                       
        ENDIF                                                           
        IF(ICFLAG) THEN                                                 
        B(INDIC+IJK)=A(INB3+IJK)                                        
        ENDIF                                                           
	ENDDO
        IF(ICFLAG) B(INDIC+NSAM3)=INEW                                  
          VAR=0                                                         
          DO  III=3,NSAM3-2                                          
          VAR=VAR+2.*A(INB3+III)**2                                     
	  ENDDO
          REAL=A(INB3+NSAM3-1)                                          
          IMAG=0.                                                       
          VAR=VAR+(REAL*REAL+IMAG*IMAG)                                 
          VARI=VAR/DBLE(NSAM3-3)                                      
          IF(ICFLAG) THEN                                               
          B(INDIC+2)=VARI                                               
          ELSE                                                          
          A(INB3+1)=VARI                                                
          CALL WRTLIN(LUN1,A(INB3+1),NSAM3,IREC)                        
          ENDIF                                                         
        IF(DEBFLAG) WRITE(NDAT,110)                                     
     $  ALP/PI*180,BET*RTOD,GAM*RTOD,THET/PI*180,PHI/PI*180,            
     $  IPLANE,IROW,IREC,MIRR                                           
110     FORMAT(1X,5(F12.4,1X),3(I5),L1)                                 
4       CONTINUE                                                        
1000    CONTINUE                                                        
        RETURN                                                          
        END                                                             
