C $$ PW2SDR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ PW2SDR.FOR
C
	SUBROUTINE  PW2SDR(LUN1,LUN2,T,Q,NNNN,NSAM,NROW,MODE)
	DIMENSION   Q(NNNN),T(NSAM)
	CHARACTER*1  MODE
	LOGICAL*1 IFND
CNO_SAVE
	IFND=MOD(NROW,2).EQ.0
	NSC=NSAM/2+1
C
	DO    J=1,NROW
	CALL  REDLIN(LUN1,Q,NNNN,J)
C
	SCL=2.0/FLOAT(NSAM)/FLOAT(NROW)
	DO    I=NNNN-1,1,-2
	Q(NNNN-1-(NNNN-1-I)/2)=
     &		SCL*SQRT(Q(I+1)*Q(I+1)+Q(I)*Q(I))
        ENDDO
	IF(MODE.EQ.'L')  CALL  AL10(Q(NSAM/2),NSAM/2)
C HAVE TO MOVE THE LAST ELEMENT
	Q(1)=Q(NNNN-1)
	CALL  WRTLIN(LUN2,Q,NSAM,J)
	ENDDO
C	CLOSE(LUN1)
C
	DO    J=1,NROW/2
	JJ=J+NROW/2+MOD(NROW,2)
	CALL  REDLIN(LUN2,Q,NSAM,J)
	CALL  REDLIN(LUN2,T,NSAM,JJ)
	CALL  WRTLIN(LUN2,Q,NSAM,JJ)
	CALL  WRTLIN(LUN2,T,NSAM,J)
	ENDDO
C
	IF(.NOT.IFND)  THEN
	CALL  REDLIN(LUN2,T,NSAM,NROW/2+1)
	DO    J=NROW/2+1,NROW-1
	CALL  REDLIN(LUN2,Q,NSAM,J+1)
	CALL  WRTLIN(LUN2,Q,NSAM,J)
	ENDDO
	CALL  WRTLIN(LUN2,T,NSAM,NROW)
	ENDIF	
C
	NSC=NNNN/2-1
	IF(IFND)  THEN
	JB=2
	CALL  REDLIN(LUN2,Q,NSAM,1)
	DO    I=2,NSC
	II=NNNN-I
	Q(I)=Q(II)
	ENDDO
	CALL  WRTLIN(LUN2,Q,NSAM,1)
	ELSE
	JB=1
	ENDIF
	DO    J=JB,NROW
	JJ=NROW-J+JB
	CALL  REDLIN(LUN2,Q,NSAM,J)
	CALL  REDLIN(LUN2,T,NSAM,JJ)
	Q(1)=T(1)
	DO    I=2,NSC
	II=NNNN-I
	Q(I)=T(II)
	ENDDO
	CALL  WRTLIN(LUN2,Q,NSAM,J)
	ENDDO
C
C         IF(MODE.NE.'L')  Q(NSAM/2+1,NROW/1+1)=0.0
C
         END
