 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE rccang
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: rccang'
       RETURN
       END
 
#else
 


C   PROGRAM TO CALCULATE THE TILTANGLE BETWEEN TWO IMAGES
C   FROM POINT OF COORDINATES. ADAPTED FROM PROGRAM TILTANG
C   PURPOSE OF THIS VERSION IS TO CHECK CONSISTENCY OF COORDINATES
C   DURING INTERACTIVE WINDOWING.
C

	SUBROUTINE RCCANG(X0,Y0,XT,YT,XL,YL,NPOINT,ALIM)

#ifdef SP_UNIX
        INCLUDE 'CMBLOCK.INC' 
#else
        INCLUDE 'COMMON1:CMBLOCK.INC' 
#endif
	DIMENSION X0(NPOINT),Y0(NPOINT),XT(NPOINT),YT(NPOINT)

C   CALCULATE TRIANGLES:
	PI=3.14159
        ICRCT=1
        SUM=0.
        IAREA=0
        LLL=NPOINT-1
        DO 1 I=1,NPOINT-2
        DO 2 K=LLL,LLL 
C   AREA IN UNTILTED IMAGE:
        X01=X0(K)-X0(I)
        Y01=Y0(K)-Y0(I)
        X02=X0(K+1)-X0(I)
        Y02=Y0(K+1)-Y0(I)
        A0=ABS(X01*Y02-X02*Y01)        
C       WRITE(NOUT,5) A0
        IF(A0.LT.ALIM) GOTO 2
        XT1=XT(K)-XT(I)
        YT1=YT(K)-YT(I)
        XT2=XL-XT(I)
        YT2=YL-YT(I)
        AT=ABS(XT1*YT2-XT2*YT1)        
C       WRITE(NOUT,4)AT
        IF(AT.LT.ALIM) GOTO 2
        W=AT/A0
        IF(W.LE.1.) GOTO 10
        ICRCT=-1
        GOTO 2
10      CONTINUE
C       WRITE(NOUT,999) A0,AT,W
999     FORMAT(1X ,'A0,AT,W',3F12.4)
        THETA=ACOS(W)
C       WRITE(NOUT,3) IAREA,(THETA/PI*180.)
3       FORMAT(1H ,I6,'TH TILTANGLE',F12.4)
        IAREA=IAREA+1
        SUM=SUM+THETA
2       CONTINUE
1       CONTINUE
        IF(ICRCT.EQ.-1) WRITE(NOUT,6) NPOINT
6       FORMAT(1X,'POINT ',I3,' LOOKS INCORRECT')
        
        IF(IAREA.GT.0) TH=SUM/FLOAT(IAREA)
        TH=TH/PI*180.
        WRITE(NOUT,11) TH,(THETA/PI*180)
11      FORMAT(1X,'THETA:  AVERAGE:',F12.4,' LAST:',F12.4)
4       FORMAT(1X ,'AT:',F12.4)
5       FORMAT(1X ,'A0:',F12.4)
        RETURN
        END       


 
#endif
 
