       SUBROUTINE READF3(LUN,NDIM,FBUF,VALUE,IND,LINENEW,LINEOLD)
C
C Subroutine to read a line from a file and return in VALUE the value at 
c index IND. LINENEW is the line to be read, LINEOLD the line read earlier
c that is still kept in FBUF. Read the new line only if LINENEW different
c from LINEOLD. 
c Written for the purpose of reading a 3D Fourier transform from disk.
c (format -7).
c                                             5/13/91  M.Radermacher
 
        DIMENSION FBUF(NDIM)
        INCLUDE 'CMBLOCK.INC'
        IF(LINENEW-LINEOLD) 2,1,2
1       VALUE=FBUF(IND)
        RETURN
2       CALL REDLIN(LUN,FBUF,NDIM,LINENEW)
        VALUE=FBUF(IND)
C        WRITE(NOUT,100) LINEOLD,LINENEW,IND
100     FORMAT(1X,'OLD LINE:',I5,' NEW LINE:',I5,' INDEX:',I5)
        LINEOLD=LINENEW
        RETURN
        END
