
C++************************************************************ 10/11/79
C
C    READR.F                                         FCHAR AUG 89 al
C                                               USED ERRT SEPT 97 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH 	       *
C **********************************************************************
C
C READR(FCHAR,NLOOP,ILOOP)
C
C PURPOSE:  SUBROUTINE TO READ VALUES INTO REGISTERS IN PROCEDURES AT
C           EXECUTION TIME
C
C PARAMETERS:	  FCHAR         INPUT STRING
C                 NLOOP		NUMBER OF REPETITIONS
C                 ILOOP		CURRENT ITERATION
C
C NOTE:   NLOOP IS NUMREP FROM DRIVER - THE # OF REPETITIONS
C
C--*******************************************************************

      SUBROUTINE READRQ(FCHAR,NLOOP,ILOOP)

      COMMON/PARAM/ PARAM(103),NSEL(10)
      COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

      CHARACTER *(*) FCHAR

      CALL READPQ(FCHAR)
      NS = NSEL(1)

      IF (NS .GE. 10 .AND. NS .LE. 99) THEN
         CALL RDPRM(PARAM(NS),NLOOP,ILOOP,'VALUE')
      ELSE
         CALL ERRT(101,'LEGAL REGISTER RANGE IS: 10...99',NE)
      ENDIF

      RETURN
      END
