
C++*******************************************************************
C REDLIN8.F                       
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C      REDLIN8(LUN,LBUF,NB,NREC,IRTFLG)
C        LUN    LOGICAL UNIT NUMBER OF FILE BEING READ
C        LBUF   BUFFER WHERE RECORD IS READ IN
C        NB     NUMBER OF VALUES IN RECORD TO BE READ
C        NREC   RECORD TO BE READ
C        IRTFLG ERROR CODE 1 IS RETURNED IN CASE OF ERROR
C                          0 is normal
C 
C--*******************************************************************

      SUBROUTINE REDLIN8(LUN,LBUF,NB,NREC,IRTFLG)

      LOGICAL * 1   LBUF(NB)
      COMMON /LUNARA/ LUNARA(100),LASLAB

C     ADD LUNARA(LUN)(FOR LABEL REC) TO NREC TO GET THE CORRECT RECORD NUMBER

      I = NREC + LUNARA(LUN)
      READ(LUN,REC=I,ERR=1000) LBUF
      IRTFLG = 0
      RETURN

1000  IRTFLG = 1
      RETURN
      END

