
C *NAME* = RETIR.FOR                   31-JAN-86      13:23:11                  
C----------------------------------=*=----------------------------------        
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*--------------------------------------------------------------------*         
C*                                                                    *         
C*      EXHAUSTIVE RANDOM DRAWING OF K INDICES BETWEEN 1 AND N.       *         
C*      STORED IN IDK(*), IDN(N) IS A WORKING ARRAY.                  *         
C*      CALL ... SEN3A. REPLACED BY RAN FUNCTION WITH TIME-DEPENDENT  *         
C*      SEED J.F. 8/20/86. OPTION FOR SEED SPECIFICATION FROM PREVIOUS*
C*	RUN INSTALLED J.F. 11/26/86				      *         
C==06.07.80                                                           *         
C*--------------------------------------------------------------------*         

      SUBROUTINE RETIR ( N, IDN, K, IDK )                                       

      DIMENSION  IDN(N) , IDK(K)

      INCLUDE 'CMBLOCK.INC'

C AUTOMATIC SELECTION OR SPECIFICATION OF PREVIOUS SEED?

	CALL RDPRM(SEED,NLOOP,ILOOP,
     1   'ENTER SEED INTEGER (0=RANDOM DRAW)$')
C
	ISEED=SEED+0.5
	IF(ISEED.NE.0) THEN
		IST=ISEED
		WRITE(NDAT,100) IST
100		FORMAT(' ** USER-SPECIFIED SEED = ',I12)
	ELSE
C
C THE SEED NEEDS TO BE A LARGE ODD INTEGER
		IST=SECNDS(0.0)*10.+1.5
		WRITE(NDAT,101) IST
101		FORMAT(' ** RANDOM SEED ASSIGNED = ',I12)
	ENDIF
C                                               
        DO   J = 1,N                                                          
          IDN(J)= J                                                                 
	ENDDO
      KFIN  = K                                                                 
        IF (K .GT. N)                  KFIN = N                                 
        DO 30  L = 1,KFIN                                                       
          X     = N - L + 1                                                         
C      I     = X*SEN3A(BIDON) + 1.0
       I     = X*RAN(IST) + 1.0	                                              
      IDK(L)= IDN(I)                                                            
        IF (I .EQ. N)                  GO TO  30                                
      N1    = N - L                                                             
        IF (N1 .LE. 0)                 GO TO  30                                
        DO   J = I,N1                                                         
          IDN(J)= IDN(J+1)                                                          
	ENDDO
   30   CONTINUE                                                                

         RETURN                                                                 
         END                                                                    
