C++************************************************************************
C
C $$ RT3D.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ RT3D.FOR
C
C
      SUBROUTINE ROTAS3(MAXMEM,MODE)
      
      INCLUDE 'CMBLOCK.INC'  
      DIMENSION Q(1)
      POINTER   (IPQ,Q) 
      LOGICAL         RUNTIME 
      COMMON          BUF(1024),KAF(1) 
      CHARACTER *81 FILNAM
      CHARACTER *1  NULL,MODE
      DATA  LUN1,LUN2/8,9/
	
CNO_SAVE
	NULL=CHAR(0)
C  3-D  ROTATION
      CALL FILERD(FILNAM,NLETI,NULL,'INPUT',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 5
      CALL OPENFB(BUF,FILNAM,LUN1,NSAM,NROW,'O',NF,NSLICE)
      GOTO (130,110),NF
110   IF(IFORM.NE.3)  GOTO 145
      MEMWANT=NSAM*(NROW*NSLICE+1)
      CALL CHKMEM(MEMWANT , KAF, MAXMEM-(1024), 
     &	            RUNTIME,IPQ,IRTFLG)
      IF(IRTFLG.NE.0) THEN 
         CALL ERRT(6,'RT 3A ',NE)
         GOTO  5
         ENDIF
      CALL FILERD(FILNAM,NLETO,NULL,'OUTPUT',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 4
      CALL OPENFB(BUF,FILNAM,LUN2,NSAM,NROW,'UNKNOWN',NF,NSLICE)
      GOTO (130,951),NF
C
951	CONTINUE
	CALL  RDPRM2(PHI,THETA,NLOOP,ILOOP,'Phi, Theta')
	CALL  RDPRM(PSI,NLOOP,ILOOP,'Psi')
	IF(MODE.EQ.'A')  THEN
	CALL  RDPRMI(NX,NY,NLOOP,ILOOP,'Center of rotation NX, NY')
	CALL  RDPRMI(NZ,J,NLOOP,ILOOP,'Center of rotation NZ')
	ENDIF
	DO    J=1,NROW*NSLICE
	CALL  REDLIN(LUN1,Q(1+(J-1)*NSAM),NSAM,J)
	ENDDO
	KK=1+NSAM*NROW*NSLICE
C
	IF(MODE.EQ.'A')  THEN
        KLX=-NX+1
        KNX=NSAM-NX
        KLY=-NY+1
        KNY=NROW-NY
        KLZ=-NZ+1
        KNZ=NSLICE-NZ
	ELSE
	IF(MOD(NSAM,2).EQ.0)  THEN
	KNX=NSAM/2-1
	ELSE
	KNX=NSAM/2
	ENDIF
	KLX=-NSAM/2
	IF(MOD(NROW,2).EQ.0)  THEN
	KNY=NROW/2-1
	ELSE
	KNY=NROW/2
	ENDIF
	KLY=-NROW/2
	IF(MOD(NSLICE,2).EQ.0)  THEN
	KNZ=NSLICE/2-1
	ELSE
	KNZ=NSLICE/2
	ENDIF
	KLZ=-NSLICE/2
	ENDIF
	CALL  ROTS3
     &	(LUN2,Q,Q(KK),KLX,KNX,KLY,KNY,KLZ,KNZ,PSI,THETA,PHI)
4	CONTINUE 
        if (runtime) CALL ALLOCIT(0,RUNTIME,IPQ,'RT 3A',IRTFLG) 
C
5       CLOSE(LUN1)
	CLOSE(LUN2)
	RETURN
130   CALL ERRT(4,'RT 3A ',NE)
      GOTO 5
145   CALL ERRT(2,'RT 3A ',NE)
      GOTO 5
        END
