C++************************************************************************
C
C $$ RTQS_Q.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ RTQS_Q.FOR
C
         SUBROUTINE  RTQS_Q(X,OUT,LSD,NSAM,NROW,THETA,SHXI,SHYI)
         DIMENSION  X(LSD,NROW),OUT(LSD,NROW)
CNO_SAVE
C
         SHX=AMOD(SHXI,FLOAT(NSAM))
         SHY=AMOD(SHYI,FLOAT(NROW))
         ICENT=NROW/2+1
         KCENT=NSAM/2+1
         RN2=-NROW/2
         SN2=-NSAM/2
         RW2=-RN2
         RS2=-SN2
         IF(MOD(NSAM,2).EQ.0)  RW2=RW2-1.0
         IF(MOD(NROW,2).EQ.0)  RS2=RS2-1.0
         COD=COSD(THETA)
         SID=SIND(THETA)
c$doacross local(i,k,yi,ycod,ysid,xi,xold,yold)
         DO    I=1,NROW
         YI=I-ICENT-SHY
         IF(YI.LT.RN2)  YI=AMIN1(RW2+YI-RN2+1.0,RW2)
         IF(YI.GT.RW2)  YI=AMAX1(RN2+YI-RW2-1.0,RN2)
         YCOD=YI*COD+ICENT
         YSID=-YI*SID+KCENT
         DO    K=1,NSAM
         XI=K-KCENT-SHX
         IF(XI.LT.SN2)  XI=AMIN1(RS2+XI-SN2+1.0,RS2)
         IF(XI.GT.RS2)  XI=AMAX1(SN2+XI-RS2-1.0,SN2)
         YOLD=XI*SID+YCOD
         XOLD=XI*COD+YSID
         OUT(K,I)=QUADRI_Q(XOLD, YOLD, LSD ,NSAM, NROW, X)
	 ENDDO
	 ENDDO
         END
