       SUBROUTINE RWF3(LUN,NDIM,FBUF,VALUE,IND,LINENEW,LINEOLD)
C
C Subroutine to update the value at position IND in a line of a file 
c with the value VALUE. LINENEW is the line to be udated, LINEOLD the line 
c read last, which is still kept in FBUF (if the calling routine does not
c destroy it in the meantime. (i.e.: don't do this!)). Read the new line 
c only if LINENEW different from LINEOLD. In that case first write buffer 
c onto disk and then read new buffer. If LINENEW negative, only write present 
c buffer onto disk (needed to finish update).
c Written for the purpose of updating a 3D Fourier transform on disk.
c (format -7).
c                                             5/13/91  M.Radermacher

        DIMENSION FBUF(NDIM)
        INCLUDE 'CMBLOCK.INC'
        IF(LINENEW) 5,5,6
5       CALL WRTLIN(LUN,FBUF,NDIM,LINEOLD)
C        WRITE(NOUT,100) LINEOLD,LINENEW,(FBUF(LL),LL=1,NDIM)
        RETURN
6       IF(LINENEW-LINEOLD) 2,1,2
1       FBUF(IND)=VALUE
        RETURN
2       IF(LINEOLD) 4,4,3
3       CALL WRTLIN(LUN,FBUF,NDIM,LINEOLD)
C        WRITE(NOUT,100) LINEOLD,LINENEW,(FBUF(LL),LL=1,NDIM)
100     FORMAT(1X,'LOLD:',I3,' LNEW:',I3,8(1X,G10.4))
4       CALL REDLIN(LUN,FBUF,NDIM,LINENEW)
C        WRITE(NOUT,101) (FBUF(LL),LL=1,NDIM)
101     FORMAT(1X,'NEW CURRENT LINE:',8(1X,G10.4))
        FBUF(IND)=VALUE
        LINEOLD=LINENEW
        RETURN
        END
