C
C** 9/22/87 J.M.C. Spider CLASsification (Fuzzy) Interface routine
C** 6/20/88 , REVISED
C INTERFACES BETWEEN EMILIO'S PROGRAMS AND SPIDER
C                               LONG FILE NAMES FEB 89 al
C 
C-***********************************************************

	SUBROUTINE SCLASF 

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE

C       TOTAL NUMBER OF FACTOR
        PARAMETER (NFAC=10) 
        
C       TOTAL NUMBER OF IMAGES
        PARAMETER (NITEM=999)
       
C       MAXIMUM NUMBER OF CLUSTERS
        PARAMETER (KCLUS=10) 
       
C       JUST FOR THE READING OF THE IMC FILES
        PARAMETER (IAUXI=100)       

C       NOTE: I CAN NOT FIND ANY USE FOR RFEATU?? al
        COMMON           RDUM(80),RFEATU(NITEM, NFAC)

        CHARACTER *81    CLU,IMC,CLUSO,IMCO,FILPATI,FILPATC
        COMMON /COMMUN/  CLU,IMC,CLUSO,IMCO,FILPATI,FILPATC

        INTEGER          DLIS(NITEM)
        REAL             RHELP(IAUXI)
        EQUIVALENCE      (BUF,DLIS),(BUF(1600),RHELP)
        PARAMETER        (NBUFSIZ = 17008)
        COMMON /IOBUF/   BUF(NBUFSIZ)

	INTEGER          KV(NFAC)
        CHARACTER * 1    NULL,CDUM
        DIMENSION        ACJK(KCLUS)
        CHARACTER        NPROG*2

        CHARACTER     IMETH

        DATA NINP/11/,NOUP/12/       

        NULL = CHAR(0)

        FILPATI = 'IMC***'//NULL
        FILPATC = 'CLU***'//NULL

        NCLUMAX = 0
 
        NLET    = 6
        CALL RDPRMI(NUM,IDUM,NLOOP,ILOOP,'INPUT IMC-FILE CODE')
        CALL FILGET(FILPATI,IMC,NLET,NUM,IRTFLG)

        CALL RDPRMI(NUM,IDUM,NLOOP,ILOOP,'OUTPUT CLUSTER-FILE CODE')
        CALL FILGET(FILPATC,CLU,NLET,NUM,IRTFLG)

        CALL FILCAN(CLUSO,NF,NULL,NULL,CLU,DATEXC,IER)
        CALL FILCAN(IMCO, NF,NULL,NULL,IMC,DATEXC,IER)

C       CLUSO AND IMCO HAVE THE CORRECT INPUT AND OUTPUT FILES
        
        NFACT = NFAC
	ILOW  = 0
	IHI   = NFAC
        CALL RDPRAI(KV,NFAC,NFACT,ILOW,IHI,
     $        '.FACTOR NUMBERS FOR CLUSTERING:', CDUM,IRTFLG)
        
        CALL RDPRMI(NCLU,NCLUMAX,NLOOP,ILOOP,'NUMBER OF CLUSTERS')

C       NOW (ALL INTEGER*4) I HAVE THE NUMBER OF FACTORS (NFACT),
C       WHICH ARE THEY KV(NFACT), AND THE NUMBER OF CLUSTERS (NCLU)

C       I READ THE IMC FILE AND STORE THE CONTENT IN THE VECTORS

C       FEATUR (IMAGES, VALUES OF THE FACTORS)
C       DLIS   (IMAGES)--------->IT HAS THE IDENTIFIER FOR EACH IMAGE
 
        OPEN (FILE=IMCO, UNIT=NINP, STATUS='OLD', FORM='UNFORMATTED')
C       OPEN (FILE=CLUSO,UNIT=NOUP, STATUS='NEW', FORM='FORMATTED')
        OPEN (FILE=CLUSO,UNIT=NOUP, STATUS='NEW', FORM='UNFORMATTED')
        READ (NINP) NAITEM,LFACT,NSAM,NROW

C       NAITEM HAS THE ACTUALL NUMBER OF IMAGES  
C       LFACT HAS THE TOTAL CALCULATED NUMBER OF FACTOR 
                                                    
C       ERROR MESSAGES
        IF (LFACT.LT.NFACT) GOTO 910      
        IF (NAITEM.GT.NITEM) GOTO 920   

        DO I=1,NAITEM

           DO  J=1,100
              RHELP(J) = 0
           ENDDO             

           READ (NINP) (RHELP(KK), KK=1,LFACT+2),IIAUXI
           DO  II=1,NFACT
              RFEATU(I,II)=RHELP(KV(II))
           ENDDO
           DLIS(I)=IIAUXI
        ENDDO
 
C          PROGRAMS

           CALL RDPRMC(IMETH,NCHAR,.TRUE.,
     &       ' APPROACH METHOD? (GK,FZ,RB,CV.....)',NULL,IRTFLG)

           IF (IMETH.EQ.'G') GOTO 1000          
           IF (IMETH.EQ.'F') GOTO 2000
           IF (IMETH.EQ.'R') GOTO 3000
           IF (IMETH.EQ.'C') GOTO 4000

1000       CALL GKTEST(DLIS,NAITEM,NFACT,NCLU,NOUP,LFACT,KV)
           GOTO 9000
 
2000       CALL FCMTST (DLIS,NAITEM,NFACT,NCLU,NOUP,LFACT,KV)
           GOTO 9000

3000       CALL RO2TEST (DLIS,NAITEM,NFACT,NCLU,NOUP,LFACT,KV)
           GOTO 9000

4000       CALL CRTEST (NAITEM,NFACT,NCLU,NCLUMAX,LFACT,KV)
           GOTO 9000


C-----------------------------------------------------------------

C       THE CLUSTER FILE SHOULD BE CREATED BY NOW
C       FILE=CLUSO (CHAR*11), LOGICAL NUMBER=NOUP (I*4)

C---------------------------------------------------------------
C       ERRORS MESSAGES

910     WRITE(NOUT,911)
911     FORMAT(' *** TOO MANY FACTORS SPECIFIED ')
        GOTO 9000

920     WRITE(NOUT,921)
921     FORMAT(' *** TOO MANY IMAGES/ITEMS ')
        GOTO  9000

C----------------------------------------------------------

9000	CLOSE (NINP)
        CLOSE (NOUP)
        RETURN
	END
