
C++************************************************************************
C
C  SEARCHQ.F -- CHANGED TO STRING VARIABLES AUG 89 al
C               REMOVED READCH JAN 97 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    SEARCHQ(STRING,IER)
C        
c    PARAMETERS:      STRING  STRING BEING SEARCHED FOR    (SENT)
C                     IER     ERROR NUMBER                 (RETURNED)
C
C--*******************************************************************

	SUBROUTINE SEARCHQ(STRING,IER)

CNO_SAVE

        INCLUDE 'CMBLOCK.INC'

        CHARACTER *(*) STRING

        CHARACTER *80 TEMP1
        CHARACTER *80 TEMP2

C       SWITCH SEARCHING TO NCHAR=4 IF A LABEL IS SEARCHED FOR
	NCHAR = 7
	IF (STRING(1:2) .EQ.'LB' .OR. STRING(1:2) .EQ. 'lb') NCHAR=4

C       MAKE FCHAR(4) A BLANK IF LOOKING FOR FOR A ONE DIGIT LABEL 
C           (E.G. LB3)

1       FCHAR(4:4) = ' '

#ifdef SP_VMS
C       NON-PORTABLE VAX FORTRAN
  10    READ(NIN,80,END=99) NCHAR1,FCHAR
  80    FORMAT(Q,A80)
#else
C       READ ANSWER STRING
10      READ(NIN,80) FCHAR
80      FORMAT(A80)
#endif

C       FIND LAST NON-BLANK            
        NCHAR1 = lnblnk(FCHAR)

C       INCREMENT FILE POINTER
	IBCNT = IBCNT + 1

C       COMPARE STRING WITH CURRENT INPUT STRING
C       FIRST CONVERT BOTH TO UPPER CASE TO AVOID CASE MISMATCHING...
        TEMP1(1:NCHAR) = FCHAR(1:NCHAR)
        TEMP2(1:NCHAR) = STRING(1:NCHAR)
	CALL SSUPCAS(TEMP1)
	CALL SSUPCAS(TEMP2)
        IF (TEMP1(1:NCHAR) .NE. TEMP2(1:NCHAR)) GOTO 1
       
C       ALL OK, STRING FOUND, CLEAR REST OF INPUT STRING AND RETURN
	IF (NCHAR1 .LT. 80) THEN
           DO  K = NCHAR1+1,80
              FCHAR(K:K) = ' '
           ENDDO
        ENDIF

        IER = 0
        RETURN

#ifdef SP_VMS
 99     IER = 1
        IF (COPT .EQ. 'B') STOP '*** END OF INPUT FILE IN BATCH MODE'
        RETURN
#endif
	END
