
C++********************************************************************
C
C SETPRM.FOR                       DATE LAST MODIFIED: 4/22/96 BY AL
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    CALL SETPRM(LUN,NSAM,NROW,FMAXD,FMIND,AVD,TYPE)
C
C    THIS SUBROUTINE WILL SET LABEL PARAMETERS IDENTIFYING TYPE,
C    NORMALIZATION STATUS OF FILE, AND TO WRITE LABEL INTO FILE.
C
C    PARAMETERS:
C      LUN            LOGICAL UNIT NUMBER OF FILE TO BE LABELED
C      NSAM,NROW      NUMBER OF SAMPLES AND ROWS
C      FMIND,FMAXD    IF AVAILABLE, THE MINIMUM AND MAXIMUM OF THE
C                     IMAGE STORED IN THE FILE
C      AVD            AVERAGE VALUE
C      TYPE           CHAR. VARIABLE CONTAINING 1 OR TWO CHARACTERS 
C			 SYMBOLIZING THE DATA TYPE:
C			TYPE SYMBOL	DATA TYPE	IFORM
C			  R		 2-D REAL	 +1
C			  R3		 3-D REAL	 +3
C			  P		 2-D POLAR	 +2
C			  D		 NON-IMAGE DATA   0
C			  F		 2-D FOURIER	 -1
C			  F3		 3-D FOURIER  	 -3
C			  U		 UNCHANGED	 UNCHANGED	
C
C
C
C       NOTE:             DO NOT USE THIS ROUTINE ANY MORE.  USE
C                         SETPRMB INSTEAD!!!!!!!!!!!!!!!!!!!!!
C
C--*******************************************************************

      SUBROUTINE SETPRM(LUN,NSAM,NROW,FMAXD,FMIND,AVD,TYPE)

      COMMON   A(100)

      INCLUDE 'CMBLOCK.INC'
 
      CHARACTER *2  TYPE

      CALL SETPRMB(A,LUN,NSAM,NROW,FMAXD,FMIND,AVD,TYPE)
      
      RETURN
      END
                           
