C
C ************************************************************************
C
C    PROGRAM TO DISPLAY CORRESPONDENCE ANALYSIS MAPS USING COORDINATE FILES
C
C    CALLED BY:  SGRAF
C
C	CALLS HISMAP  HISMAP4  CLASYM  DATE  TIME  RDPRMC  RDPRMI
C     
C    REMOVED FROM SGRAF.FOR APRIL 89 BY al
C
C *************************************************************************

        SUBROUTINE SGRAF1(NDIM,ITEM,NFAC,N1,N2,LUNS,LMAP,LTMP,FOPT,
     &    NLINE, NPAGE, PEX, ANS, COO, X, Y, ID, ILOOK, TXT,
     &    EXTEN,XFLIP,YFLIP,TSYMB,PTYPE)

        COMMON /BATCH/ IBCNT,NLOOP,IABSLP,ILOOP
        COMMON /UNITS/LUNC,NIN,NOUT

        LOGICAL * 1    IDAT(10),ITIM(8)
        CHARACTER *10  CDAT
        CHARACTER *8   CTIM
        EQUIVALENCE    (CDAT,IDAT),(CTIM,ITIM)
        REAL * 4       COO,X,Y
	INTEGER        NDIM,ITEM,NFAC,IMSTA
        INTEGER        LMAP,MODE,ILOOK,II,NCHAR,IRTFLG,IDUM,
     &                 NLOOP,ILOOP,IK,NOUT,ITEMA,I,LUNS,K,N1,XFLIP,
     &                 N2,YFLIP,IPOS,KK,NUMDIG,NPAGE,NLINE,LTMP,IBCNT,
     &                 IABSLP,LUNC,NIN
	DIMENSION      COO(NFAC), X(NDIM), Y(NDIM), ILOOK(NDIM)
        REAL           RWGT,DIO,PEX
	INTEGER        IIII,LKUPDC,ITO(20)
        CHARACTER *(*) EXTEN,TXT,TSYMB
        CHARACTER *4   CBUF,ID(NDIM)
        CHARACTER      ANS,FOPT,PTYPE,NULL
        CHARACTER *20  CSYMB
        LOGICAL * 1    LSYMB(20)
	EQUIVALENCE    (CSYMB,LSYMB(1))

c	DATA NID/1/, NOR/1/

	CALL DATE(CDAT)
	CALL TIME(CTIM)
	WRITE(LMAP,11) CDAT,CTIM, TXT
11	FORMAT('1 ** FACTOR MAP :: ON  ',A9,' AT  ',A8,'  ** ',A/)

	IF (TXT(1:1) .EQ. 'T') WRITE(LMAP,12)
12	FORMAT(/,' ** SOURCE DATA WERE IN TRANSPOSED FORM')

        NULL       = CHAR(0)

        CSYMB(1:1) = TSYMB(1:1)

	IF (FOPT .EQ. 'S') THEN
          MODE=1

	ELSEIF (FOPT .EQ. 'C') THEN
          MODE=1

	ELSEIF (FOPT .EQ. 'I') THEN
          MODE=4

	ELSEIF (FOPT .EQ. 'D') THEN
          MODE=1
          IIII = LKUPDC(0,ILOOK)

        ELSEIF (FOPT .EQ. 'A') THEN
          MODE = 1

C         GET ALL SYMBOLS (MAXIMUM 20)
140       II = 1
142       CALL RDPRMC(CSYMB(II:II),NCHAR,.FALSE.,
     &           'SYMBOL (<RET>=END,MAX:20)',NULL,IRTFLG)
          CALL RDPRMI(ITO(II),IDUM,NLOOP,ILOOP,'UNTIL ID#')
          IF (ITO(II) .EQ. 0) THEN

C           GOT ALL THE SYMBOLS WANTED
            DO IK = II, 20
              CSYMB(IK:IK) = ' '
            END DO
            GOTO 144
          ENDIF
          II = II + 1
          IF (II .GT. 20) THEN
             WRITE(NOUT,*) ' ONLY 20 SYMBOLS ALLOWED, TRY AGAIN.'
             GOTO 140
          ENDIF
          GOTO 142
        END IF

C       ITEMA COUNTS THE NUMBER OF ACTIVE IMAGES. ONLY THESE ARE FLAGGED
C       WHEN THE CLUSTER LOOKUP OPTION IS USED
144     ITEMA = 0

        II=1
	DO  I = 1, ITEM
          READ(LUNS) (COO(K),K=1,NFAC),RWGT,DIO,IIII,IMSTA

	  IF (FOPT .EQ. 'S') THEN
C           USE 2 SYMBOLS FROM LSYMB
	    ID(I) = CSYMB(1:1)
	    X(I) = COO(N1)*XFLIP
	    Y(I) = COO(N2)*YFLIP

	  ELSEIF (FOPT .EQ. 'A') THEN
C           SYMBOL ASSIGNMENTS:
            IF (IIII .LE. ITO(II)) THEN
              ID(I) = CSYMB(II:II)
            ELSE
              II = II + 1
              ID(I) = CSYMB(II:II)
            ENDIF
	    X(I) = COO(N1)*XFLIP
	    Y(I) = COO(N2)*YFLIP

          ELSEIF (FOPT.EQ.'C' .AND. IMSTA.NE.0) THEN
	    ITEMA     = ITEMA+1
	    ID(ITEMA) = CHAR(IIII)
	    X(ITEMA)  = COO(N1)*XFLIP
	    Y(ITEMA)  = COO(N2)*YFLIP

	  ELSEIF (FOPT.EQ.'I' .OR. FOPT.EQ.'D') THEN
	    ITEMA    = ITEMA + 1
	    X(ITEMA) = COO(N1)*XFLIP
	    Y(ITEMA) = COO(N2)*YFLIP

	    IF (FOPT .EQ. 'D') THEN
C             FIXED (?) SEPT 92 al
              IIII  = LKUPDC(IIII,ILOOK)
	      IF (PTYPE .EQ. 'Y') THEN
                 CBUF(1:4) = CHAR(IIII) // '   ' 
                 IPOS  = 1
              ELSE
                 IPOS  = 3
                 CBUF(1:4) = '   ' // CHAR(IIII)
              ENDIF

            ELSE
C             THIS WRITE HAS BLANKS BEFORE THE RIGHT JUSTIFIED NUMBER

	      WRITE(CBUF(1:4),40) IIII
40	      FORMAT(I4)
              KK = NUMDIG(IIII,0)
              IPOS = 4 - KK
            ENDIF

	    IF (ANS .EQ. 'I'.AND. FOPT .NE. 'D') THEN
              IF (IPOS .GT. 0) THEN
C               ADDED JAN 90 FOR 4 DIGIT ID'S al
                IF (IMSTA .EQ. 0) CBUF(IPOS:IPOS) = 'I'
                IF (IMSTA .EQ. 1) CBUF(IPOS:IPOS) = 'A'
	      ELSE
C               IF(IMAGE NUMBER IIII IS 1*** WRITE IT AS B***, 2*** AS C***
C               CHECK IF THE IMAGE NUMBER IS GREATER THAN A 1000
                IF (KK .GT.3) THEN
                  KK = IIII / 1000 + ICHAR('A')
                  CBUF(1:1) = CHAR(KK)
	        ENDIF
              ENDIF
	    ENDIF
            ID(I) = CBUF
	  ENDIF
 	ENDDO

	IF (NPAGE .LE. 0) NPAGE = 1
	IF (PEX   .LE. 0) PEX = 2.3

	IF (FOPT .EQ. 'C') THEN
C         CLASS SYMBOL LOOKUP REQUESTED
          CALL CLASYM(ITEMA,ILOOK,ID)

C         ID CONTAINS OLD IMAGE ID WHEN CLASYM IS CALLED, AND UPON
C         RETURN FROM CLASYM, ID CONTAINS THE CLASS SYMBOL
          ITEM = ITEMA
	ENDIF	

	IF (PTYPE .EQ. 'O') THEN
C         PLOT MAP WITH SOLID AXES AND PRINTER LINE PLOT
          CALL HISMAP(NDIM,ITEM,N1,N2,X,Y,ID,
     &                MODE,NLINE,NPAGE,PEX,LMAP,
     &                LTMP,EXTEN,.TRUE.)

	ELSEIF (PTYPE .EQ. 'Y') THEN
C         CONTINUOUS SCALE PLOT. NO LINE PLOTTER OUPUT
C          CALL HISMAP4(NDIM,ITEM,N1,N2,X,Y,ID,MODE,PEX,NOR,NID,EXTEN)
          CALL HISMAP4(NDIM,ITEM,X,Y,ID,MODE,PEX,EXTEN)

	ELSEIF (PTYPE .EQ. 'W') THEN
C         WANT TO INTERACTIVELY STUDY WINDOWS FROM THE MAP FOR ANGLES
          WRITE(NOUT,*) '*** LEXIDATA ROUTINE NO LONGER LINKED' 
       
	ELSE
C         NO MAP PLOT FILE DESIRED. PRINTER LINE PLOT ONLY
          CALL HISMAP(NDIM,ITEM,N1,N2,X,Y,ID,
     &                MODE,NLINE,NPAGE,PEX,LMAP,LTMP,
     &                EXTEN,.FALSE.)
	ENDIF

	RETURN
 	END
