	SUBROUTINE  SH180_2(X,Y,LSD2,NSAM,NROW,SX,SY)
C
C  Shift 2-D in Fourier space rotating 180 degs with copy;
C  no-power-of-two dimensions
C  If SX and SY equal zero then no shift
C
	COMPLEX  X(LSD2,NROW),Y(LSD2,NROW)
	COMPLEX  R
	DOUBLE PRECISION  PI2
CNO_SAVE
	IF(SX.EQ.0.0  .AND.  SY.EQ.0.0)  THEN
	CALL  COP(X,Y,2*LSD2*NROW)
	RETURN
	ENDIF
C	INS=1
C	CALL  FMRS_2(X,NSAM,NROW,INS)
C	IF(INS.EQ.0)  THEN
C	sx=0.0
C	sy=0.0
C	RETURN
C	ENDIF
	PI2=8.0*DATAN(1.0D0)
	PX=PI2*SX/FLOAT(NSAM)
	PY=PI2*SY/FLOAT(NROW)
c$doacross local(i,j,arg,argy,iy,ix)
        DO    J=1,NROW
        IY=J-1
        IF(IY.GT.NROW/2)  IY=IY-NROW
        ARGY=PY*IY
        DO    I=1,LSD2
        IX=I-1
        ARG=PX*IX+ARGY
        Y(I,J)=CONJG(X(I,J))*CMPLX(COS(ARG),SIN(ARG))
	ENDDO
	ENDDO
C	INS=-1
C	CALL  FMRS_2(Y,NSAM,NROW,INS)
	END
