      SUBROUTINE SHIF3F (LUNI,LUNO,NSAM,NROW,NSLICE,SAMS,ROWS,SLICS)
C    
C     3-D Shift by a non-integer magnitude
C           
C     LUNI,LUNO: INPUT,OUTPUT FILES
C     SAMS, ROWS, SLICS: FLOATING POINT TRANSLATIONAL VECTOR
C
C     
C     12/30/86 J.M.Carazo
C-----------------------------------------------------------------------


      COMMON BUF (1)
      INCLUDE 'CMBLOCK.INC' 
      R0=0.
C
C It makes the X-Y  shift 
C
      IF (SAMS.EQ.0.0 .AND. ROWS.EQ.0.0) GOTO 30
      DO  ISLICE=1, NSLICE  
         NNROWS=(ISLICE-1)*NROW+1  
c	  done by MR & ML
c         NNROWE= NROWS + NROW -1
         NNROWE= NNROWS + NROW -1
         NNROWK=1
        CALL SHIFTR (LUNI,LUNO,NSAM,NROW,NNROWS,NNROWE,
     1                NNROWK,SAMS,ROWS)         
      ENDDO
      IF(SLICS.NE.0.0)  THEN
      WRITE(NOUT,*) 
     & '  Sorry, cannot make X-Y and Z real shifts in one step !'
      ENDIF
      RETURN
C
C It makes the Z SHIFT 
C
30    CONTINUE
      IF (SLICS.EQ.0.0) GOTO 101
      DO  IROW=1,NROW            
         NNROWS=IROW         
         NNROWE=(NSLICE-1)*NROW+IROW
         NNROWK=NROW
         CALL SHIFTR (LUNI,LUNO,NSAM,NROW,NNROWS,NNROWE,
     1                NNROWK,R0,SLICS)
      ENDDO
	RETURN
C
101   CONTINUE
      NLINES=NROW*NSLICE
      DO  I=1,NLINES
      CALL REDLIN(LUNI,BUF,NSAM,I)
      CALL WRTLIN(LUNO,BUF,NSAM,I)
      ENDDO
C
      END
