C++*******************************************************************
C
C $$ SHIFT2:    SHIFT A TWO-DIMENSIONAL ARRAY (PICTURE)
C
C       THIS SUBROUTINE WILL SHIFT A TWO-DIMENSIONAL ARRAY OR PICTURE
C       STORED ON LUN1 CIRCULARLY BY NSAMS,NROWS;  OUTPUT TO BE FOUND 
C       ON LUN2.
C
C       CALL SHIFT2(LUN1,LUN2,BUF,NSAM,NROW,NSAMS,NROWS)
C         LUN1           LOGICAL UNIT NUMBER OF INPUT IMAGE
C         LUN2           LOGICAL UNIT NUMBER OF OUTPUT IMAGE
C         BUF            REAL BUFFER OF SIZE NSAM
C         NSAM,NROW      DIMENSIONS OF IMAGE
C         NSAMS,NROWS    NUMBER OF SAMPLES AND ROWS TO BE SHIFTED
C
C--*******************************************************************
C
C
      SUBROUTINE SHIFT2(LUN1,LUN2,NSAM,NROW,NSAMS,NROWS)
      COMMON BUF(1)
CNO_SAVE
      NS = MOD(NSAMS,NSAM)
      NR = MOD(NROWS,NROW)
      IF(NR.LT.0) NR = NR+NROW
	if(ns.ne.0)  goto  300
      DO  I = 1,NROW
      CALL REDLIN(LUN1,BUF,NSAM,I)
      I1 = I+NR
      IF(I1.GT.NROW) I1=I1-NROW
      CALL WRTLIN(LUN2,BUF,NSAM,I1)
      ENDDO
      RETURN
300   DO  I = 1,NROW
      CALL REDLIN(LUN1,BUF,NSAM,I)
      CALL SHIFT1(BUF,buf(1+nsam),NSAM,NSAMS)
      I1 = I+NR
      IF(I1.GT.NROW) I1=I1-NROW
      CALL WRTLIN(LUN2,BUF(1+nsam),NSAM,I1)
      ENDDO
      END
