C++************************************************************************
C
C $$ SHIFT3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ SHIFT3:
C 
C THREE-DIMENSIONAL CIRCULAR SHIFT
C
	SUBROUTINE SHIFT3(LUN1,LUN2,NSAM,NROW,NSLICE,NSAMS,NROWS,NSLICS)
CNO_SAVE
	NZ = MOD(NSLICS,NSLICE)
	IF(NZ.LT.0) NZ = NZ + NSLICE
	IF(NZ.EQ.0) GOTO 300
	LEND = NSLICE-NZ
	DO  L = 1,LEND
	JROFF = (L-1)*NROW
	JWOFF = (L+NZ-1)*NROW
	CALL SHIFTT(LUN1,LUN2,NSAM,NROW,NSAMS,NROWS,JROFF,JWOFF)
	ENDDO
	DO  L = LEND+1,NSLICE
	JROFF = (L-1)*NROW
	JWOFF = (L-LEND-1)*NROW
	CALL SHIFTT(LUN1,LUN2,NSAM,NROW,NSAMS,NROWS,JROFF,JWOFF)
	ENDDO
	RETURN
300	DO  L = 1,NSLICE
	JROFF = (L-1)*NROW
	CALL SHIFTT(LUN1,LUN2,NSAM,NROW,NSAMS,NROWS,JROFF,JROFF)
	ENDDO
	END
