
C**************************************************************************
C
C   SHOSLI.FOR  -- CREATED OCT 90
C **************************************************************************
C *  AUTHOR: ArDean Leith 
C *  COPYRIGHT (C)1990 , WADSWORTH CENTER FOR LABORATORIES AND RESEARCH    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C      SHOSLI2(LUNOUT,BUF,NSAM,NSAM1,NSAM2,NREC1,NREC2,SLICE) 
C
C      PURPOSE:     PRINTS SLICE ARRAY 
C
C      PARAMETERS:  
C
C      CALLS:       WRTLIN 
C
C      CALLED BY:   CONINT
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

       SUBROUTINE SHOSLI2(LUNOUT,BUF,NSAM,NSAM1,NSAM2,NREC1,NREC2,SLICE)
 
       INTEGER   * 2  SLICE(*)
       DIMENSION      BUF(*)

         IPIX  = NSAM2 - NSAM1 + 1

         DO  I = NREC1,NREC2
            IPTR = (I-1) * NSAM + NSAM1
            WRITE(LUNOUT,90) (SLICE(J),J=IPTR,IPTR+IPIX-1)
90          FORMAT(30I4)

         END DO

         WRITE(LUNOUT,*) ' '


         RETURN
         END
    
