 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE showmen
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: showmen'
       RETURN
       END
 
#else
 

C***************************************************************************
C
C $$ SHOWMEN.FOR  -- CREATED FEB 90
C                                                                 
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1990 , WADWSWORTH CENTER FOR LABORATORIES AND RESEARCH,  *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C $$ SHOWMEN(MEN1,EXP1,MEN2,EXP2,MEN3,EXP3,MEN4,EXP4,ISEL)
C
C    PURPOSE:      WRITES OUT MENU CHOICES
C
C    PARAMETERS:   MEN1..             MENU CHOICES
C                  EXP1..             MENU EXPLANATIONS
C                  ISEL               0 FOR 1ST AND LAST
C                                     1 FIRST
C                                     2 MIDDLE
C                                     3 LAST
C
C    CALLED BY:    WI**** ROUTINES
C
C    CALLS:        
C
C        0         2         3         4         5         6         7     
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

      SUBROUTINE SHOWMEN(MEN1,EXP1,MEN2,EXP2,MEN3,EXP3,MEN4,EXP4,ISEL)

#ifdef SP_UNIX
      INCLUDE 'CMBLOCK.INC'
#else
      INCLUDE 'COMMON1:CMBLOCK.INC'
#endif

      CHARACTER *(*)  MEN1,EXP1,MEN2,EXP2,MEN3,EXP3,MEN4,EXP4
      CHARACTER *4    LABEL
      CHARACTER       NULL

      NULL = CHAR(0)

      LABEL = '    '
      IF (ISEL .EQ. 0 .OR. ISEL .EQ. 1) LABEL = 'MENU'
      WRITE(NOUT,90) LABEL,MEN1,EXP1
90    FORMAT(' ',7X,A4,6X,A,T29,A)

      IF (MEN2 .NE. NULL) WRITE(NOUT,91) MEN2,EXP2
91    FORMAT(' ',17X,A,T29,A)

      IF (MEN3 .NE. NULL) WRITE(NOUT,91) MEN3,EXP3

      IF (MEN4 .NE. NULL) WRITE(NOUT,91) MEN4,EXP4

      IF (ISEL .EQ. 0 .OR. ISEL .EQ. 3) WRITE(NOUT,*) ' '

      RETURN
      END



 
#endif
 
