
C++*************************************************************** 1/22/81
C
C $$ SHR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ SHR:      SUBROUTINE TO SHRINK IMAGE FROM OUTSIDE
C
C***************************************************************************

	SUBROUTINE SHR(LUN1,LUN2,NSAM,NROW)

	COMMON ADUM(80),BUF(1)
	COMMON/FUNCTION/FCHAR
        COMMON    /BATCH/IBCNT,NLOOP,IABSLP,ILOOP
        INTEGER          IBCNT,NLOOP,IABSLP,ILOOP

        CHARACTER *80 FCHAR
        CHARACTER     NULL,FOPT

        NULL = CHAR(0)

	CALL RDPRMC(FOPT,NCHAR,.TRUE.,
     &    'RETAIN PIXELS (A)BOVE OR (B)ELOW THRESHOLD? (A/B)',
     &    NULL,IRTFLG)

	CALL RDPRM(THR,NLOOP,ILOOP,'THRESHOLD$')
	FACT = 1.0
	IF (FCHAR(4:4) .EQ. 'M') FACT=0.
	IF (FOPT .EQ. 'B') GOTO 200

	DO 100 I=1,NROW
          CALL REDLIN(LUN1,BUF,NSAM,I)
          IF (FCHAR(4:4) .EQ. 'M') THEN
            DO  K=1,NSAM
              BUF(NSAM+K)=1.
	    ENDDO
          ENDIF
16        DO  K=1,NSAM
            KK=K
            B = BUF(K)
            IF (B .LT. THR) BUF(K+NSAM)=THR*FACT
            IF (B .GE. THR) GOTO 11
	  ENDDO
          GOTO 12

11        IF (KK .EQ. NSAM) GOTO 100
12	  DO  K=NSAM,1,-1
            KK=K
            B=BUF(K)
            IF(B.LT.THR)BUF(K+NSAM)=THR*FACT
            IF(B.GE.THR)GOTO 100
	  ENDDO
100	CALL WRTLIN(LUN2,BUF(NSAM+1),NSAM,I)
	RETURN

200	DO 300 I=1,NROW
          CALL REDLIN(LUN1,BUF,NSAM,I)
          IF (FCHAR(4:4) .EQ. 'M') THEN
            DO  K=1,NSAM
              BUF(NSAM+K)=1.
	    ENDDO
          ENDIF
220	  DO  K=1,NSAM
            KK=K
            B=BUF(K)
            IF (B.GT.THR)BUF(K+NSAM)=THR*FACT
            IF (B.LE.THR)GOTO 321
	  ENDDO
          GOTO 322

321	  IF (KK.EQ.NSAM) GOTO 300
322       DO  K=NSAM,1,-1
            KK=K
            B=BUF(K)
            IF (B.GT.THR)BUF(K+NSAM)=THR*FACT
            IF (B.LE.THR)GOTO 300
	  ENDDO
300	CALL WRTLIN(LUN2,BUF(NSAM+1),NSAM,I)

	END

