
C++**************************************************************************
C
C SHRINKQ.FOR
C                  ADAPTED FROM SHRINK.FOR FOR CHAR. AUG 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    SHRINKQ:      SUBROUTINE TO  SHRINK STRING BY IGNORING BLANKS
C
C    PARAMETERS:   INSTR      INPUT STRING TO BE SHRANK
C                  LENIN      LENGTH OF INPUT STRING.  KEPT FOR
C                             COMPATIBILIY WITH OLD CALLS
C                  OUTSTR     OUPUT SHRUNKEN STRING
C                  LENOUT     LENGTH OF SHRUNKEN STRING
C
C *************************************************************************

	SUBROUTINE SHRINKQ(INSTR,LENIN,OUTSTR,LENOUT)

        CHARACTER *(*) INSTR,OUTSTR

C**        OUTSTR = ' '

        LENMAX = LEN(OUTSTR)
        LENS   = LENIN
        IF (LENS .EQ. 0) LENS = LEN(INSTR)

        LENOUT = 0
	DO  I=1,LENS
          IF (INSTR(I:I) .NE. ' ' .AND. LENOUT .LT. LENMAX) THEN
            LENOUT = LENOUT + 1
            OUTSTR(LENOUT:LENOUT) = INSTR(I:I)
          ENDIF
	ENDDO

        IF (LENOUT. LT. LENMAX) THEN
C          PUT BLANKS AT END OF OUTSTR
           OUTSTR(LENOUT+1:LENMAX) = ' '
        ENDIF

	RETURN
	END
