
C++************************************************************************
C
C  SSTOGL.FOR  -- CREATED OCT 87
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1985 & 1986, DIVISION OF LABORATORIES AND                *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    SSTOGL(PARAM,TRUEM,FALSEM,RECAL,RECALC,IRTFLG)
C
C    PURPOSE:       
C
C    PARAMETERS:    
C                   IRTFLG       ERROR RETURN
C
C    CALLED BY:     SSDRV5
C
C    CALLS:         
C
C--********************************************************************

        SUBROUTINE SSTOGL(PARAM,TRUEM,FALSEM,RECAL,RECALC,IRTFLG)

        COMMON /UNITS/ LUNDOC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

        CHARACTER *(*) TRUEM,FALSEM
        LOGICAL        PARAM,RECAL,RECALC

         PARAM = .NOT. PARAM

         IF (PARAM) THEN
            NCHAR = INDEX(TRUEM,'$') - 1
            IF (NCHAR .LE. 0) NCHAR = LEN(TRUEM)
            WRITE(NOUT,90) (TRUEM(III:III),III=1,NCHAR)
90          FORMAT(1X,80A1,/)

         ELSE
            NCHAR = INDEX(FALSEM,'$') - 1
            IF (NCHAR .LE. 0) NCHAR = LEN(FALSEM)
            WRITE(NOUT,90) (FALSEM(III:III),III=1,NCHAR)
         ENDIF

         IF (RECAL) RECALC = .TRUE.

         RETURN
         END

