C AUTHOR: M.RADERMACHER, 6/92                                           
                                                                        
      SUBROUTINE TDLOCAL(LUN1,LUN2,LUN3)                                
#ifdef SP_UNIX                                                          
      INCLUDE 'CMBLOCK.INC'                                             
#else                                                                   
      INCLUDE 'COMMON1:CMBLOCK.INC'                                     
#endif                                                                  
      PARAMETER (MAXKEY=5000)                                           
      PARAMETER (MAXREG=4)                                              
      COMMON BUF(2048),FR(10),IP(10),IR(10),FF(10),                     
     $ISQ(4000),SELECT(4000),PHIG(4000),THEG(4000),                     
     $DBUF(MAXREG,MAXKEY),PLIST(7)                                      
     $,ILIST(10000),A0(262144)                                          
      CHARACTER*81 DOCNAM,DOCNAMO,FILIN,FILOUT1,FILOUT2,FNPR            
      CHARACTER*1 NULL,YN                                               
      LOGICAL GFLAG,SFLAG,MFLAG,VFLAG                                   
      PI=3.1415927                                                      
      NULL=CHAR(0)                                                      
      CALL FILERD(DOCNAM,NLET,NULL,'INPUT DOCUMENT',IRTFLG)             
      CALL FILERD(DOCNAMO,NLETO,NULL,'OUTPUT DOCUMENT',IRTFLG)          
      CALL FILCAN(DOCNAM,NLET,NULL,NULL,DOCNAM,DATEXC,IRTFLG)           
101   CALL RDPRMC(YN,NA,.TRUE.,'IMPUT FROM (V)ISUAL MAP OR (H)AC$',     
     $NULL,IRTFLG)                                                      
      IF(YN.EQ.'V') THEN                                                
       VFLAG=.TRUE.                                                     
       ELSE                                                             
         IF(YN.NE.'H') THEN                                             
         WRITE(NOUT,*) 'PLEASE ANSWER  H  OR  V'                        
         GOTO 101                                                       
         ENDIF                                                          
         VFLAG=.FALSE.                                                  
      ENDIF                                                             
      IF(VFLAG) THEN                                                    
      NLIST=3                                                           
      CALL UNSDAL(DOCNAM,ICALL,LUN1,1,PLIST,NLIST,DBUF,MAXKEY,          
     $MAXREG,NKEY,LERR)                                                 
      IFILNUM=10000                                                     
      CALL RDPRAI(ILIST,10000,IFILNUM,1,10000,'SQUARE NUMBERS$',        
     $NULL,IRTFLG)                                                      
      IPCOUNT=0                                                         
      DO 11 K=1,IFILNUM                                                 
      ISQUARE=ILIST(K)                                                  
      DO 1 I=1,NKEY                                                     
      IF(DBUF(3,I).NE.ISQUARE) GOTO 1                                   
      IPCOUNT=IPCOUNT+1                                                 
      SELECT(IPCOUNT)=DBUF(2,I)                                         
      ISQ(IPCOUNT)=ISQUARE                                              
1     CONTINUE                                                          
11    CONTINUE                                                          
      CLOSE(LUN1)                                                       
      ELSE                                                              
       NLIST=2                                                          
       CALL UNSDAL(DOCNAM,ICALL,LUN1,1,PLIST,NLIST,DBUF,MAXKEY,         
     $MAXREG,NKEY,LERR)                                                 
       IPCOUNT=NKEY                                                     
       DO 102 I=1,NKEY                                                  
       ISQ(I)=0                                                         
       SELECT(I)=DBUF(2,I)                                              
102    CONTINUE                                                         
       CLOSE(LUN1)                                                      
      ENDIF                                                             
                                                                        
      NRUN=0                                                            
      IF(IPCOUNT.EQ.0) THEN                                             
      WRITE(NOUT,*) ' IMAGE SET EMPTY, NO RECONSTRUCTION POSSIBLE '     
      RETURN                                                            
      ENDIF                                                             
      CALL FILERD(FILIN,NLETP,NULL,'TILT IMAGE FILES TEMPLATE'          
     $,IRTFLG)                                                          
      CALL RDPRMI(IX,IY,NLOOP,ILOOP,'X,Y-DIMENSION OF REAL SPACE 3D$')  
      CALL RDPRMI(IZ,IDUM,NLOOP,ILOOP,'Z-DIMENSION$')                   
      CALL RDPRM2(RMASK,RAYL,NLOOP,ILOOP,                               
     $'PROJ.MASK RADIUS,RAY LENGHT$')                                   
      IF(RMASK.EQ.0) RMASK=1.5*IX                                       
      IF(RAYL.EQ.0) RAYL=1.5*IX                                         
      CALL FILERD(FILOUT1,NLET1,NULL,                                   
     $'3D TRANSFER FUNCTION, * IF NOT DESIRED',                         
     $IRTFLG)                                                           
      IF(FILOUT1(1:1).EQ.'*') GOTO 100                                  
         NA=1                                                           
         CALL RDPRMC(YN,NA,.TRUE.,'(S)INC-FCT.,(G)AUSS-FCT.,(M)IXED $', 
     $   NULL,IRTFLG)                                                   
         GFLAG=.FALSE.                                                  
         SFLAG=.FALSE.                                                  
         MFLAG=.FALSE.                                                  
         IF(YN.EQ.'G') THEN                                             
         GFLAG=.TRUE.                                                   
         WRITE(NOUT,*) 'GAUSSIAN'                                       
         ENDIF                                                          
         IF(YN.EQ.'S') THEN                                             
         SFLAG=.TRUE.                                                   
         WRITE(NOUT,*) 'SINC-FUNCTION'                                  
         ENDIF                                                          
         IF(YN.EQ.'M') THEN                                             
         MFLAG=.TRUE.                                                   
         WRITE(NOUT,*) 'SINC * GAUSS -FUNCTION'                         
         ENDIF                                                          
         IF(MFLAG) CALL RDPRM(GRAY,NLOOP,ILOOP,'SIGMA$')                
         NA=1                                                           
         CALL RDPRMC(YN,NA,.TRUE.,                                      
     $    '2 X PADDED TRANFER FUNCTION? (Y/N=DEF)$',NULL,IRTFLG)        
         IPAD=1                                                         
         IF(YN.EQ.'Y') IPAD=2                                           
       MISS=0                                                           
      DO 201 I=1,IPCOUNT                                                
      NR=SELECT(I)                                                      
      CALL FILGET(FILIN,FNPR,NLETP,NR,IERR)                             
      CALL OPENFB(BUF,FNPR,LUN2,NSAM,NROW,'OLD',NF,NDUM)                
      IF (NF .NE. 2 .OR. IFORM .LT. 0) THEN                             
      WRITE (NOUT,51) FNPR(1:20)                                        
   51 FORMAT                                                            
     $(' *** WARNING:',A20,' DOES NOT EXIST, OR ARRAY NOT REAL ***')    
      MISS=MISS+1                                                       
      GOTO 201                                                          
      ENDIF                                                             
      NN = 3                                                            
      CALL GETANG(LUN2,NSAM,BUF,15,NN,FF,IRTFLG)                        
      PHIG(I-MISS)=FF(1)/180.*PI                                        
      THEG(I-MISS)=FF(2)/180.*PI                                        
      CLOSE(LUN2)                                                       
201   CONTINUE                                                          
      IPC=IPCOUNT-MISS                                                  
      IYW=IPAD*IY                                                       
      IZW=IPAD*IZ                                                       
      NSAMW=IPAD*IX+2                                                   
      IFORM=-9                                                          
      CALL OPENFB(BUF,FILOUT1,LUN2,NSAMW,IYW,'UNKNOWN',IER,IZW)         
      CRIT=1.                                                           
      CALL TRANS3D                                                      
     $(LUN2,NSAMW,IYW,IZW,PHIG,THEG,GFLAG,                              
     $ SFLAG,MFLAG,GRAY,RAYL,.FALSE.,IPC,CRIT,                          
     $ A0(1),A0(4001),A0(8001),A0(12001))                               
      CLOSE(LUN2)                                                       
100   CALL FILERD(FILOUT2,NLET2,NULL,                                   
     $' SIMPLE BACK-PROJECTION FILE, * IF NOT DESIRED',                 
     $IRTFLG)                                                           
      IF(FILOUT2(1:1).EQ.'*') GOTO 200                                  
      CALL RDPRM(ENL,NLOOP,ILOOP,'ENLARGEMENT FACTOR$')                 
      IFORM=3                                                           
      CALL OPENFB(BUF,FILOUT2,LUN1,IX,IY,'U',NF,IZ)                     
      IR(1)=IX                                                          
      IR(2)=IY                                                          
      IR(3)=IZ                                                          
      IR(4)=1                                                           
      IR(5)=IZ                                                          
      IR(6)=1                                                           
      FR(1)=ENL                                                         
      FR(7) = RMASK                                                     
      FR(8) = RAYL                                                      
      NRUN=0                                                            
      DO 1000 K = 1,IPCOUNT                                             
      NR=SELECT(K)                                                      
                                                                        
      CALL FILGET(FILIN,FNPR,NLETP,NR,IERR)                             
      IF (IERR .EQ. 2) THEN                                             
      CLOSE(LUN1)                                                       
      RETURN                                                            
      ENDIF                                                             
      CALL OPENFB(BUF,FNPR,LUN2,NSAM,NROW,'OLD',NF,NDUM)                
      IF (NF .NE. 2 .OR. IFORM .LT. 0) THEN                             
      WRITE (NOUT,50) FNPR(1:20)                                        
   50 FORMAT                                                            
     $(' *** WARNING:',A20,' DOES NOT EXIST, OR ARRAY NOT REAL ***')    
      PLIST(1)=K                                                        
      PLIST(2)=NR                                                       
      PLIST(3)=ISQ(K)                                                   
      PLIST(4)=0.                                                       
      PLIST(5)=0.                                                       
      PLIST(6)=0.                                                       
      PLIST(7)=0.                                                       
      CALL SAVDN1(LUN3,DOCNAMO,PLIST,7,NRUN,1)                          
      NRUN=1                                                            
      GOTO 1000                                                         
      ENDIF                                                             
      IP(1) = NSAM                                                      
      IP(2) = NROW                                                      
      IP(3) = IFORM                                                     
      NN = 3                                                            
      CALL GETANG(LUN2,NSAM,BUF,15,NN,FF,IRTFLG)                        
      FR(4) = FF(2)                                                     
      FR(5) = FF(1)                                                     
      FR(6) = FF(3)                                                     
      PLIST(1)=K                                                        
      PLIST(2)=NR                                                       
      PLIST(3)=ISQ(K)                                                   
      PLIST(4)=FF(1)                                                    
      PLIST(5)=FF(2)                                                    
      PLIST(6)=FF(3)                                                    
      PLIST(7)=1.                                                       
      CALL SAVDN1(LUN3,DOCNAMO,PLIST,7,NRUN,1)                          
      NRUN=1                                                            
      WRITE(NOUT,500) FR(4),FR(5),FR(6)                                 
500   FORMAT('  THETA=',F10.2,'   PHI=',F10.2,'   PSI=',F10.2)          
      DO 800 J = 1, NROW                                                
      CALL REDLIN(LUN2,BUF,NSAM,J)                                      
      IND = (J-1)*NSAM                                                  
      DO 600 J1 = 1, NSAM                                               
      INDI = IND + J1                                                   
      A0(INDI)=BUF(J1)                                                  
600   CONTINUE                                                          
800   CONTINUE                                                          
      CLOSE(LUN2)                                                       
      CALL MIRBP3A(A0,LUN1,BUF,IR,FR,IP,1)                              
1000  CONTINUE                                                          
      CLOSE(LUN1)                                                       
      CLOSE(LUN3)                                                       
200   CONTINUE                                                          
      RETURN                                                            
      END                                                               
