C++************************************************************************
C
C $$ TFD.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C changed 9/5/94 to include intelligible
C Gaussian parameter jf
C
C $$ TFD.FOR
C
         SUBROUTINE TFD(B,CS,DZ,LAMBDA,KM,NSAM,Q,DS,IE,AK,WGH,ENV)
         REAL LAMBDA,KM,KAPPA
         DATA  PI/3.14159/
CNO_SAVE
         CS1 = CS*1.E7
         F1=1./SQRT(CS1*LAMBDA)
         F2=SQRT(SQRT(CS1*LAMBDA**3))
         Q1 = (Q*F2)**2
         ENV1=ENV/F2**2
         AK=AK*F2
         F=-PI**2
         DS1=DS*DS*F1
         KAPPA=DS1*F/(16.*ALOG(2.))
         DZ1=DZ*F1
         P=AK**3-DZ1*AK
         CH=EXP(AK**4*KAPPA)
C         B=(EXP(F*Q1*P**2)*CH)*2*EXP(-ENV1*AK**2)
C Factor "2" was removed to have the CTF=W at zero.
         B=(EXP(F*Q1*P**2)*CH)*EXP(-ENV1*AK**2)
         IF(IE.EQ.1) RETURN
         QQT=2.*PI*(.25*AK**4-.5*DZ1*AK**2)
         B=B*((1.0-WGH)*SIN(QQT)-WGH*COS(QQT))
         END

