
C++************************************************************************
C
C $$ TRAF.FOR
C                                      LONG FILE NAMES JAN 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ TRAF(LUN)
C
C        LUN    LOGICAL UNIT NUMBER OF FILE
C
C--*******************************************************************

        SUBROUTINE TRAF(LUN)

        INCLUDE 'CMBLOCK.INC'
        COMMON ADUM(80),B
        COMMON /COMMUN/FILNAM

        CHARACTER *81 FILNAM
        CHARACTER     NULL,ANS,E,S,OPTC
	REAL          B(512),LAMBDA,KM

	DATA E/'E'/,S/'S'/
CNO_SAVE
        NULL = CHAR(0)
C
	CALL FILERD(FILNAM,NLET,NULL,'OUTPUT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
	CALL RDPRM(CS,NLOOP,ILOOP,'CS ')
	CALL RDPRM(LAMBDA,NLOOP,ILOOP,'LAMBDA')
	CALL RDPRM(DZ1,NLOOP,ILOOP,'LOWER DEFOCUS LIMIT')
	CALL RDPRM(DZ2,NLOOP,ILOOP,'UPPER DEFOCUS LIMIT')
	CALL RDPRMI(NSAM,NROW,NLOOP,ILOOP,
     &	'NUMBER OF SP.FREQ.PTS/DEF.POINTS')
	CALL RDPRM(KM,NLOOP,ILOOP,'MAXIMUM SPATIAL FREQUENCY[A-1]')
	CALL RDPRM(Q,NLOOP,ILOOP,'SOURCE SIZE[A-1]')
	CALL RDPRM(DS,NLOOP,ILOOP,'DEFOCUS SPREAD[A]')
         CALL RDPRM2(WGH,ENV,NLOOP,ILOOP,
     &   'Ampl contrast ratio [0-1], Gaussian env halfw [Fou units]')
	ENV=1./ENV**2
        IFORM = 1
C       OPEN CONVERTED TO OPEN3 JUNE 88 al
        NSAMT=NSAM
        NROWT=NROW
C       I CAN NOT SEE HOW THIS HAS ANY LOGIC HERE!  al
c        IF (OPTC .EQ. 'Y') THEN
c          copied next two lines to below ml 2/2/95
c           NSAMT=NSAM+2
c           NROWT=NROW+2
c        ENDIF
        NF=1
	NSLICE=1
        CALL OPENF(FILNAM,LUN,NSAMT,NROWT,'UNKNOWN',NF,NSLICE)
	CALL RDPRMC(ANS,NCHAR,.TRUE.,
     &     '(D)IFFRACTOGRAM/(E)NVELOPE/(S)TRAIGHT',NULL,IRTFLG)
        CALL RDPRMC(OPTC,NCHAR,.TRUE.,'FRAME? (Y/N)',NULL,IRTFLG)
	IF (ANS .EQ. E)IE=1
	DZ=DZ1
	DDZ=(DZ2-DZ1)/FLOAT(NROW)

C       FRAME OPTION
        IF (OPTC .EQ. 'Y') THEN
c          copied next two lines from above ml 2/2/95
           NSAMT=NSAM+2
           NROWT=NROW+2
           IOFF=1
           B(1)=1
           B(NSAMT)=1
           IFRAME=1
        ELSE
           IOFF=2
           IFRAME=0
        ENDIF
C
        IDONE=0
	DO  I=1,NROW
	  CALL TF(B(2),CS,DZ,LAMBDA,KM,NSAM,Q,DS,IE,WGH,ENV)
          IF (OPTC .EQ. 'Y') B(NSAMT)=1

C         ZERO DEFOCUS LINE AS PART OF FRAME
          IF (OPTC.EQ.'Y'.AND.ABS(DZ).LT.DDZ.AND.IDONE.EQ.0) THEN
            DO  K=1,NSAMT
5             B(K)=1
            END DO
            IDONE=1
          ENDIF
C
          IF (ANS .EQ. S) GOTO 12
	  DO  IA=2,NSAM+1
	    B(IA)=B(IA)*B(IA)
	  ENDDO

12	  CALL WRTLIN(LUN,B(IOFF),NSAMT,I+IFRAME)
	  DZ=DZ+DDZ
	ENDDO

        IF (OPTC .EQ. 'Y') THEN
           DO  K=1,NSAMT
             B(K)=1
	   ENDDO
           CALL WRTLIN(LUN,B(IOFF),NSAMT,1)
           CALL WRTLIN(LUN,B(IOFF),NSAMT,NROWT)
        ENDIF
	CALL SETPRM(LUN,NSAMT,NROWT,0.,0.,0.,'R')
	END
