
C
C **************************************************************************
C *  AUTHOR :                                                              *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C
C***************************************************************************
C

        SUBROUTINE TRANSPOSE(T,NPIX,NACT,NUMIM,LUV,LSAV,LTRANSP)

C        INTEGER*4 NUMIM, NPIX, NACT
        DIMENSION T(NPIX, NACT), LUV(NUMIM)
C, DAV, VAR, WEIGHT
C        INTEGER LUV(NUMIM)
C        INTEGER LTMP, LSAV, LAC, LTRANSP
        DATA  LTMP /78/, LAC /1/  
C        INTEGER JA, I, J
CNO_SAVE
c  Warning !  luv changes meaning ...

        CALL  REW(LSAV, 1)
        JA = 0
        DO  I = 1, NUMIM
          IF(LUV(I) .EQ. 1)  THEN
            JA = JA + 1
            READ(LSAV)  (T(J, JA), J = 1, NPIX), dav, var, luv(i)
          ELSE
            READ(LSAV)
          END IF
        END DO
        
        WRITE(LTRANSP)  NPIX, NACT
        DO   J = 1, NPIX
          VAR = 0.0
          WEIGHT = 0.0
          DO  I = 1, NACT
            WEIGHT = WEIGHT + T(J, I)
            VAR = VAR + T(J, I)**2
          END DO
          DAV = WEIGHT/NACT
          VAR = (VAR - (DAV**2) * NACT )/(NACT - 1)
          WRITE(LTRANSP)  (T(J, I), I = 1, NACT), WEIGHT, VAR, LAC
        END DO
        RETURN
        END
