#ifdef SP_SUN4 
 
C   THIS ROUTINE FAILED TO COMPILE ON SUN
 
       SUBROUTINE unix32
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: unix32'
       RETURN
       END
 
#else


C++************************************************************************
C
C    UNIX32.FOR  --  FEB 91 al
C
C **************************************************************************
C *  COPYRIGHT (C)1991,       WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    FUNCTION UNIX32(IVAL)
C
C    PURPOSE:  QUICKLY CONVERT A UNIX FLOATING POINT NUMBER TO A VAX FLOATING
C              POINT NUMBER. 
C
C    PARAMETERS:   IVAL       FLOATING POINT NUMBER!!!
C
C **************************************************************************

      REAL * 4 FUNCTION UNIX32(IVAL)

      LOGICAL * 1  IO1,IO2,IO3,IO4,IN1,IN2,IN3,IN4,LVALIN(4),LVALOUT(4)

      INTEGER * 2  I2
      INTEGER * 4  IVALIN,IVAL

      EQUIVALENCE  (I2,FVALOUT),(LVALIN,IVALIN),(LVALOUT,FVALOUT)
      
      EQUIVALENCE  (IN1,LVALIN(1)), (IN2,LVALIN(2)), (IN3,LVALIN(3)),
     &             (IN4,LVALIN(4))

      EQUIVALENCE  (IO1,LVALOUT(1)),(IO2,LVALOUT(2)),(IO3,LVALOUT(3)),
     &             (IO4,LVALOUT(4))
 
      IVALIN = IVAL

C     FLIP THE BYTES IN EACH OF THE WORDS
      IO1 = IN2
      IO2 = IN1
      IO3 = IN4
      IO4 = IN3

C     IF THE EXPONENT IS NOT ZERO, CHANGE THE EXPONENT FROM UNIX EXCESS 
C     127 NOTATION TO VAX EXCESS 128 BY ADDING ONE TO EXPONENT FIELD
C     32640 = 0111 1111 1000 0000
C     256 = 0000 0001 0000 0000
C     I2 IS EQUIVALENCED TO FIRST HALF OF FVALOUT

      IF (IAND(INT(I2),32640) .NE. 0)  I2 = I2 + 256

      UNIX32 = FVALOUT

      RETURN
      END
#endif  
