
C++*************************************************************************
C
C UNSDAL2.FOR                            MERGED WITH UNSDAL SEPT 96 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  UNSDAL2(DOCNAM,ICALL,IC,NDOC,IKEY,PLIST,NLIST,DBUF,MAXKEY,MAXREG,
C          NKEY,LERR)
C
C    PURPOSE:  RECOVERS ARRAY OF REGISTERS FROM DOCUMENT FILES.  
C
C    PARAMETERS:
C         DOCNAM        DOC. FILE NAME        (SENT WITHOUT EXTENSION)
C         ICALL         FLAGS SHOWING A DOC FILE IS IN 
C                          DBUF(*,*,IC) NOW                     (SENT)
C         IC            NUMBER FOR THIS DOC FILE (<3)           (SENT)
C         NDOC          LOGICAL UNIT FOR DOC FILE               (SENT)
C         IKEY          KEY FOR LINE OF REGISTERS RETURNED      (SENT)
C                           IN PLIST
C         NLIST         NUMBER OF KEYS ON A LINE                (SENT)
C         DBUF          BUFFER OF RETRIEVAL FROM DOC. FILE  (RETURNED)
C         MAXKEY        NUMBER OF HIGHEST LINE THAT MAY BE 
C                         IN DOC. FILE                          (SENT)
C         NKEY          NUMBER OF HIGHEST KEY FOUND IN FILE (RETURNED)
C         LERR          ERROR FLAG                          (RETURNED)
C
C--*******************************************************************

C       DO NOT USE THIS ROUTINE ANYMORE !!!
C       CALL  UNSDAL DIRECTLY INSTEAD.

C       NOTE THAT A DIRECT CALL OF THIS ROUTINE WITH IC >= 2
C       WOULD HAVE FAILED ANYWAY, SO IT WAS USELESS FOR ANY IC
C       OTHER THAN 1 EXCEPT WHEN CALLED THRU RDDOC2AQ

        SUBROUTINE UNSDAL2(DOCNAM,ICALL,IC,NDOC,IKEY,PLIST,NLIST,
     &                      DBUF,MAXKEY,MAXREG,NKEY,LERR)

CNO_SAVE

        CALL UNSDAL(DOCNAM,ICALL,NDOC,IKEY,PLIST,NLIST,
     &                      DBUF,MAXKEY,MAXREG,NKEY,LERR)

        RETURN
        END


