        SUBROUTINE  UQU
        PARAMETER  (N=3)
        DIMENSION  P(N+1,N),Y(N+1),PR(N),PRR(N),PBAR(N),AK(N)
        COMMON /ITERU/  ITER
        COMMON  /PARM/  NT,PIT(4)
        EXTERNAL  FCNQ
C       EXTERNAL  GRAD
        data  pi/3.1415926/
CNO_SAVE
C
        ITER=0
        DO    I=1,3
          P(2,I)=PIT(I)/180.0*PI
	ENDDO
c bracket by 20 degs
	BRACKET=0.34906585
        P(1,1)=P(2,1)-BRACKET
        P(1,2)=P(2,2)+BRACKET
	P(1,3)=P(2,3)+BRACKET
        P(3,1)=P(2,1)+BRACKET
        P(3,2)=P(2,2)+BRACKET
	P(3,3)=P(2,3)-BRACKET
        P(4,1)=P(2,1)-BRACKET
        P(4,2)=P(2,2)+BRACKET
	P(4,3)=P(2,3)-BRACKET
C find initial values
	DO    J=1,4
	DO    I=1,3
	  AK(I)=P(J,I)
	ENDDO
	Y(J)=FCNQ(AK)
	ENDDO
c
         EPS=0.0001
	ITRMAX=300	
	call  amoeba(P,Y,N,EPS,FCNQ,ITER,ITRMAX,pr,prr,pbar)
c
        DO    I=1,3
          PIT(I)=P(4,I)*180.0/PI
	ENDDO
        PIT(4)=1.0-Y(4)
        WRITE(NT,1020)  (PIT(L),L=1,4)
1020    FORMAT(' The Eulerian angles found by minimization procedure',/,
     &  '     Phi,  theta,  psi  and  function value',/,
     &  3(1X,F9.4),1X,F10.7)
        END
