
C **************************************************************************
C
C	THESE COMMANDS ARE GROUPED UNDER THE NAME
C	EXTRACT CLUSTERS (EC)
C	THEY DEAL WITH CLUSTER CONNECTIVITY VOLUMES.
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987 WADSWORTH CENTER FOR LABORATORIES AND          *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C--*************************************************************************
             
        SUBROUTINE UTIL6(MAXDIM)
		                                                                                        
        INCLUDE 'CMBLOCK.INC'

C	MAXIMUM NUMBER OF REGISTERS PER KEY IN 'UD IC'
	PARAMETER (MAXREG=7)    
C	MAXIMUM NUMBER OF KEYS IN 'UD IC'
	PARAMETER (MAXKEY=4000)
 
	IF (FCHAR(4:5) .EQ. 'CLOSE') THEN

            CALL MAPDIST(.FALSE.,.TRUE.,IRTFLG)

        ELSEIF (FCHAR(4:5) .EQ. 'SE') THEN

           CALL MAPDOC(IRTFLG)

        ELSEIF (FCHAR(4:5) .EQ. 'ST') THEN

           CALL IMSTAT(IRTFLG)

        ELSEIF (FCHAR(4:5) .EQ. 'FI') THEN

           CALL MAPFILT(IRTFLG)

        ELSEIF (FCHAR(4:5) .EQ. 'CL')  THEN

           MAXTAB = MAXREG * MAXKEY * 2
           CALL CONINT(MAXDIM,MAXTAB)

        ENDIF

	RETURN
	END

