 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE vax32
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: vax32'
       RETURN
       END
 
#else
 
C++************************************************************************
C
C $$ VAX32.FOR  --  FEB 88 al
C
C **************************************************************************
C *  COPYRIGHT (C)1989       WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ VAX32(FVAL)
C
C    PURPOSE:  QUICKLY CONVERT A VAX FLOATING POINT NUMBER TO A SUN FLOATING
C              POINT NUMBER.

C
C    PARAMETERS:   IVAL       FLOATING POINT NUMBER!!!
C
C **************************************************************************

      SUBROUTINE VAX32(IVAL)

      LOGICAL * 1  IO1,IO2,IO3,IO4,IN1,IN2,IN3,IN4,LVALIN(4),LVALOUT(4)

      INTEGER * 2  I2
      INTEGER * 4  IVALIN,IVAL,IVALOUT
      EQUIVALENCE  (I2,IVALIN),(LVALIN,IVALIN),(LVALOUT,IVALOUT)
      
      EQUIVALENCE  (IN1,LVALIN(1)), (IN2,LVALIN(2)), (IN3,LVALIN(3)),
     &             (IN4,LVALIN(4))
      EQUIVALENCE  (IO1,LVALOUT(1)),(IO2,LVALOUT(2)),(IO3,LVALOUT(3)),
     &             (IO4,LVALOUT(4))
 
      BYTE         BO1,BO2,BO3,BO4,BN1,BN2,BN3,BN4
      EQUIVALENCE  (IO1,BO1),(IO2,BO2),(IO3,BO3),(IO4,BO4)
      EQUIVALENCE  (IN1,BN1),(IN2,BN2),(IN3,BN3),(IN4,BN4)

      IVALIN = IVAL

C     CHANGE THE EXPONENT TO EXCESS 127 NOTATION FOR SUN

      IF (IAND(I2,'7F80'X) .NE. 0)  I2 = I2 - '0100'X

C     FLIP THE BYTES IN EACH OF THE WORDS
      IO1 = IN2
      IO2 = IN1
      IO3 = IN4
      IO4 = IN3

      IVAL =  IVALOUT

      RETURN
      END
   
 
#endif
 
