C++************************************************************************
C
C $$ VOEA.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ VOEA.FOR
C
         SUBROUTINE VOEA(MAXMEM)
C  Prepare ang doc file for pj 3q (quasi-equal angular spacing) 04/23/92
C  Modified on 10/23/96 to get even spacing in phi.
         INCLUDE 'CMBLOCK.INC'
         COMMON  DUMMY(1024),FIO(4)
         CHARACTER*80  FILNAM,FINPAT
         CHARACTER*1  NULL
         EQUIVALENCE  (FIO(2),PSI),(FIO(3),THETA),(FIO(4),PHI)
	LOGICAL  SKIP
         DATA  NDOUT/56/
CNO_SAVE
         NULL=CHAR(0)
         PSI=0.0
C
         CALL  RDPRM(DELTA,NLOOP,ILOOP,'Delta theta')
         CALL  RDPRM2(T1,T2,NLOOP,ILOOP,'Range of theta (0,90)')
         CALL  RDPRM2(P1,P2,NLOOP,ILOOP,'Range of phi (0,359.9)')
         IF(T1.EQ.0.0.AND.T2.EQ.0.0.OR.T1.GE.T2) THEN
         T1=0.0
         T2=90.0
         ENDIF
         IF(P1.EQ.0.0.AND.P2.EQ.0.0.OR.P1.GE.P2) THEN
         P1=0.0
         P2=359.9
         ENDIF
C
	SKIP=T1.LT.90.0.AND.T2.EQ.90.0.AND.P1.EQ.0.0.AND.P2.GT.180.0
         LITER=0
         NLIST=4
C     do  1  theta=0.,90.0,delta
         DO  1  THETA=T1,T2,DELTA
         IF(THETA.EQ.0.0.OR.THETA.EQ.180.0)  THEN
		DETPHI=360.0
		LT=1
         ELSE
		DETPHI=DELTA/SIND(THETA)
		LT=MAX0(INT((P2-P1)/DETPHI)-1,1)
		DETPHI=(P2-P1)/LT
         ENDIF
C     do  1  phi=0.,359.9,detphi
C         DO  1  PHI=P1,P2,DETPHI
	DO  1  I=1,LT
	PHI=P1+(I-1)*DETPHI
	IF(SKIP.AND.THETA.EQ.90.0.AND.PHI.GE.180.0)  GOTO  1
         LITER=LITER+1
         FIO(1)=LITER
         CALL  SAVD(NDOUT,FIO,NLIST,IRTFLG)
         IF(IRTFLG.EQ.-1) GOTO  5
1        CONTINUE
         WRITE(NOUT,33)  LITER
33       FORMAT('   Total number of directions =',i10)
5        CALL  SAVDC
         CLOSE(NDOUT)
	 IF(NSEL(1).NE.0)  PARAM(NSEL(1))=LITER
         END
