      SUBROUTINE WEIFU(A,NA,L,IST)
C-----------------------------------------------------------------------
C     PROGRAMM ZUR WICHTUNG DER PROJEKTIONEN
C     SEPT., 1980, M.RADERMACHER
C     CHANGED FOR IMPLEMENTATION INTO SPIDER. FEB. 83 M.R.
C
C     L=1 WEIGHT IN Y-DIRECTION, ELSE IN X-DIRECTION
C
C    BEDEUTUNG DER WICHTIGSTEN VARIABLEN:
C     NX=X-DIMENSION,NY=Y-DIMENSION,
C
C_______________________________________________________________________
      INCLUDE 'CMBLOCK.INC'
      DIMENSION A(*)
      DIMENSION NA(3)
      WRITE(NOUT,100)
100   FORMAT(' WEIGHTING')
      IF(L.EQ.1) GOTO 200
      CALL WEIFU3(A,NA,IST)
      GOTO 300
200   NX=(NA(1)/2+1)*2
      NY=NA(2)
      IHALB=NY/2+1
      STE=1./FLOAT(IHALB-1)
      DO  K=1,IHALB
      FAK=STE*(K-1)
C REDUCE 0-COEFFICIENT ONLY BY THE SAME AMMOUNT AS FIRST ONE, TO
C KEEP CONSTANT AVERAGE IN SINGLE AXIS TILT SERIES.
      IF(IST.EQ.1.AND.K.EQ.1) FAK=STE
      IND1=(K-1)*NX
      DO2 I=1,NX
      IX=IND1+I
      A(IX)=A(IX)*FAK
2     CONTINUE
      ENDDO
      KA=IHALB+1
      DO  K=KA,NY
      ZW=NY+1-K
      FAK=ZW*STE
      IND1=(K-1)*NX
      DO  I=1,NX
      IX=IND1+I
      A(IX)=A(IX)*FAK
      ENDDO
      ENDDO
300   RETURN
      END
