
C++*************************************************************************
C
C $$ WRTLIN8.FOR                           
C                                      
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ WRTLIN8:    WRITE A LINE OF 8 BIT INTEGERS INTO A FILE
C
C     CALL WRTLIN8(LUN,LBUF,NB,NREC)
C
C        LUN    LOGICAL UNIT NUMBER OF FILE TO BE WRITTEN TO
C        LBUF   LOGICAL * 1 BUFFER THAT RECORD IS READ FROM
C        NB     NUMBER OF VALUES IN RECORD TO BE WRITTEN
C        NREC   RECORD TO BE WRITTEN INTO
C
C        0         2         3         4         5         6         7     
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

      SUBROUTINE   WRTLIN8(LUN,LBUF,NB,NREC)

      LOGICAL * 1     LBUF(NB)

      COMMON /LUNARA/ LUNARA(100),LASLAB

C     ADD LUNARA(LUN)(FOR LABEL REC) TO NREC TO GET THE CORRECT RECORD NUMBER
      I = NREC + LUNARA(LUN)
      WRITE(LUN,ERR=100,REC=I) LBUF

      RETURN

100   WRITE(6,*)' WRTLIN8 ERROR, UNIT:',LUN,' REC:',NREC,' LENGTH:',NB
      RETURN
      END

