C weighting function in 2D according to MvH
C
        SUBROUTINE WTM(PROJ,W,NNNN,NSAM,NROW,SS,NANG,DIAMETER,NUMP)
        DIMENSION  SS(6,NANG),PROJ(NNNN,NROW),W(NNNN/2,NROW)
	DIMENSION  CC(3),VV(3),CP(2),VP(2),RI(3,3)
CNO_SAVE
C
C         R(1,1)=CPHI*CTHETA*CPSI-SPHI*SPSI
C         R(2,1)=-CPHI*CTHETA*SPSI-SPHI*CPSI
C         R(3,1)=CPHI*STHETA
C         R(1,2)=SPHI*CTHETA*CPSI+CPHI*SPSI
C         R(2,2)=-SPHI*CTHETA*SPSI+CPHI*CPSI
C         R(3,2)=SPHI*STHETA
C         R(1,3)=-STHETA*CPSI
C         R(2,3)=STHETA*SPSI
C         R(3,3)=CTHETA

         RI(1,1)=SS(1,NUMP)*SS(3,NUMP)*SS(5,NUMP)-SS(2,NUMP)*SS(6,NUMP)
         RI(2,1)=-SS(1,NUMP)*SS(3,NUMP)*SS(6,NUMP)-SS(2,NUMP)*SS(5,NUMP)
         RI(3,1)=SS(1,NUMP)*SS(4,NUMP)
         RI(1,2)=SS(2,NUMP)*SS(3,NUMP)*SS(5,NUMP)+SS(1,NUMP)*SS(6,NUMP)
         RI(2,2)=-SS(2,NUMP)*SS(3,NUMP)*SS(6,NUMP)+SS(1,NUMP)*SS(5,NUMP)
         RI(3,2)=SS(2,NUMP)*SS(4,NUMP)
         RI(1,3)=-SS(4,NUMP)*SS(5,NUMP)
         RI(2,3)=SS(4,NUMP)*SS(6,NUMP)
         RI(3,3)=SS(3,NUMP)
C
	NR2=NROW/2
C
	THICK=NSAM/DIAMETER/2.0
c$doacross local(i,j)
	DO    J=1,NROW
	DO    I=1,NNNN/2
c set w to 1 - projection with itself
	W(I,J)=1.0
	ENDDO
	ENDDO
C
c	if(nang.gt.0) goto 77
	DO  5  L=1,NANG
	IF(L.EQ.NUMP)  GOTO  5
	CC(1)=SS(2,L)*SS(4,L)*SS(3,NUMP)-SS(3,L)*SS(2,NUMP)*SS(4,NUMP)
	CC(2)=SS(3,L)*SS(1,NUMP)*SS(4,NUMP)-SS(1,L)*SS(4,L)*SS(3,NUMP)
	CC(3)=SS(1,L)*SS(4,L)*SS(2,NUMP)*SS(4,NUMP)-
     &		SS(2,L)*SS(4,L)*SS(1,NUMP)*SS(4,NUMP)
	ccn=sqrt(cc(1)**2+cc(2)**2+cc(3)**2)
	alpha=asind(ccn)
	if(alpha.gt.180.0) alpha=alpha-180.0
	if(alpha.gt.90.0) alpha=180.0-alpha
        fm=THICK/(abs(sind(alpha)))
	if(alpha.lt.1.0e-6)  then
c$doacross local(i,j)
	DO  J=1,NROW
	DO  I=1,NNNN/2
	w(i,j)=w(i,j)+1.0
	ENDDO
	ENDDO
	else
	do    M=1,3
	cc(M)=cc(M)/ccn
	enddo
	vv(1)=SS(2,L)*SS(4,L)*cc(3)-SS(3,L)*cc(2)
	vv(2)=SS(3,L)*cc(1)-SS(1,L)*SS(4,L)*cc(3)
	vv(3)=SS(1,L)*SS(4,L)*cc(2)-SS(2,L)*SS(4,L)*cc(1)
	do    LL=1,2
	cp(LL)=0.0
	vp(LL)=0.0
	do    m=1,3
	cp(lL)=cp(lL)+ri(lL,m)*cc(m)
	vp(lL)=vp(lL)+ri(lL,m)*vv(m)
	enddo
	enddo
	tmp=cp(1)*vp(2)-cp(2)*vp(1)
C prevent tmp to be too small, sign is irrelevant
	tmp=amax1(1.0E-4,abs(tmp))
C
c$doacross local(i,j,jy,fv,rt)
	DO  J=1,NROW
	JY=(J-1)
        IF(JY.GT.NR2)  JY=JY-NROW
	DO  I=1,NNNN/2
C
	fv=abs((JY*cp(1)-(I-1)*cp(2))/tmp)
	rt=1.0-fv/fm
	W(I,J)=W(I,J)+AMAX1(rt,0.0)
	ENDDO
	ENDDO
	endif
5	CONTINUE
C
77	INV=+1
	CALL   FMRS_2(PROJ,NSAM,NROW,INV)
          IF(INV.EQ.0)THEN
          CALL ERRT(38,'BMQ',NE)
          RETURN
	  ENDIF
c$doacross local(i,j,ww)
	DO  J=1,NROW
	DO  I=1,NNNN,2
	WW=1.0/W((I+1)/2,J)
	PROJ(I,J)=PROJ(I,J)*WW
	PROJ(I+1,J)=PROJ(I+1,J)*WW
	ENDDO
	ENDDO
	INV=-1
	CALL   FMRS_2(PROJ,NSAM,NROW,INV)
	END
