
C++************************************************************************
C
C $$ X1YR.FOR
c
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.                             *
C *  COPYRIGHT (C)1981,1992, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  $$  X1YR(M,X,F)
C
C      CALLED BY:  WFTCIRC
C
C        0         2         3         4         5         6         7
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************
  
	SUBROUTINE X1YR(M,X,F)

	REAL*8 F,XX(20),YY(20),X(3)
	COMMON XX,YY

        F = 0.
	DO  I=1,M
           F = F+SQRT(((XX(I)-X(1))**2+(YY(I)-X(2))**2-X(3))**2)
	ENDDO

	RETURN
	END 

