
/*$Header: /net/ithaca/usr1/web/src/RCS/addext.c,v 1.1 1997/02/24 17:24:55 leith Exp $*/
/*
C++************************************************************************
C
C addext.c
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C addext(char * filnam, char * datexc, int lennam)
C
C PURPOSE: Adds datexc onto filnam.  Returns TRUE if all OK.
C
C**************************************************************************
*/

#include "common.h"
#include "routines.h"

 int addext(char * filnam, char * datexc, int lennam)
 { 
 if (* datexc)
    { /* have extension to add onto filnam */
    if ((strlen(filnam) + strlen(datexc) + 1) >= (size_t) lennam)
       {
       spouts("*** Filename too long to add extension:");
       spouts(filnam); spouts(" : "); spout(datexc);
       return FALSE;
       }
    strcat(filnam,".");
    strcat(filnam,datexc);
    }
 return TRUE;
 }


