
/*$Header: /net/ithaca/usr1/web/src/RCS/changepat.c,v 1.4 1995/07/11 20:19:05 mladjadj Exp $*/

/***********************************************************************
 *
 * changepat.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 * 
 * PURPOSE:  Change current filename search pattern     
 * 
 * PARAMETERS:	Widget 		iw_temp		pushbutton (not used)
 *		caddr_t		data		label text string
 *		caddr_t		call_data	not used 
 *
 ***********************************************************************
*/

#include "common.h"
#include <Xm/FileSB.h>
#include "routines.h"


 /* internal functions */
 void            changepat_cb   (Widget, caddr_t, caddr_t);


 /* file variables */
 static char       label_string[] = "Enter new file search string";  
 static Widget     iw_text = (Widget)0;
 static int        ixtext = 0;      /* x coord for widget    */
 static int        iytext = 0;      /* y coord for widget    */
 

/************************  changepat  ***********************************/

 void changepat(Widget iw_temp, caddr_t data, caddr_t call_data)
 {

 /* create new directory input box */
 iw_text = wid_text(iw_win, iw_text, label_string, filwant,
                       *changepat_cb, NULL, ixtext, iytext);
 }


 /**********************  changepat_cb  *********************************/

 void changepat_cb(Widget iw_temp, caddr_t data, caddr_t call_data)
 {
 XmString      txt_string;
 Arg           args[1];   /* arg list */
 XmString      str_dir;

 XmSelectionBoxCallbackStruct *cbs =
      (XmSelectionBoxCallbackStruct *) call_data;
 
 strncpy(filwant,extractstr(cbs -> value),80);


 }

