 
/*$Header: /alwyn/usr1/web//RCS/checkcom.c,v 1.2 93/11/30 10:58:58 leith Exp $*/

/**********************************************************************
 *
 * checkcom.c
 *
 **********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 **********************************************************************
 *
 * checkcom()
 * 
 * PURPOSE:	checks for first command or incompatible commands
 *
 * RETURNS:	ok flag
 * 
 * PARAMETERS:  none
 *
 ********************************************************************
*/

#include "common.h"

 /* external function prototypes */
 extern void   spout        (char *);
 extern void   fin_cb       (Widget, caddr_t, caddr_t);
 extern void   webclear     (Widget, caddr_t, caddr_t); 
 extern int    wicolor      (GC, int);

 static int    newrun = TRUE;

 /******************************************************************/
 
 void checkcom(Widget iw_dum, caddr_t cdum1, caddr_t cdum2)
 {

 /*** printf(" in checkcom now\n");   ***/


 if (newrun) 
    {  /* this is the initial command in web */
    newrun = FALSE;

    /* clear the screen of junk from previous runs */
    webclear(NULL,NULL,NULL);

    /* set initial foreground color */
    wicolor(icontx,icolor);

    }
 return;
 }

  
