/* standard header file for cnt file header data */

#ifndef FILESHCNT
#define FILESHCNT

#include "std.h"
#include "files.h"

 typedef struct {
        FILEDATA * image;
        int    irecln;
        float * contrl;
        float * txtctr;

        int    maxcnt;
        int    maxtxt;
        int    maxrec;
        int    ndtsuf;
        int    ntxsuf;
        int    ifrmcs;
        float  scale;
        float  xmax;
        float  xmin;
        float  ymax;
        float  ymin;
        int    icomp;
        int    ndtctl;
        int    ncntrs;
        int    istcon;
        int    lstcon;
        int    isttxt;
        int    lsttxt;
        int    ntxt;
        float  pixpcm;
        int    lencor;
        int    icntfmt;
        int    lsrecd;

        char   date[12];
        char   time[9];
        char   title[41];
        char   filenam[80];
        float  *buf;
 } FILEDATACNT;

 typedef struct {
        float  zcoo;
        int    itangl;
        int    itsize;
        int    just;
        int    inten;
        int    ifon;
        int    ipen;
        int    mark;
        int    limfil;
        int    ishap;
        int    lintp;
        int    threed;
        int    icntr;
        int    itext;
        int    ndata;
        int    nsize;
        float * data;
 } DATACNT;


#endif
