 
/*$Header: /net/ithaca/usr1/web/src/RCS/getloc.c,v 1.2 1996/05/16 17:03:11 leith Exp $*/
/*
C++*************************************************************************
C
C getloc -- SEPT 92 al                                                
C **************************************************************************
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C getloc
C
C PURPOSE:       finds location for key or mouse
C
C PARAMETERS:    
C
C CALLED BY:     movearea
C
C NOTE:          The event positions are integers in the structure!
C
C--*********************************************************************
*/

#include "x.h"
#include "std.h"


 /************************* getloc  ***************************/
 
 void getloc(XEvent * event, char type, int *ix, int *iy)
 {
 if (type == 'm' || type == 'M')            
    {
    /* get mouse position */

    /*****************
    *ix   = event -> xmotion.x_root;
    *iy   = event -> xmotion.y_root;************* */


    *ix   = event -> xmotion.x;
    *iy   = event -> xmotion.y;
     }

 else if (type == 'b' || type == 'B')
    {
    /* get mouse position when key pressed*/

    /************
    *ix = event -> xkey.x_root;
    *iy = event -> xkey.y_root; ********/

    *ix = event -> xkey.x;
    *iy = event -> xkey.y;
   /* Using x_root and y_root yields high coordinates, but placement
       is done relative to iw_win 'looks' right.
       Using x and y yields expected numbers, but placement is done
       relative to the terminal screen (i.e., 0,0 is ulhs of screen)
       This may cause problems when the user inputs coords.
    */
    }
 }




