
/*$Header$*/

/***********************************************************************
 *
 * invert.c
 *
 ***********************************************************************
 * author : ArDean Leith
 * COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * invert()
 * 
 * PURPOSE:    inverts an image
 *
 * RETURNS:    true or false
 *
 * PARAMETERS: 
 *
 ***********************************************************************
*/

#include "std.h"
#ifndef VMS
#include "float.h"
#endif

 /******************************  notit *****************************/

 int invert(float * oldimage, int nsamt, int nrowt, 
             float * newimage, float * fmint, float * fmaxt)
 {
 int     iloc;
 float   fcon;

 fcon = *fmaxt + *fmint;

 /* convolve over all positions in the new image */

 for (iloc = 0; iloc < nsamt * nrowt; iloc++)
     {
     newimage[iloc] = fcon - oldimage[iloc];
     }

  return TRUE;
 }


