
/*$Header: /alwyn/usr1/web/RCS/outmess.c,v 1.1 93/11/10 10:11:12 leith Exp $*/
/*
 * outmess.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * 
 * 
 * PURPOSE:     prints text in the message window (iw_scroll)
 *
 * RETURNS:     void
 * 
 * PARAMETERS:  text	the text to be printed
 *
 ***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/Text.h>

extern Widget iw_scroll;

void outmess (char *text)
{
   /* insert the text after the last position */
   XmTextInsert(iw_scroll, XmTextGetLastPosition(iw_scroll), text);

   /* add a newline to the string */
   XmTextInsert(iw_scroll, XmTextGetLastPosition(iw_scroll), "\n");

   /* move cursor so XmNmotionVerifyCallback gets called */
   XmTextSetInsertionPosition(iw_scroll, XmTextGetLastPosition
                                        (iw_scroll));
}
