
/*$Header: /net/ithaca/usr1/web/src/RCS/pickdisp.c,v 1.2 1994/04/05 16:46:55 leith Exp $*/

/*C++*************************************************************************
C
C pickdisp.c             Mar. 94
C                                                                  
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1994, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    PARAMETERS:   
C
C    PURPOSE:      redisplays particle image pair
C
C    CALLED BY:    pickmen  backmen
C
C--********************************************************************
*/

#include "common.h"
#include "routines.h"
 
 /* external commmon variables */
 extern XImage*    imager;
 extern XImage*    imagel;

 /***************************** pickdisp *****************************/

 void pickdisp(int leftside, int rightside)

 {
 if (leftside)
    {
    /* shift left image to shifted location */
    XPutImage(idispl,iwin,   icontx,imagel, nsam1l, nrow1l,
              ixull,iyull, nsam2l - nsam1l + 1, nrow2l - nrow1l + 1);
    XPutImage(idispl,imagsav,icontx,imagel, nsam1l, nrow1l,
              ixull,iyull, nsam2l - nsam1l + 1,nrow2l - nrow1l + 1);
    }

 if (rightside)
    {
    /* shift right image */      
    /* display, window, gc, image, srcx, srcy destx, desty width height */
    XPutImage(idispl,iwin,   icontx,imager, nsam1r, nrow1r,
              ixulr,iyulr, nsam2r - nsam1r + 1, nrow2r - nrow1r + 1);
    XPutImage(idispl,imagsav,icontx,imager, nsam1r, nrow1r,
              ixulr,iyulr, nsam2r - nsam1r + 1, nrow2r - nrow1r + 1);
    }

 return; 
 }



   
  
