
/*
C++************************************************************************
C
C pixlen
C
C **************************************************************************
C *  AUTHOR:  Lekan Odesanya                                                *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    pixlen
C
C    PURPOSE:  computes and return the width (in pixels) of a string 
C
C
C***********************************************************************
*/

#include "common.h"

 /************************   pixlen  ******************************/

 int pixlen( GC gc, char * strg )
 {
  GContext      theId;

  theId = XGContextFromGC( gc );
  return XTextWidth( XQueryFont(idispl, theId), strg, strlen(strg) );

 }
