
/*$Header: /net/ithaca/usr1/web/src/RCS/rdprx.c,v 1.2 1995/02/08 16:40:42 liy Exp $*/
/*
C++************************************************************************
C
C RDPRX
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C RDPRX
C
C PURPOSE:         GET INTEGER OR FLOATING POINT VALUE FROM TEXT WIDGET 
C
C PARAMETERS:      
C
C CALLED BY:       
C
C***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/Text.h>

extern void   spout         (char *);


 /******************  rdprx   *******************************/

 int rdprx(Widget iw_t, char type, int * ival, float * fval)

 {  
 
 char *string;

 if (iw_t <= (Widget)0) 
    {
    spout("*** pgm error, ivalid Widget in rdprx!");
    return FALSE;
    }

 string = XmTextGetString(iw_t);

 if (type == 'i' || type == 'I')
    {   /* want to return integer */
    *ival = atoi(string);
    }
 else
    {
    if (sscanf(string,"%f",fval) != 1)
       {
       spout("*** Invalid floating point input in rdprx!");
       XtFree(string); 
       return FALSE;
       }
    }
 XtFree(string);
 return TRUE;
 }
 
