
/*$Header: /alwyn/usr1/web//RCS/wid_lutinfo.c,v 1.3 94/03/18 10:42:12 leith Exp $*/
/*
C***************************************************************************
C
C    WID_LUTINFO
C
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1992,  WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    WID_LUTINFO(MAP)
C
C    PURPOSE:        LISTS COLORMAP POSITIONS
C
C    PARAMETERS:
C
C    CALLED BY:      
C
C *********************************************************************
*/

#include "std.h"
#include "x.h"

 extern Display *idispl;

 /************************  wid_lutinfo   **************************/

 int wid_lutinfo(Colormap map, int npix) 
 {

    int            i;
    XColor         color;

    printf(" Lut contents for first %d positions in map: %d \n",
           npix,map);
    printf(" --------------------------\n");

    for (i = 0; i < npix; i++)
       {
       color.pixel = i;

       XQueryColor(idispl,map,&color);

       printf(" %5d -- %5u %5u %5u     ",i,color.red,color.green,color.blue);
       if (i%2 != 0) printf("\n");
       }
    return TRUE;
 }

