
/*$Header: /alwyn/usr1/web/RCS/windata.c,v 1.1 93/11/10 10:11:32 leith Exp $*/
/*
C++*************************************************************************
C
C WID_WINDAT.FOR -- CREATED MAY 91 al
C                   RENAMED WINDATA, CONVERTED TO C -- SEPT 92 al      
C **************************************************************************
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C WINDATA
C
C PURPOSE:       DESCRIBES SELECTED WINDOW
C
C PARAMETERS:    NONE
C
C CALLS:         X-WINDOWS ROUTINES
C
C--*********************************************************************
*/

#include "std.h"
#include "x.h"
#include "common.h"

 /* external functions */
 extern void     xorbox     (Window, GC, int, int, int, int, int);
 extern void  spout(char *);


 /************************* windata ********************************/
 

 void windata(int ixi, int iyi, int nsami, int nrowi)
 {
 char outstr[60];

 if (leavit)
    {    /* leave box around window at this location */
    xorbox(iwin,    icontx, TRUE, ixulw, iyulw, nsamw, nroww);
    xorbox(imagsav, icontx, TRUE, ixulw, iyulw, nsamw, nroww);
    }

 if (sayit)
    {    /* list window coordinates */
    sprintf(outstr," Screen window: (%d,%d) %d X %d",
                     ixulw,iyulw,nsamw,nroww);
    spout(outstr);
    if (ixi > 0)
       {    /* list image coordinates */
       sprintf(outstr," Image  window: (%d,%d) %d X %d",
                        ixi,iyi,nsami,nrowi);
       spout(outstr);
       }
    }
 }


#ifdef NEVER
 ********************** FUTURE *******************************
 if (leavit)
          RECORD WINDOW COORDINATES IN DOC FILE
          IDOC = IDOC + 1
          DLIST(1) = IDOC
          DLIST(2) = IXULW
          DLIST(3) = IYULW
          DLIST(4) = NSAMW
          DLIST(5) = NROWW
          CALL SAVDN1(LUNDOCW,DOCNAM,DLIST,5,NRUN,0)
       ENDIF
       IF (SAYIT .AND. DOCIT) THEN
C         LIST WINDOW COORDINATES WITH DOC FILE KEY

          WRITE(OUTSTR,8000) IDOC,IXI,IYI,NSAMI,NROWI
8000      FORMAT('IMAGE WINDOW: ',I4,' (',I4,',',I4,')...',I4,' X',I4)
          CALL WID_OUTPUT(0,OUTSTR,0)

#endif 
