

AP RA     Alignment Program - Rotational Alignment          AP RA    
                                                            9/28/94

PURPOSE:   Rotationally aligns an image series.


SEE ALSO:  AP CA  (classification alignment)
           AP MD  (3D projection alignment)
           AP SA  (shift alignment)
           AP SR  (shift and rotational alignment)


USAGE:    AP RA

          .Template for 2-D image name file: USER3:[XXXXX.YYY.ZZZ]UKZ005
          [Give the name of any of the existing files from the series
           to be aligned.]

          .File numbers: 1-5,8,20-230

          .First and last ring: 5,15
          [Only  rings with the radii in the range 5-15 (in pixel units)
           will be analyzed.]

          .Skip: 1
          [If skip=0 or 1 then each ring between 5 and 15 will be taken;
           for skip=2 each second, and so on.]

          .Full or Half: H
          [Full - full ring treated (real data); Half - half ring treated
           (autocorrelation function).]

         .Document file name: FALDOC
         [This is the only output produced by this program.
          It contains 4 columns:
          '<PRE>'
           1.File number.
            Real file number to deal with gaps in file series.

           2.Rotation angle. 
            Image has to be rotated +angle to produce average.

           3.Distance.
            Distance from the total  average. Can be used as a similarity
            measure.

           4.Group number.
            Always 1.0 to be in agreement with AP CA and to be read by AP SA.]
          '</PRE>'
                                                          
NOTE:  1. Images do not have to have power-of-two dimensions.
          As this program is usually used together with shift
          alignment, please check manual chapter "AP SA" for 
          limitations.

       2. Please note that all the parameters produced by this program,
          (rotation and/or shift parameters), are given with
          the proper signs.  It means that to rotate and/or shift the images
          afterwards this parameters should be applied directly (without
          sign reversion).  To combine parameters given by repeated
          alignment the 'SA P' command has to be used. Only the angle signs used
          for 3-D reconstruction from tilted series have to be reversed.

       3. AN example can be found in APSA.MAN manual chapter.

       4. The command is used in the refal.sys procedure.

       5. Implemented by Paul Penczek

SUBROUTINE: FALB

CALLER:     UTIL4

