
AR        ARithmetic operation                              AR      
                                                            04/04/96

PURPOSE:  Performs arithmetic operations point for point on the
          input picture to create an output picture.

USAGE:    AR

          .INPUT FILE: PIC001
          [Enter the name of the input picture.]

          .OUTPUT FILE: PIC002
          [Enter the name of the output picture.]

          .FORMULA: P2=:((P1+0.5)*2.)
          [Enter formula to be used to compute the output picture
          (referred to by P2) from the input picture (P1).  Note
          that the operations can be + - * / .  If the first 
          operation is + or -, the second one can only be * or / .  If
          the first operation is * or /, the second one can only be
          + or - .  The formula entered by the user starts with the 
          two left parentheses.                            '<BR>'

          Examples of accepted formulae:                   '<BR>'
                              ((P1-2.)/2.)                 '<BR>'                              ((P1/512.)+0.)                '<BR>'

          Examples of unacceptable formulae:               '<BR>'
                              ((P1+3.)+50.)                '<BR>'
                              ((P1*4.)/10.)                '<BR>'
                   ...because in both cases the arithmetic
          operations are not mixed.                        '<BR>'

          The constants used must be floating point, i.e., the
          decimal point must be specified.]


NOTES:    1.  It is also possible to obtain the logarithm (base 10)
              of the resulting picture by simply putting LOG in 
              front of the expression, e.g.               '<BR>'
                                   LOG((P1-2.)/2.)        '<BR>'
                                   LOG((P1/512.)+0.)      '<BR>'
              It is the user's responsibility to make sure that the
              argument of the logarithm function is positive 
              everywhere.
              The main application of the LOG function is the
              display of the power spectrum.

              Additional functions possible are:               '<BR>'
                                   ABS((P1-2.)/2.)             '<BR>'
                                   EXP((P1-2.)/2.)             '<BR>'

          2.  In order to normalize a picture between 0. and 2., one
              can make use of the automatic register updating; X3
              and X4 always contain the maximum and minimum of the
              last picture accessed by SPIDER:
              '<PRE>'
              FI
              PIC001
              X10=2./(X3-X4)
              AR
              PIC001
              PIC002
              ((P1-X4)*X10)
              '</PRE>'

SUBROUTINE: ARITH

CALLER:     UTIL2
