
AS DC     Average images - find & save variance, from doc. file  AS DC
                                                              8/22/96

PURPOSE:  Adds 2 or more (up to 20000) images together, computing
          several measures of variance (per point, total, etc.).
          The sum and the variance images are stored in separate
          output files.

SEE ALSO: AS     (Average images - find & save variance)
          AS AD  (Average images - add to the existing average - find variance.)
          AS F   (Average images - find statistics & Q factor map)
          AS R   (Average images - find & save variance, better)      

USAGE:    AS DC

          .INPUT: PIC001
          [Enter pattern of image name to be added.]

          .DOCUMENT WITH FILE NUMBERS: FILES001
          [Enter document file name with first column containing numbers
           of images to be added.]

          .ALL, ODD-EVEN (A/O): O
          ['A' - all images will be added into one output file,
           'O' - two subaverages will be calculated: one for 
          odd-numbered images and one for even-numbered images. The 
          next two questions will appear twice for the 'O' option.]

          .AVERAGE FILE: AVG001
          [Enter name of output file receiving average.]

          .VARIANCE FILE: VAR001
          [Enter name of output file receiving variance map.]

          [Questions for average and variance files are repeated if
           option 'O' was chosen.]

          The following values are then printed out:
 '<PRE>'
           Number of images
           Number of elements
           Total variance              Total std. deviation
           Variance. per point         Std. deviation per point
           Average offset = 0.0
           Variance of average image
 '</PRE>'

NOTES:    This version of 'AS' does not subtract the average from
          each images during the calculation of global average
          and variance.  Thus, the statistics calculated are
          'Real' and the average offset is always zero.  Command 'AS'
          results in the variance estimator which is usually
          far 'too optimistic' - the variance obtained is too small
          and cannot be used for statistical tests.
          
SUBROUTINE: ADDS

CALLER:     UTIL2
