
AS R      Average images - find & save variance, better      AS R      
                                                           08/15/96

PURPOSE:  Adds 2 or more (up to 20000) pictures together, computing
          several measures of variance (per point, total, etc.).
          The sum and the variance images are stored in separate
          output files.  The command works for 2D and 3D data.

SEE ALSO: AS     (Average images - find & save variance)
          AS AD  (Average images - add to the existing average - find variance.)
          AS DC  (Average images - find & save variance, doc. file)
          AS F   (Average images - find statistics & Q factor map)

USAGE:    AS R

          FOR IMAGES TO BE AVERAGED
          .ENTER FILE PREFIX OR TEMPLATE (EG. PIC****): PIC
          [Enter prefix of image series to be added.]

          .ENTER FILE NUMBERS: 1-10,12,15-17
          [Enter numbers of files within a series to be added.]

          .ALL, ODD-EVEN (A/O): O
          ['A' - all images will be added,
           'O' - two sub-averages will be calculated: 
           one for odd-numbered images and one for even numbered 
           images.  For 'O' option the next two questions will
           appear twice.]

          .AVERAGE FILE: AVG001
          [Enter name of output file receiving average.]

          .VARIANCE FILE: VAR001
          [Enter name of output file receiving variance map.]

            The following values are then printed out:
           '<PRE>'
           Number of images
           Number of elements
           Total variance             Total std. deviation
           Variance. per point        Std. deviation per point
           Average offset = 0.0
           Variance of average image
           '</PRE>'

NOTES:    This version of 'AS' does not subtract the average from
          each image during the calculation of global average
          and variance.  Thus, the statistics calculated are
          'Real' and the average offset is always zero.  Command 'AS'
          results in the variance estimator which is usually
          far 'too optimistic' - the variance obtained is too small
          and cannot be used for statistical tests.
          
SUBROUTINE: ADDS

CALLER:     UTIL2
