
CA S      Correspondence Analysis - find Solution            CA S    
                                                             8/22/97

PURPOSE:  Second part of CORAN or PCA: '<BR>'
          Execute correspondence analysis of image data previously
          stored in a sequential file using 'CA SI'.
          the solution is found and eigenimages are calculated.

SEE ALSO: CA MAP (Correspondence Analysis - nonlinear mapping)
          CA SI  (Correspondence AnalysiS - initialize)
          CA SM  (Correspondence Analysis - factor map)
          CA SME (Correspondence Analysis - factor map and Eigen Values)
          CA SR  (Correspondence Analysis - full reconstitution of images)
          CA SRD (Correspondence AnalysiS - reconstitute differential images)
          CA SRI (Correspondence AnalysiS - reconstitute importance images)
          CA SRP (Correspondence Analysis - PCA reconstitution)
          CA VIS (Correspondence Analysis - Create visual map)

USAGE:    CA S

          .SEQUENTIAL FILE: SEQ001
          [Enter the name of the "sequential file" containing the
          image data, which has been previously created by 
          executing 'CA SI'.]

          .NUMBER OF FACTORS, COORDINATE FILE CODE: 8,1
          [Enter the number of factors to be used.  Note that 
          eigenvectors and eigenvalues are only computed up to this
          number. 'CA S' creates three files to store
          the results.  Their respective names and meanings are'<BR>'
          IMC#     image coordinates'<BR>'
          PIX#     pixel coordinates'<BR>'
          EIG#     eigenvectors and eigenvalues'<BR>'
          Here the code number is used to distinguish coordinate
          file sets of different 'CA S' runs.  The code is used in
          subsequent operations ('CA SM','CA SME','CA SR','CA SRD')
          to refer to the results of a particular run.

          .PRINCIPAL COMPONENT ANALYSIS (Y/N)?: Y or N
          [answer Y: will start Principal Component analysis.]
          [answer N: continue CORAN]
 
          .ENTER INACTIVE IMAGE NUMBERS (EG. 1-3,5,6-9 or 0 ): 0
          [The following solicitations exist to let the user define 
          a subset of images that will be treated differently from the
          rest. The subset specified below will be interpreted as THOSE 
          IMAGES, out of the total pool, THAT ARE TO BE SWITCHED 
          INACTIVE.

          .IN-CORE (1) TRANSPOSE (2) OR ITERATIVE (3) METHOD SOLUTION:
          [Depending on the memory available on the system (or allocated 
          to the user, the user can choose between 3 methods of doing
          the matrix computations involved in the Coran or PCA analysis)]

SUBROUTINES: JPMSK1, SCORAN3,  PCA_MAIN

CALLER:      UTIL1
