
CE MED    Contrast Enhancement - using Median Filtering       CE MED
                                                            12/27/93

PURPOSE:  Applies median filter to a 2D OR 3D picture.

SEE ALSO: CE     (contrast enhancement)
          CE FIT (contrast enhancement - fit histogram)
          CE GNC (contrast enhancement - using graduated non-convex restoration)

USAGE:    CE MED

          .INPUT FILE: PIC001
          [Enter name of picture to be processed.]

          .OUTPUT FILE: PIC002
          [Enter name of file receiving the output picture.]

          .FILTER LENGTH (ODD): 5
          [Enter filer length, must be odd number =>3.]

          .BOX OR CROSS (B/C): C
          [Choose the shape of filter support. See notes for explanation.]

NOTES:    1. Two or three dimensional median filter is applied to the picture.
          This is the non-linear filter which means that it performance
          depends on the data processed. The longer the filter length
          the stronger the filtration. Box or Cross question refers to
          the shape of filter support. Both of them result in different
          kind of noise structures being suppressed in the picture. Basicly
          the stronger filtration can be achieved by box filter. 
          The purpose of median filter is to suppresses the 'pink' noise in
          a picture leaving edges basically unaffected at the same time.
          The detailed description of median filter features can be found
          in: '<I>' Two-dimensional digital signal processing II : transforms
          and median filters'</I>', Editor: Huang.
          (NYS Library: C 621.380433, T974, 81-32691)

          2. Implemented by Paul Penczek.

SUBROUTINE: MEDIAN, MD2, MD3

CALLER:     UTIL2
