
CG 3S     Center of Gravity - Solid body option              CG 3S
                                                           6/25/96

PURPOSE:  Compute center of gravity and radius of gyration of a 3-D
          density distribution.

SEE ALSO:  CG    (center of gravity)
           CG 3  (center of gravity - radius of gyration)
           CG PH (center of gravity - phase approximation)

USAGE:    CG 3S X10,X11,X12,X20

          .THREED FILE: 3DQ003
          [Enter name of file containing the 3-D density distribution.]

          THRESHOLD: 0.53
          [Only data above the threshold will be used in computation.]

NOTES:    1.  The coordinates of the center of gravity, with respect to
          the center at (NSAM/2 + 1, NROW/2 + 1, NSLICE/2 +1), and
          the radius of gyration are printed out and put into the
          first four (optional) registers appearing on the command
          line.

          2.  For this operation, data above the threshold are
          replaced by a uniform density.  Thus, the 3-D object is
          treated as a solid body without internal density 
          variations.

          3.  For the definition of the radius of gyration, see 
          International Tables of Crystallography, vol. III, p327.

SUBROUTINE: CENGR3

CALLER:     UTIL1
