
CP FROM PDB   Copy PDB file to SPIDER format 	          CP FROM PDB               
						          8/17/96

PURPOSE: Copy a PDB image data file to SPIDER volume.

SEE ALSO: 
#include "cp_include.also"

USAGE:    CP FROM PDB

          INPUT PDB FILE: TRNA03.PDB
          [Enter the name of PDB file with extension.]

          .VOXEL SIZE (A): 2.2
          [Enter the voxel size of SPIDER file in angstroms.]

          .VOLUME NSAM, NROW: 75,95
          .VOLUME NSLICE: 85
          [Enter size of the SPIDER file (number of voxels in each
           dimension).]

          .SPIDER FILE: TRNA03
          [Enter the file that will contain the volume.]

NOTES:   1. The program reads atomic coordinates of a structure 
         from a PDB file, then creates a  SPIDER volume by adding the 
         Z values times the occupancy factor in each resolution cell.  
         The resulting sum is divided by 1000 for convenience. The 
         density is proportional to the Coulomb potential.
   
         2.  Author: Jun Zhu

SUBROUTINE: READPDB

CALLER:     COPY1

