CP FROM PE   Copy Perkin Elmer disk file to SPIDER format    CP FROM PE  
                                                             3/20/97

PURPOSE:  Converts Perkin Elmer densitometer disk files to SPIDER
          image files.  Operation was previously named "TR DISK". 

USAGE:    COPY FROM PE

          .SCAN INPUT FILE: IMAGE0001
          [Enter file name.  Each image scanned by the densitometer is
          contained in two files. Both have the name of the 
          identification specified in SCANSALOT with 4 digits added to it. 
          Example: If the identification was "IMAGE", then you need to 
          have two files: IMAGE0001.IMG and IMAGE0001.HDR in the same 
          directory.  This program looks up in IMAGE0001.HDR to find 
          the file dimensions and the scanning direction. This information 
          is then used to convert IMAGE0001.IMG into a SPIDER image file.]

          .OUTPUT FILE: SPI001
          [Enter output file name (use SPIDER conventions)]

          .(D)ENSITY, (T)RANSMISSION: D
          [If image was digitzed in density mode, enter D , otherwise
          enter "T" and the program will convert the transmission values
          into densities]
              
       If "T" was answered, the system asks:

          .ENTER GAIN FACTOR: 5
          [Default value is 1. If the micrdensitometer was calibrated 
          according to the description in the manual (1988), the gain
          value is 5]

          .REDUCTION FACTOR (0 IF NO RED.): 4
          [Enter integer reduction factor. The program averages over
          aXa pixels (a=reduction factor).  If you do not want to have 
          any reduction, enter 1.] 

NOTES:  1) This operation converts only files that were originally 
        written onto disk by the PDS software. If file was originally
        written to tape by the PDS software, use 'COPY FROM TR"
        for conversion.

        2) The output file will occupy twice as much disk space as the 
           input file.

	3) After scanning if you somehow corrupt your .HDR file you
	   can retreive your image by modifying any other .HDR file
	   (it is an ASCII file) and substituting the known X and Y
	   dimensions.  If you do not know the dimensions divide the
	   size of the file by 2 and the answer is the product of the
	   X and Y dimension. i.e. a 4451 X and 3502 Y will give you
	   a file that has the size of 31174804. 

SUBROUTINE: COPYPDS 

CALLER:    COPY1

