CP FROM TR   Copy old TR file to SPIDER format            CP FROM TR  
                                                             3/18/97

PURPOSE:  Converts Perkin Elmer file that was copied from tape onto 
          disk into SPIDER format. Operation was previously named 
          "TR TDISK".

USAGE:    CP FROM TR

          .SCAN INPUT FILE: FILE1.SCN
           [Enter file name including extension (max. 40 characters)]

          .(L)IST RECORD HEADINGS,(S)KIP RECORDS,(G)O ON: L
          [Enter L for listing of record headers, S if a number
           of records from the input file should be skipped,
           G if conversion should continue without skipping.]

       If the answer was "L" or "S" the following quesiton appears:

          .NUMBER OF RECORDS TO LIST/SKIP: 10
          [Enter number of records to list or skip. With option L
           the headers of the specified records are listed and the
           program returns to the OPERATION prompt, otherwise it 
           continues normally.]
          
          .OVERWRITE NSAM <RET=NO>: <RET>
           [Allows you to overwrite NSAM if something went wrong during
            scanning]

          .OUTPUT FILE: SPI001
           [Enter output file name (use SPIDER conventions)]

          .(D)ENSITY, (T)RANSMISSION: D
           [If image was digitized in density mode, enter "D" , otherwise
            enter "T" and the program will convert the transmission values
            into densities]
              
       If "T" was answered, the program asks:
          .ENTER GAIN FACTOR: 5
          [Default value is 1. If the microdensitometer was 
          calibrated according to the description in the manual
          (1988), the gain value is 5]

          .HOW MANY LINES (0=ALL): 0
           [Specify number of lines to be read (starts at line 1)]

      If the reduction option is used:
          .REDUCTION FACTOR (0 IF NO RED.): 4
           [Enter integer reduction factor. The program averages over
            aXa pixels (a=reduction factor), if you do not want to have 
            any reduction, enter 1.] 

NOTE:  1) This operation only converts files, that were originally 
       written onto tape by the PDS software.  To get the image onto
       disk the tape has to be mounted /FOREIGN, with a sufficiently
       large blocksize. Then use e.g. COPY MSA0: SCANFILE1.OUT to copy
       the tape data onto disk. 

       2) The output file will occupy twice as much disk space as the 
         input file.

SUBROUTINE: COPYMDTR 

CALLER:    COPY1

