
CS DI PL  Contour display - convert to HPGL              CS DI PL
                                                          1/29/96

PURPOSE:  Converts a contour storage metafile to HPGL format.
          Gould plotters accept this format.

SEE ALSO: CS DI GD  (Contour display - on Gould plotter)
          CS DI PO  (Contour display - on Postscript)
          CS DI TX  (Contour display - on Tektronix 4662 plotter)
          CS DI VT  (Contour display - on VT125/240 terminal)

USAGE:    CS DI PL  
            
          .PLOT FILE: CNT001
          [Enter name of the existing contour storage metafile.]

          .CLEAR THE SCREEN FIRST? (Y/N): Y

          .Enter viewport size (100-480):
          
          .DO YOU WANT TO WINDOW? (Y/N): N
          [This question only occurs for some devices.
          Windowing allows you to plot only a portion of the
          plot metafile. If the answer is "Y" then the 
          following two questions appear.  The window is
          calculated assuming a normalized 1.0 by 1.0 plot.]

          .ENTER X & Y CO-ORD. OF BOTTOM LEFT CORNER (0.0 - 1.0): .0 .5

          .ENTER X & Y CO-ORD. OF TOP RIGHT CORNER (0.0 - 1.0):   .8 .9

          .CENTER THE PLOT? (Y/N): Y
          [A "Y" answer centers the output on the device.]

          Lists current display scale.

          .ENTER NEW DISPLAY SCALE OR <CR>: 450
          [You can alter the plot size by entering a different value.]

          .PRINT TEXT? (Y/N/M): Y
          [Can omit text if desired.  An answer of "M" will 
          mirror output around a X axis so as to flip the
          top and bottom of the plot.]

          .PLOT AGAIN (P), HARDCOPY (H), DO NOT CLEAR(D) (P/H/D):

NOTES: 1. The different output devices may vary somewhat
          in the questions which appear, depending on the
          capabilities of the device.

SUBROUTINES: CNGOUL, CNFILE

CALLER:      PLOT1


