
DF        Density Foldover                                  DF      
                                                           1/14/90

PURPOSE:  Expands display density by re-mapping the density
          range, yielding multiple output density assignments.  
          The result contains equal-density contours 
          along which the foldover occurs ("equidensitometry").

USAGE:    DF

          .INPUT FILE: H_PIC001
          [Enter the name of the image file to be remapped.]

          .OUTPUT FILE: H_IMG015
          [Enter name of output file where result is to be put.]

          [SPIDER will now write minimum FMIN, maximum FMAX, and 
          the offset used for normal display (=FMIN) on the 
          terminal.]

          .ENTER SCALING FACTOR: 3.5
          [Density scaling factor by which each pixel will be
          multiplied according to

                TEMPPIXEL = (OLDPIXEL-OFFSET)*SCALE.  

          From this, the output is computed according to

                NEWPIXEL = AMOD(TEMPPIXEL,DIFF)

          where DIFF is FMAX-FMIN for the image before re-scaling.]


          .ENTER OFFSET: 0.15
          [Enter offset constant, to be subtracted from the image
          before rescaling.  Unless you want to truncate part of the
          density range, use 0.0]

NOTES:    contact: jf

Subroutine: DENOV
Caller:     UTIL2
