
DU   V    DUst - with Value set                              DU  V   
                                                            2/09/96

PURPOSE:  Eliminates all data in a picture that is more than a given
          multiple of the standard deviation away from the mode of 
          the histogram. The eliminated data are set to the given value.

SEE ALSO:
          DU (Dust)

USAGE:    DU V

          .INPUT FILE: PIC001
          [Enter the name of the image that is to be "dusted".
           Note: The file will be overwritten by the new data!]

          [The original standard deviation and density range of the
          picture are printed on the terminal.]

          .STANDARD DEVIATION FACTOR: 3
          [This factor defines the bottom and top sided truncation
          of the data.  In the given case, all data that are smaller
          than (MODE-3 * S.D.) and all data larger than (MODE+3 *
          S.D) are replaced by the solicited value.]

          .(1) BOTTOM  (2) TOP  (3) BOTH SIDES: 3
          [Specify if you want one-sided or two-sided truncation.]

          .VALUE TO BE SUBSTITUTED: 2
          [The pixels outside out of the given range will be set to this
           value.]

SUBROUTINE: HIST

CALLER:     UTIL1
