
EC CLOSE  Extract Connected CLusters - merge CLOSE             EC CLOSE 
							 9/11/97

PURPOSE:  Merges neighboring clusters of voxels in a 3D volume into
          a single "object" or lower hierarchical-level cluster.  '<BR>'

          Reads a SPIDER document file containing cluster centers
          of mass.   Determines distances between all clusters. If the 
          distance between two clusters is less than the solicited 
          threshold, it sets higher-numbered cluster voxels to the 
          same number as the lower-numbered cluster.  
 
SEE ALSO: EC SELECT (Extract connected clusters - selection)
	  EC        (Extract connected clusters)
	  EC FILTER (Extract connected clusters - filter)
	  EC STAT   (Extract connected clusters - statistics)

USAGE:    EC CLOSE

          .CENTER-OF-MASS DOC FILE: doc003
          [Contains cluster numbers and centers of masses.  Usually
          prepared using operation 'EC STAT'.]
	  
          .ENTER THRESHOLD AND STARTING CLUSTER: 15, 2
          [Clusters closer together than specified threshold distance
          are given same cluster number.  Clusters below the starting 
          cluster are ignored.]

          .CLUSTER INPUT FILE: VVV001
          [Usually a cluster file produced by running 'EC CL'.]

          .CLUSTER OUTPUT FILE: VVV002
          [Contains remapped cluster numbers.]

NOTES:    Document files have same format as 'EC STAT' output:            '<BR>'
                                                                        '<BR>'
             Index key = cluster number + 1                             '<BR>' 
             First register = number of voxels in the cluster           '<BR>' 
             Next 3 registers = X,Y, and Z center of mass of cluster.
	  
SUBROUTINES: MAPDIST, MAKTAB, MAPIM

CALLER:      UTIL6	
