
EC SELECT   Extract Connected CLusters - SELECTion     EC SELECT
							9/11/97

PURPOSE:  Reads a SPIDER document file for mapping an image file into
 	  a new image file. The document file contains X, Y, and Z
	  locations of a voxel in the image file. All voxels in the 
          file having the cluster number found at this location are 
          transferred into a new file. All other voxels are set to zero.

SEE ALSO: EC CL     (Extract connected clusters)
	  EC CLOSE  (Extract connected clusters - merge close)
	  EC FILTER (Extract connected clusters - filter)
	  EC STAT   (Extract connected clusters - statistics)

USAGE:    EC SELECT

          .LOCATION DOC FILE:  DOC001
          [Name of document file contining voxel locations.  This file
           may be edited output from the WEB "PIXEL" operation or from
           some other source.]

          .CLUSTER INPUT FILE: VVV001
          [Usually a cluster file produced by previous run of EC CL.]

          .CLUSTER OUTPUT FILE: VVV002
          [Contains remapped cluster numbers.]

	  
NOTES:    Document file should contain X, Y, and Z locations in the
          first three registers.  The index key is not used.
	  
SUBROUTINES:  MAPDOC, MAPIM

CALLER:      UTIL6
	  
