
EP TT      T test                                            EP TT
                                                            2/27/96

PURPOSE:  Computes the t-test values for pairs of points from two  
          average images resulting from adding two image series.  Images
          can be 2D or 3D.

USAGE:    EP TT

          .FIRST AVERAGE FILE: AVE001
          [Enter the name of the file containing the average of first
           image series.  This is obtained by using operation 'AS R'.]

          .FIRST VARIANCE FILE: VAR001
          [Enter the name of the file containing the variance of first
           image series.  This is obtained by using operation 'AS R'.]

          .NUMBER OF IMAGES AVERAGED: 56
          [Enter the number of images added when the first average image
           was formed.]

          .SECOND AVERAGE FILE: AVE001
          [Enter the name of the file containing the average of second
           image series.  This is obtained by using operation 'AS R'.]

          .SECOND VARIANCE FILE: VAR001
          [Enter the name of the file containing the variance of second
           image series.  This is obtained by using operation 'AS R'.]

          .NUMBER OF IMAGES AVERAGED: 56
          [Enter the number of images added when the second average image
           was formed.]

          .SIGNIFICANCE IMAGE: SIG001
          [Enter the name of the file which will contain the statistical
           significance of the point-by-point differences.]

NOTES: 1. For an elementary introduction into the theory of  
          statistical inference, see (e.g.) P. Armitage, "Statistical
          Methods in Medical Research", Blackwell Scientific
          Publications, p99ff. (WCL&R Library:  19.A77)

       2. The images can be 2D as well as 3D.

       3. Please keep in mind that command 'AS' subtracts the average
          from the images added. Such averages can produce incorrect
          results in t-test (too significant).

       4. Since the correct normalization of EM images is usually unknown
          the results of t-test should be taken with a grain of salt.

       5. Implemented by: P. Penczek.

SUBROUTINE: TTEST

CALLER:     CONF1
