
FF S      Fourier Filter - restore Surface topography        FF S    
                                                           1/7/94

PURPOSE:  Restores surface topography from a micrograph of a
          shadowed surface relief. [Reference:
          Smith and Kistler, J.Ultrastr.Res.  61 (1977) 124-133.]
          '<STRONG>'PROGRAM NOT TESTED - RESULTS MAY BE INCORRECT '</STRONG>'   

USAGE:    FF S

          .INPUT FILE: FOU001
          [Enter name of input file containing Fourier transform of
          data. The file will be overwritten by the filtered 
          transform.]

          .(E)XACT CORRECTION OR (P)HASE CORRECTION ONLY: E
          [Specify filter mode.  Enter 'E' for combined phase and
          amplitude correction, or 'P' for phase correction only.
          cf Smith and Kistler paper.]

          .SHADOWING ANGLE THETA: 45.
          [Enter shadowing elevation angle with respect to plane of
          specimen, i.e. 90 degrees for perpendicular shadowing.]

          .DEPOSIT THICKNESS D: 5
          [Enter vertical thickness of metal deposit (parameter D in
          Smith/Kistler paper), in sampling units.]

          .EPSILON: 0.01
          [Epsilon is the smallest value permitted for ABS(1-exp(-2PI Ra))
          so that unreasonable noise amplification is avoided.]

          .SHADOWING AZIMUTH PHI: 30.
          [Enter azimuth of base line of shadowing vector, in 
          degrees.  The azimuth is measured with respect to the
          direction of the x-axis.]

SUBROUTINE: FSHADO

CALLER:     FOUR1
