FI N      File Information - Do not halt if file not found      FI N      
                                                              7/10/97

PURPOSE:  Prints out information on specified file.

SEE ALSO: FI    (File information - single file information)
          FI A  (File information - multiple files)
          FI X  (File information - place header values in registers)
          FR    (File read)

USAGE:    FI N  

          .FILE INFO. ON FILE: PIC002
          [Prints out FILE INFORMATION for the single file specified.]
      
NOTES:  1. The following header information is printed:

          '<PRE>'
           7  FMAX  = IMAGE MAXIMUM
           8  FMIN  = IMAGE MINIMUM
           9  AV    = IMAGE AVERAGE
          10  SIG   = STANDARD DEVIATION (SQ. ROOT OF VARIANCE)
          15  PHI   = EULER ANGLES: ANGLE AROUND Z
          16  THETA = EULER ANGLES: ANGLE AROUND Y
          17  PSI   = EULER ANGLES: ANGLE AROUND Z 
          18  XOFF  = X OFFSET
          19  YOFF  = Y OFFSET
          20  ZOFF  = Z OFFSET
          '</PRE>'

       2.  Angles: PHI, THETA and PSI (often also referred to as GAMMA) 
           have meaning consistent with the operation where they are 
           set (see commands 'RT', 'PJ', 'BP' etc.).

SUBROUTINES: FILGEN, FILDAT

CALLER:     UTIL1

