
FS        Find Statistics                                   FS      
                                                            01/28/98

PURPOSE:  To compute and print out statistical parameters (i.e. 
          minimum, maximum, average, and standard deviation) of a
          image or volume.

SEE ALSO: FS M  (find statistics - within mask)

USAGE:    FS XM,XN,XO,XP
          [XM, XN, XO, and XP are optional register parameters, such
          that 10 <= M,N,O,P <= 99.  On completion of the operation,
          XM contains the picture maximum, XN its minimum, XO its
          average, and XP its standard deviation. 
          However, only if the image statistics have already been 
          determined in a previous operation and have been recorded 
          in the file header are the values are placed in the 
          registers: XM,XN,XO,XP.

          .INPUT FILE: PIC001
          [Enter name of image file to be analyzed. If this is a 
           whole stack then results are reported for all of the
           images in the stack]

NOTES:    The statistical parameters will be printed out on the
          terminal and in the results file.  No printing will occur
          at the terminal if the user is in batch mode.
          Image can be 2D, 3D or a whole stack.

SUBROUTINE: QSTAT, NORM3

COTASK:     UTIL1
