HI D      HIstogram - output in Document file                HI D
                                                            3/22/96

PURPOSE:  Computes the histogram of an image and puts the output in
          user specified document file.

SEE ALSO: HI    (histogram)
          HI T  (histogram - display on terminal)
          HI M  (histogram - masked area)

USAGE:    HI D

          .INPUT FILE: PIC027
          [Enter the name of the file containing the image.]

          .DOCUMENT FILE: DOC001
          [Enter name of output document file]

NOTES: 1. The 128 level histogram of PIC027 will be computed and put
          into the RESULTS file.  The boundaries and number of pixels
          in each of the 128 bins will be saved in user's document
          file.  The following information will be printed out at the
          user's terminal:

          '<PRE>'
          FILE RANGE:               .........    
          HISTOGRAM RANGE:          .........      
          FILE MEAN:                MODE:              
          S.D.:                     BIN SIZE:       
          '</PRE>'   

       2. The histogram is no longer permanently kept in
          the picture label.  

SUBROUTINE: HIST, SAVD

CALLER:     UTIL1
