
SPIDER Cross-Reference Index

add images (same size)  AD
           (different size)  PA
add image series  AS
align (reference-free)  AP
      (reference-based) -> PROC
arithmetic point-for-point operations  AR
ART iterative reconstruction  BP 3
auto-correlation  AC

back-project  BP
blank file  BL
blow up an image  IP
box convolution  BC

center of gravity  CG, CG 3
classification  CL
confidence interval  CI
contrast normalization  (linear ramp subtraction) RA
                        (Gaussian fit and subtraction) RA GN
construct Fourier  CF, CF 3
contour storage  CS
contrast-enhance CE
contrast transfer function  TF
copy to and from SPIDER files CP
contour  (line graphics) CO
         (into image) FC
convolute CN, see also WEB
correspondence analysis  CA
cosine shading of volumes -> surface shading
create constant image file  BL
cross-correlation  CC

delete  DE
density foldover (multiple linear density mapping) DF
density reference (insert "calibration threads")
                  (compare 2 volumes)  DR DIFF
                  (difference between 2 volumes)  DR ERR
divide  MU / or  MU D
do-loop  (start) DO
         (end) LB<N> where <N> is an integer
dust  (remove outlier values from image)  DU

edge detection (recursive, real space)  ED
end SPIDER session  EN
enlarge an image  IP
error probability  EP
extract central section from 3D Fourier  EF

factor map display  CA SM  or  create doc file (SD C) then WEB
file info  FI
find statistics of an image  FS
Fourier filter  FF, FQ
Fourier interpolation  (by padding with zeros) FP
Fourier list  FL
Fourier ring correlation  RF
Fourier transform  FT

gallery (put images into gallery) MN  or WEB/Montage
go to (in conjunction with logical if) GOTO LB<N> where <N> is an integer
graph  (produce display of selected image row) GR

histogram  HI  (also see WEB)

if  (in batch) IF
insert (an image into another, larger one) IN

label  LB<N> where <N> is an integer
lattice indexing  (from hardcopy of power spectrum) WT
list (image)  LI
     (document file) LI D
logical if  IF
low-pass filtration (box convolution) BC
                    (Fourier filtration) FT-FF-FT
                    (quick Fourier filtration) FQ

marker fit  (single-tilt reconstruction) MK
mask  MA
      (create by using threshold) TH M
menu  ME
mirror  (create mirror-related image) MR
mode (global switch)  MD
model (create model distributions in 2D and 3D) MO, MO 3
montage  MN
multiply (images) MU
         (image with mask) MM
         (complex-valued files) MU *
multi-variate statistics  CA

new code  (switch to new data code) NC
non-linear mapping  (of MSA coordinates onto 2D plane) CA MAP

orientation search  OR

pad  (put image into larger frame, fill outside with value) PD
patch averaging  WV
pattern  (create p. using single pixels) PT
PDB to SPIDER  CP PDB
peak search  PK
phase residual (differential)  RF
pick slice  (from a volume) PS
POCS-replace  CV REPL
power spectrum  (create p. from Fourier transform) PW
principal component analysis CA
print (image on line printer or various old terminals)  PR
project  PJ

read register  RR
reciprocal lattice filter  GF
reconstitute images CA SR, CA SRD
reduce transform  (condenses Fourier into small Fourier file)  RD
resolution criterion  (by comparing two Fourier transforms) RF
return  (from procedure) RE
R-Factor  RF
rotate  RT
rotational average  (of an image with respect to a given center) RO

save into document  (saves selected registers into doc file) SD
                    (saves MSA coordinates into doc file) SD C
save (or unsave) registers during SPIDER session  SR
shift SH
sort document  (sorts doc file by values in selected column) SD S
square  (multiply image with itself) SQ
square root  (take sqare root of each pixel) WU
sum alignment  (2D vectorial additions of rotations and shifts)  SA
stack images to form volume  SK
stack-replace  (replace a slice by an image) SK R
statistics of an image FS
sub-sample an image  IP
subtract  SU
surface representation of volumes  PJ ST
surface shading (together with PJ ST) PJ SHAD

three-dimensional plot  (perspective plot of any 2D map) TP
threshold an image from above or below  TH
          (and produce binary mask file) TH M
time  (print time at given point in batch) TM
title  (add title to SPIDER file) TT
trace -> MD/TR ON
transfer function  TF
t-test  EP TT

unsave document  UD

variance (of an image series) AS
         (of an image) FS
vector operation  (performs vectorial additions on angles in doc file) VO

window  (select small area from image) WI, see also WEB
window averaging  (average unit cell repeats within patches) WV
