
LI X      List pixel values - in registers                   LI X
                                                            9/4/96

PURPOSE:  Puts image values at specified coordinates in registers
          and also lists them in "RESULTS" file.

SEE ALSO:  LI    (List image values - in RESULTS file)
           LI D  (List image values - in doc. file)
           LI T  (List image values - on terminal)
           LI R  (List registers - in RESULTS file)

USAGE:    LI X11,X12,...

          .INPUT1 FILE: PIC001
          [Enter the file of interest.]

          .ENTER X-COORDINATES: 3,6-8
          [Enter one x-coordinate for each specified register.]

          ENTER Y-COORDINATES: 7,12,1,33
          [Enter one y-coordinate for each specified register. If 
           e.g. LI X11,X12,X13 has been entered, register X11
           will receive the image value found at (nsam=3,nrow=7),
           X12 will receive the value found at (6,12), and X13 will
           receive the value at (7,1) and X14 will receive the value
           at (8,33).]
          
NOTES:     1. Hyphens can be used to specify the COORDINATES.

SUBROUTINES: LISTITR

Caller:      UTIL1
