
MM        Mask Multiplication                               MM      
                                                            9/19/94

PURPOSE:  Mask an image or a volume according to a mask
          reference file.  This operation will retain image values
          from the original image wherever the corresponding location
          in the reference image is >= 0.5.  If the corresponding
          location in the reference image is < 0.5 the image value 
          will be replaced with a background value.


SEE ALSO: MM C  (Mask multiplication - continuous)
          MA    (Mask)

USAGE:    MM

          .MASK REFERENCE FILE: MAS001
          [Enter mask reference file containing values >= 0.5 where
          INPUT2 file is to be passed, and < 0.5 where elements in
          input are to be replaced by a background value.]

          .IMAGE (OVERWITTEN!): IMA001
          [Enter name of image or volume file to be masked.  This
          image or volume file will be overwritten by the masked 
          output image.]

          .ENTER BACKGROUND: 0.8
          [Enter value of background to be used in masking.]

SUBROUTINES: MASKMU

CALLER:      UTIL2
