
MU D      Divide real or complex files                         MU D
                                                             8/1/97

PURPOSE:  Divides two or more images, volumes, 2 or 3D
          Fourier transforms. 

SEE ALSO: MU    (Multiply real or complex files)
          MU M  (Multiply 1st complex file by 2nd conjugated)
          MU O  (Multiply with arithmetic OR)

USAGE:    MU D

          .INPUT FILE: PIC001
          [Enter the name of the first file to be divided.]

          .DIVISOR FILE: PIC002
          [Enter the name of file containing divisor.  Can be same
           as first file.]

          .OUTPUT FILE: PIC999
          [Enter the name of file for output.  Can be the same
           file as either input.]

   The system continues:

          .DIVISOR FILE: *
          [Enter '*' if no more files are to be processed.]

NOTES:    1.  PIC001 contains first term of the operation, PIC002 the 
          second term. The result is kept in PIC999.

          2.  "MU D" may only be used for images, volumes, or
          Fourier tranforms having the same dimensions.
          
SUBROUTINES: ADD

CALLER:      UTIL2
