
MU M      Multiply 1st complex file by 2nd conjugated file       MU M
                                                                8/1/97

PURPOSE:  Multiplies two or more images, volumes, 2D, or 3D
          Fourier transforms in the form of (X) * CONJ(Y). 

SEE ALSO: MU   (multiply real or complex files)
          MU D (divide real or complex files)
          MU O (multiply with arithmetic OR)

USAGE:    MU M

          .INPUT  FILE: PIC001
          [Enter the name of the first file to be processed.]

          .MULTIPLIER FILE: PIC002
          [Enter the name of the file containing multiplier. Can
           be the same file as the first input.]

          .OUTPUT FILE: PIC999
          [Enter the name of the output file.  Can be the same
           as either input file.]

   The system continues:

          .MULTIPLIER FILE: *
          [Enter '*' if no more files are to be processed.]

NOTES:    1. PIC001 contains first term of the operation, PIC002 the 
          second term. The result is kept in PIC999.

          2. "MU M" may only be used for images, volumes, or
          Fourier tranforms having the same dimensions.
       
SUBROUTINES: ADD

CALLER:      UTIL2
