
MU O      MUltiply with arithmetic Or                       MU O    
                                                            8/1/97

PURPOSE:  Combines two images of equal size according to OR logic.
          Each pixel is set equal to the pixel of the first image if
          it is nonzero, or to the pixel of the second image if it
          is nonzero.  In case both are nonzero, the first image is
          used.  

SEE ALSO:  MU    (Multiply real or complex files)

USAGE:    MU O

          .INPUT FILE: PIC001
          [Enter the name of the first image.]

          .MULTIPLIER FILE: PIC002
          [Enter the name of the second image. Can be same as first]

          .OUTPUT FILE: PIC999
          [Enter the name of the output image.  Can be same as
           either of the first two input files]

   The system continues:

          .MULTIPLIER FILE: *
          [Enter '*' to terminate the operation.]

NOTES:    1.  PIC001 contains first term of the operation, PIC002 the 
          second term. The result is kept in PIC999.

          2.  "MU O" may only be used for images, volumes, or
          Fourier tranforms having the same dimensions.
          
SUBROUTINES: ADD

CALLER:      UTIL2
