
OR 2      ORientation search for rotation angle in 2D       OR 2
                                                            2/19/98

PURPOSE:  Determines rotational orientation between two images.

SEE ALSO:  OR 2M  (Orientation search - 2D, multiple peaks)
           OR 3A  (Orientation search - 3D, arbitrary center)
           OR 3Q  (Orientation search - 3D, Eulerian angles)

USAGE:    OR 2,X10,X11

          [The optional output parameters X10,X11 specify register
          positions for the rotation angle and the value of the
          angular correlation peak found in this operation.]

          .INPUT FILE: UUU001
          [Enter name of the file.]

          .REFERENCE FILE: GGG002
          [Enter the name of the file containing the reference
          picture; dimensions must correspond to those of the first
          picture.]

          .FIRST AND LAST RING: 5,15
          [Only  rings with the radii in the range 5-15 (in pixel units)
           will be used.]
  
          .SKIP: 1
          [If skip=0 or 1 then each ring between 5 and 15 will be taken;
          for skip=2 every second, and so on.]

          .(F)ULL OR (H)ALF CIRCLE:F
          [F - full ring (360 degrees) will be used; H - half ring
           (180 degrees) will be used.  Option H is appropriate
           for rotational search using autocorrelation functions.]

NOTES: 1. Implemented by: Paul Penczek

SUBROUTINES: ORMD, ORMD_P, ALPRBS, NORMAS, ALRQ, FOURING, CROSRNG, 
             PRB1D, ANGMOR

CALLER:      UTIL3
