
PJ 3      ProJect - 3D volume                                  PJ 3    
                                                             09/10/96

PURPOSE:  Computes a projection of a 3D density distribution along
          two specified angles (azimuth angle, PHI, and tilt angle,
          THETA). 

SEE ALSO: PJ 3E   (ProJect - 3D volume using Eulerian angles, fast)
          PJ 3Q   (ProJect - 3D volume using Eulerian angles)
          PJ 3T   (ProJect - 3D volume using internal Threshold)
          PJ AT   (ProJect - 3D volume using exponential ATtenuation)
          PJ CYL  (ProJect - 3D volume onto cylinder)

USAGE:    PJ 3

          .THREED FILE: PIC001
          [Enter the name of the file whose projection is to be
          computed.]
       
          .PROJECTION SAMPLE DIM.: 110,78
          [Enter the X dimension and (optional) Y dimension 
          for the projection file equal to, or smaller than, the volume 
          sidelength. If the Y dimension = 0 then the Y dimension is chosen
          such that the X/Y ratio in the projection is the same as in the
          volume. Arbitrary dimensions can be used.]

          .OUTPUT FILE: PRJ001
          [Enter the name of the file where the projection is to be
          stored.]

          .AZIMUTH ANGLE (PHI): 45.5
          [Enter the azimuth angle, in degrees.]

          .TILT ANGLE (THETA): -30.0
          [Enter the tilt angle, in degrees.]

          [For this example, the projection of PIC001 with PHI equal
          to 45.5 and THETA equal to -30.0 is computed and stored in
          PRJ001.]

SUBROUTINES: PROJ3

CALLER:      VTIL2


