
PK        PeaK search                                       PK      
                                                            9/21/95

PURPOSE:  Searches for local peaks in a picture.

SEE ALSO:  PK 3   (Peak search - 3D)
           PK 3D  (Peak search - 3D, output to doc. file)
           PK C   (Peak search - center of gravity)
           PK D   (Peak search - output to doc. file)
           PK DC  (PeaK search - center of gravity, output to doc. file

USAGE:    PK X11,X12,X13,X14,X15,X16,X17

          [The first three optional output parameters (in this example
          X11,X12,X13) specify registers that are to receive
          the coordinates and the value of the largest peak found 
          in this operation (Integer values)). X14 contains the ratio
          of the first peak relative to the peak # specified for 
          that ratio (option ORIGIN OVERRIDE). The last two registers 
          (here X15 and X16) return the non-integer coordinates 
          according to a 9-point parabolic fit, X17 contains the 
          value of the maximum.]

          .INPUT FILE: PIC001
          [Enter the name of the image file.]

          .ENTER # OF PEAKS,CENTER ORIGIN OVERRIDE (0/1): 12,0
          [Enter the number of peaks to be searched for.  If an origin
          position other than at the picture's center (NSAM/2 + 1,
          NROW/2 + 1) is desired, enter '1' in the second position.
          The system will then allow you to enter the x,y coordinates 
          of the origin to be used.]

    If the option "CENTER ORIGIN OVERRIDE" is specified]:

          .NEW ORIGIN COORDINATES: 1,1
          [Enter the new origin coordinates.]

          .ENTER PEAK NUMBER FOR RATIO: 1
          [Enter the number of the peak relative to which the
          heights of the other peaks are calculated.  This ratio
          is printed out and listed in the document file along
          with the other parameters of the peaks.]

          [In the above example, the computer will find the 12
          largest peaks.  Their positions will be printed in the
          RESULTS file, and the value position of the largest peak
          will be printed to the user's terminal.  In addition, the
          peak positions and values will be put into the temporary
          registers if output parameters X11-X16 are specified. The 
          registers can be used as input to a subsequent shift
          ("SH") operation.

NOTES:    This routine does not find "maximum" location when image
          has plateaus.  It may find the "last" value along the
          plateau.  To overcome this use low pass filtration first.

SUBROUTINES: SPEAK, SPEAKC

CALLER:      UTIL1

