
PL HI     PLot HIstogram - from document file                    PL HI
                                                                7/16/96
 
PURPOSE:  Calculates and plots a histogram from a document file.

SEE ALSO: PL      (Plot doc. file into contour storage meta-file)
          PL FIT  (Fit polynomial to data stored in doc. file)

USAGE:    PL HI

          .DOCUMENT FILE:
          [Enter input file name.]

          .FIRST & LAST KEY NUMBERS: 1,10
          [Enter first, last key to be used.]

          .COLUMN # IN DOC FILE USED FOR HISTOGRAM: 2
          [Enter column # for histogram, 0=key.]
 
          .STARTING X VALUE, INTERVAL: -180, 10 

          .X-RANGE (ENDING X VALUE): 180 

          .PLOT FILE: PLT001 
          [Enter output contour storage file]

          Lists bounds on Y axis of plot.

          .ENTER NEW LOWER, UPPER Y AXIS BOUNDS OR <CR>:
          [Can change Y axis bounds. To keep default enter
           <return>.]

          Lists bounds on X axis of plot.

          .ENTER NEW LOWER, UPPER X AXIS BOUNDS OR <CR>:
          [Can change X axis bounds. To keep default enter
          <return>.]

          .ENTER NEW AXIS LABEL UNIT AND TICKS / LABEL OR <CR> :
          [Can change Y axis label unit or keep default]

          Y axis label units listed.

          .ENTER LABEL NO. TO EDIT.  USE 0 FOR LABEL:  1
          -1  TO RELIST ALL LABELS, OR <CR> TO CONTINUE: <CR> '<BR>'
          [Can change X axis label unit or keep default.]

          .ENTER NEW AXIS LABEL UNIT AND TICKS / LABEL OR <CR> :

          X axis label units listed.

          .ENTER LABEL NO. TO EDIT.  USE  0  FOR LABEL:  1
          -1  TO RELIST ALL LABELS,  OR  <CR> TO CONTINUE: <CR> '<BR>'
          [Can change X axis label unit or keep default]

NOTES:   1. To convert CNT meta-file to Postscript use the 'CS DI PO' 
            operation.

         2. To view the CNT meta-file use Web and 'Show contourfile'

SUBROUTINE: DCHIST, OPENDOC

CALLER:     PLOT1

