
PS        Pick Slice - Y (xz planes)                            PS
                                                           1/27/96

PURPOSE:  Picks Y slice out of a volume file containing a 
          three-dimensional density distribution.

SEE ALSO:  PS X  (Pick slice - X, yz planes)
           PS Z  (Pick slice - Z, xy planes)
           PS A  (Pick slice - arbitrary direction)
    
USAGE:    PS  -or- PS N

          .INPUT FILE: SPH001
          [Enter the name of the file containing the 
          three-dimensional information.]

          .OUTPUT FILE: SLI001
          [Enter the name of the file where the two-dimensional
          slice (xz plane) is to be put.]

          .Y-SLICE NUMBER: 15
          [Enter the number of the slice you wish to select.]

NOTES: 1. Due to the way the volume is stored on disk, 'PS'
          (='PS Y' by default) and 'PS Z' are much faster
          than 'PS X'.

       2. Use 'PS N' to keep the FMIN and FMAX values from
          the original volumes in the slices.

SUBROUTINES: PICKSV

CALLER:      VTIL2
