
PS Z      Pick Slice - Z, (xy planes)                             PS Z
                                                                1/27/96

PURPOSE:  Picks Z slice out of a file containing a three-dimensional
          density distribution.

SEE ALSO:  PS          (pick slice - Y, xz planes)
           PS X        (pick slice - X, yz planes)
           PS A        (pick slice - arbitrary direction)
  
USAGE:    PS Z  -or- PS ZN

          .INPUT FILE: SPH001
          [Enter the name of the file containing the three-dimensional 
	  information.]

          .OUTPUT FILE: SLI001
          [Enter the name of the file where the two-dimensional
          slice (xy plane) is to be put.]

          .Z-SLICE NUMBER: 15
          [Enter the number of the slice you wish to select.]

NOTES: 1. Due to the way the volume is stored on disk, 'PS'
          (='PS Y' by default) and 'PS Z' are much faster
          than 'PS X'.

       2. Use 'PS ZN' to keep the FMIN and FMAX values from
          the original volumes in the slices.

SUBROUTINES: PICKSL

CALLER:      VTIL2
