
SL        SLice image series                                SL      
                                                            6/27/97

PURPOSE:  Constructs a perpendicular section through a stack of 
          successive images of slices from a three-dimensional specimen
          along a specified row.  For slicing a volume, see the
          Pick Slice ('PS') operation.

SEE ALSO: PS  (Pick Slice)

USAGE:    SL

          .ENTER FILE PREFIX OR TEMPLATE (EG. PIC****) PIC****
          [Enter the template for constructing the input file names.
          All images to be included in this operation must have the
          same prefix.]

          .ENTER FILE NUMBERS: 1-3,8,12-15
          [Enter the file numbers in any sequence.  Consecutive
          files can be specified by using hyphens.  A maximum of 40
          files can be specified.]

          .ROW NUMBER OF SECTION: 16
          [Enter the row number where the section is to be obtained.
          The row number must be in the limits   1 < IROW < NROW
          where NROW is the total number of rows.]

          .OUTPUT FILE: OUT001
          [Enter the name of the file where the section is to be
          stored.]

          [SLICE will construct intermediate rows by interpolation.
          Thus, a stack of 20 images will yield an output file with
          39 rows.]

SUBROUTINES: SLICE

CALLER:      UTIL3
