
SR        Save/unsave Registers                                  SR      
                                                            4/22/97

PURPOSE:  Allows the user to save or unsave the values of the
          registers during a session.  (For saving register values
          permanently to a document file, use 'SD').

SEE ALSO: SD X0    (Save registers in Document file)

USAGE:    SR

          .(S)AVE OR (U)NSAVE: S
          [Registers X0-X99 will then be saved.]

          [This operation is useful if it is desired to change the
          values of the registers, during a SPIDER session, without
          losing the old values. For example]:

                  X12=5                        '<BR>'
                  SR                           '<BR>'
                  .(S)AVE OR (U)NSAVE: S       '<BR>'
                  X12=6                        '<BR>'
                  .                            '<BR>'
                  .                            '<BR>'
                  .                            '<BR>'
                  SR                           '<BR>'
                  .(S)AVE OR (U)NSAVE: U       '<BR>'

          [X12 will now contain the value 5.]

SUBROUTINES: DRIV1

CALLER:      DRIV1
