
TH        THreshold                                         TH      
                                                          4/22/97

PURPOSE:  Replaces all values within an image or volume beyond a 
          specified threshold by the threshold value.
          Operation works for both 2-D and 3-D images. 

SEE ALSO: TH F   (Threshold, fixup constant)
          TH M   (Threshold replace)
          TH M   (Threshold and create mask)
 
USAGE:    TH

          .IMAGE TO BE THRESHOLDED FILE: TST001
          [Enter the name of the input file.]

          .OUTPUT FILE: TST002
          [Enter the name of the output file.]

          .ALTER (A)BOVE THRESHOLD, (B)ELOW, OR (C) BOTH SIDES (A/B/C): A
          [Option 'A' : Replaces all values greater than the specified 
                        threshold with the threshold value.           '<BR>'
           Option 'B' : Replaces all values smaller than the specified 
                        threshold with the threshold value.           '<BR>'
           Option 'C' : Replaces all values smaller than the lower 
                        threshold with the lower threshold value and
                        all values greater than the upper 
                        threshold with the upper threshold value.

    For options '<B>' 'A' and 'B' '</B>', SPIDER asks:

          .THRESHOLD: 1.2
          [Enter the threshold value desired.]

    For option '<B>' 'C' '</B>', SPIDER asks:

          .UPPER, LOWER THRESHOLD: 1.2, 0.8 
          [Enter two thresholds between which the original image
          data are to be preserved.]

SUBROUTINES: THRESH

CALLER:      UTIL2
