
TH F     THreshold - set a Fixed value                     TH F
                                                           4/22/97

PURPOSE:  Replaces all values within an image or volume before/beyond a 
          specified threshold by a specified value.
          Operation works for both 2-D and 3-D images. 

SEE ALSO: TH     (Threshold)
          TH C   (Threshold - change a value)
          TH M   (Threshold - and create mask)
 
USAGE:    TH F

          .IMAGE TO BE THRESHOLDED FILE: TST001
          [Enter the name of the input file.]

          .OUTPUT FILE: TST002
          [Enter the name of the output file.]

          .ALTER (A)BOVE THRESHOLD, (B)ELOW, OR (C) BOTH SIDES (A/B/C): A
          [Option 'A' : Replaces all values greater than the specified 
                        threshold with the fixup density vlaue.    '<BR>'
           Option 'B' : Replaces all values smaller than the specified 
                        threshold with the fixup density value.    '<BR>'
           Option 'C' : Replaces all values smaller than the lower 
                        threshold or greater than the upper 
                        threshold with the fixup density value.

    For options '<B>' 'A' and 'B''</B>',  SPIDER asks:

          .THRESHOLD: 1.2
          [Enter the threshold value desired.]

    For option '<B>' 'C' '</B>',  SPIDER asks:

          .UPPER, LOWER THRESHOLD: 1.2, 0.8 
          [Enter two thresholds between which the original image
          data are to be preserved.]

    For '<B>'all options '</B>', SPIDER asks:

          .ENTER FIXUP DENSITY: 0.5
          [Enter value to be give to pixels before/beyond the
           desired threshold(s).]

SUBROUTINES: THRESH

CALLER:      UTIL2
