
TH M      THreshold - and create Mask                         TH M    
                                                            12/6/89

PURPOSE:  Creates a mask (consisting of pixels valued at either 1 or 0)
          based on thresholding of an image or volume.
          Operation works for both 2-D and 3-D images.

SEE ALSO: TH     (Threshold)
          TH F   (Threshold - set a fixed value)
 
USAGE:    TH M

          .IMAGE TO BE THRESHOLDED FILE: AVG001
          [Enter the name of the file to be searched.  Depending
          upon the value of a pixel as compared with the threshold,
          the corresponding pixel in the mask is set to 0 or 1.]

          .OUTPUT FILE: MSK001
          [Enter the name of the output file.]

          .BLANK OUT  (A)BOVE THRESHOLD OR (B)ELOW THRESHOLD (A/B): A
          [Option 'A':  Mask is filled with 1's wherever the pixel
                        values do not exceed the threshold, and with
                        0's elsewhere.

           Option 'B': 'B':  Mask is filled with 1's wherever the pixel
                        values exceed the threshold, and with 0's
                        elsewhere.]

          .THRESHOLD: 1.4
          [Enter the threshold to be used in the search of the input
          image/volume.]

SUBROUTINES: THRESH

CALLER:      UTIL2
