
WI        WIndow                                            WI      
                                                          8/21/96

PURPOSE:  Cut out a window from a specified image file.

SEE ALSO: WI B   (Window - using specified background)

USAGE:    WI
 
          .INPUT FILE: H_PIC001
          [Enter the name of the file that is to be windowed.]

          .OUTPUT FILE: H_IMG051
          [Enter the name of the file where the window is to be
          kept.]

          .ENTER DIMENSIONS (NSAM, NROW): 64,64
          [Enter the size of the window.]

    If the file contains a 3D volume:

          .ENTER NUMBER OF SLICES (NSLICE): 42
          [The number of slices]

          .TOP LEFT COORDINATES: 1,1
          [Enter the upper left coordinates of PIC001 where the 
          window volume is to start.]

    If the file contains a 3D volume:

          .TOP SLICE: 4
          [The slice where windowing should start]

          [WIN001 will contain a window of H_PIC001 of size 64x64
          positioned in the upper left corner of PIC001. If the
          input file had a 3-D format, WIN001 would contain a
          volume with dimensions 64x64x42, obtained by cutting
          the input volume at x=1, y=1 and starting at slice=4.]

NOTES:    1. Remember that in SPIDER 1,1 is the origin of an
             image.

          2. This routine should handle windows that go outside of
             the original image correctly. Any outside area will be
             given the background value of 0.0.

SUBROUTINES: WINDOW

CALLER:      UTIL2
