C++************************************************************************
C
C $$ AFS.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ AFS.FOR
C
         SUBROUTINE  AFS(X,OUT,NSAM,NROW,
     &                        A,B,C,D,SHXI,SHYI,LUN2,LB)
         DIMENSION  X(NSAM,NROW),OUT(NSAM)
CNO_SAVE
C
	DET=A*D-B*C
C Determinant was checked in the calling program
	AT=A/DET
	DT=D/DET
	BT=-B/DET
	CT=-C/DET
         ICENT=NROW/2+1
         KCENT=NSAM/2+1
         DO    I=1,NROW
           YI=I-ICENT-SHYI
c$doacross local(k,xi,xold,yold)
           DO    K=1,NSAM
             XI=K-KCENT-SHXI
             XOLD=AT*XI+BT*YI+ICENT
             YOLD=CT*XI+DT*YI+KCENT
             OUT(K)=QUADRI(XOLD, YOLD, NSAM, NROW, X)
	   ENDDO
           CALL  WRTLIN(LUN2,OUT,NSAM,LB+I)
	 ENDDO
         END
