C++************************************************************************
C
C $$ ALROSI_Q.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ ALROSI_Q.FOR
C
         SUBROUTINE  ALROSI_Q(A,ATMP,B,C,REFER,LSD,NSAM,NROW,NSI,
     &   WRK,PARA,NOCHANGE,
     &   A_CIRC,REFER_CIRC,LCIRC,JACUP,NUMR,NRING,MAXRIN,TEMP,MODE,KTN)
         DIMENSION   A(LSD,NROW),B(LSD,NROW),C(LSD,NROW)
         DIMENSION   REFER(LSD,NROW),ATMP(LSD,NROW),PARA(3),WRK(*)
         INTEGER*2  NUMR(3,NRING),MAXRIN
         DOUBLE PRECISION  TEMP(MAXRIN+2,2),TOTMIN
         DIMENSION  A_CIRC(LCIRC),REFER_CIRC(LCIRC)
         LOGICAL  NOCHANGE
         CHARACTER*1 MODE
CNO_SAVE
C
         NSNR=LSD*NROW
C
C  atmp has to be updated before the call
C
         ITER=0
         NOCHANGE=.FALSE.
101      ITER=ITER+1
         CALL  ALRQ_Q
     &   (ATMP,LSD,NSAM,NROW,NUMR,A_CIRC,LCIRC,NRING,MODE,IPIC)
         CALL  FOURING_Q
     &   (A_CIRC,LCIRC,NUMR,NRING,TEMP,MODE)

         CALL  CROSRNG_Q
     &   (REFER_CIRC,A_CIRC,LCIRC,NRING,TEMP,TEMP(1,2),
     &   MAXRIN,JACUP,NUMR,TOTMIN,TOT,MODE)
C
         ROTMP=ANG(TOT,MODE)
         CALL  RTQ_Q(ATMP,B,LSD,NSAM,NROW,ROTMP)
C
         INS=1
         CALL  FMRS_2(B,NSAM,NROW,INS)
         CALL  CCRS_2R(REFER,B,C,LSD/2,NSAM,NROW)
         CALL  FINDMX_Q(C,LSD,NSAM,NROW,NSI,CMX1,SX1,SY1)
C
         DD=((COSD(ROTMP)-1.0)*NUMR(1,NRING)+SX1)**2
     &   +(SIND(ROTMP)*NUMR(1,NRING)+SY1)**2
         IF(DD.LT.0.25 )  THEN
         IF(ITER.EQ.1)  NOCHANGE=.TRUE.
C
C next line would be used for non-zero tot only
C     call  updtc(refer_circ,a_circ,lcirc,nring,numr,tot,maxrin,ktn)
C
         CALL  UPDTF(REFER_CIRC,A_CIRC,LCIRC,KTN)
         CALL  UPDTF(REFER,B,NSNR,KTN)
         RETURN
         ENDIF
C
         CALL  SUMAP(PARA(1),PARA(2),PARA(3),ROTMP,SX1,SY1,P1,P2,P3)
         PARA(1)=P1
         PARA(2)=P2
         PARA(3)=P3
         CALL  RTQS_Q(A,ATMP,LSD,NSAM,NROW,PARA(1),PARA(2),PARA(3))
         IF(ITER.GT.25)  RETURN
         GOTO 101
         END
