C ++********************************************************************
C
C ATPK
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C                                                                      *
C ATPK                                                                 *
C                                                                      *
C***********************************************************************

        SUBROUTINE ATPK(MAXDIM)

	INCLUDE 'CMBLOCK.INC'

        COMMON	Q(1)

        CHARACTER *80   FILEP
        COMMON /F_SPEC/ FILEP,NLET

	CHARACTER*1   NULL
	DIMENSION     DLIST(4)

	DATA LUN1/77/,NDOC/55/
CNO_SAVE
	NULL = CHAR(0)

	CALL FILERD(FILEP,NLET,NULL,'INPUT',IRTFLG)
	CALL OPENF(FILEP,LUN1,NSAM,NROW,'O',NF,NSLICE)
	IF (NF .NE. 2) THEN
	   WRITE(NOUT,*) '*** FILE NOT FOUND'
	   RETURN
	ENDIF
	CALL RDPRMI(NGH,NDUM,NLOOP,ILOOP,
     &              'NEIGHBOURHOOD PIXELS FOR SEARCH')
	IF (NGH .LT. 3) THEN
	   CALL ERRT(31,'PKDS',NE)
           RETURN
	ENDIF
        NQ = NGH/2
        K_Q = 1
        K_G=K_Q+(2*NQ+1)*(2*NQ+1)
        K_1=K_G+NSAM*(2*NQ+1)

        CALL  RDPRM(THRSH,NLOOP,ILOOP,'THRESHOLD FOR PEAKS')
        CALL RDPRMI(NNSAM,NNROW,NLOOP,ILOOP,'WINDOW DIMENSIONS')
        WRITE(NOUT,*)'   '
        WRITE(NOUT,*)'****WINDOW DIMENSIONS ARE USED TO EXCLUDE PEAKS'
        WRITE(NOUT,*)'     CLOSER TO THE EDGE OF THE MICROGRAPH****'
	WRITE(NOUT,*)'   '
	CALL  PKD(LUN1,NSAM,NROW,NQ,Q(K_Q),Q(K_G),Q(K_1),THRSH,L,
     &            NNSAM,NNROW)

	NLIST    = 2
	DLIST(1) = -1
	DLIST(2) = L
	CALL SAVD(NDOC,DLIST,NLIST,IRTFLG)

	NLIST = 4
	DO I=1,L
           DLIST(1) = I
           DLIST(2) = Q(K_1+(I-1)*3)
           DLIST(3) = Q(K_1+(I-1)*3+1)
           DLIST(4) = Q(K_1+(I-1)*3+2)
           CALL SAVD(NDOC,DLIST,NLIST,IRTFLG)
        ENDDO

	CALL SAVDC

	CLOSE(NDOC)
	CLOSE(LUN1)

	END
