C++************************************************************************
C
C $$ BLDR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ BLDR.FOR
C
         SUBROUTINE  BLDR(R,PSI,THETA,PHI)
         DOUBLE  PRECISION  R(3,3),CPHI,SPHI,CTHETA,STHETA,CPSI,SPSI
CNO_SAVE
         CPHI=DCOSD(DBLE(PHI))
         SPHI=DSIND(DBLE(PHI))
         CTHETA=DCOSD(DBLE(THETA))
         STHETA=DSIND(DBLE(THETA))
         CPSI=DCOSD(DBLE(PSI))
         SPSI=DSIND(DBLE(PSI))
         R(1,1)=CPHI*CTHETA*CPSI-SPHI*SPSI
         R(2,1)=-CPHI*CTHETA*SPSI-SPHI*CPSI
         R(3,1)=CPHI*STHETA
         R(1,2)=SPHI*CTHETA*CPSI+CPHI*SPSI
         R(2,2)=-SPHI*CTHETA*SPSI+CPHI*CPSI
         R(3,2)=SPHI*STHETA
         R(1,3)=-STHETA*CPSI
         R(2,3)=STHETA*SPSI
         R(3,3)=CTHETA
         END
