#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE ca3d
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: ca3d'
       RETURN
       END
 
#else
 

	SUBROUTINE CA3D(LUNS,LUN3D)

#ifdef SP_UNIX
	INCLUDE 'CMBLOCK.INC' 
#else
	INCLUDE 'COMMON1:CMBLOCK.INC' 
#endif
	COMMON BUF(1)
        COMMON /COMMUN/ SEQNAM,FILNAM

        CHARACTER *81 FILNAM,SEQNAM
        CHARACTER     NULL
        CHARACTER *4  CODE(250)
	INTEGER       NCOO(4,250),MAX(3),MIN(3)
	REAL          SC(6)

        NULL=CHAR(0)
C
	CALL FILERD(SEQNAM,NLET,NULL,'CLUSTER',IRTFLG)
	IF(SEQNAM(1:1).EQ.'*')RETURN
        CALL FILCAN(SEQNAM,NLET,NULL,NULL,SEQNAM,DATEXC,IRTFLG)

        OPEN(LUNS,FILE=SEQNAM,STATUS='OLD',IOSTAT=IER)
        IF (IER .NE. 0) RETURN

	CALL FILERD(FILNAM,NLET,NULL,'THREED',IRTFLG)
	IF(FILNAM(1:1).EQ.'*')RETURN
	CALL RDPRMI(NSAM,NROW,NLOOP,ILOOP,'ENTER DIMS (NSAM,NROW)$')
	CALL RDPRMI(NSLICE,NDUM,NLOOP,ILOOP,'NSLICE$')
	IFORM=3
	CALL OPENF(FILNAM,LUN3D,NSAM,NROW,'UNKNOWN',NF,NSLICE)
	IF(NF.EQ.1)GOTO 900
C
C CLEAR 3-D VOLUME
	DO 1 K=1,NSAM
1	BUF(K)=0.
	DO 2 L=1,NSLICE
	I1=(L-1)*NROW
	DO 2 I=1,NROW
	CALL WRTLIN(LUN3D,BUF,NSAM,I+I1)
2	CONTINUE
C
	NIM=1
	DO 8 K=1,3
	MIN(K)=10000
	MAX(K)=-MIN(K)
8	CONTINUE
10	READ(LUNS,11,END=20) CODE(NIM)(:4), (NCOO(K,NIM),K=1,8)
11	FORMAT(A4,8I5)
	IF (CODE(1)(4:4) .NE. '*') GOTO 10

	DO 15 K=1,3
          IF(NCOO(K,NIM).LT.MIN(K))MIN(K)=NCOO(K,NIM)
          IF(NCOO(K,NIM).GT.MAX(K))MAX(K)=NCOO(K,NIM)
15	CONTINUE
	NIM=NIM+1
	GOTO 10

20	IF (NIM .EQ. 1) THEN
           CALL ERRT(101,'INVALID NIM VALUE IN MODULE CA3D  ',NE)
           RETURN
        ENDIF

C DETERMINE SCALE FACTOR. NOTE THAT POSITION OF ZERO IS KEPT IN
C THE CENTER.
	SC(1)=FLOAT(NSAM)/FLOAT(IABS(MAX(1)))
	SC(2)=FLOAT(NSAM)/FLOAT(IABS(MIN(1)))
	SC(3)=FLOAT(NROW)/FLOAT(IABS(MAX(2)))
	SC(4)=FLOAT(NROW)/FLOAT(IABS(MIN(2)))
	SC(5)=FLOAT(NSLICE)/FLOAT(IABS(MAX(3)))
	SC(6)=FLOAT(NSLICE)/FLOAT(IABS(MIN(3)))
C
	SCMIN=SC(1)
	DO 25 I=2,6
	IF(SC(I).LT.SCMIN)SCMIN=SC(I)
25	CONTINUE
	SCMIN=SCMIN/2.
	DO 100 I=1,NIM
	ISAM=NCOO(1,I)*SCMIN+NSAM/2
	IROW=NCOO(2,I)*SCMIN+NROW/2
	ISLI=NCOO(3,I)*SCMIN+NSLICE/2
	IF(ISAM.LT.1)ISAM=1
	IF(ISAM.GT.NSAM)ISAM=NSAM
	IF(IROW.LT.1)IROW=1
	IF(IROW.GT.NROW)IROW=NROW
	IF(ISLI.LT.1)ISLI=1
	IF(ISLI.GT.NSLICE)ISLI=NSLICE
	IRECT =(ISLI-1)*NROW+IROW
	CALL REDLIN(LUN3D,BUF,NSAM,IRECT)
	BUF(ISAM)=1.
	CALL WRTLIN(LUN3D,BUF,NSAM,IRECT)
100	CONTINUE
C
	CLOSE(LUN3D)
	CLOSE(LUNS)
	RETURN

900	CALL ERRT(4,'CA3D  ',NE)
	RETURN
	END
 
#endif
 
