C++************************************************************************
C
C $$ CC3D.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ CC3D.FOR
C
         SUBROUTINE CC3D(Q,LUN1,LUN2,NSAM,NROW,NSLICE,IFORM1,IFORM2)
         CHARACTER*2  CFORM
         DIMENSION Q(1),VALUES(3)
CNO_SAVE
C
         IF(LUN1.EQ.LUN2)  THEN
C ACF
         DO    J=1,NROW*NSLICE
         CALL  REDLIN(LUN1,Q(1+(J-1)*NSAM),NSAM,J)
	 ENDDO
         IF(IFORM1.EQ.3)  THEN
         INV=1
         CALL  F3mr(Q,NSAM,NROW,NSLICE,INV,q(1+nsam*nrow*nslice))
         ENDIF
         CALL  MALFI3(Q(1),NSAM,NROW,NSLICE)
         GOTO 501
         ENDIF
C CCF
         IF(IFORM2.EQ.3)  THEN
         DO    J=1,NROW*NSLICE
         CALL  REDLIN(LUN2,Q(1+(J-1)*NSAM),NSAM,J)
	 ENDDO
         INV=1
         CALL  F3mr(Q,NSAM,NROW,NSLICE,INV,q(1+nsam*nrow*nslice))
         DO    J=1,NROW*NSLICE
         CALL  WRTLIN(LUN2,Q(1+(J-1)*NSAM),NSAM,J)
	 ENDDO

         VALUES(1) = 1.0
         VALUES(2) = 0.0
         VALUES(3) = 0.0

C       NEGATIVE IRTFLG SUPRESSES PRINT-OUT
         IRTFLG    = -1
         CFORM='Q3'
C       SINCE SETPRM USES UNLABELED COMMON FOR Q THIS SHOULD BE OK
         CALL SETLAB(LUN2,NSAM,Q,14,3,VALUES,CFORM,IRTFLG)
         ENDIF
         DO    J=1,NROW*NSLICE
         CALL  REDLIN(LUN1,Q(1+(J-1)*NSAM),NSAM,J)
	 ENDDO
         IF(IFORM1.EQ.3)  THEN
         INV=1
         CALL  F3mr(Q,NSAM,NROW,NSLICE,INV,q(1+nsam*nrow*nslice))
         ENDIF
         CALL  MULFI3(LUN2,Q(1),Q(1+NSAM*NROW*NSLICE),
     &   Q(1+(NSAM+1)*NROW*NSLICE),
     &   NSAM,NROW,NSLICE)
C
501      INV=-1
         CALL  F3mr(Q,NSAM,NROW,NSLICE,INV,q(1+nsam*nrow*nslice))
         DO    J=1,NROW*NSLICE
         CALL  WRTLIN(LUN1,Q(1+(J-1)*NSAM),NSAM,J)
	 ENDDO
C
         VALUES(1) = 1.0
         VALUES(2) = 0.0
         VALUES(3) = 0.0
C       NEGATIVE IRTFLG SUPRESSES PRINT-OUT
         IRTFLG    = -1
         CFORM='R3'
C       SINCE SETPRM USES UNLABELED COMMON FOR Q THIS SHOULD BE OK
         CALL SETLAB(LUN1,NSAM,Q,14,3,VALUES,CFORM,IRTFLG)
C       SET SCALE
         VALUES(1) = 0.0
         IRTFLG    = -1
         CALL SETLAB(LUN1,NSAM,Q,21,1,VALUES,'U',IRTFLG)
C       FILE NOT SEARCHED FOR MIN-MAX
         VALUES(1) = 0.0
         IRTFLG    = -1
         CALL SETLAB(LUN1,NSAM,Q, 6,1,VALUES,'U',IRTFLG)
C
         END
