	subroutine  ccff(lef,rit,ncol,nrow,nslice,
     &		       ncoll,nrowl,nslil,ixull,iyull,izull,
     &                 ncolr,nrowr,nslir,maxcol,maxrow,maxsli,rm)
c
c  lef(ncol,nrow,nslice),  rit(ncol,nrow,nslice) input arrays
c  ncoll, nrowl, nslil - window size, taken from lef
c                        and crosscorrelated with rit
c  ixull, iyull, izull   upper left coordinates of the window
c  ncolr, nrowr, nslir is range of search 
c         in rit (-ncolr .. +ncolr; -nrowr .. +nrowr; -nslicr .. +nslicr)
c  maxcol, maxrow, maxsli  position found
c  rm      maximum correlation coefficient

	real*4      lef(ncol,nrow,nslice),rit(ncol,nrow,nslice)

	double precision  sx,sy,sqx,sqy,sxy,sx2,qt
CNO_SAVE
        ixulls  = ixull + ncoll - 1
        iyulls  = iyull + nrowl - 1
        izulls  = izull + nslil - 1

        nsrelgo = -nslir
        if (izull .le. nslir) nsrelgo = 1 - izull 

        nsrelend = nslir
        if ((izull + nslil + nslir).gt. nslice) 
     &       nsrelend = nslice - izull - nslil

        nrrelgo = -nrowr
        if (iyull .le. nrowr) nrrelgo = 1 - iyull 

        nrrelend = nrowr
        if ((iyull + nrowl + nrowr).gt. nrow) 
     &       nrrelend = nrow - iyull - nrowl

	ncrelgo = -ncolr
	if(ixull .le. ncolr)  ncrelgo = 1 - ixull

        ncrelend = ncolr
        if ((ixull + ncoll + ncolr) .ge. ncol ) 
     &       ncrelend = ncol - ixull - ncoll  

c....
	nnn=ncoll*nrowl*nslil
	sx=0.0
	sqx=0.0
c$doacross  local(irowl,icoll,islil),reduction(sx,sqx)
	   do  islil =izull,izulls
	     do  irowl =iyull,iyulls
       	  	do  icoll = ixull,ixulls
		sx=sx+lef(icoll,irowl,islil)
	    sqx=sqx+lef(icoll,irowl,islil)*dble(lef(icoll,irowl,islil))
		enddo
	     enddo
           enddo


	sx2=sqx-sx*sx/nnn

	rm=-1.e20

        do  islirr = nsrelgo,nsrelend
        do  irowrr = nrrelgo,nrrelend
        do  icolrr = ncrelgo,ncrelend
 	sy=0.0
	sqy=0.0
	sxy=0.0
c$doacross local(islil,irowl,icoll,islirp,irowrp,qt),
c$& reduction(sy,sqy,sxy)
	   do  islil =izull,izulls
           islirp=islirr+islil
	     do  irowl =iyull,iyulls
             irowrp=irowrr+irowl
       	  	do  icoll = ixull,ixulls
			qt  = rit(icoll + icolrr,irowrp,islirp)
			sy=sy+qt
			sqy=sqy+qt*qt
			sxy=sxy+qt*lef(icoll,irowl,islil)
                enddo
             enddo
           enddo


		r = (sxy-sx*sy/nnn)/dsqrt(sx2 * (sqy - sy*sy/nnn))
c	print  *,icolrr,irowrr,islirr,r
                if (r .gt. rm)  then
                   rm   = r
                   maxcol = icolrr
                   maxrow = irowrr
                   maxsli = islirr
                endif
        enddo
        enddo
        enddo

	end

