C ++********************************************************************
C
C  CENGCA                                       LONG FILENAMES JAN 89 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C) 1985-1996, WADSWORTH CENTER FOR LABORATORIES AND    *      *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C                                                                      *
C                                                                      *
C***********************************************************************

#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE CENGCA
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: CENGCA'
       RETURN
       END
 
#else

	SUBROUTINE CENGCA(LUN,LUN2)

 
	INCLUDE 'CMBLOCK.INC'  

	COMMON          BUF(1)
        COMMON /COMMUN/ SEQNAM,FILNAM

        CHARACTER *81   SEQNAM,FILNAM,FILPAT
        CHARACTER       NULL
	DIMENSION       NUMBER(100)
        CHARACTER *4    FCODE

        NULL = CHAR(0)

	WRITE(NOUT,*) ' MOMENT FILE NUMBERS:'
        NUMIM = 100
        CALL FILSEQP(FILPAT,NLET,NUMBER,100,NUMIM, 
     $  'FILE PREFIX OR TEMPLATE (EG. PIC****)',IRTFLG)
   
	CALL FILERD(SEQNAM,NLETS,NULL,'SEQUENCE',IRTFLG)

	CALL RDPRMI(NMAX,NDUM,NLOOP,ILOOP,'MAX NUMBER OF INVARIANTS')
	IF (NMAX.GT.7)NMAX=7
	IF (NMAX.LT.1)NMAX=7

        CALL FILCAN(SEQNAM,NLETS,NULL,NULL,SEQNAM,DATEXC,IRTFLG)
        OPEN(LUN2,FILE=SEQNAM,STATUS='NEW',IOSTAT=IER)

	DO 100 I=1,NUMIM
          CALL FILGET(FILPAT,FILNAM,NLET,NUMBER(I),IRTFLG)
          IFOUND=-4
          CALL REDLIN(LUN,BUF,7,1)
          DO 30 K=1,7
            BUF(K+7)=0.0
            IF (BUF(K).LT.0.0) THEN
		BUF(K+7)=-BUF(K)
		BUF(K)=0.0
            ENDIF
30        CONTINUE
          WRITE(NOUT,111)(BUF(K),K=1,7)
111       FORMAT(3G20.10)
          CLOSE(UNIT=LUN)
C**       ENCODE(4,51,FCODE)NUMBER(I)
          WRITE(FCODE,51) NUMBER(I)
51        FORMAT(I4)
          CALL WRITS(LUN2,FCODE,BUF,2*NMAX)
100	CONTINUE
	CLOSE(LUN2)

	RETURN
	END

#endif
 
