C++************************************************************************
C
C $$ CENT_3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ CENT_3.FOR
C
         SUBROUTINE  CENT_3(LUN,B,X,Y,Z,NSAM,NROW,NSLICE,SNS,SNR,SNC)
         DIMENSION  B(NSAM),X(NSAM),Y(NROW),Z(NSLICE)
CNO_SAVE
         DO    I=1,NSAM
         X(I)=0.0
	 ENDDO
         DO    J=1,NROW
         Y(J)=0.0
	 ENDDO
         DO    K=1,NSLICE
         Z(K)=0.0
	 ENDDO
         DO    K=1,NSLICE
         DO    J=1,NROW
         CALL  REDLIN(LUN,B,NSAM,J+(K-1)*NROW)
         T=0.0
         DO    I=1,NSAM
         T=T+B(I)
         X(I)=X(I)+B(I)
	 ENDDO
         Y(J)=Y(J)+T
         Z(K)=Z(K)+T
	 ENDDO
	 ENDDO
         C=0.0
         S=0.0
         P=8*DATAN(1.0D0)/NSAM
         DO    I=1,NSAM
         C=C+COS(P*(I-1))*X(I)
         S=S+SIN(P*(I-1))*X(I)
	 ENDDO
         FI=ATAN2(S,C)
         IF(FI.LT.0.0)  FI=FI+8*DATAN(1.0D0)
         SNS=FI/P+1.0
C
         C=0.0
         S=0.0
         P=8*DATAN(1.0D0)/NROW
         DO    J=1,NROW
         C=C+COS(P*(J-1))*Y(J)
         S=S+SIN(P*(J-1))*Y(J)
	 ENDDO
C
         FI=ATAN2(S,C)
         IF(FI.LT.0.0)  FI=FI+8*DATAN(1.0D0)
         SNR=FI/P+1.0
C
         C=0.0
         S=0.0
         P=8*DATAN(1.0D0)/NSLICE
         DO    K=1,NSLICE
         C=C+COS(P*(K-1))*Z(K)
         S=S+SIN(P*(K-1))*Z(K)
	 ENDDO
C
         FI=ATAN2(S,C)
         IF(FI.LT.0.0)  FI=FI+8*DATAN(1.0D0)
         SNC=FI/P+1.0
         END
