
C++************************************************************************
C
C   CNFILE.FOR -- CREATED JUNE 87
C
C **************************************************************************
C    AUTHOR :  ArDean Leith
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    CNFILE(FILNAM,NLET,PROMPT,DISP,EXTEN,LUNCS,IRTFLG)
C
C    PURPOSE:        GETS NAME FOR A CNT (NOT .SSR OR .CNT)
C                    AND OPENS THE FILE ON LUNCS. CAN BE CALLED FROM
C                    SPIDER ALSO.
C
C    PARAMETERS:     FILNAM = WHOLE FILE NAME WITH EXTENSION
C                    PROMPT = PROMPT WHICH SOLICTS FILE NAME
C                    DISP   = TYPE OF FILE ( 'U' IS UNKNOWN, 'N' IS NEW,
C                             'O' IS OLD)
C                    NLET   = IS NUMBER OF LETTERS IN FILE NAME
C                    LUNCS  = UNIT NUMBER TO OPEN FILE ON
C                    IRTFLG = ERROR RETURN FLAG
C
C    CALLED BY:      CNGRAF    PLOT1
C
C    CALLS:          ALFILE    CNOPN    SPFILE
C
C--*******************************************************************

        SUBROUTINE CNFILE(FILNAM,NLET,PROMPT,DISP,EXTEN,LUNCS,IRTFLG)

        INCLUDE 'CONSTG.INC'

        COMMON /UNITS/ LUNDOC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

        CHARACTER *(*) FILNAM,PROMPT,DISP,EXTEN
        CHARACTER * 1  NULL

	NULL=CHAR(0)

C..     ASK FOR FILE NAME, ACCEPT AN EXTENSION IF IT IS GIVEN
30      IRTFLG = 9
        CALL FILERD(FILNAM,NLET,EXTEN,PROMPT,IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN

C       OPEN THE FILE
        IRCLND = 1080
        IF (IRECLN .GT. 1080) IRCLND = IRECLN
        CALL CNOPN(FILNAM(1:NLET),DISP,LUNCS,IRCLND,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 30

        IF (DISP(1:1) .EQ. 'O' .AND. SCALE .EQ. 0.0) THEN
C..         FILE NEEDS SCALING
            WRITE(NOUT,*)' SCALING CONTOUR FILE NOW.'
            CALL CSSCALT(LUNCS,0)
            CALL CSTRAP(LUNCS)
        ENDIF

        RETURN
        END

