                                                                        
C23456789012345678901234567890123456789012345678901234567890123456789012

C  AUTHOR: M.RADERMACHER  
                                              
      SUBROUTINE COMP3DMAd(LUN,LUN1,LUN2,LUN3) 
                         
      IMPLICIT DOUBLE PRECISION (A-H,O-X)                               
      INCLUDE 'CMBLOCK.INC' 
CNO_SAVE  
                                            
      COMMON          ADUM(80),BUF(2048)                                         
      COMMON /COMMUN/ FIL2,FIL1,FIL3,FIL4                               
      REAL            ADUM,BUF                                                     
      CHARACTER *81   FIL2,FIL1,FIL3,FIL4                                 
      CHARACTER *1    NULL,YN                                             
      INTEGER         NVOX                                                
      LOGICAL         FMASK,FOUT,FDIFMASK                                       
                                                                      
      NULL = CHAR(0)                                                      
      WRITE(NOUT,101)                                                   
101   FORMAT(' COMPARISON OF 2 3D ARRAYS:')
    
      MAXIM = 0                         
      CALL OPFIL(.TRUE.,FIL1,LUN,'O',NSAM,NROW,NSLICE,
     &           MAXIM,'FIRST',.FALSE.,IRTFLG)
      IF (IRTFLG .NE. 0) GOTO 9100

      MAXIM = 0                         
      CALL OPFIL(.TRUE.,FIL2,LUN1,'O',NSAM2,NROW2,NSLIC2,
     &           MAXIM,'SECOND',.FALSE.,IRTFLG)
      IF (IRTFLG .NE. 0) GOTO 9100

      IF(NSAM2.NE.NSAM.OR.NROW2.NE.NROW.OR.NSLIC2.NE.NSLICE) GOTO 9900  
      FMASK    = .TRUE.                                                      
      FDIFMASK = .TRUE.                                                   
      CALL FILERD(FIL3,NLET2,NULL,'MASK',IRTFLG)                        
      IF (IRTFLG .GT. 0) GOTO 9999                                      
      IF (FIL3(1:1) .EQ. '*') FMASK = .FALSE. 
                               
      IF (FMASK) THEN                                                    
         MAXIM = 0                         
         CALL OPFIL(.FALSE.,FIL3,LUN2,'O',NSAM3,NROW3,NSLIC3,
     &           MAXIM,'XXXX',.FALSE.,IRTFLG)
         IF (IRTFLG .NE. 0) GOTO 9100

         IF (NSAM3.NE.NSAM.OR.NROW3.NE.NROW.OR.NSLIC3.NE.NSLICE) 
     &       GOTO 9900  
         CALL RDPRMC(YN,NA,.TRUE.,                                      
     $      'APPLY MASK TO BOTH, SCALING AND DIFFERENCE/ERROR? (Y/N)',     
     $      NULL,IRT)                                                      
         IF (YN.EQ.'N') FDIFMASK=.FALSE.                                 
      ENDIF                                                             
      FOUT = .TRUE.                                                       
      CALL FILERD(FIL4,NLET2,NULL,'OUTPUT DIFFERENCE',IRTFLG)           
      IF (IRTFLG .GT. 0) GOTO 9999                                      
      IF(FIL4(1:1).EQ.'*') FOUT=.FALSE.                                 
      IF(FOUT) THEN                                                     
         MAXIM = 0                         
         CALL OPFIL(.FALSE.,FIL4,LUN3,'O',NSAM,NROW,NSLICE,
     &           MAXIM,'XXXX',.TRUE.,IRTFLG)
         IF (IRTFLG .NE. 0) GOTO 9100
      ENDIF                                                             
      S1=0.                                                             
      S2=0.                                                             
      S3=0.                                                             
      S4=0.                                                             
      SUM1=0.
      SUM2=0.
      NVOX=0                                                          
      DO ISL=1,NSLICE                                                     
         IOFF=(ISL-1)*NROW                                                      
         DO  I = 1,NROW                                                  
            CALL REDLIN(LUN,BUF,NSAM,I+IOFF)                                  
            CALL REDLIN(LUN1,BUF(NSAM+1),NSAM,I+IOFF)                         
            IF(FMASK) CALL REDLIN(LUN2,BUF(2*NSAM+1),NSAM,I+IOFF)             
            DO 20 K = 1,NSAM                                                  
               IF (FMASK) THEN                                                    
                  IF(BUF(2*NSAM+K).LT..5) GOTO 20                                 
               ENDIF                                                             
               NVOX=NVOX+1                                                       
               B = BUF(K)                                                        
               C=BUF(NSAM+K)                                                     
               P1=B*C                                                            
               P2=C*C                                                            
               S1=S1+P1                                                          
               S2=S2+P2                                                          
               S3=S3+C                                                           
               S4=S4+B                                                           
C              IF((B.NE.0.OR.C.NE.0).AND.NSAM.LE.16)                             
C     $        WRITE(NOUT,103)ISL,I,K,B,C,P1,P2,S1,S2,S3,S4                    
C103            FORMAT(1H ,'SLICE: ',I3,' , ROW: ',I3,' , COL: ',I3,/             
C     $         ' VOXEL 1: ',F16.4,' , VOXEL 2: ',F16.4, /                        
C     $         '     AD1: ',F16.4,'       AD2: ',F16.4, /                        
C     $         '      S1: ',F16.4,'        S2: ',F16.4, /                        
C     $         '      S3: ',F16.4,'        S4: ',F16.4)                          
20          CONTINUE                                                          
         ENDDO
      ENDDO
      IF (NVOX.EQ.0) THEN                                                
      WRITE(NOUT,601)                                                   
601   FORMAT(//1X,'THERE ARE NO VOXELS PASSED WITH THE MASK PROVIDED'/  
     $' A COMPARISON WOULD BE MEANINGLESS AND THEREFOR'/                
     $' HAS NOT BEEN DONE. IT WOULD BE ADVISABLE TO CHECK'/             
     $' YOUR MASK.'//)                                                  
      GOTO 9999                                                         
      ENDIF                                                             
      A=(S1-S3*S4/NVOX)/(S2-S3*S3/NVOX)                                 
      CONST=(A*S3-S4)/NVOX                                              
      BMEAN=S4/NVOX                                                     
      SUM1=0.
      SUM2=0.
      DNOM=0.
      DNUM=0.
      DO  ISL=1,NSLICE                                                
      IOFF=(ISL-1)*NROW                                                 
      DO  I = 1,NROW                                                  
      CALL REDLIN(LUN,BUF,NSAM,I+IOFF)                                  
      CALL REDLIN(LUN1,BUF(NSAM+1),NSAM,I+IOFF)                         
          IF(FMASK) CALL REDLIN(LUN2,BUF(2*NSAM+1),NSAM,I+IOFF)         
      DO 21 K = 1,NSAM                                                  
          IF(FOUT) BUF(3*NSAM+K)=0.                                     
          IF(FMASK.AND.FDIFMASK) THEN                                   
            IF(BUF(2*NSAM+K).LT..1) GOTO 21                             
          ENDIF                                                         
      B = BUF(K)                                                        
      C=BUF(NSAM+K)                                                     
      BD=(A*C-B-CONST)                                                  
      BD1=DABS(BD)                                                      
      BD2=DABS(B-BMEAN)                                                 
      SUM1=SUM1+BD1                                                     
      SUM2=SUM2+BD2                                                     
      BD1SQ=BD1*BD1                                                     
      DNOM=DNOM+(B-BMEAN)*(B-BMEAN)                                     
      DNUM=DNUM+BD1SQ                                                   
C     IF((B.NE.0.OR.C.NE.0).AND.NSAM.LE.16)                             
C     $ WRITE(NOUT,104)ISL,I,K,B,C,BD1,BD2,SUM1,SUM2                     
C104   FORMAT(1H ,'SLICE: ',I3,' , ROW: ',I3,' , COL: ',I3,/             
C     $' VOXEL 1: ',F16.4,' , VOXEL 2: ',F16.4, /                        
C     $'     BD1: ',F16.4,'       BD2: ',F16.4, /                        
C     $'    SUM1: ',F16.4,'      SUM2: ',F16.4)                          
      IF(FOUT) BUF(3*NSAM+K)=BD                                         
21    CONTINUE                                                          
         IF(FOUT) CALL WRTLIN(LUN3,BUF(3*NSAM+1),NSAM,I+IOFF)           
      ENDDO
      ENDDO

      DIF=(SUM1)/SUM2                                                   
      DISCR=DSQRT(DNUM/DNOM)                                            
      WRITE(NOUT,100) A,CONST,DIF,DISCR                                 
100   FORMAT(' SCALING OF SECOND 3D: VOXEL_NEW=VOXEL_OLD*',F16.6,    
     $' - ',F16.6/                                                      
     $' MEAN RELATIVE ERROR: ',F10.5/                                   
     $'         DISCREPANCY: ',F15.5)                                   
      IF(NSEL(1).EQ.0) GOTO 9999                                      
      PARAM(NSEL(1))=A                                                
      IF(NSEL(2).EQ.0) GOTO 9999                                      
      PARAM(NSEL(2))=CONST                                            
      GOTO 9999 
                                                        
9100  CONTINUE                                                          
9900  CONTINUE                                                          
      CALL ERRT(IER,'DR DIFF',NE)                                        
9999  CLOSE (LUN)                                                       
      CLOSE (LUN1)                                                      
      CLOSE (LUN2)                                                      
      CLOSE (LUN3)                                                      
      END                                                               
                                                                        
