	SUBROUTINE  CR180_2(X,Y,O,NNNN,NSAM,NROW)
C
C  Calculates circular croscorrelation 
C    between 180 deg rotated image and 0 degs
C  non-power-of-two dimensions
C  Input - X,Y Fourier transforms
C  Output -  O=F(conjg(X)*conjg(Y))
C
	COMPLEX  X(NNNN,NROW),Y(NNNN,NROW),O(NNNN,NROW)
        DOUBLE PRECISION  PI2
CNO_SAVE
C
C	INS=1
C	CALL  FMRS_2(X,NSAM,NROW,INS)
C	IF(INS.EQ.0)  RETURN
C	CALL  FMRS_2(Y,NSAM,NROW,INS)
C
        PI2=8.0*DATAN(1.0D0)
 	ITMP=NSAM/2
	SX=PI2*FLOAT(ITMP)/FLOAT(NSAM)
	ITMP=NROW/2
	SY=PI2*FLOAT(ITMP)/FLOAT(NROW)
c$doacross local(i,j,ix,iy,argy,arg)
        DO    J=1,NROW
        IY=J-1
        IF(IY.GT.NROW/2)  IY=IY-NROW
        ARGY=SY*IY
        DO    I=1,NNNN
        IX=I-1
        ARG=SX*IX+ARGY
        O(I,J)=CONJG(X(I,J))*CONJG(Y(I,J))*CMPLX(COS(ARG),SIN(ARG))
	ENDDO
	ENDDO
C
	INS=-1
	CALL  FMRS_2(O,NSAM,NROW,INS)
	END
