
C-***********************************************************************
C
C     USED IN FUZZY CLASSIFICATION
C 
C     CALLED BY SCLASF
C
C-**********************************************************************

      SUBROUTINE CRTEST(N,M,NCLU,NCLUMAX,LFACT,KV)

      INCLUDE 'CMBLOCK.INC'

      PARAMETER (NN=999,IP=10,IC=10,NCT=13,IDIM=4*NN+3*IC)

      CHARACTER NAM*10,YES*1,NAME*14,ANS*1,EXPLANATION(NCT)*30

C     THIS COMMON IS ALSO USED IN M_J SO DO NOT CHANGE IT
C     WITHOUT LOOKING THERE
      INTEGER AREA1
      COMMON RDUM(80),X(NN,IP),U(IC,NN),V(IC,IP),
     +       KMIN,KMAX,IPB,INIC,AM,MAXIT,EPSIL,A,B,
     +       METRIC,NCRT(NCT),CRT(NCT),AREA1(2*NN),
     +       AREA2(6*IC+IC*IC+500*100),AREA3(IDIM),
     +       R(IC,NCT),XDUM(NN,IP)

      REAL    RD(IC)
      INTEGER KV(IC)


      DATA EXPLANATION/
     + 'Part. Coeff.          (+)', 
     + 'Class. Entropy        (-)', 
     + ' ',
     + '2ndMAX/MIN            (-)', 
     + 'Non Fuzzy Index       (+)',
     + 'Non Fuzziness Index P (+)', 
     + ' ', 
     + 'Normalized entrop.    (-)', 
     + ' ',' ',
     + 'Min Hard-Tendency     (+)', 
     + 'Mean Hard-Tendency    (+)', 
     + 'Moreau and Jain       (-)'/


       CALL RDPRM2 (AM,EPSIL,NLOOP,ILOOP,
     * ' FUZZY EXPONENT (1, INF.), EPSILON TO STOP ITERATION $')
       CALL RDPRMI(MAXIT,MINTER,NLOOP,ILOOP,
     * ' MAXIMUM NUMBER OF ITERATIONS ANYWAY $') 

       CALL RDPRMI(IPB,INIC,NLOOP,ILOOP,
     * ' NUMBER OF BOOTSTRAPS, NUMBER OF INIZIALIZATIONS $')
   
       METRIC=0
       CALL RDPRMI(METRIC,JDUM,NLOOP,ILOOP,
     * ' METHOD TO BE USED (0 = FCM, 1 = G-K) $')


       WRITE (NOUT,1040) N,M,LFACT,(KV(I),I=1,IP),AM,EPSIL,
     *                   MAXIT,NCLU,NCLUMAX,IPB,INIC,METRIC

      WRITE (NDAT,1040) N,M,LFACT,(KV(I),I=1,IP),AM,EPSIL,
     *                   MAXIT,NCLU,NCLUMAX,IPB,INIC,METRIC


1040  FORMAT (//,1X,'NUMBER OF ITEMS/IMAGES = '
     * ,I5,/,' TOTAL NUMBER OF FACTORS IN CLAS.= ',I2,
     * ' , NUMBER IN IMC= ',I2,/,
     * ' FACTORS USED= ',10I2,/,
     * ' FUZZY PARAMETER = ',F3.1,2X
     * ,' , EPSILON = ',F10.7,2X,/,
     * ' MAXIMUM ITERATIONS = ',I4,/,
     * ' STARTING CLUSTER SEARCH  = ',I2,
     * ' FINAL CLUSTER SEARCH =', I2,/
     * ' NUMBER OF BOOTSTRAPS= ',I4,' , NUMBER OF INITIALIZATIONS= ',I4,
     *   /,' METRIC = ',I2, '  (0=EUCL., 1=LOCAL MAHA.)')


      A=.75   
C     PARAMETERS OF THE LINEAR COMBINATION OF M&J CRITERIA
      B=.25   
C      "
      KMIN=NCLU         
C      MINIMUM NUMBER AND
      KMAX=NCLUMAX      
C     MAXIMUM NUMBER OF CLUSTERS TO BE TESTED
      IF (KMIN.LE.1) KMIN=2

      DO  IG=1,12
	NCRT(IG+1)=IG
      ENDDO
      NCRT(1)=12	

      CALL M_J (N,M,R,RD,AREA1,AREA2,AREA3)



      WRITE (NDAT,667) KMIN,KMAX
667   FORMAT (//, ' TABLE OF CLUSTER VALIDITY CRITERIA FOR EACH CLUSTER',
     + //,'  CRITERIA FROM 1-13 [MJ IS THE 13]',/,
     + ' VALUE FOR THE CLUSTERS FROM ',I3,' TO ',I3,//)

      DO 666 J=1,NCT
        IF (J.EQ.3.OR.J.EQ.4.OR.J.EQ.5.OR.
     +      J.EQ.7.OR.J.EQ.8.OR.J.EQ.9.OR.J.EQ.10) GOTO 666
        WRITE(NDAT,4) J, EXPLANATION (J), (R(I,J),I=KMIN,KMAX)
C        WRITE(NOUT,*) J, EXPLANATION (J), (R(I,J),I=KMIN,KMAX)
666   continue
4     FORMAT (2X,I3,2X,A30,2X,13(F8.4,1X))

      RETURN
      END
