
C++************************************************************************
C
C CSVMS.FOR  -- CREATED JAN 85
C
C **************************************************************************
C *  AUTHOR: R. BANERJEE                                                   *
C *  COPYRIGHT (C)1985 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    CSVMS(COMLIN)
C
C    PURPOSE:  TO EXECUTE SYSTEM COMMANDS LIKE COPY, RENAME, 
C              DELETE FILES, ETC.
C
C    PARAMETERS:
C        COMLIN   COMMAND LINE FOR THE SYSTEM COMMAND 
C                 CALLER PUTS THE COMMAND IN THE COMLIN
C
C--********************************************************************

#ifdef SP_VMS

	SUBROUTINE CSVMS(COMLIN,IERR)

	COMMON /UNITS/LUNDOC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

	CHARACTER *(*)  COMLIN
	INTEGER   *4    IFOUR,LIB$SPAWN

        WRITE(NOUT,102)COMLIN
  102   FORMAT(/,2X,A80)
	IFOUR = LIB$SPAWN(COMLIN)

	IF (IFOUR .NE. 1) WRITE(NOUT,101) IFOUR
101	FORMAT(' ERROR IN CSVMS... ERROR CODE=',Z10)

	RETURN
	END

#else

	SUBROUTINE CSVMS(COMLIN,IERR)
CNO_SAVE
	COMMON /UNITS/LUNDOC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

	CHARACTER *(*)  COMLIN
         
        NCHAR = lnblnk(COMLIN)
        WRITE(NOUT,102)COMLIN(1:NCHAR)
  102   FORMAT(/,1X,A)

 	IRET = system(COMLIN(1:NCHAR))

	RETURN
	END

#endif
