                                                                20-Apr-1998 16:06:05  Digital Fortran 77 V4.0-1         Page 1 	    
                                                                20-Apr-1998 16:06:05  dattimtit.i  

	      1 # 1 "dattimtit.f"
	      2 
	      3 C++*********************************************************************
	      4 C
	      5 C DATTIMTIT.F   -- REMOVED FROM OPEN3.F
	      6 C
	      7 C **********************************************************************
	      8 C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
	      9 C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
	     10 C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
	     11 C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
	     12 C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
	     13 C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
	     14 C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
	     15 C **********************************************************************
	     16 C
	     17 C    DATTIMTIT(BUF,DAT,TIM,TITL)
	     18 C
	     19 C    PURPOSE:       .
	     20 C
	     21 C    PARAMETERS:
	     22 C
	     23 C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
	     24 C--*********************************************************************
	     25 
	     26 	SUBROUTINE DATTIMTIT(BUF,RECOVER,NEWDAT,LENTIT,IRTFLG)
	     27 
	     28         INCLUDE 'CMBLOCK.INC'
	    173         INCLUDE 'LABLOCK.INC'
	    193 CNO_SAVE
	    194 
	    195         DIMENSION      BUF(1)
	    196         CHARACTER * 1  NULL
	    197         LOGICAL        RECOVER,NEWDAT
	    198         DIMENSION      ZBUF(45)
	    199         CHARACTER *180 CLINE
	    200         EQUIVALENCE    (CLINE,ZBUF)
	    201 
	    202 	NULL=CHAR(0)
	    203 
	    204         IF (RECOVER) THEN
	    205 C          RECOVER DATE, TIME & TITLE FROM CLINE
	    206 
	    207 C          MOVE ALPHA-NUMERIC PART OF BUF TO ZBUF FOR CLINE ACCESS
	    208            DO  I = 1,45 
	    209               ZBUF(I) = BUF(I+211) 
	    210            ENDDO
	    211 
	    212 
	    213 C          ALPHA OSF UNIX WITH IEEE TYPE DATA SPECIFIC CODE FOLLOWS
	    214 C          NOTE THAT ALPHA-NUMERICAL DATA (ABCD) WILL BE WRITTEN (DCBA)
	    215            call FLIPBYTES(CLINE,180,IRTFLG)
	    216 C          END ALPHA OSF UNIX WITH IEEE TYPE DATA SPECIFIC CODE 
	    217 
	    218 
	    219 C          READ DATE, TIME & TITLE FROM HEADER
	    220            CDAT    = CLINE(1:9) // ' '

DATTIMTIT                                                       20-Apr-1998 16:06:05  Digital Fortran 77 V4.0-1         Page 2 	    
                                                                20-Apr-1998 16:05:58  dattimtit.f  

	    221            CTIM    = CLINE(13:20) 
	    222            CTIT    = CLINE(21:180)
	    223            LENTIT  = MAX(0,(INDEX(CTIT,NULL)-1))
	    224 
	    225         ELSE
	    226 C          SET DATE, TIME & TITLE IN CLINE
	    227 
	    228 C          PUT CURRENT DATE AND TIME INTO THIS IMAGE HEADER
	    229            IF (NEWDAT) THEN
	    230               CALL DATE(CDAT)
	    231               CALL TIME(CTIM)
	    232            ENDIF
	    233 
	    234 C          DATE TAKES 2 & 1/4 FLOATING POINT VARIABLES IN BUF (9 CHAR)
	    235            CLINE(1:12)  = CDAT(1:9) // '   '
	    236 
	    237 C          TIME TAKES 2 FLOATING POINT VARIABLES IN BUF (8 CHAR.)
	    238            CLINE(13:20) = CTIM(1:8)
	    239 
	    240 C          TITLE TAKES 40 FLOATING POINT VARIABLES IN BUF (160 CHAR)
	    241            CLINE(21:180) = CTIT(1:160)
	    242            LENTIT        = lnblnk(CTIT)
	    243            LOCNULL       = INDEX(CTIT,NULL)
	    244            IF (LOCNULL .GT. 0 .AND. LOCNULL .LT. LENTIT) THEN
	    245               LENTIT     = LOCNULL -1
	    246            ENDIF
	    247 
	    248 
	    249 C          ALPHA OSF UNIX WITH IEEE TYPE DATA SPECIFIC CODE FOLLOWS
	    250            CALL FLIPBYTES(CLINE,180,IRTFLG)
	    251 c          END ALPHA OSF UNIX WITH IEEE TYPE DATA SPECIFIC CODE
	    252 
	    253 
	    254 C          COPY CLINE STUFF INTO BUF
	    255            DO  I = 1,45 
	    256               BUF(I+211) = ZBUF(I)
	    257            ENDDO
	    258         ENDIF
	    259         IRTFLG = 0
	    260 
	    261         RETURN
	    262 	END

DATTIMTIT                                                       20-Apr-1998 16:06:05  Digital Fortran 77 V4.0-1         Page 3 	    
                                Symbol Table                    20-Apr-1998 16:05:58  dattimtit.f  



PROGRAM SECTIONS

    Name				 Bytes   Attributes

  1 $UNINIT                                192   PIC CON REL LCL NOSHR NOEXE   RD   WRT NOSEC OCTA
  2 $CODE                                  728   PIC CON REL LCL   SHR   EXE NORD NOWRT NOSEC OCTA
  3 batch_                                  16   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
  4 batch2_                                  1   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
  5 units_                                  28   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
  6 iprtt_                                  24   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
  7 master_                                 48   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
  8 master1_                               186   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
  9 param_                                 492   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
 10 proc_                                   20   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
 11 doloop_                                104   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
 12 function_                               84   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
 13 cmax_                                    8   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA
 14 labnew_                                324   PIC OVR REL GBL NOSHR NOEXE   RD   WRT NOSEC OCTA

    Total Space Allocated                 2255


ENTRY POINTS

    Address   Type  Name     
                             
  2-00000000        DATTIMTIT


VARIABLES

    Address   Type  Name          Address   Type  Name          Address   Type  Name          Address   Type  Name     
                                                                                                                       
  7-00000020  R*4   AV          5-00000010  I*4   IFOUND      5-00000018  I*4   NDAT       10-00000010  R*4   PNAME    
  8-00000008  CHAR  CDAT        7-00000028  I*4   IHIST       5-0000000C  I*4   NECHO       8-00000004  CHAR  PRJEXC   
  1-00000008  CHAR  CLINE       3-0000000C  I*4   ILOOP           **      L*4   NEWDAT     14-00000010  R*4   PSI      
  4-00000000  CHAR  COPT        7-00000014  I*4   IMAMI       7-0000000C  I*4   NHISTREC   14-00000040  R*4   PSI1     
 13-00000000  R*4   CRVMAX     10-0000000C  I*4   INFLUN      5-00000004  I*4   NIN        14-00000034  R*4   PSI2     
 13-00000004  R*4   CRVMIN     10-00000000  I*4   IPROC       3-00000004  I*4   NLOOP           **      L*4   RECOVER  
  8-00000012  CHAR  CTIM        7-0000002C  I*4   IPROT       5-00000008  I*4   NOUT       14-00000020  R*4   SCALE    
  8-0000001A  CHAR  CTIT        6-00000000  I*4   IPRTT       5-00000014  I*4   NPROC       7-00000024  R*4   SIG      
  8-00000000  CHAR  DATEXC      7-00000008  I*4   IREC        7-00000004  I*4   NROWC       6-00000014  L*4   SILENT   
 12-00000000  CHAR  FCHAR           **      I*4   IRTFLG      7-00000000  I*4   NSAMC      14-0000000C  R*4   THETA    
 14-00000024  R*4   FLAG       10-00000004  I*4   ITI        12-00000050  I*4   NSTART     14-0000003C  R*4   THETA1   
  7-00000018  R*4   FMAX       10-00000008  I*4   IWHERE      6-00000004  I*4   NTRACE     14-00000030  R*4   THETA2   
  7-0000001C  R*4   FMIN       14-00000028  I*4   KANGLE      1-00000000  CHAR  NULL       14-00000014  R*4   XOFF     
      **      I*4   I          14-00000000  I*4   LABLEN      6-00000010  I*4   N_MOSAIC   14-00000018  R*4   YOFF     
  3-00000008  I*4   IABSLP          **      I*4   LENTIT      6-0000000C  I*4   N_VERBOSE  14-0000001C  R*4   ZOFF     
 14-00000004  I*4   IANGLE    REG-00000000  I*4   LOCNULL    14-00000008  R*4   PHI                                    
  3-00000000  I*4   IBCNT       5-00000000  I*4   LUNC       14-00000038  R*4   PHI1                                   
  7-00000010  I*4   IFORM       6-00000008  I*4   NALPH      14-0000002C  R*4   PHI2                                   



DATTIMTIT                                                       20-Apr-1998 16:06:05  Digital Fortran 77 V4.0-1         Page 4 	    
                                Symbol Table                    20-Apr-1998 16:05:58  dattimtit.f  

ARRAYS

     Address  Type  Name            Bytes  Dimensions

      **      R*4   BUF                **  (1)
 14-00000044  R*4   HDR_VALS          256  (64)
 11-00000000  I*4   IALPHA            104  (26)
  9-0000019C  I*4   NSEL               80  (20)
  9-00000000  R*4   PARAM             412  (103)
  1-00000008  R*4   ZBUF              180  (45)



FUNCTIONS AND SUBROUTINES REFERENCED

  Type  Name              Type  Name           
                                               
        FLIPBYTES         I*4   LNBLNK         

DATTIMTIT                                                       20-Apr-1998 16:06:05  Digital Fortran 77 V4.0-1         Page 5 	    
                                Symbol Table                    20-Apr-1998 16:05:58  dattimtit.f  

	    263 
	    264 


  +---------------------------------------------------+
  |               KEY TO ADDRESS CODE FORMATS         |
  |   ppp-oooooooo  - In Psect ppp, Offset oooooooo   |
  |   ***-********  - External                        |
  |               # - Suffix: Also In Registers       |
  |   REG-rrrrrrrr  - In Register rrrrrrrr            |
  |   REG-########  - In Various Registers            |
  |        **       - Not Used; Not Allocated         |
  +---------------------------------------------------+


COMPILER OPTIONS BEING USED

  no	-align commons 			.  no	-automatic				.  no	-recursive
  yes	-align records			.  no	-d_lines				.
  yes	-assume accuracy_sensitive	.  no	-extend_source				.  no	-pad_source
  no	-assume backslash		.  yes	-f77					.
  no	-assume byterecl		.  						.
  no	-assume dummy_aliases		.  no	-gen_feedback				.  no	-pg
  yes	-assume source_include		.  no	-ident					.
  yes	-assume underscore		.  no	-syntax_only				.
  no	-check bounds			.  no	-vms					.  yes	-OSF
  no	-check format			.  yes	-call_shared				.
  no	-check output_conversion	.  no	-S					.
  no	-check overflow			.  						.
  yes	-check power			.  						.
  no	-check underflow		.       -blas nomapped				.
  no	-show code			.       -error_limit 30 			.
  no	-show include			.       -float ieee_float  			.       -convert big_endian
  yes	-show map			.       -reentrancy none    			.
  yes	-show single			.       -fpe0 					.       -fprm nearest
  no	-show xref			.       -G 0    				.
  no	-stand mia			.       -g1  					.  no	-synchronous_exceptions
  no	-stand semantic			.       -granularity quadword 			.
  no	-stand source_form		.       -instruction_set floating_point  	.       
  no	-stand syntax			.       -integer_size 32			.       -real_size 32   -double_size 64
  yes	-warn alignments		.       -math_library accurate			.  no	-transform_loops
  no	-warn argument_checking		.       -names lowercase			.  no	-pipeline
  no	-warn declarations		.       -O4    					.       -inline speed   -unroll 0
  yes	-warn general			.       -terminal nostatistics			.       -speculate none
  yes	-warn informational		.  						.
  no	-warn truncated_source		.       					.       -tune unspecified
  yes	-warn uncalled			.  						.
  yes	-warn uninitialized		.  						.
  yes	-warn unreachable		.  						.
  no	-warn unused			.  						.
  yes	-warn usage			.  						.

  -I    path : .f,.for,.FOR,,/usr/include/.f,/usr/include/.for,/usr/include/.FOR,/usr/include/
  -V    filename : dattimtit.l
  -o    filename : dattimtit.o
  -ana  filename : none
  -diag filename : none

                                                                20-Apr-1998 16:06:05  Digital Fortran 77 V4.0-1         Page 6 	    
                                Compilation Statistics          20-Apr-1998 16:06:05  dattimtit.i  

  -feedback file : none

COMPILER: Digital Fortran 77 V4.0-1-3231

COMPILATION STATISTICS

  CPU time:          0.06 seconds
  Elapsed time:      0.10 seconds
  Pagefaults:           0
  I/O Count:            3
