C++************************************************************************
C
C $$ DENLST.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ DENLST.FOR
C
         SUBROUTINE DENLST(NDOC,VMIN,VMAX,NKLA,V,NUM,IRTFLG)

         COMMON /UNITS/ LUNC,NIN,NOUT

         DIMENSION V(NKLA),DLIST(3),NUM(NKLA)

         INTEGER      NUMT
         CHARACTER *4 CNUM
         EQUIVALENCE  (CNUM,NUMT)
CNO_SAVE
         IF (VMAX .EQ. VMIN) THEN
C        PREVENT DIVISION BY ZERO
         WRITE(NOUT,*) 'DENLST ABORTED TO AVOID DIVISION BY 0'
         IRTFLG = 1
         RETURN
         ENDIF

         FACT = 1.0 / (VMAX - VMIN)

         DO  I = 1,NKLA

C        FOR SOME REASON NUM IS STORED AS CHAR. IN INTEGER VARIABLES
         NUMT = NUM(I)
c this is temporary - the problem is for N>9999
         READ(CNUM,8000,ERR=21) N
8000     FORMAT(I4)
	GOTO 22
21	N=I
22	CONTINUE

         DLIST(1) = I
         DLIST(2) = N

C        NORMALIZE THE V VALUES FROM 0...1.0
         DLIST(3) = (V(I) - VMIN) * FACT

C        STORE THIS LINE IN DOC FILE
         CALL SAVD(NDOC,DLIST,3,IRTFLG)
	 ENDDO
         CALL  SAVDC
         CLOSE(NDOC)
         IRTFLG = 0
         END
