C++************************************************************************
C
C $$ FHODT.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ FHODT.FOR
C
	FUNCTION  FHODT(B,N,LENH,XI,H1,H2,A,AVR)
	DIMENSION  XI(N),H1(LENH),H2(LENH)
CNO_SAVE
C
	AVR=0.0
	DO    I=1,N
	AVR=AVR+ALOG10(XI(I)+B)
	ENDDO
	AVR=AVR/N
	SVR=0.0
	DO    I=1,N
	Q=ALOG10(XI(I)+B)-AVR
	SVR=SVR+Q*Q
	ENDDO
	A=SQRT(N/SVR)
C
	DO    I=1,LENH
	H2(I)=0.0
	ENDDO
	DO    I=1,N
	Q=A*(ALOG10(XI(I)+B)-AVR)
	L=MAX0(1,MIN0(LENH,INT((Q+3.0)/6.0*FLOAT(LENH-1))+1))
	H2(L)=H2(L)+1
	ENDDO
C
	FHT=0.0
	DO    I=1,LENH
	IF(H2(I).NE.0.0)  FHT=FHT+(H1(I)-H2(I)/N)**2
	ENDDO
	FHODT=FHT
	END
