C++************************************************************************
C
C $$ FHT.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ FHT.FOR
C
         FUNCTION  FHT(AK,N,LENH,XI,H1,H2,IFP)
         DIMENSION  AK(2),XI(N),H1(3*LENH),H2(3*LENH)
         LOGICAL*1  IFP(N)
         COMMON  /PARTR/  RXR,XRMI
CNO_SAVE
         DO    I=1,3*LENH
         H2(I)=0
	 ENDDO
         DO  2  I=1,N
         IF(IFP(I))  THEN
         XN=XI(I)*AK(1)+AK(2)
         L=INT((XN-XRMI)/RXR*(LENH-1)+LENH+1)
         IF(L.LT.1 .OR. L.GT.3*LENH)  GOTO 2
         H2(L)=H2(L)+1
         ENDIF
2        CONTINUE
C
         FHT=0.0
         DO    I=1,3*LENH
         FHT=FHT+(H1(I)-H2(I))**2
	 ENDDO
         END
