	SUBROUTINE  FINT(F1,F2,NDIM,NROW,NDIMN,NROWN,WORK)
	DIMENSION  F1(NDIM,NROW),F2(NDIMN,NROWN),WORK(*)
CNO_SAVE
C
C  Interpolation using Fourier zero padding
C  F1 and F2 can be the same
C
	INV=1
	CALL  FMR_2(F1,NDIM,NROW,WORK,INV)
	IF (INV.EQ.0) THEN
	CALL ERRT(38,'FP ',NE)
	RETURN
	ENDIF
C  If you prefer exact values on an old grid replace:
C       SQ2=2.0
C	D2=4.0
C  Warning! It will cause an error in total energy.
C
	SQ2=SQRT(2.0)
	D2=2.0
C
	FM=FLOAT(NDIMN*NROWN)/FLOAT(NDIM*NROW)
	NR21=NROW/2+1
	DO    J=NROW,1,-1
	DO    I=NDIM,1,-1
	F2(I,J)=F1(I,J)*FM
	ENDDO
	ENDDO
	DO    J=NROW+1,NROWN
	DO    I=1,NDIMN
	F2(I,J)=0.0
	ENDDO
	ENDDO
	DO    J=1,NROW
	DO    I=NDIM+1,NDIMN
	F2(I,J)=0.0
	ENDDO
	ENDDO
C
	DO    J=2,NROW/2
	DO    I=3,NDIM
	F2(I,NROWN-J+2)=F2(I,NROW-J+2)
	F2(I,NROW-J+2)=0.0
	ENDDO
	ENDDO
	DO    I=3,NDIM
	F2(I,NROWN-NROW+NR21)=F2(I,NR21)/SQ2
	F2(I,NR21)=F2(I,NR21)/SQ2
	ENDDO
	F2(NDIM+1,1)=F2(2,1)/SQ2
	F2(2,1)=0.0
	F2(1,NROW+1)=F2(1,2)/SQ2
	F2(1,2)=0.0
	DO    J=3,NROW,2
	F2(NDIM+1,(J+1)/2)=F2(2,J)/SQ2
	F2(NDIM+2,(J+1)/2)=F2(2,J+1)/SQ2
	F2(NDIM+1,NROWN-(J-3)/2)=F2(2,J)/SQ2
 	F2(NDIM+2,NROWN-(J-3)/2)=-F2(2,J+1)/SQ2
	F2(2,J)=0.0
	F2(2,J+1)=0.0
	ENDDO
	F2(NDIM+1,NR21)=F2(2,2)/D2
	F2(NDIM+1,NROWN-NROW+NR21)=F2(2,2)/D2
	F2(2,2)=0.0
C
	INV=-1
	CALL  FMR_2(F2,NDIMN,NROWN,WORK,INV)
	IF (INV.EQ.0)   CALL ERRT(38,'FP ',NE)
	END
