C++*********************************************************************
C
C $$ FOUR2.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************


C $$ FOUR2:

      SUBROUTINE    FOUR2(D,N,NDIM,ISIGN,IFORM)
      DIMENSION     D(1),N(1)

      NTOT = 1
      DO  IDIM = 1, NDIM
      NTOT = NTOT*N(IDIM)
      ENDDO

      IF (IFORM) 70,20,20
   20 NREM = NTOT

      DO  60 IDIM = 1, NDIM
      NREM = NREM/N(IDIM)
      NPREV=NTOT/(N(IDIM)*NREM)
      NCURR=N(IDIM)
      IF(IDIM-1+IFORM) 30,30,40
   30 NCURR=NCURR/2
   40 CALL BITRV(D,NPREV,NCURR,NREM)
      CALL COOL2(D,NPREV,NCURR,NREM,ISIGN)
      IF (IDIM-1+IFORM) 50,50,60
   50 CALL FIXRL(D,N(1),NREM,ISIGN,IFORM)
      NTOT = (NTOT/N(1))*(N(1)/2+1)
   60 CONTINUE
      RETURN

   70 NTOT=(NTOT/N(1))*(N(1)/2+1)
      NREM=1

      DO  JDIM = 1, NDIM
      IDIM = NDIM + 1 - JDIM
      NCURR=N(IDIM)
      IF(IDIM-1)80,80,90
   80 NCURR=NCURR/2
      CALL FIXRL(D,N(1),NREM,ISIGN,IFORM)
      NTOT = NTOT/(N(1)/2+1)*N(1)
   90 NPREV= NTOT/(N(IDIM)*NREM)
      CALL BITRV(D,NPREV,NCURR,NREM)
      CALL COOL2(D,NPREV,NCURR,NREM,ISIGN)
      NREM = NREM*N(IDIM)
      ENDDO
      RETURN
      END
