C++************************************************************************
C
C $$ FOURING_Q.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ FOURING_Q.FOR
C
        SUBROUTINE  FOURING_Q(CIRC,LCIRC,NUMR,NRING,EO,MODE)
        INTEGER*2  NUMR(3,NRING)
        DIMENSION  CIRC(LCIRC)
        CHARACTER*1  MODE
        DOUBLE PRECISION  E,EO,QT,PI
CNO_SAVE
        PI=4.0*DATAN(1.0D0)
        IF(MODE.EQ.'F')  PI=2*PI
        E=0.0
c$doacross local(i,j,nsirt,qt,l),reduction(e)
        DO  I=1,NRING
        NSIRT=NUMR(3,I)-2
        QT=REAL(NUMR(1,I))*PI/REAL(NSIRT)
        DO  J=NUMR(2,I),NUMR(2,I)+NSIRT-1
	E=E+QT*DBLE(CIRC(J))*CIRC(J)
	ENDDO
	ENDDO
        EO=E
c$doacross local(i,nsirt,inv)
        DO  I=1,NRING
	INV=+1
        NSIRT=NUMR(3,I)-2
        CALL  FMRS_1(CIRC(NUMR(2,I)),NSIRT,INV)
	ENDDO
        END
