        FUNCTION  FUNIQ(P,M,Q1,Q2,KLX,KNX,KLY,KNY,KLZ,KNZ,R)
        DIMENSION  P(M)
        DIMENSION Q1(KLX:KNX,KLY:KNY,KLZ:KNZ),
     &			Q2(KLX:KNX,KLY:KNY,KLZ:KNZ)
        DIMENSION  IM(3)
        COMMON  /QNORMA/  AA,AB
        COMMON  /PARM/  NT
        DOUBLE PRECISION  AA,AB
        DOUBLE PRECISION  CHI,AV,RM(3,3),QR(3),DX,DY,DZ
C        EQUIVALENCE  (IM(1),IX),(IM(2),IY),(IM(3),IZ)
C
        COMMON  /ITERU/  ITER
        data  pi/3.1415926/
CNO_SAVE
C
        ITER=ITER+1
C
        write(nt,1020)  (P(L)*180.0/PI,L=1,3)
1020    FORMAT(' FUNIQ - new parameters ',3(1X,F9.4))
        PHI=P(1)*180.0/PI
        THETA=P(2)*180.0/PI
        PSI=P(3)*180.0/PI
        CHI=0.0
        RR=R*R
C
	CALL BLDR(RM,PSI,THETA,PHI)
C
c$doacross local(ix,iy,iz,rz,ry,rt,qr,a1,a2,a3,a4,a5,a6,a7,a8,
c$&   iox,ioy,ioz,dx,dy,dz,av),reduction(chi)
        DO  5  IZ=KLZ,KNZ
        RZ=IZ*IZ
        DO  5  IY=KLY,KNY
        RY=IY*IY+RZ
        DO  5  IX=KLX,KNX
        RT=IX*IX+RY
        IF(RT-RR)  2,2,5
2       CONTINUE
C	DO  3  I3=1,3
C        QR(I3)=0.0
C        DO  3  I2=1,3
C3       QR(I3)=QR(I3)+RM(I2,I3)*IM(I2)
        QR(1)=RM(1,1)*IX+RM(2,1)*IY+RM(3,1)*IZ
        QR(2)=RM(1,2)*IX+RM(2,2)*IY+RM(3,2)*IZ
        QR(3)=RM(1,3)*IX+RM(2,3)*IY+RM(3,3)*IZ
C
        IOX=QR(1)+FLOAT(1-KLX)
        DX=QR(1)+FLOAT(1-KLX)-IOX
        DX=DMAX1(DX,1.0D-5)
        IOX=IOX+KLX-1
        IOY=QR(2)+FLOAT(1-KLY)
        DY=QR(2)+FLOAT(1-KLY)-IOY
        DY=DMAX1(DY,1.0D-5)
        IOY=IOY+KLY-1
        IOZ=QR(3)+FLOAT(1-KLZ)
        DZ=QR(3)+FLOAT(1-KLZ)-IOZ
        DZ=DMAX1(DZ,1.0D-5)
        IOZ=IOZ+KLZ-1
C
c
C faster version :
c
         A1 = Q2(IOX,IOY,IOZ)
         A2 = Q2(IOX+1,IOY,IOZ) - Q2(IOX,IOY,IOZ)
         A3 = Q2(IOX,IOY+1,IOZ) - Q2(IOX,IOY,IOZ)
         A4 = Q2(IOX,IOY,IOZ+1) - Q2(IOX,IOY,IOZ)
         A5 = Q2(IOX,IOY,IOZ) - Q2(IOX+1,IOY,IOZ) - Q2(IOX,IOY+1,IOZ)
     &   + Q2(IOX+1,IOY+1,IOZ)
         A6 = Q2(IOX,IOY,IOZ) - Q2(IOX+1,IOY,IOZ) - Q2(IOX,IOY,IOZ+1)
     &   + Q2(IOX+1,IOY,IOZ+1)
         A7 = Q2(IOX,IOY,IOZ) - Q2(IOX,IOY+1,IOZ) - Q2(IOX,IOY,IOZ+1)
     &   + Q2(IOX,IOY+1,IOZ+1)
         A8 = Q2(IOX+1,IOY,IOZ) + Q2(IOX,IOY+1,IOZ)+ Q2(IOX,IOY,IOZ+1)
     &   - Q2(IOX,IOY,IOZ)- Q2(IOX+1,IOY+1,IOZ) - Q2(IOX+1,IOY,IOZ+1)
     &   - Q2(IOX,IOY+1,IOZ+1) + Q2(IOX+1,IOY+1,IOZ+1)
         AV= A1 + DZ*(A4 + A6*DX + (A7 + A8*DX)*DY) + A3*DY
     &   + DX*(A2 + A5*DY)
C**********************************************************
C       CHI=CHI+(Q1(IX,IY,IZ)-AV)*(Q1(IX,IY,IZ)-AV)
        CHI=CHI+Q1(IX,IY,IZ)*AV
5       CONTINUE
        CHI=(CHI-AB)/AA
        FUNIQ=1.0-CHI
        write(nt,*)
     &  'Iteration #',ITER,'  Distance =',FUNIQ,' r=',CHI
        END
