C++************************************************************************
C
C    HELS.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************


        SUBROUTINE HELS(MAXMEM)

        PARAMETER (NDLI = 2)

        INCLUDE 'CMBLOCK.INC'
        DIMENSION DLIST(NDLI)
        COMMON  DUMMY(1024),Q(1)
        integer  x41,x42
        integer  totel
        CHARACTER*80  FINP,FINPAT,DOCFIL
        CHARACTER*1  NULL
        DATA  NDOC,NDOUT/55,56/
CNO_SAVE        
        NULL = CHAR(0)
        
        CALL  RDPRM(X51,NLOOP,ILOOP,'Threshold')
        CALL  FILERD(DOCFIL,NLETI,NULL,'Dedrogram document',IRTFLG)
        IF(IRTFLG.EQ.-1)  RETURN
        
        NMAX = 0
        CALL  FILSEQP(FINPAT,NLET,ILIST,NMAX,NIMA,
     &                'Enter template for selection doc',IRTFLG)

C	# OF OBJECTS IN A GROUP

        X41 = 0
        totel = 0.0

C	# OF GROUPS

        X42 = 1
        NLIST = 2
        K = 0
        K2 = 1

778     continue

        LERR = -1
        KP1 = K+1
        CALL  UNSAV(DOCFIL,K,NDOC,KP1,Q,2,LERR,K2)
        IF(LERR.EQ.0)  THEN

          IF(K.EQ.0)  THEN
            X31 = Q(1)
            X32 = Q(2)
            K = K+1
            X41 = X41+1
            CALL  FILGET(FINPAT,FINP,NLET,X42,INTFLAG)
            DLIST(1) = X41
            DLIST(2) = X31
            IAP = 0
            CALL  SAVDN1(NDOUT,FINP,DLIST,NDLI,X41-1,IAP)
            GOTO  778
          ENDIF

          X21 = Q(1)
          X22 = Q(2)
          K = K+1

          IF(X32.LT.X51) THEN
            X41 = X41+1
            DLIST(1) = X41
            DLIST(2) = X21
            IAP = 1
            CALL  SAVDN1(NDOUT,FINP,DLIST,NDLI,K,IAP)
            X32 = X22

          ELSE
            CLOSE(NDOUT)
            IF(X42.EQ.1)  WRITE(NOUT,122)
122         FORMAT(1X,'Group number      ','Number of elements')
            WRITE(NOUT,123)  X42,X41
123         FORMAT(1X,I5,14X,I10)
            totel = totel+x41
            X42 = X42+1
            CALL  FILGET(FINPAT,FINP,NLET,X42,INTFLAG)
            X41 = 1
            X32 = X22
            DLIST(1) = X41
            DLIST(2) = X21
            IAP = 0
            CALL  SAVDN1(NDOUT,FINP,DLIST,NDLI,X41-1,IAP)
          ENDIF

          GOTO 778
        ENDIF

        WRITE(NOUT,123)  X42,X41
        totel = totel+x41
        write(nout,33)  totel,x42
33      FORMAT('   Total number of objects  = ',i10,
     &         ' Number of classes  = ',I10)
5       CLOSE(NDOC)
        CLOSE(NDOUT)

        return
        END
