C++************************************************************************
C
C $$ HIANG.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ HIANG.FOR
C
	SUBROUTINE  HIANG(ANG,NANG,DM,LB)
	DIMENSION  ANG(3,NANG),LB(NANG),DM(9,NANG)
	DOUBLE PRECISION  CPHI,SPHI,CTHE,STHE,CPSI,SPSI
C ANG(1 - PHI, ANG(2 - THETA, ANG(3 - PSI
CNO_SAVE
	do    i=1,NANG
	LB(I)=1
      if(ANG(2,i).ge.90.0)  then
         ANG(2,i)=180.0-ANG(2,i)
         ANG(1,i)=ANG(1,i)+180.0
         if(ANG(1,i).ge.360.0)  ANG(1,i)=ANG(1,i)-360.0
      endif
	enddo
	do    i=1,NANG
	JJJ=INT(100.0*ANG(1,I))
	ANG(1,I)=FLOAT(JJJ)/100.0
	enddo
      do i=1,NANG-1
      if(LB(I).ne.0)  then
         do  j=i+1,NANG
         if(LB(I).ne.0)  then
            if(ANG(1,i).eq.ANG(1,j).and.ANG(2,i).eq.ANG(2,j))  then
             LB(i)=LB(i)+1
             LB(j)=0
            endif
         endif
	 enddo
      endif
      enddo
	lo=0
	do    i=1,NANG
	if(LB(I).ne.0)  then
	lo=lo+1
	ANG(1,lo)=ANG(1,i)
	ANG(2,lo)=ANG(2,i)
C - PSI SET TO ZERO - IRRELEVANT
	ANG(3,lo)=0.0
	LB(LO)=LB(I)
	endif
	enddo
	NANG=LO
C
	DO    I=1,NANG
	CPHI=DCOSD(DBLE(ANG(1,I)))
	SPHI=DSIND(DBLE(ANG(1,I)))
	CTHE=DCOSD(DBLE(ANG(2,I)))
	STHE=DSIND(DBLE(ANG(2,I)))
	CPSI=1.0D0
	SPSI=0.0D0
C
	DM(1,I)=CPHI*CTHE*CPSI-SPHI*SPSI
	DM(2,I)=SPHI*CTHE*CPSI+CPHI*SPSI
	DM(3,I)=-STHE*CPSI
	DM(4,I)=-CPHI*CTHE*SPSI-SPHI*CPSI
	DM(5,I)=-SPHI*CTHE*SPSI+CPHI*CPSI
	DM(6,I)=STHE*SPSI
        DM(7,I)=STHE*CPHI
        DM(8,I)=STHE*SPHI
        DM(9,I)=CTHE     
	ENDDO
	END
