C++************************************************************************
C
C $$ HISTOD.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ HISTOD.FOR
C
	SUBROUTINE HISTOD(MAXMEM)
	INCLUDE 'CMBLOCK.INC'
	COMMON Q(1)
	CHARACTER *81 FILNAM
	CHARACTER *1  NULL
C
	DATA  LUN1/11/
CNO_SAVE
	NULL=CHAR(0)
C
	CALL FILERD(FILNAM,NLETI,NULL,'Image to correct',IRTFLG)
	IF (IRTFLG .EQ. -1) GOTO 5
	CALL OPENF(FILNAM,LUN1,NSAM,NROW,'O',NF,NSLICE)
	GOTO (130,111),NF
111	IF(IFORM.LT.1) GOTO 145
	NSR=NSAM*NROW*NSLICE
	CALL  RDPRMI(LENH,ITRMAX,NLOOP,ILOOP,'Histogram length')
C
C  MEMORY
C
	K1=1
	K2=K1+NSR
	K3=K2+LENH
	MEMTOT=K3+LENH
	WRITE(NOUT,1010)   MEMTOT
1010	FORMAT(' Memory needed=',I8)
	IF(MEMTOT.GT.MAXMEM)  THEN
	CALL  ERRT(6,'CE OD  ',NE)
	GOTO  5
	ENDIF
	DO    J=1,NROW*NSLICE
  	CALL  REDLIN(LUN1,Q(K1+(J-1)*NSAM),NSAM,J)
	ENDDO
	CLOSE(LUN1)
C
	CALL  HISTODC(Q(K1),Q(K2),Q(K3),NSR,LENH)
	RETURN
C
130	CALL ERRT(4,'CE OD  ',NE)
	GOTO 5
145	CALL ERRT(2,'CE OD  ',NE)
5	CLOSE(LUN1)
	END
