	SUBROUTINE  HKMC
     &	  (CIRSEED,CIRC,CIRNEW,NK,LCIRC,IP,IQ,ES,EC,E,DIST,ROT,NRING,
     &		TEMP,MAXRIN,JACUP,NUMR,MAXIT,NIMA,MODE,TOTAL,NOUT)
	INTEGER*2  MAXRIN
	INTEGER*2  NUMR(3,NRING),IQ(NK),IP(NIMA)
	DIMENSION  CIRC(LCIRC,NIMA),CIRSEED(LCIRC,NK),CIRNEW(LCIRC)
	DIMENSION  DIST(NIMA),ROT(NIMA)
	DOUBLE PRECISION  TEMP(MAXRIN,2),
     &		ENER,PEAK,SNEW,EC(NIMA),ES(NK),E(NK)
	DOUBLE PRECISION  F,DS,WSS,WSSMAX,TOTAL
	LOGICAL*1  CH_ANG,ZEROGR
	CHARACTER*1  MODE
CNO_SAVE
C
C  ES  - ENERGY OF A SEED
C  E   - SUM OF SQUARES IN A CLUSTER
C
c$doacross local(j)
	DO    J=1,NK
	ES(J)=ENER(CIRSEED(1,J),LCIRC,NRING,NUMR,MODE)
	ENDDO
C
	WSSMAX=1.0D30
C
	DO  1  ITER=1,MAXIT
	WRITE(NOUT,2020)  ITER
2020	FORMAT('  Iteration #',I3)
C
C  FIND ASSIGNMENT
C
	DO    I=1,NK
	IQ(I)=0
	ENDDO
	    DO    I=1,NIMA
	    F=1.0D30
		DO  J=1,NK
		CALL  CROSRNG(CIRSEED(1,J),CIRC(1,I),
     &	LCIRC,NRING,TEMP,TEMP(1,2),MAXRIN,JACUP,NUMR,PEAK,TOT,MODE)
		DS=ES(J)+EC(I)-2.0*PEAK
C	WRITE(NOUT,  *,'Object #',I,'  Group #',J,'  Dist.=',DS
		IF(DS.LT.F)  THEN
		    ROT(I)=TOT
		    F=DS
		    IR=J
		ENDIF
		ENDDO
	     IP(I)=IR
	     IQ(IR)=IQ(IR)+1
C	WRITE(NOUT,  *,'Set to group #',IP(I)
	    ENDDO
	WRITE(NOUT,*)  ' Number of objects in clusters'
	LK=NK/10
	MK=MOD(NK,10)
	IP1=1
	IP2=0
	DO    J=1,LK+MIN0(MK,1)
	IP2=MIN0(IP1+9,NK)
	WRITE(NOUT,2092) (I,I=IP1,IP2)
	WRITE(NOUT,2092) (IQ(I),I=IP1,IP2)
	WRITE(NOUT,2092)
	IP1=IP1+10
	ENDDO
2092	FORMAT(1X,10I5)
C	WRITE(NOUT,  *,' Assignment'
C	WRITE(NOUT,  2002,IP
C
C  BUILD NEW CENTERS WITH CORRECTIONS
C
	DO  201  J=1,NK
	IF(IQ(J).EQ.1)  THEN
		DO    I=1,NIMA
		II=I
		IF(IP(I).EQ.J)  GOTO  468
		ENDDO
468		CONTINUE
		DO    I=1,LCIRC
		  CIRSEED(I,J)=CIRC(I,II)
		ENDDO
		ROT(II)=0.0
		DIST(II)=0.0
 		ES(J)=ENER(CIRSEED(1,J),LCIRC,NRING,NUMR,MODE)
		E(J)=0.0
		GOTO  201
	ENDIF
	    DO    I=1,LCIRC
	       CIRSEED(I,J)=0.0
	    ENDDO
C
C  BUILD FIRST AVERAGE
C
	IQ(J)=0
	DO  203  I=1,NIMA
	IF(IP(I).NE.J)  GOTO  203
	IQ(J)=IQ(J)+1
	TOT=ROT(I)
	IMI=IQ(J)
 	CALL  UPDTC(CIRSEED(1,J),CIRC(1,I),
     &	      LCIRC,NRING,NUMR,TOT,MAXRIN,IMI)
203	CONTINUE
 	ES(J)=ENER(CIRSEED(1,J),LCIRC,NRING,NUMR,MODE)
	E(J)=0.0
C
C2001	FORMAT(10(1X,F6.1))
C
C  Iterations to get better approximation
C
	ITR=0
901	CONTINUE
	ITR=ITR+1
	CH_ANG=.FALSE.
	SNEW=0.0
	IQT=0
C
	IF(MOD(ITR,2).EQ.1)  THEN
	K1=NIMA
	K2=1
	K3=-1
	ELSE
	K1=1
	K2=NIMA
	K3=1
        ENDIF
	DO  812  IMI=K1,K2,K3
	IF(MOD(ITR,2).EQ.1)  THEN
	KTN=K1-IMI+1
	ELSE
	KTN=IMI
	ENDIF
	IF(IP(IMI).NE.J)  GOTO  812
	IQT=IQT+1
	CALL  CROSRNG
     &		(CIRSEED(1,J),CIRC(1,IMI),LCIRC,NRING,TEMP,TEMP(1,2),
     &			MAXRIN,JACUP,NUMR,PEAK,TOT,MODE)
	IF(ROT(IMI).NE.TOT)  THEN
	CH_ANG=.TRUE.
	ROT(IMI)=TOT
	ENDIF
	F=ES(J)+EC(IMI)-2.0*PEAK
	SNEW=SNEW+F
	DIST(IMI)=F
	CALL  UPDTC(CIRNEW,CIRC(1,IMI),LCIRC,NRING,NUMR,TOT,MAXRIN,IQT)
812	CONTINUE
c	WRITE(NOUT,5515)  j,itr,snew,CH_ANG
c5515	format(' Group #',i2,'  Iteration #',i4,' SNEW=',1pe13.6,2x,l1)
	IF((E(J).EQ.0.0.OR.(SNEW.LE.E(J))).AND.CH_ANG)  THEN
	DO    I=1,LCIRC
	  CIRSEED(I,J)=CIRNEW(I)
	ENDDO
	ES(J)=ENER(CIRNEW,LCIRC,NRING,NUMR,MODE)
	E(J)=SNEW
	GOTO  901
	ENDIF
	E(J)=SNEW
201	CONTINUE
	ZEROGR=.FALSE.
	DO  I=1,NK
	IF(IQ(I).EQ.0)  THEN
	ZEROGR=.TRUE.
	DMAX=-1.E30
	DO  J=1,NIMA
	IF(DIST(J).GT.DMAX)  THEN
	DMAX=DIST(J)
	MAX=J
	DIST(J)=-1.E30
	ENDIF
	ENDDO
	DO    J=1,LCIRC
	CIRSEED(J,I)=CIRC(J,MAX)
	ENDDO
	WRITE(NOUT,5992)  I
5992    FORMAT('  Warning! Empty cluster detected #',I3)
	WRITE(NOUT,5993)  MAX
5993    FORMAT('           New seed created from object #',I5)
	ENDIF
	ENDDO
	IF(ZEROGR)  GOTO  1
C
C  Calculate  Within Sum of Squares
C
	WSS=0.0
c$doacross local(i),reduction(wss)
	DO    I=1,NK
	WSS=WSS+E(I)
	ENDDO
	WNK=0.0
c$doacross local(i),reduction(wnk)
	DO    I=1,NK
	WNK=WNK+E(I)/IQ(I)
	ENDDO
	WRITE(NOUT,2060)WSS
2060	FORMAT('  Within Sum of Squares=',1PE10.3)
	WRITE(NOUT,2008) E
2008	FORMAT('  Within-Group Sum of Squares:',/,5(2X,1PD10.3))
C	WRITE(NOUT,  2001,(ANG(ROT(J),MODE),J=1,NIMA)
C
C  Halting rule
C
	IF(ABS(WSS-WSSMAX)/WSSMAX.LT.0.001)  GOTO  501
	WSSMAX=WSS
1	CONTINUE
	WRITE(NOUT,*) ' MAXIMUM NUMBER OF ITERATIONS REACHED'
501	CONTINUE
	WRITE(NOUT,*) ' Number of objects in clusters'
	LK=NK/10
	MK=MOD(NK,10)
	IP1=1
	IP2=0
	DO    J=1,LK+MIN0(MK,1)
	IP2=MIN0(IP1+9,NK)
	WRITE(NOUT,  2092)(I,I=IP1,IP2)
	WRITE(NOUT,  2092)(IQ(I),I=IP1,IP2)
	WRITE(NOUT,  2092)
	IP1=IP1+10
	ENDDO 
	WRITE(NOUT,  *)' Assignment'
	WRITE(NOUT,  2002)IP
2002	FORMAT(1X,20I3)
	WRITE(NOUT,  2003)WSS,TOTAL,TOTAL-WSS
2003	FORMAT('      Sum of Squares:',/,
     &	'  Within =',1PD10.3,' Total=',1PD10.3,'  Between=',1PD10.3)
	WRITE(NOUT,  2004)WSS*(TOTAL-WSS),NK*WSS,WNK
2004	FORMAT('      CRITERIA:  W*B,           k*W,    SUM(Wk/Nk)',/,
     &  6X,3(5X,1PE10.3))
	END
