
C++*************************************************************************
C
C IMSTAT.FOR -- CREATED NOV 90 
C **************************************************************************
C *  AUTHOR:  ArDean Leith
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C    IMSTAT(IRTFLG)
C
C    PURPOSE:       CALLS MAPSTAT TO GET IMAGE STATISTICS.
C
C    PARAMETERS     IRTFLG       ERROR RETURN
C
C    CALLS:         OPENF    FILERD       
C
C    CALLED BY:     DRIVERT   
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

       SUBROUTINE IMSTAT(IRTFLG)
		                                                                                        
        INCLUDE 'CMBLOCK.INC'

       CHARACTER *81 IMFILE

       DATA LUNIM,LUND/20,21/

       IRTFLG = 1

20     CALL OPFIL(.TRUE.,IMFILE,LUNIM,'OLD',NSAM,NROW,NSLICE,
     &             IFORM,'CLUSTER INPUT',.FALSE.,IRTFLG)
       IF (IRTFLG .EQ. -1) RETURN

       IF (FMIN .LT. 0.0) THEN
C         WILL NOT WORK RIGHT
          WRITE(NOUT,*) ' *** CAN NOT USE FILE WITH FMIN < 0.0'
          CLOSE(LUNIM)
          CALL ERRT(100,'IMSTAT',NE)
          RETURN
       ENDIF

       NREC2 = NROW * NSLICE
       CALL MAPSTAT(LUNIM,LUND,NSAM,NROW,NSLICE,1,NREC2,NVOX,IRTFLG)            
       CLOSE(LUNIM)
         
       RETURN
       END




