
C++*********************************************************************
C
C INITINLN.F
C                                           
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK         *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND      *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.   *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR  *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR*
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 		       *
C **********************************************************************
C
C    INITINLN()
C
C    PURPOSE:       TO INITIALIZE INLINE BUFFER FOR RANDOM 
C                   ACCESS READING/WRITING VIA REDLIN AND WRTLIN.
C                   (USED ON VMS ONLY)
C
C    PARAMETERS:
C
C    VARIABLES:  
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

      SUBROUTINE INITINLN(ASK,IRTFLG)

      LOGICAL ASK

      INCLUDE 'CMBLOCK.INC' 
      
C     RUN-TIME ALLOCATION SPECIFIC CODE FOLLOWS

#ifdef SP_NT
      INTEGER LOCLUN
#else
      INTEGER * 8     LOCLUN
#endif
      LOGICAL         USEINLN
      COMMON /LUNARB/ LOCLUN(100),NSAMLUN(100),NWORDLUN(100),USEINLN

      IF (ASK) THEN
         USEINLN = .NOT. USEINLN
         IF (.NOT. USEINLN) THEN
            WRITE(NOUT,95)
 95         FORMAT(' --- INLINE BUFFER DEACTIVATED')
         ELSE
            WRITE(NOUT,92)
 92         FORMAT
     &      (' --- INLINE BUFFER ACTIVATED, SIZE IS AUTOMATICALLY SET')
         ENDIF
      ELSE
         USEINLN = .TRUE.
      ENDIF
C     RUN-TIME ALLOCATION SPECIFIC CODE ENDS


      IRTFLG = 0

      RETURN
      END
