C ++********************************************************************
C
C                                        LONG FILE NAMES JAN 89 al
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************

	SUBROUTINE INTERL

        INCLUDE 'CMBLOCK.INC'

        COMMON ADUM(80),BUF(1024)
        COMMON /COMMUN/ FIL1,FIL2,FIL3

        CHARACTER *81 FIL1,FIL2,FIL3
        CHARACTER *1  NULL

        NULL=CHAR(0)

        IOFF=40
        LUN1=15
        LUN2=16
        LUN3=17
        CALL FILERD(FIL1,NLET,NULL,'LEFT  EYE FILE',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
        CALL FILERD(FIL2,NLET,NULL,'RIGHT EYE IMAGE',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
        CALL FILERD(FIL3,NLET,NULL,'OUTPUT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

        CALL OPENF(FIL1,LUN1,NSAM,NROW,'OLD',NF,NSL)
        IF (NF .NE. 2) RETURN
	IF (IMAMI.NE.1)CALL NORM3(LUN1,NSAM,NROW,NSL,FMAX,FMIN,AV)
        FMAX1=FMAX
        FMIN1=FMIN

        CALL OPENF(FIL2,LUN2,NSAM,NROW,'OLD',NF,NSL)
        IF (NF .NE. 2) GOTO 10
	IF (IMAMI.NE.1)CALL NORM3(LUN2,NSAM,NROW,NSL,FMAX,FMIN,AV)
        FMAX2=FMAX
        FMIN2=FMIN

        CALL OPENF(FIL3,LUN3,NSAM,NROW,'UNKNOWN',NF,NSL)
        IF (NF .NE. 2) GOTO 11

        D1=FMAX1-FMIN1
        D2=FMAX2-FMIN2
        WRITE(NOUT,100) D1,D2,FMAX1,FMIN1,FMAX2,FMIN2
100     FORMAT('   D1     D2    FMAX1  FMIN1  FMAX2  FMIN2'/
     $          1X,6(G10.3,1X))
        IF (D2 .GT. D1)  D1 = D2
        PERC = D1/128.
        D3   = 2*D1+2*PERC
        DO I=1,NROW,2
           I1=I+1
           CALL REDLIN(LUN1,BUF(IOFF),NSAM,I)
           IF(I1.LE.NROW) CALL REDLIN(LUN2,BUF(NSAM+1+IOFF),NSAM,I1)
           DO K=1,NSAM
              BUF(IOFF-1+K)=BUF(IOFF-1+K)+D1+PERC
           ENDDO
           IF (I.EQ.1) BUF(IOFF)=D3
           CALL WRTLIN(LUN3,BUF(IOFF),NSAM,I)
           IF (I1.LE.NROW) CALL WRTLIN(LUN3,BUF(IOFF+NSAM+1),NSAM,I1)
        ENDDO

11      CLOSE(LUN3)
10      CLOSE(LUN2)
        CLOSE(LUN1)

        RETURN
        END
