
C++************************************************************************
C
C    ISBARE.F                                                NEW JAN 98
C                                                  AUTHOR: ARDEAN LEITH
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C      PURPOSE: FIND IF A FILENAME DENOTES A BARE STACK
C
C      PARAMETER: FILNAM   INPUT FILENAME
C
C **************************************************************************

       LOGICAL FUNCTION ISBARE(FILNAM)

       CHARACTER *(*) FILNAM

C      FIND LOCATION OF @ IN FILNAM
       ILOCAT = INDEX(FILNAM,'@')

C      FIND LOCATION OF LAST NON-NULL NON-BLANK CHARACTER IN FILE 
       LENB   = lnblnk(FILNAM)
       LENN   = INDEX(FILNAM,CHAR(0)) 
       IF (LENN .GT. 1 .AND. LENN .LE. LENB) LENB = LENN - 1

C      IF IT IS A BARE STACK ILOCAT IS LENB
       ISBARE =  ILOCAT .GT. 1 .AND. ILOCAT .EQ. LENB

       RETURN
       END
