
C++************************************************************************
C
C $$ LONGER.FOR -- OCT 88 ArDean Leith
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $ LONGER
C
C   PURPOSE:  CONCATENATES TWO STRINGS WITH ERROR CHECKING FOR LENGTHS
C
C ************************************************************************

	SUBROUTINE LONGER(STRING,NLET,SUFFIX,IRTFLG)

        CHARACTER *(*) STRING,SUFFIX
        CHARACTER*1 NULL
 
        NULL=CHAR(0)

        LENSUF = INDEX(SUFFIX,NULL) - 1
        IF (LENSUF .LT. 0) LENSUF = LEN(SUFFIX)

        LENSTR = LEN(STRING)
        IF ((NLET + LENSUF + 1) .GT. LENSTR) THEN
C          TOO LONG
           IRTFLG = 1

        ELSEIF (LENSUF .EQ. 0) THEN
C          SUFFIX HAS NULL LENGTH
           STRING(NLET+1:NLET+1) = NULL
           IRTFLG = 2

        ELSE
           STRING(NLET+1:NLET+LENSUF+1) = SUFFIX(1:LENSUF) // NULL
           NLET = NLET + LENSUF
           IRTFLG = 0
        ENDIF

        RETURN
        END

