C++************************************************************************
C
C $$ MACF.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ MACF.FOR
C
         SUBROUTINE MACF(MAXMEM)
         INCLUDE 'CMBLOCK.INC'
         COMMON Q(1)
C
         CHARACTER *81 FILNAM
         CHARACTER *1  NULL,ASK

         DATA  LUN1,LUN2/8,9/
CNO_SAVE
         NULL=CHAR(0)

C     MASKED AUTOCORELATION FUNCTION
	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &             IDUM,'INPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .EQ. -1) GOTO 130
	IF(IFORM.NE.1) GOTO 145
         CALL FILERD(FILNAM,NLETO,NULL,'OUTPUT',IRTFLG)
         IF (IRTFLG .EQ. -1) GOTO 5
         CALL RDPRMI(IRA,IDUM,NLOOP,ILOOP,'MASK RADIUS')
         IF(IRA.LT.2.OR.IRA.GT.NSAM/2.OR.IRA.GT.NROW/2)  THEN
         CALL  ERRT(31,'MACF  ',NE)
         GOTO  5
         ENDIF
	LSD=2*NSAM+2-MOD(2*NSAM,2)
         IF(2*LSD*NROW.GT.MAXMEM)  THEN
         CALL  ERRT(6,'MACF  ',NE)
         GOTO  5
         ENDIF
         KB=1+2*LSD*NROW
C
         CALL  RDPRMC(ASK,NCHAR,.TRUE.,
     &   '(F)ULL OR (H)ALF OUTPUT (F/H)',NULL,IRTFLG)
         IF(ASK.EQ.'H')  THEN
         CALL OPENF(FILNAM,LUN2,NSAM,NROW,'UNKNOWN',NF,1)
         GOTO (130,951),NF
         ELSEIF(ASK.EQ.'F')  THEN
         CALL OPENF(FILNAM,LUN2,2*NSAM,2*NROW,'UNKNOWN',NF,1)
         GOTO (130,951),NF
         ELSE
         CALL  ERRT(31,'MACF  ',NE)
         GOTO  5
         ENDIF

951      CALL  MACF_P(LUN1,LUN2,NSAM,NROW,Q,LSD,IRA,ASK)

5        CLOSE(LUN1)
         CLOSE(LUN2)
         RETURN

130      CALL ERRT(4,'MACF  ',NE)
         GOTO 5

145      CALL ERRT(2,'MACF  ',NE)
         GOTO 5
         END
