#ifdef SP_NT
 
C   THIS ROUTINE SPECIFIC TO UNIX SPIDER AND IS NOT 
C       USED AT  NT SITES
 
       SUBROUTINE mhelp(IPROMPT,IANS,USER_STR,NCHAR,IS_HELP)

       LOGICAL        IS_HELP
       CHARACTER *(*) IPROMPT, USER_STR
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: mhelp'
       RETURN
       END

 
#else

C++*************************************************************************
C
C  MHELP.FOR -- CREATED 3/29/93 ML
C
C **************************************************************************
C *  AUTHOR: MAHIEDDINE LADJADJ                                            *
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    MHELP(IPROMPT,IANS,USER_STR)
C
C    PURPOSE:        DISPLAY HELP FILES
C
C    PARAMETERS:    IPROMPT   SPIDER PROMPT
C                   USER_STR   USER RESPONSE
C                   NCHAR     NUMBER OF CHARACTER IN USER_STR STRING
C                   IANS      POSITION OF '?' IN USER_STR STRING
C                   IS_HELP   .TRUE. IF "HELP" WAS TYPED IN IANS STRING.
C
C                   LUNDOC    UNIT TO READ FILE (SET TO 98)
C
C    CALLED BY:     READCH.F
C    
C    CALLS:         MHELP_SUB   FILCAN
C
C        1         2         3         4         5         6         7       
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

        SUBROUTINE MHELP(IPROMPT,IANS,USER_STR,NCHAR,IS_HELP)

        INCLUDE 'CMBLOCK.INC'

        CHARACTER *(*) IPROMPT, USER_STR
        INTEGER        IANS, NCHAR, LUNDOC, EXT_DONE
        INTEGER        I, I1, I2, J, IER, N, NA, LENA, IP,
     &                 IMOOP, JKOOP, NLEN, NEWFILE_LEN, IRTFLG 
        INTEGER        HELP_FILEON
        CHARACTER * 80 ANSWER, S_PROMPT, DIR_NAME, NEWFILE
        CHARACTER * 1  NULL
        LOGICAL        EX, IS_HELP, J_HELP
        CHARACTER * 81 FILNAM, PROMPT00
        CHARACTER *4   MASTER
        CHARACTER * 4  EXT, EXT0, EXT1
        CHARACTER * 9  FIND_DIR
        CHARACTER *2   MENU_LIST
	CHARACTER *80  UPFUNC
        CHARACTER * 16 FMT2
	CHARACTER *80  FLSPEC,RSLTSPEC
        REAL CTXT

        DATA DIR_NAME /' '/
        DATA MASTER/'    '/
        DATA FILNAM/' '/
        DATA MENU_LIST/'ME'/
	DATA EXT0/'.MAN'/
	DATA EXT1/'.MA1'/
	DATA FIND_DIR/'SPMAN_DIR'/
        DATA FMT2 /'($,'' .'',A  '': '')'/
        DATA UPFUNC/' '/
        DATA FLSPEC/' '/
        DATA RSLTSPEC/' '/

        NULL = CHAR(0)

	IF(N_MOSAIC.EQ.1) THEN
 
c	WE HAVE INSTALLED A HELP ON MOSAIC .
 
           NLEN = lnblnk(FCHAR)
	   IF(NLEN.NE.0) THEN
             ANSWER(1:NLEN) = FCHAR(1:NLEN)
             NCHAR = NLEN
           ELSE
             ANSWER(1:NCHAR) = USER_STR(1:NCHAR)
           END IF
           PROMPT00 = "$SPIDER_LOC/../docs/utils/htbrowse help "
     $               // ANSWER(1:nchar)  // NULL

           CALL CSVMS(prompt00, ierr)
	   RETURN

	END IF

C	PROCESS PROMPT TO CREATE THE FORMAT
        NA = INDEX(IPROMPT,'$') - 1
        IF (NA .LE. 0) NA = LEN(IPROMPT)
        WRITE(FMT2(10:11),8001) NA
8001    FORMAT(I2)
        LUNDOC = 98
        LENA = LEN(IPROMPT)
        S_PROMPT(1:LENA) = IPROMPT(1:LENA)

#ifdef SP_VMS
        NLEN = 10
        DIR_NAME(1:9) = FIND_DIR(1:9)
        DIR_NAME(10:10) = ':' 
#else
C       READ IN THE ENVIRONMENT VARIABLE 'SPMAN_DIR'.
        CALL MYGETENV(FIND_DIR,DIR_NAME,NLEN,
     &               'DIR_CONTAINING_SPIDER_MANUALS',IRTFLG)
#endif
        IF (.NOT.(IS_HELP)) GOTO 12

C       THE USER HAS ENTERED HIS CRY FOR HELP. HOWEVER WE WILL
C       DISPLAY THE MENU DEFAULT ONLY IF THIS WAS DONE AT THE 
C       'OPERATION' PROMPT.
 10     CALL CHECK_THIS_OUT(S_PROMPT,LENA,'OPERATION',9,J_HELP)
        IF (.NOT.(J_HELP)) THEN

C         "HELP" WAS ENTERED, SO ANS() DOES NOT HAVE THE NAME OF THE
C	  HELP FILE. BUT FCHAR() SHOULD NOT BE EMPTY.
          JKOOP = 2
          EXT_DONE=0
          EXT(1:4) = EXT0(1:4)
	  GOTO 180
        END IF
 11     S_PROMPT(1:1)='*'
        DO I=2, LENA
          S_PROMPT(2:I)=' '
        END DO
        UPFUNC(1:2) = MENU_LIST(1:2)
        EXT(1:4) = EXT0(1:4)

C	SEARCH FOR THE FILE IN THE CURRENT DIRECTORY
        FILNAM = DIR_NAME(1:NLEN) // UPFUNC(1:2) // EXT // NULL
#ifndef SP_VMS
        CALL SSLOWCAS(FILNAM)
#endif
        INQUIRE(FILE=FILNAM,EXIST=EX,ERR=999)
        IF(EX) THEN

C         HELP FILE EXISTS, READ AND DISPLAY IT.
          CALL MHELP_SUB(FILNAM,LUNDOC,S_PROMPT)
        ELSE
          WRITE(NOUT,*) 'NO MENU LISTING.'
        END IF
        WRITE(NOUT,FMT2) IPROMPT
        RETURN                                        

C	THE ROUTINE SEARCHS FOR FILES WITH EXTENSIONS .MAN
C       (EXT_DONE=0) THEN FILES WITH EXTENSIONS .MA1 (EXT_DONE=1)
C	BEFORE EXITING FROM THE HELP PROGRAM
  12    CONTINUE
        EXT_DONE=0
        EXT(1:4) = EXT0(1:4)

C       FIRST, THE ROUTINE CHECKS IF A FILE NAME EXISTS IN USER_STR STRING.
C       SECOND, THE ROUTINE CHECKS IF A FILE NAME EXISTS IN FCHAR STRING.
C       THIRD, THE ROUTINE CHECKS IF A FILE NAME EXISTS IN IPROMPT STRING.
C
C       FIRST OPTION
1200    CONTINUE
        JKOOP = 1
        ANSWER(1:NCHAR) = USER_STR(1:NCHAR)
        GOTO 200

C       SECOND OPTION
180     NCHAR = LEN(FCHAR)
        ANSWER(1:NCHAR) = FCHAR(1:NCHAR)
        GOTO 200

C       THIRD OPTION
190     NCHAR = LEN(IPROMPT)
        ANSWER(1:NCHAR) = IPROMPT(1:NCHAR)

C	STRIP LEADING AND TRAILING BLANKS AND NULLS
200     CONTINUE
        DO  I = 1, NCHAR
          IF ( ANSWER(I:I) .NE. NULL .AND.
     &         ANSWER(I:I) .NE. ' '  .AND.
     &         ANSWER(I:I) .NE. '?'             ) THEN
            I1 = I
            I2 = I
            DO  J = NCHAR, I, -1
              IF ( ANSWER(J:J) .NE. NULL .AND.
     &             ANSWER(J:J) .NE. ' '  .AND.
     &             ANSWER(J:J) .NE. '?'         ) THEN
                I2 = J

C               THE ANSWER STRING IS NOT EMPTY.
                NA = I2 - I1 +1
                IF (NA .EQ. 0) STOP ' IMPOSSIBLE IN MHELP.FOR 1'

C               COPY  THE FUNC STRING SO IT IS CONVERTED TO UPCASE
C               DON'T WANT TO CHANGE THE ORIGINAL AND CONFUSE CALLER.
	        UPFUNC(1:NA) = ANSWER(I1:I2)
	        CALL SSUPCAS(UPFUNC)
                GOTO (1000, 5000, 5000) JKOOP
              END IF
            END DO 
          END IF
        END DO

C       ANSWER IS OF THE FORMAT ANSWER()= '?'
C	THE USER HAS JUST ASKED FOR HELP.
C	USE IPROMPT AND FCHAR STRINGS TO FIND THE RELEVANT 
C	PORTIONS OF HELP NEEDED.
C       NOTE; if iprompt = 'OPERATION' then fchar=0
C	      we should display the default menu.
        CALL CHECK_THIS_OUT(S_PROMPT,LENA,'OPERATION',9,J_HELP)
        IF (J_HELP) GOTO 11
        JKOOP = JKOOP + 1
        IF (JKOOP .GT. 3) THEN
          WRITE(NOUT,*) 'NO INDICATION WHAT HELP IS WANTED '
          RETURN
        ELSE
          GOTO (180, 190) (JKOOP - 1)
        END IF
        WRITE(NOUT,*) 'COULD NOT FIND ANY HELP'
	RETURN

C       THE FILENAME HAS BEEN PROVIDED BY THE USER IN THE FORMAT 
C       ANSWER() = FILE ?
C       RESET THE POINTER NCHAR TO THE LAST NON-NULL CHAR. IN ANSWER() STRING
1000    CONTINUE
        NCHAR = I2

C	CHECK THAT "?" IS EITHER AT THE END OF ANSWER OR AT THE BEGINNING
        IF(IANS .GT. I1 .AND. IANS .LT. I2) THEN
          WRITE(NOUT,*) '     '
          WRITE(NOUT,*) ' THE CALL FOR HELP HAS TO BE :         '
          WRITE(NOUT,*) '      [command] [subcommand]  ?   or   '
          WRITE(NOUT,*) '   ?  [command] [subcommand]           '
          WRITE(NOUT,*) '     '
          WRITE(NOUT,*) '  with [subcommand] being optional     '
          WRITE(NOUT,*) '     '
          WRITE(NOUT,FMT2) IPROMPT
          RETURN
        END IF

C	THE USER HAS ASKED FOR SPECIFIC HELP. FIND IT AND DISPLAY IT.
C	THE ROUTINE WILL CONSTRUCT THE LONGEST POSSIBLE FILENAME AND
C	CALL THAT FILE FOR DISPLAY.
5000    CONTINUE
        IP = 0
        IMOOP = NA
        J = 1
        DO WHILE (IMOOP .GT. 0)   
          IF (UPFUNC(J:J) .EQ. ' ' .OR. UPFUNC(J:J) .EQ. NULL) THEN  

C           DELETE BLANKS FROM THE FILE NAME
            DO  I = J, J + IMOOP - 1
              UPFUNC(I:I) = UPFUNC(I+1:I+1)
            END DO
            GOTO 2010
          END IF

C	SEARCH FOR THE FILE IN THE CURRENT DIRECTORY
          FILNAM = DIR_NAME(1:NLEN) // UPFUNC(1:J) // EXT // NULL
#ifndef SP_VMS
          CALL SSLOWCAS(FILNAM)
#endif
          INQUIRE(FILE=FILNAM,EXIST=EX,ERR=999)
          IF(EX) THEN
            IP = J
          END IF
          J = J + 1
 2010     IMOOP = IMOOP -1 
        END DO
        IF (IP .GT. 0) THEN

C       HELP FILE EXISTS, READ AND DISPLAY IT.
          FILNAM = DIR_NAME(1:NLEN) // UPFUNC(1:IP) // EXT // NULL
#ifndef SP_VMS
          CALL SSLOWCAS(FILNAM)
#endif
          CALL MHELP_SUB(FILNAM,LUNDOC,S_PROMPT)
          WRITE(NOUT,FMT2) IPROMPT
          RETURN
        ELSE
          IF(EXT_DONE .EQ. 0) THEN
            EXT_DONE=1
            EXT(1:4) = EXT1(1:4)
            GOTO 1200
          ELSE

#ifdef SP_VMS
            UPFUNC(1:2) = USER_STR(1:2)
            UPFUNC(3:3) = '*'
            EXT(1:4) = '.MA*'
            FLSPEC= DIR_NAME(1:NLEN) // UPFUNC(1:3) // EXT // NULL

C           VMS LIBRARY CALLS TO FIND A FILE OF FORMAT 'XX*.MA*' WHERE
C           XX ARE THE TWO FIRST CHAR OF THE COMMAND NAME.
C           THE FIRST CALL IS TO FIND A FILE WITH A WILD CARD,
C           THE SECOND CALL IS TO FREE THE VIRTUAL MEMORY  ALLOCATED.
            CALL LIB$FIND_FILE(FLSPEC,RSLTSPEC,CTXT)
            CALL LIB$FIND_FILE_END(CTXT)
            FILNAM=RSLTSPEC
            INQUIRE(FILE=FILNAM,EXIST=EX,ERR=999)
            IF(EX) THEN

C       HELP FILE EXISTS, READ AND DISPLAY IT.
              CALL MHELP_SUB(FILNAM,LUNDOC,S_PROMPT)
              WRITE(NOUT,FMT2) IPROMPT
              RETURN
            ELSE
              WRITE(NOUT,*) ' '
              FILNAM = UPFUNC(1:3) // EXT // NULL
              WRITE(NOUT,990) FILNAM
 990          FORMAT(' NO HELP FILE FOUND. FILNENAME :',A30)
              WRITE(NOUT,*) ' '
              NA = INDEX(IPROMPT,'$') - 1
              IF (NA .LE. 0) NA = LEN(IPROMPT)
              WRITE(FMT2(10:11),8001) NA
            END IF

#else
#ifndef __osf__
#ifndef SP_SUN4
C  SEARCH THE DIRECTORY FOR XX*.MA* FILES.
            IRTFLG = HELP_FILEON(DIR_NAME(1:NLEN), NLEN, UPFUNC(1:2), 2,
     &           LUNDOC,S_PROMPT)
            IF (IRTFLG .EQ. -1) GOTO 999
#endif
#endif
#endif
            GOTO 998
          END IF
	END IF

999     WRITE(NOUT,*) '     '	
        WRITE(NOUT,*) 'ERROR :: UNABLE TO FIND FILE',FILNAM
        WRITE(NOUT,*) '     '
998     WRITE(NOUT,FMT2) IPROMPT
        RETURN
        END

C **************************************************************************
C
C $$ CHECK_THIS_OUT(USER_STR,NCHAR,STR2,I2,IS_HELP)
C
C    PURPOSE: CHECK IF STR2 IS IN USER_STR. IF SO, 
C             RETURN IS_HELP = .TRUE.
C
C    PARAMETERS:    USER_STR    USER RESPONSE
C                   NCHAR       NUMBER OF CHAR. IN USER_STR
C                   STR2, I2    A STRING AND ITS LENGTH.
C                   IS_HELP     LOGICAL VALUE
C
C
C    CALLED BY:     READCH.FOR, MHELP.FOR
C    
C        1         2         3         4         5         6         7       
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

        SUBROUTINE CHECK_THIS_OUT(USER_STR,NCHAR,STR2,I2,IS_HELP)

        CHARACTER *(*) USER_STR, STR2
        CHARACTER *80 STRING1
        INTEGER NCHAR, I, I2
        LOGICAL IS_HELP

C       CONVERT STRING TO ALL UPPER CASE.
        STRING1(1:NCHAR) = USER_STR(1:NCHAR)
        CALL SSUPCAS(STRING1(1:NCHAR))
        IS_HELP = .FALSE. 
        I = 1
        DO WHILE (I .LT. NCHAR)
          IF ( STRING1(I:I) .NE. STR2(1:1) ) GOTO 1000
          DO J = 2, I2
            I = I + 1
            IF( STRING1(I:I) .NE. STR2(J:J)) GOTO 1000
          END DO
          IS_HELP = .TRUE.
          RETURN
1000      I = I + 1
        END DO
        RETURN
        END
 
 
#ifndef SP_VMS 
#ifndef __osf__
#ifndef SP_SUN4
 
C   THIS ROUTINE SPECIFIC TO UNIX SPIDER AND IS NOT 
C       USED AT VAX SITES
C*************************************************************************
C
C       WRITTEN BY MAHIEDDINE LADJADJ         5/19/93
C
C       INTEGER FUNCTION HELP_FILEON()
C
C  This function is called with two arguments. the first arg. is the
C  name of a file (input) and the second arg. is the name of a file
C  that is the longest with the same starting two char.
C      infile : INPUT name of the file given by the calling program.
C      newfile: OUTPUT name of the file  returned.
C      int    : the function returns iflag to indicate the success or
C               failure of the call.
C               iflag  =  -1   no such file
C                          1  file exists
C
C       OPEN : OPENS THE "DIRECTORY FILE".
C              DIR_PTR: FILE DESCRIPTOR.
C              DIR_PATH: PATH TO THE DIRECTORY
C       GETDENTS: READ DIRECTORY ENTRIES AND PUT THEM IN A FILE SYSTEM
C       INDEPENDENT FORMAT.
C       INTEGER*4 FUNCTION GETENDS
C       THE INDEPENDENT FORMAT STORES THE DIRECTORY ENTRIES IN STRUCTURES
C       (man dirent) THAT NEEDS (LONG, LONG, SHORT, CHAR. ENTRY NAME).
C       NOTE : THE ENTRY NAME ALWAYS STARTS ON A LONG BOUNDARY. 
C
C **************************************************************************
C *  AUTHOR: MAHIEDDINE LADJADJ                                            *
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C	DIR_PATH, DIR_LEN	: DIRECTORY NAME AND ITS LENGTH
C	INFILE, INFILE_LEN	: INPUT FILE NAME AND ITS LENGTH
C	LUNDOC			: UNIT NUMBER FOR READ
C	S_PROMPT		: USER PROMPT
C

        INTEGER FUNCTION HELP_FILEON(DIR_PATH, DIR_LEN,
     $			INFILE, INFILE_LEN, LUNDOC, S_PROMT)

C       NUMBER OF BYTES IN A LONG AND A SHORT WORD ON THE MACHINE.
        INTEGER N_LONG, N_SHORT
        PARAMETER ( N_LONG = 4, N_SHORT = 2)
C       NBYTES NEEDED FOR GETDENTS FUNCTION.
C       BEST IF NBYTES IS DIVISIBLE BY N_LONG.
        INTEGER*4 NBYTES, O_RDONLY, MODE, O_WRONLY
        PARAMETER ( NBYTES = 100)
C       EXECUTE BY OWNER (SEE CHMOD & UMASK SYSTEM CALLS)
        PARAMETER (MODE = 100, O_RDONLY = 0, O_WRONLY = 1)

        CHARACTER * 512 BUF
        CHARACTER * 81 FILNAM, ENTRY_NAME, NEWFILE
        DATA (FILNAM(I:I), I=1,81)/81*' '/
        CHARACTER *(*) INFILE, DIR_PATH
        CHARACTER NULL
        INTEGER*4 DIR_PTR, NXT_TRY
        INTEGER*4 OPEN, GETDENTS, CLOSE
        INTEGER LEN, K, L1, L2, L3, IRTFLG, LUNDOC
        INTEGER DIR_LEN, P_DOT, INFILE_LEN, NEWFILE_LEN
        CHARACTER *80 STR_ERR, S_PROMPT
        CHARACTER *14 IS_DIR
        DATA IS_DIR/'Is a directory'/

        NULL = CHAR(0)
        NEWFILE_LEN = 0
 	IF(DIR_LEN .EQ. 0) THEN
	  DIR_PATH(1:1) = '.'
          DIR_PATH(2:2) = NULL
          DIR_LEN = 1
	ELSE
C         OPEN THE DIRECTORY FILE DIR_PATH
          DIR_PTR = 0
          DIR_PTR = OPEN(DIR_PATH(1:DIR_LEN), O_RDONLY, MODE)
          IF(DIR_PTR .LE. 0) THEN
            CALL GERROR(STR_ERR)
            IF (STR_ERR(1:14) .EQ. IS_DIR(1:14)) THEN
              WRITE(NOUT,*)'  DIRECTORY EXISTS:  ',DIR_PATH(1:DIR_LEN)
              WRITE(NOUT,*)'  BUT COULD NOT OPEN IT. RETURN WITH ERROR'
            ELSE
              WRITE(NOUT,*)' NO DIRECTORY EXISTS ',DIR_PATH(1:DIR_LEN)
              WRITE(NOUT,*)' HELP_FILEON.FOR  1'
            END IF 
            HELP_FILEON = -1
            RETURN
          END IF
	END IF
	IF (INFILE_LEN .EQ. 0) THEN
            HELP_FILEON = -1
            WRITE(NOUT,*)' FILENAME FOR SEARCH DOES NOT EXIST'
            WRITE(NOUT,*)' LENGTH OF FILENAME IS ZERO.'
            WRITE(NOUT,*)' HELP_FILEON.FOR  2'
            RETURN
	END IF

C       NXT_TRY:  NUMBER OF BYTES ACTUALLY READ
        NXT_TRY = GETDENTS(DIR_PTR, BUF, NBYTES)
        IF (NXT_TRY .EQ. 0) THEN

C         END OF DIRECTORY::
          IF (NEWFILE_LEN .EQ. 0) THEN
            HELP_FILEON =  -1
            WRITE(NOUT,*)' END OF DIRECTORY : NO HELP FILES'
            WRITE(NOUT,*)' DIRECTORY IS ::',  DIR_PATH(1:DIR_LEN)
            WRITE(NOUT,*)' HELP_FILEON.FOR  4'
          END IF
	  GOTO 9999
        ELSE
          IF (NXT_TRY .LT. 0) THEN
            WRITE(NOUT,*)' ERROR:: COULD NOT READ DIRECTORY FILES'
            WRITE(NOUT,*)' DIRECTORY IS ::',  DIR_PATH(1:DIR_LEN)
	    HELP_FILEON = -1
            WRITE(NOUT,*)' HELP_FILEON.FOR  5'
	    GOTO 9999
          END IF
        END IF

C       NULL TERMINATE BUF ARRAY JUST IN CASE TO HELP IN DO WHILE LOOP
        BUF(NXT_TRY + 1:NXT_TRY + 1) = NULL

C       FIND THE NUMBER OF BYTES FOR A LONG AND A SHORT ON THIS MACHINE
        OFF_ENTRY = N_LONG + N_LONG + N_SHORT
        DO WHILE (NXT_TRY .GT. 0)

C         FIRST ENTRY NAME POSITION
          I = 1
          I = I + OFF_ENTRY
          DO WHILE (I .LT. NXT_TRY)

C           PARSE BUF ARRAY TO FIND THE ENTRY NAMES.
            L1 = I
            DO WHILE (BUF(I:I) .NE. NULL)
              I = I + 1
            END DO
            IF (I .GT. NXT_TRY) GOTO 5000

C           DIRECTORY ENTRY FOUND : ENTRY_NAME.
            LEN_ENTRY = I - L1
            ENTRY_NAME(1:LEN_ENTRY) = BUF(L1:I - 1)
	    CALL SSUPCAS(ENTRY_NAME(1:LEN_ENTRY))

C	    CHECK THAT THE BEGINNING OF FILENAME IS THE SAME,
C	    THEN THAT .MAN OR .MA1 IS THE EXTENSION.
	    IF (INFILE(1:2) .EQ. ENTRY_NAME(1:2)) THEN
              IF (ENTRY_NAME(LEN_ENTRY - 3:LEN_ENTRY) .EQ. '.MAN'
     &          .OR. ENTRY_NAME(LEN_ENTRY - 3:LEN_ENTRY) .EQ.'.MA1')
     &        THEN
	        IF (NEWFILE_LEN. LT. LEN_ENTRY) THEN

C                 CHOOSING THE LONGEST NAME AVAILABLE
                  NEWFILE(1:LEN_ENTRY) = ENTRY_NAME(1:LEN_ENTRY)
                  NEWFILE_LEN = LEN_ENTRY
                END IF
	      END IF
	    END IF

C           ALIGN THE BEGINNING OF THE STRUCTURE ON A LONG BOUNDARY
 4000       K = MOD(I, N_LONG)
            IF (K .GT. 0) I = I + (N_LONG - K)
            I = I + OFF_ENTRY + 1
          END DO
C         END DO OF  DO WHILE (I .LT. NXT_TRY)

C         NULL TERMINATE BUF ARRAY JUST IN CASE TO HELP IN DO WHILE LOOP
 5000     NXT_TRY = GETDENTS(DIR_PTR, BUF, NBYTES)
          BUF(NXT_TRY + 1:NXT_TRY + 1) = NULL

        END DO

 9999   IRTFLG = CLOSE(DIR_PTR)
        IF (NEWFILE_LEN .GT. 0) THEN
	  FILNAM = DIR_PATH(1:DIR_LEN) // NEWFILE(1:NEWFILE_LEN)
     &             //NULL

          HELP_FILEON = 1
          CALL MHELP_SUB(FILNAM,LUNDOC,S_PROMPT)
        ELSE
          HELP_FILEON = -1
        END IF
        RETURN
        END
#endif
#endif
#endif
#endif


