
C ++********************************************************************
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)    , WADSWORTH CENTER FOR LABORATORIES AND          *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C                                                                      *
C 
C
C **********************************************************************

      SUBROUTINE MIRCOL(N,M,MM,A,EPS,X,IRTFLG)

      DIMENSION A(N,MM),X(MM,1)
      LOGICAL WURZ(6)

      IRTFLG = 1

      EPS1=EPS*EPS
      DO  I=1,N
      WURZ(I)=.TRUE.
      S=A(I,I)
      IF (I.EQ.1) GOTO 10
      III=I-1
      DO  J=1,III
         IF (.NOT.WURZ(J)) S=(S+A(J,I)*A(J,I))
      IF (WURZ(J))      S=(S-A(J,I)*A(J,I))
      ENDDO
C     WRITE(6,100) S,J,I
100   FORMAT(' S=',F12.3,'J=',I4,'I=',I4)
10    IF (S.GT.0) GOTO 3
      S=-S
      WURZ(I)=.FALSE.
3     IF (S.LT.EPS1) RETURN 
      A(I,I)=SQRT(S)
      III=I+1
      DO  K=III,MM
         S=A(I,K)
         JJJ=I-1
         IF (JJJ.LT.1) GOTO 12
         DO  J=1,JJJ
            IF (.NOT.WURZ(J)) S=(S+A(J,I)*A(J,K))
         IF (WURZ(J)) S=(S-A(J,I)*A(J,K))
	 ENDDO
12       CONTINUE
C        WRITE(6,100) S,J,I
         IF (WURZ(I)) GOTO 6
         S=-S
6        A(I,K)=S/A(I,I)
      ENDDO
      ENDDO
C     WRITE(6,110) ((A(I,K),K=1,MM),I=1,N)
110   FORMAT(' ',3(4(F12.4,1X)/1X))
      DO  K=1,M
         DO  II=1,N
            I=N-II+1
            S=A(I,N+K)
            KKK=I+1
            IF(KKK.GT.N) GOTO 11
            DO  J=KKK,N
              S=(S-X(J,K)*A(I,J))
	    ENDDO
11          X(I,K)=S/A(I,I)
C           WRITE(6,120) S,((X(L,LL),L=1,N),LL=1,M)
120         FORMAT(' ',E11.3)
	ENDDO
      ENDDO

      IRTFLG = 0
      RETURN
      END
