C++************************************************************************
C
C $$ MRALI_P.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ MRALI_P.FOR
C
         SUBROUTINE  MRALI_P(NSAM,NROW,NSI,NIMA,MODE,JACUP,
     &   	WRK,A,B,C,D,PARA,
     &   	A_CIRC,REFER_CIRC,LCIRC,
     &		NUMR,NRING,MAXRIN,TEMP,QM,
     &		NR)
        PARAMETER (NDLI = 7)
	COMMON  BUF(1024)
        DIMENSION DLIST(NDLI)
	INCLUDE 'CMBLOCK.INC'
	DIMENSION  WRK(*)
	DIMENSION  A(NSAM,NROW),B(NSAM,NROW),C(NSAM,NROW),D(NSAM,NROW)
	DIMENSION  PARA(3),QM(NSAM,NROW,NIMA)
	INTEGER*2  NUMR(3,NRING),MAXRIN
	DOUBLE PRECISION  TEMP(MAXRIN,2)
	DIMENSION  A_CIRC(LCIRC),REFER_CIRC(LCIRC,NIMA)
	CHARACTER*1  MODE,NULL
	COMMON  /FISPEC/  FINPAT,FINPIC,DOCFIL,NLET,NLETI
	CHARACTER*80  FINPAT,FINPIC,DOCFIL
	DATA  NDOC/56/,INDOC/57/,INPIC/58/
C -------------------------
CNO_SAVE
C
         NSNR=NSAM*NROW
C PREPARE REFERENCES
C
C do it for all the reference images
	DO    IMI=1,NIMA
	CALL  NRML(QM(1,1,IMI),NSNR)
         CALL  ALRQ
     &   (QM(1,1,IMI),NSAM,NROW,NUMR,REFER_CIRC(1,IMI),
     &		LCIRC,NRING,MODE,IPIC)
         CALL  FOURING
     &   (REFER_CIRC(1,IMI),LCIRC,NUMR,NRING,TEMP,MODE)
         INS=1
         CALL  FMR_2(QM(1,1,IMI),NSAM,NROW,WRK,INS)
        IF (INS.EQ.0)THEN
           CALL ERRT(38,'AP MR ',NE)
           RETURN
        ENDIF 
	ENDDO
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C  alignment
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
C  images to be aligned
	NULL=CHAR(0)
         CALL  FILERD(FINPAT,NLET,NULL,
     &   'Enter template for 2-D image name',IRTFLG)
         CALL  FILERD(DOCFIL,NLETI,NULL,'Selection doc',IRTFLG)
         K=0
         K2=1
         IMI=0
878      LERR=-1
         KP1=K+1
         CALL  UNSAV(DOCFIL,K,INDOC,KP1,WRK,1,LERR,K2)
         IF(LERR.EQ.0)  THEN
         IMI=IMI+1
C
         LIM=WRK(1)
         NULL=CHAR(0)
         CALL  FILGET(FINPAT,FINPIC,NLET,LIM,INTFLAG)
         CALL  OPENFB(BUF,FINPIC,INPIC,NSAMT,NROWT,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,*)  ' FILE NOT FOUND:',FINPIC
         RETURN
         ENDIF
	IF(NSAMT.NE.NSAM.OR.NROWT.NE.NROW)  THEN
	CALL ERRT(1,'AP MR',NE)
	CLOSE(INPIC)
         RETURN
         ENDIF
         DO    J=1,NROW
	      CALL  REDLIN(INPIC,A(1,J),NSAM,J)
	 ENDDO
         CLOSE(INPIC)
	 CALL  NRML(A,NSNR)
	DLIST(5)=-1.0E23
c go through reference images
	DO   LIMA=1,NIMA
	 PARA(1)=0.0
	 PARA(2)=0.0
	 PARA(3)=0.0
C
C run rotation-shift alignment
C
C  input:  two real images, b and refer
C  output: c - real aligned image, para - udated parameters
C          nochange=.true. - no change in the position of the image
C
         CALL  ALROSR(A,C,D,B,QM(1,1,LIMA),NSAM,NROW,NSI,
     &   WRK,PARA,
     &   A_CIRC,REFER_CIRC(1,LIMA),LCIRC,JACUP,NUMR,NRING,
     &		MAXRIN,TEMP,MODE,CORR)
	CORR=CORR/NSAM/NROW
	IF(CORR.GT.DLIST(5))  THEN
        DLIST(2)=PARA(1)
        DLIST(3)=PARA(2)
        DLIST(4)=PARA(3)
	DLIST(5)=CORR
        DLIST(6)=LIMA
        DLIST(7)=LIM
	ENDIF
	ENDDO
        DLIST(1)=IMI
        CALL  SAVD(NDOC,DLIST,NDLI,IRTFLG)
C---------------------------------------------------------------------
         K=K+1
         GOTO  878
         ENDIF
879      CLOSE(INDOC)
	CLOSE(NDOC)
	CALL  SAVDC
         END
