      SUBROUTINE MRERROR
     &	(p3dref,p3d1,ntpt,PHI,THETA,PSI,SHIFT,SCAL,nout)
C
C
C ***********************************************************
C
C INPUT:
C     p3dref(3,NTPT)= POINTS IN REFERENCE IMAGE
C     P3D1(3,NTPT)= POINTS IN VIEWS TO BE ALIGNED
C     PHI= ANGLE TO ROTATE VIEW ABOUT Z (IN PLANE)
C     THETA= TILT ANGLE OF VIEW (ABOUT Y AXIS)
C     PSI= ANGLE TO TURN ABOUT NEW Z AXIS
C     SCAL= MULTIPLICATIVE SCALING FACTOR


      DIMENSION   SHIFT(3),p3dref(3,NTPT),P3D1(3,NTPT),CNEW(3)
	REAL  SCAL
	data   cnv/57.29578/
CNO_SAVE

      CZ=COS(PHI)
      SZ=SIN(PHI)
      CY=COS(THETA)
      SY=SIN(THETA)
      CNZ=COS(PSI)
      SNZ=SIN(PSI)

	write(nout,*)  '  Reference points coordinates'
	write(nout,401)  (m,(p3dref(i,m),i=1,3),m=1,ntpt)
401	format(2x,i2,3f12.3)
	write(nout,*)  '  Aligned points coordinates and the errors'
	erg=0.0
	do    m=1,ntpt
       CNEW(1) =
     &    SCAL*((CNZ*CZ*CY - SZ*SNZ)*P3D1(1,m)
     &    + (SZ*CY*CNZ + SNZ*CZ)*P3D1(2,m) - CNZ*SY*P3D1(3,m))

       CNEW(2) =
     &    SCAL*(-(SZ*CNZ + CZ*SNZ*CY)*P3D1(1,m)
     &    + (CZ*CNZ - SNZ*CY*SZ)*P3D1(2,m) +SNZ*SY*P3D1(3,m))

       CNEW(3) =
     &     SCAL*(SY*CZ*P3D1(1,m) + SY*SZ*P3D1(2,m) + CY*P3D1(3,m))
c
	ert=0.0
	do    j=1,3
	ert=ert+(cnew(j)-p3dref(j,m))**2
	enddo
	ert=sqrt(ert)
	write(nout,402)  m,CNEW,ert
402	format(2x,i2,4f12.3)
	erg=erg+ert
	enddo
	write(nout,*)  '  Total error=',erg/ntpt
      END
