      SUBROUTINE MRNEWANGLE(PSI,THETA,PHI)
C ***********************************
C  USING ANGLES TO CHANGE VOLUME, AND THE TILT ANGLES
C  OF THE SECOND IMAGE SERIES, CALCULATES THE EULERIAN
C  ANGLES OF THIS SECOND SERIES SO IT MAY BE USED IN
C  CONJUNCTION WITH THE ORIGINAL SERIES TO CREATE A
C  3D IMAGE

      INCLUDE     'CMBLOCK.INC'

      PARAMETER (LV=300)
      PARAMETER (MAXREG=7)
      PARAMETER (MAXKEY=100)

      DIMENSION         PLIST(MAXREG)
      DIMENSION         A1(3),A2(3),A3(4)
      CHARACTER * 1     NULL
      CHARACTER * 81    CORFIL
      DATA  NDOC,NDOUT/55,56/
      DATA DTOR/0.017453292/
      DATA  NLIST/4/
CNO_SAVE
	NULL=char(0)
C           PREPARE ARRAY FOR ANGLES
      A1(1)=PSI/DTOR
      A1(2)=THETA/DTOR
      A1(3)=PHI/DTOR
      CALL  FILERD(CORFIL,NLETI,NULL,
     &      'IMAGE SERIES CORRECTION ',IRTFLG)
      IF(IRTFLG.EQ.-1)  RETURN
c the following passage does the same as VO RA
	NULL=char(0)
      K=0
      K2=1
778   LERR=-1
      KP1=K+1
      CALL UNSAV(CORFIL,K,NDOC,KP1,PLIST,2,LERR,K2)
      IF(LERR.EQ.0)  THEN
        K=K+1
        A2(1)=0
        A2(2)=PLIST(2)
        A2(3)=0
        CALL  CALD(A1,A2,A3(2))
        A3(1)=K
        CALL  SAVD(NDOUT,A3,NLIST,IRTFLG)
        IF(IRTFLG.EQ.-1) GOTO  5
        GOTO  778
      ENDIF
c      PRINT *,LERR
5     CALL  SAVDC
      CLOSE(NDOUT)
      CLOSE(NDOC)
      END
