C++*************************************************************************
C
C MULFC3.FOR                        
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************
C  OUT=A1*CONJG(B1)
C  H2=H2+B1^2
        SUBROUTINE MULFC3(LUN1,A1,B1,OUT,H2,NN2,NROW,NSLICE)
        COMPLEX  A1(NN2,NROW,NSLICE),OUT(NN2,NROW,NSLICE)
        COMPLEX  B1(NN2),H2(NN2,NROW,NSLICE)
CNO_SAVE
C
        DO    K=1,NSLICE
        DO    J=1,NROW
 	NR1=J+(K-1)*NROW
        CALL  REDLIN(LUN1,B1,2*NN2,NR1)
	DO    I=1,NN2
        OUT(I,J,K)= OUT(I,J,K)+A1(I,J,K)*CONJG(B1(I))
	H2(I,J,K)=H2(I,J,K)+CMPLX(REAL(B1(I)*CONJG(B1(I))),0.0)
	ENDDO
	ENDDO
	ENDDO

	END
