 
#ifdef SP_VMS 
 
C   THIS ROUTINE SPECIFIC TO UNIX SPIDER AND IS NOT 
C       USED AT VAX SITES
 
       SUBROUTINE nextversion
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: nextversion'
       RETURN
       END
 
#else
 
C++*************************************************************************
C
C NEXTVERSION.F                                                 3/2/94
C
C **************************************************************************
C *  AUTHOR: MAHIEDDINE LADJADJ                                            *
C *  COPYRIGHT (C)1986 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C   NEXTVERSION(FILENAME,UNIT10)
C
C   PARAMETERS:     FILIN (IN INPUT::
C                                   FILE NAME FOR WHICH THE HIGHEST
C                                   VERSION NUMBER HAS TO BE FOUND.
C                   FILOUT( IN OUTPUT:: 
C                                   THE FILE NAME WILL HAVE A VERSION
C                                   NUMBER APPENDED TO IT.)
C                   UNIT10   (READ UNIT FOR THE FILE)
C                                       
C        
C       THIS ROUTINE WILL CALL A SCRIPT CALLED Nextresults THAT WILL
C       DO A CHECK OF THE DIRECTORY FILES AND FIND THE NEXT VERSION
C       NUMBER FOR A FILE. NEXTVERSION WILL WRITE THE NAME OF THE FILE
C       WITH THE CORRECT VERSION TO A FILE CALLED SPIDER_JUNK.TMP.
C       THIS ROUTINE READS SPIDER_JUNK.TMP AND DELETES IT.
C
C--*************************************************************************

        SUBROUTINE NEXTVERSION(FILIN,FILOUT,UNIT10)


        INCLUDE 'CMBLOCK.INC'
  
        CHARACTER*(*)  FILIN, FILOUT
        CHARACTER * 1  NULL
        INTEGER        UNIT10
        CHARACTER*280  SCRIPT
        CHARACTER * 80 DIR_NAME, FILNAM
        CHARACTER * 9  FIND_DIR
	LOGICAL        EX
	DATA FIND_DIR/'SPMAN_DIR'/
        DATA (DIR_NAME(I:I), I=1,80)/80*' '/

	NULL = CHAR(0)

C       READ IN THE ENVIRONMENT VARIABLE 'SPMAN_DIR'.
        CALL GETENV(FIND_DIR,DIR_NAME)
        NLEN = lnblnk(DIR_NAME)
        IF (NLEN.EQ.0 .OR. NLEN .GT. 74) THEN
          WRITE(NOUT,*)' '
          WRITE(NOUT,*)' '
          WRITE(NOUT,*)'"MAN" DIRECTORY NOT FOUND. '
          WRITE(NOUT,*)'IN YOUR STARTUP FILE, DEFINE  DIRECTORY AS'
          WRITE(NOUT,*)'THE ENVIRONMENTAL VARIABLE SPMAN_DIR '
          WRITE(NOUT,*)'       E.G:   setenv SPMAN_DIR  " /MAN/ "'
          WRITE(NOUT,*)' WHERE "MAN" IS THE DIRECTORY WHERE  '
          WRITE(NOUT,*)'        THE HELP FILES.MAN ARE STORED '
          WRITE(NOUT,*)' '
          WRITE(NOUT,*)' PLEASE NOTE THE LAST / IN THE PATH   '
	  GOTO 999
        END IF

	FILNAM = DIR_NAME(1:NLEN) // 'Nextresults'// NULL
	INQUIRE(FILE=FILNAM,EXIST=EX,ERR=999)
        IF(EX) THEN
	  CONTINUE
	ELSE
          WRITE(NOUT,*)' '
          WRITE(NOUT,*)' '
	  WRITE(NOUT,93)FILNAM
93	  FORMAT("FILE NOT FOUND !  ",A)
	  FILOUT = FILIN
	  GOTO 96
        END IF
        
C       CALL THE SCRIPT Nextresults TO FIND THE NEXT VERSION NUMBER OF
C       FILE FILENAME.

        SCRIPT = '$SPMAN_DIR/Nextresults ' // FILIN //
     &               ' > SPIDER_JUNK.TMP' // NULL

        CALL system(SCRIPT)

C       READ THE FILE FILENAME.NBR' FOUND AND STORED IN SPIDER_JUNK.TMP
        OPEN(UNIT10, FILE='SPIDER_JUNK.TMP',STATUS='OLD',ERR=98)

        READ(UNIT10,12) FILOUT
12      FORMAT(A)
        CLOSE(UNIT10)

C       DELETE THE TEMP FILE.
        SCRIPT = 'rm -f SPIDER_JUNK.TMP' // NULL
        CALL system(SCRIPT)

96      WRITE(NOUT,97) FILOUT
97      FORMAT(/,' Results file: ',A)
        RETURN

98      WRITE(NOUT,99)
99      FORMAT('*** Could not open SPIDER_JUNK.TMP in nextresults')

        RETURN

C	NO NEXT VERSION POSSIBLE
999	FILOUT = FILIN
	GOTO 96

        END        

#endif
