
      SUBROUTINE NLMREALSTRT (CNAME,DH,DL,XLO,XLOC,X,Y,HIDIM,NF,
     &                        NIM,INUM)

      INCLUDE 'CMBLOCK.INC'

      COMMON /DIM1/MAXIM,MAXFAC,MAXLO,NDIST
      CHARACTER*4 CNAME(MAXIM)
      DIMENSION DH(NDIST),DL(NDIST),HIDIM(MAXIM,MAXFAC),
     $    XLO(MAXIM,2),XLOC(MAXIM,2),X(MAXIM),Y(MAXIM),INUM(MAXFAC)

C     NOTE: THIS STATEMENT HAS TO BE IN THE CALLING PROGRAM:
C      EQUIVALENCE (XLO(1,1),X(1)),(XLO(1,2),Y(1))

      COMMON /TR/TITRE(20)
      CHARACTER*1 STER,NULL      
      CHARACTER*81 MAPI,MAP,OUTI,OUT

      NULL = CHAR(0)

C     STANDARD NAME END:
      STER='*'

C     LUN FOR MAP:
      LUNS=25
      LUNH=21
      IWR=LUNS

C     WRITE WHAT IS THERE NOW:
      WRITE(NOUT,10) NF,NIM
10    FORMAT(' NUMBER OF FACTORS:',I5,'NUMBER OF IMAGES:',I5)


C     CHECK IF THERE ARE IDENTICAL IMAGES, MAINTAIN ONLY THE FIRST
C     AND REORDER HIDIM, REDEFINE NIM

       CALL DISTTST(HIDIM,NF,NIM,CNAME,XLO,DMAX)

C     CALCULATE START DISTRIBUTION:

      NSW=1
      CALL STRTDIS(EPS,HIDIM,XLO,XLOC,DH,DL,NF,NIM,ZFAC,MOD,
     $    IL1,IL2,ITMAX,EXP,LUNS,DMAX)

C     MINIMIZE THE ERROR:

      CALL RDPRMI(ITMAX,IR,NLOOP,ILOOP,'NUMBER OF ITERATIONS')
      ZFAC=0.4
      CALL RDPRM(EPS,NLOOP,ILOOP,'EPSILON')
      CALL RDPRM(EXP,NLOOP,ILOOP,'EXPONENT IN ERROR')
      CALL FILERD(OUTI,NLET,NULL,'2D-OUT',IRTFLG)
      CALL FILCAN(OUT,NUM,NULL,NULL,OUTI,DATEXC,IER)

      CALL NONLMAP(EPS,HIDIM,XLO,XLOC,DH,DL,NF,NIM,ZFAC,IL1,IL2,
     $   ITMAX,IT,1,EZ,EXP,CNAME,OUT,LUNS)

C     PRINT MAP, STORE 2D-COORDINATES

      CALL FILERD(MAPI,NLETM,NULL,'MAP',IRTFLG)
      CALL FILCAN(MAP,NUM,NULL,NULL,MAPI,DATEXC,IER)

C     STORE 2D COORDINATES
      CALL NLTFILE(OUT,LUNS,CNAME,XLOC,NIM)

      XMAX=XLOC(1,1)
      XMIN=XMAX
      YMAX=XLOC(1,2)
      YMIN=YMAX

      DO  K=1,NIM
        IF(XMAX.LT.XLOC(K,1))XMAX=XLOC(K,1)
        IF(XMIN.GT.XLOC(K,1))XMIN=XLOC(K,1)
        IF(YMAX.LT.XLOC(K,2))YMAX=XLOC(K,2)
        IF(YMIN.GT.XLOC(K,2))YMIN=XLOC(K,2)
        IXLOC=XLOC(K,1)
        IYLOC=XLOC(K,2)
      ENDDO
21    FORMAT(A4,2E14.6)
      CLOSE(LUNS)

C     WRITE TITLE INTO MAP FILE

      OPEN(FILE=MAP,UNIT=LUNS,STATUS='UNKNOWN',FORM='FORMATTED')
22    FORMAT(' SUMMARY:'/' NAME OF INPUT CLUSTER FILE:',
     $   A15,' AXES USED:',10I3)
      IF (MOD.NE.4.AND.MOD.NE.2) WRITE(LUNS,23) INUM(IL1),INUM(IL2)
23    FORMAT('$AXES OF START DISTRIBUTION:',2I3)
      WRITE(LUNS,998) EPS,EZ,IT,EXP,NIM,NF,MOD
998   FORMAT(' EPSILON=',E12.4,' LAST ERROR=',E12.4,
     $' NUMBER OF ITERATIONS=',I5,/' EXPONENT IN ERROR=',F7.2,
     $' NUMBER OF IMAGES=',I4,' NUMBER OF FACTORS=',I3/
     $' START DISTRIBUTION: OPTION=',I3)
       J1=IL1
       J2=IL2

C     PRINT MAP INTO MAP FILE
      CALL RDPRMI(IPG,IBR,NLOOP,ILOOP,'PAGES')

      NIMD=NIM
      NIM2=NIM+2
      XFAC=XMAX-XMIN
      YFAC=YMAX-YMIN
      DO  KK=1,NIM
        X(KK)=(X(KK)-XMIN)/XFAC
        Y(KK)=(Y(KK)-YMIN)/YFAC
      ENDDO	
      OPEN(UNIT=LUNH,STATUS='SCRATCH',FORM='UNFORMATTED')

      CALL HISMAP(NIM2,NIMD,0,0,X,Y,CNAME,4
     $    ,0,IPG,4.,LUNS,LUNH,DATEXC,.FALSE.)

      CLOSE(UNIT=LUNS)
      CLOSE(UNIT=LUNH)

      RETURN
      END
