C++************************************************************************
C
C $$ NRML.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ NRML.FOR
C
	SUBROUTINE  NRML(X,N)
	DIMENSION  X(N)
	DOUBLE PRECISION  AV,VR
CNO_SAVE
        AV=0.0D0
        VR=0.0D0
c$doacross local(i),reduction(av,vr)
	DO    I=1,N	
          AV=AV+X(I)
          VR=VR+X(I)*DBLE(X(I))
	ENDDO
        AV=AV/N
        VR=1.0/DSQRT((VR-N*AV*AV)/(N-1))
c$doacross local(i)
        DO    I=1,N
          X(I)=(X(I)-AV)*VR
	ENDDO
        END
