#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE od
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: od'
       RETURN
       END
 
#else
 

C++*************************************************************************
C
C    OD.FOR
C                                      LONG FILENAMES JAN 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    OD:   OD-CONVERSION ACCORDING TO LOOKUP-TABLE
C
C    SUBROUTINE  OD(LUN1,LUN2,LUN3,NSAM,NROW,MAXDIM)
C
C    CALLER:   UTIL3
C
C--*************************************************************************

	SUBROUTINE OD(LUN1,LUN2,LUN3,NSAM,NROW,MAXDIM)

	COMMON YINT(801),B(1)

        INCLUDE 'CMBLOCK.INC'

        COMMON/COMMUN/FILNAM

        CHARACTER *81 FILNAM
        CHARACTER *1 NULL
       
        NULL=CHAR(0)

	CALL FILERD(FILNAM,NLET,NULL,'TABLE',IRTFLG)
	IF (IRTFLG .NE. 0) RETURN

        CALL FILCAN(FILNAM,NLET,NULL,NULL,FILNAM,DATEXC,IRTFLG)
	IF (IRTFLG .NE. 0) RETURN

	OPEN(UNIT=LUN3,FILE=FILNAM,STATUS='OLD')

	READ(LUN3,101) YINT
101	FORMAT(1X,10F12.6)
	CLOSE(LUN3)

	DO 100 I=1,NROW
          CALL REDLIN(LUN1,B,NSAM,I)
          DO 50 K=1,NSAM
            J=INT(200.*B(K)+1.1)
            IF(J.LT.1)J=1
            IF(J.GT.801) THEN
               B(NSAM+K)=YINT(801)+(YINT(801)-YINT(800))*
     &          FLOAT(I-801)
            ELSE
               B(NSAM+K)=YINT(J)
            ENDIF
50        CONTINUE
100	CALL WRTLIN(LUN2,B(NSAM+1),NSAM,I)
	RETURN
        END
 
#endif
 
