
C=======================================================================

C WRITTEN BY MORTEN KJELDGAARD, NOV 1993.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE PAGEDHDR (OLUN, ORIGIN, EXTENT, GRID, CELL, 
     $                    SIGMA, PROD, PLUS, ERRCOD)

#ifndef SP_SUN4
      IMPLICIT     NONE
#endif

      INTEGER  OLUN, ORIGIN(3), EXTENT(3), GRID(3), PLUS, ERRCOD
      REAL     CELL(6), PROD, SIGMA
      COMMON /PAGEDC/ FMT
      CHARACTER*4  FMT
      CHARACTER    STR*512

C     FOR OLD FORMAT
      INTEGER*2 FIRST(256)               
      INTEGER   I1, I2, I                  

      IF (FMT .EQ. 'OLD') THEN
C ---   FILL UP OUR FIRST RECORD
         I1 = 80
         I2 = 100
         DO  I=1,3
            FIRST(I  ) = ORIGIN(I)
            FIRST(I+3) = EXTENT(I)
            FIRST(I+6) = GRID(I)
            FIRST(I+9) = I1*CELL(I)
            FIRST(I+12)= I1*CELL(I+3)
	 ENDDO
         FIRST(16) = I2*PROD
         FIRST(17) = PLUS
         FIRST(18) = I1
         FIRST(19) = I2
         DO  I=20,256
            FIRST(I) = 0
	 ENDDO

         WRITE (OLUN, REC=1, IOSTAT=ERRCOD) FIRST

      ELSE
         WRITE (STR, 10) ORIGIN, EXTENT, GRID, CELL, PROD, PLUS, SIGMA,
     $        CHAR(0),CHAR(12)

 10      FORMAT (':-) ORIGIN', 3I5,' EXTENT', 3I5, ' GRID', 3I5,
     $        ' CELL ', 6F10.3, ' PROD', F12.5, ' PLUS',I8, 
     $        ' SIGMA ', F12.5, 2A1)
      
         WRITE (OLUN, REC=1, IOSTAT=ERRCOD) STR

      ENDIF
      RETURN
      END



C=======================================================================
        SUBROUTINE PAGED_FORMAT (STR)
#ifndef SP_SUN4
      IMPLICIT     NONE
#endif
        CHARACTER*(*) STR
        COMMON /PAGEDC/ FMT
        CHARACTER*4 FMT

        IF (STR .EQ. 'OLD') THEN
           FMT = 'OLD'
        ELSE
           FMT = 'NEW'
        ENDIF
        END

C=======================================================================
        SUBROUTINE BYTSWP (REC)
#ifndef SP_SUN4
      IMPLICIT     NONE
#endif
        LOGICAL * 1 REC(2,256)
        LOGICAL * 1 ONE
        INTEGER     I

        DO  I=1,256
          ONE      = REC (1,I)
          REC(1,I) = REC(2,I)
          REC(2,I) = ONE
	ENDDO
        RETURN
        END
