
C
C++************************************************************************
C
C   
C
C **************************************************************************
C *  AUTHOR :                                                              *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C
C	AUTHOR: MAHIEDDINE LADJADJ          11/1/93
C
C
C
C	OPERATION OF PROJECTION AND DIAGONALIZATION, FOR DIAGO-
C       NALIZATION BY DIRECT READING.
C
C         
C--*********************************************************************


        SUBROUTINE PCA_CPROJ(NUMIM, JBASE, NPIX, S, D, BB, U, AD, 
     &                    SOMP, PJ, NB, LUV,jcase, inb)

        DIMENSION S(NPIX, JBASE),  BB(NPIX, JBASE),  AD(JcASE, JcASE), 
     &              U(NPIX),  PJ(NPIX),  D(NPIX),  LUV(NUMIM)
        logical  inb(jbase)
CNO_SAVE
        CALL REW(NB,  1)
        DO  M  =  1, JcASE
          DO L  =  1, JcASE
            AD(L, M)  =  0.0
          END DO
        END DO

        DO  I  =  1, NUMIM                                     
          IF(LUV(I) .EQ. 0) THEN
            READ(NB)
          ELSE
            READ (NB) (U(KK),  KK = 1, NPIX) , PIA,  VAR,  INO
            mc = 0
            DO  M  =  1, JBASE
              if(inb(m))  then
                mc = mc + 1
                lc = 0
                DO L  =  1, M
                  if(inb(l))  then
                    lc = lc + 1
                    CIL  =  0.0
                    CIM  =  0.0
                    DO K  =  1, NPIX        
                      UUU  =  U(K)  -  PJ(K)
                      CIL  =  CIL  +  S(K, L) * UUU
                      CIM  =  CIM  +  S(K, M) * UUU
                    END DO
                    AD(Lc, Mc)  =  AD(Lc, Mc)  +   CIL * CIM
                  endif
                END DO
              endif
            END DO
          ENDIF
        END DO
                                                                               
        DO M  =  1, JcASE                                                       
          DO L  =  1, M                                                   
            AD(M, L)  =  AD(L, M)
          END DO
        END DO
C        
C     DIAGONALIZATION OF THE PROJECTED MATRIX
C
        CALL VPROP (JcASE ,  JcASE ,  AD ,  D ,  U ,  KOD)

        mc = 0
        DO  M  =  1, JBASE
          if(inb(m))  then
            mc = mc + 1
            DO J  =  1, NPIX
              BB(J, M)  =  0.0
              kc = 0
              DO  K  =  1, JBASE
                if(inb(k))  then
                  kc = kc + 1
                  BB(J, M)  =  BB(J, M)  +  S(J, K) * AD(Kc, Mc)
                endif
              END DO
            END DO
          endif
        END DO

        DO  L  =  1, JBASE
          if(inb(l))  then
            DO J  =  1, NPIX
              S(J, L)  =  BB(J, L)
            END DO
          endif
        END DO
        END
