
C
C++************************************************************************
C
C   
C
C **************************************************************************
C *  AUTHOR :                                                              *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C
C	AUTHOR: MAHIEDDINE LADJADJ          11/1/93
C
C         
C--*********************************************************************
        
        SUBROUTINE PCA_ITPOW(NUMIM, NPIX, JBASE, NAR, PJ, S, BB, U, V,
     &                  SOMP, TRACE, NB, LUV, inb)
                                                                               
        DIMENSION PJ(NPIX),  S(NPIX, JBASE),  BB(NPIX, JBASE)
        DIMENSION U(NPIX),  V(NPIX),  LUV(NUMIM)
        logical  inb(jbase)
        LOGICAL CENTER
CNO_SAVE                                                                               
        CALL REW(NB,  1)
        DO  L  =  1, JBASE
          if(inb(l))  then
            DO  J  =  1, NPIX
              BB(J, L)  =  S(J, L)
              S(J, L)  =  0.0
            END DO
          endif
        END DO
                                                                               
        DO  IA  =  1, NUMIM
          IF(LUV(IA) .EQ. 0)  THEN
            READ(NB)
          ELSE
            READ(NB) (U(K),  K = 1, NPIX),  PIA,  VAR, INO
            CENTER = MOD(IA, NAR) .EQ. 0 .OR. IA .EQ. NUMIM
            DO L  =  1, JBASE
              if(inb(l))  then
                T1  =  0.0                                                
                DO K  =  1, NPIX
                  T1  =  T1  +  BB(K, L) * (U(K) - PJ(K))
                END DO
                                                                              
                DO K  =  1, NPIX
                  S(K, L)  =  S(K, L)  +  (U(K) - PJ(K)) * T1
                END DO
                IF(CENTER)  THEN
C
C........ PERIODIC CENTERING
C
                  T2  =  0.0                                                
                  DO JP  =  1, NPIX
                    T2  =  T2  + S(JP, L)
                  END DO
                  T2 = T2 / NPIX
                  DO J  =  1, NPIX
                    S(J, L)  =  S(J, L)  -  T2                            
                  END DO
                ENDIF
              endif
            END DO
          ENDIF
        END DO
        DOP  =  TRACE/2/(NPIX  -  1)
                                                                             
        DO  L  =  1, JBASE
          if(inb(l))  then
            DO  J  =  1, NPIX
              S(J, L)  =  S(J, L)  -  DOP * BB(J, L)
            END DO
          endif
        END DO
        do l = 1, jbase
          if(.not.inb(l))  then
            CALL PCA_GSMODl(NPIX,  JBASE, S,  KRANG, v, inb)
            RETURN
          endif
        enddo
        CALL PCA_GSMOD(NPIX, NPIX,  JBASE, S,  KRANG, v)
        END            
