
C++************************************************************************
C
C    PDATES.F                               FILNAM LENGTHENED DEC 88 al
C                                        FILNAM OUTPUT FIXED SEPT 97 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    PDATES(FILNAM,IFMAT)
C
C    PARAMETERS:
C         FILNAM    CHAR. ARRAY, CONTAINING FILE NAME OR INFO. STRING
C         IFMAT     FLAG TO BEGIN NEW PAGE OF OUTPUT 
C
C--*********************************************************************

      SUBROUTINE PDATES(FILNAM,IFMAT)

      CHARACTER *10    CDAT
      CHARACTER *8     CTIM
      CHARACTER *160   CTIT
      CHARACTER *4     DATEXC,PRJEXC
      COMMON /MASTER1/ DATEXC,PRJEXC,CDAT,CTIM,CTIT
      COMMON /UNITS/   LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

      CHARACTER  *(*)  FILNAM
      CHARACTER  *1    NULL
      CHARACTER  *  9  CDATT
      CHARACTER  *  8  CTIMT

      NULL = CHAR(0)

      CALL DATE(CDATT)
      CALL TIME(CTIMT)

C     PAGE FORMATTING
      IF (IFMAT .EQ. 1) THEN
C        NEW PAGE
         WRITE(NDAT,90)
90       FORMAT('1')
      ELSEIF (IFMAT .NE. -1) THEN
C        SKIP LINE
         WRITE(NDAT,91)
91       FORMAT('0')
      ENDIF

      NLET   = lnblnk(FILNAM)
      IF (CTIT(1:1) .NE. NULL) THEN
         WRITE(NDAT,92,ERR=223)FILNAM(1:NLET),CDATT,CTIMT,CTIT
      ELSE
         WRITE(NDAT,92,ERR=223)FILNAM(1:NLET),CDATT,CTIMT
      ENDIF
92    FORMAT(' ',A  ,2X,A9,' AT ',A8,4X,A40,/,:,1X,A80,/,:,1X,A40/)
      RETURN

223   WRITE(NOUT,*) '*** PGM. ERROR IN PDATES FORMAT:'
      RETURN
      END

