
C ++********************************************************************
C
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)    , WADSWORTH CENTER FOR LABORATORIES AND          *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************

	SUBROUTINE PRB1D(B,NPOINT,POS)

	DOUBLE PRECISION B(NPOINT),C2,C3
CNO_SAVE
	NHALF  = NPOINT/2 + 1
	POS=0.0
	IF (NPOINT .EQ. 7) THEN
	   C2 = 49.*B(1) + 6.*B(2) - 21.*B(3) - 32.*B(4) - 27.*B(5)
     1       - 6.*B(6) + 31.*B(7)
	   C3 = 5.*B(1) - 3.*B(3) - 4.*B(4) - 3.*B(5) + 5.*B(7)
	ELSEIF (NPOINT .EQ. 5) THEN
           C2 = (74.*B(1) - 23.*B(2) - 60.*B(3) - 37.*B(4)
     1        + 46.*B(5) ) / (-70.)
	   C3 = (2.*B(1) - B(2) - 2.*B(3) - B(4) + 2.*B(5) ) / 14.
	ELSEIF (NPOINT .EQ. 3) THEN
	   C2 = (5.*B(1) - 8.*B(2) + 3.*B(3) ) / (-2.)
	   C3 = (B(1) - 2.*B(2) + B(3) ) / 2.
	ELSEIF (NPOINT .EQ. 9) THEN
	   C2 = (1708.*B(1) + 581.*B(2) - 246.*B(3) - 773.*B(4)
     1         - 1000.*B(5) - 927.*B(6) - 554.*B(7) + 119.*B(8)
     1         + 1092.*B(9) ) / (-4620.)
	   C3 = (28.*B(1) + 7.*B(2) - 8.*B(3) - 17.*B(4) - 20.*B(5)
     1        - 17.*B(6) - 8.*B(7) + 7.*B(8) + 28.*B(9) ) / 924.
	ENDIF

	IF (C3.NE.0.0D0)  POS = C2/(2.*C3) - NHALF
        RETURN
	END
