C
C++******************************************************5/20/80
C
C	FROM MPI-5/20/80
C  	CALL PROBER(A,N,LUN2,LUN3,NSAM,NROW)
C
C
C  PROBER EVALUATES THE PROBABILITY OF THE ERROR AT EVERY
C  POINT (X,Y), THE MAGNITUDE OF THE CONFIDENCE INTERVAL
C  BEING GIVEN
C
C
C	    A:	THE MAGNITUDE OF THE CONFIDENCE INTERVAL
C	    N:  NUMBER OF SAMPLE FILES ADDED
C	 LUN2:  LUN OF V (VARIANCE) FILE
C	 LUN3:	LUN OF FILE CONTAINING THE PROBABILITY OF THE ERROR
C
C--***************************************************************
C
C
	SUBROUTINE PROBER(A,N,LUN2,LUN3,NSAM,NROW,NZERO)
	COMMON ADUM(80),BUF(1)
CNO_SAVE
	NZERO=0
	AN1=0.70710678*A*SQRT(FLOAT(N))
	DO  I=1,NROW
	CALL REDLIN(LUN2,BUF,NSAM,I)
	DO  J=1,NSAM
	IF(BUF(J).LE.0) THEN
	BUF(J)=1.0
	NZERO=NZERO+1
	ELSE
	ZALPHA=AN1/SQRT(BUF(J))
	BUF(J)=ORCDF(ZALPHA)
	ENDIF
	ENDDO
	CALL WRTLIN(LUN3,BUF,NSAM,I)
	ENDDO
	END
