	SUBROUTINE  PUT_P(A,NDIM,NROW,IX,IY,QQ)
	DIMENSION  A(NDIM,NROW)
	COMPLEX  QQ
CNO_SAVE
C
C  THIS FUNCTION PUTS ONE COMPLEX ELEMENT
C  ONTO THE 2-D FOURIER TRANSFORM PRODUCED
C  BY THE FFT2D_P SUBROUTINE
C  (CAN BE USED FOR FILTRATION)
C
C  0 <= IX <= NDIM/2
C  -NROW/2+1 <= IY <= NROW/2
C
	IF(IX.EQ.0)  THEN
		IF(IY.EQ.0)  THEN
		A(1,1)=REAL(QQ)
		RETURN
		ELSEIF(IY.EQ.NROW/2)  THEN
		A(1,2)=REAL(QQ)
		RETURN
		ELSEIF(IY.LT.0)  THEN
		PRINT  *,' OUT OF BOUNDERY, IX=0'
		STOP
		ELSE
		IROW=2*IY+1
		A(1,IROW)=REAL(QQ)
		A(1,IROW+1)=AIMAG(QQ)
		RETURN
		ENDIF
	ENDIF
C
	IF(IX.EQ.NDIM/2)  THEN
		IF(IY.EQ.0)  THEN
		A(2,1)=REAL(QQ)
		RETURN
		ELSEIF(IY.EQ.NROW/2)  THEN
		A(2,2)=REAL(QQ)
		RETURN
		ELSEIF(IY.LT.0)  THEN
		PRINT  *,' OUT OF BOUNDERY, IX=NDIM/2'
		STOP
		ELSE
		IROW=2*IY+1
		A(2,IROW)=REAL(QQ)
		A(2,IROW+1)=AIMAG(QQ)
		RETURN
		ENDIF
	ENDIF
	IROW=IY+1
	IF(IY.LT.0)  IROW=IROW+NROW
	IDIM=2*IX+1
	A(IDIM,IROW)=REAL(QQ)
	A(IDIM+1,IROW)=AIMAG(QQ)
	RETURN
	END
