C
C
C++************************************************************************
C
C $$ PW2SR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ PW2SR.FOR
C
	SUBROUTINE  PW2SR(Q,NNNN,NSAM,NROW,MODE)
	DIMENSION   Q(NNNN,NROW)
	CHARACTER*1  MODE
	LOGICAL*1 IFND
CNO_SAVE
	IFND=MOD(NROW,2).EQ.0
	NSC=NSAM/2+1
C
C	DO  1  J=1,NROW
C1	CALL  REDLIN(LUN1,Q(1,J),NSAM,J)
C	INV=+1
C	CALL  FMRS_2(Q,NSAM,NROW,INV)
C
	SCL=2.0/FLOAT(NSAM)/FLOAT(NROW)
	DO    J=1,NROW
	DO    I=NNNN-1,1,-2
	Q(NNNN-1-(NNNN-1-I)/2,J)=
     &		SCL*SQRT(Q(I+1,J)*Q(I+1,J)+Q(I,J)*Q(I,J))
        ENDDO
	IF(MODE.EQ.'L')  CALL  AL10(Q(NSAM/2,J),NSAM/2)
	ENDDO
C
	DO    J=1,NROW/2
	JJ=J+NROW/2+MOD(NROW,2)
	DO    I=NSC,NNNN-1
	TEMP=Q(I,J)
	Q(I,J)=Q(I,JJ)
	Q(I,JJ)=TEMP
	ENDDO
	ENDDO
C
	IF(.NOT.IFND)  THEN
	DO    I=NSC,NNNN-1
	TEMP=Q(I,NROW/2+1)
	DO    J=NROW/2+1,NROW-1
	Q(I,J)=Q(I,J+1)
	ENDDO
	Q(I,NROW)=TEMP
	ENDDO
	ENDIF	
C
	NSC=NNNN/2-1
	IF(IFND)  THEN
	JB=2
	DO    I=1,NSC
	II=NNNN-I
	Q(I,1)=Q(II,1)
	ENDDO
	ELSE
	JB=1
	ENDIF
	DO    J=JB,NROW
	JJ=NROW-J+JB
	DO    I=1,NSC
	II=NNNN-I
	Q(I,J)=Q(II,JJ)
	ENDDO
	ENDDO
C
C         IF(MODE.NE.'L')  Q(NSAM/2+1,NROW/1+1)=0.0
C
C         DO  3  J=1,NROW
C3        CALL  WRTLIN(LUN2,Q(1,J),NSAM,J)
         END
