C
C++************************************************************************
C
C $$ PW3SR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ PW3SR.FOR
C
	SUBROUTINE  PW3SR(Q,NNNN,NSAM,NROW,NSLICE,MODE)
	DIMENSION   Q(NNNN,NROW,NSLICE)
	CHARACTER*1  MODE
	LOGICAL*1 IFND,IFNL
CNO_SAVE
	IFND=MOD(NROW,2).EQ.0
	IFNL=MOD(NSLICE,2).EQ.0
	NSC=NSAM/2+1
C
C	DO  1  K=1,NSLICE
C	DO  1  J=1,NROW
C	NR=J+(K-1)*NROW
C1	CALL  REDLIN(LUN1,Q(1,J,K),NSAM,NR)
C	INV=+1
C	CALL  FMRS_3(Q,NSAM,NROW,NSLICE,INV)
C
	SCL=2.0/FLOAT(NSAM)/FLOAT(NROW)/FLOAT(NSLICE)
	DO    K=1,NSLICE
	DO    J=1,NROW
	DO    I=NNNN-1,1,-2
	Q(NNNN-1-(NNNN-1-I)/2,J,K)=
     &		SCL*SQRT(Q(I+1,J,K)*Q(I+1,J,K)+Q(I,J,K)*Q(I,J,K))
        ENDDO
   	ENDDO
  	ENDDO
C
	DO    K=1,NSLICE
	DO    J=1,NROW/2
	JJ=J+NROW/2+MOD(NROW,2)
	DO    I=NSC,NNNN-1
	TEMP=Q(I,J,K)
	Q(I,J,K)=Q(I,JJ,K)
	Q(I,JJ,K)=TEMP
	ENDDO
	ENDDO
	ENDDO
C
	IF(.NOT.IFND)  THEN
	DO    K=1,NSLICE
	DO    I=NSC,NNNN-1
	TEMP=Q(I,NROW/2+1,K)
	DO    J=NROW/2+1,NROW-1
	Q(I,J,K)=Q(I,J+1,K)
	ENDDO
	Q(I,NROW,K)=TEMP
	ENDDO
	ENDDO
	ENDIF	
C
	DO    K=1,NSLICE/2
	KK=K+NSLICE/2+MOD(NSLICE,2)
	DO    J=1,NROW
	DO    I=NSC,NNNN-1
	TEMP=Q(I,J,K)
	Q(I,J,K)=Q(I,J,KK)
	Q(I,J,KK)=TEMP
	ENDDO
	ENDDO
	ENDDO
C
	IF(.NOT.IFNL)  THEN
	DO    J=1,NROW
	DO    I=NSC,NNNN-1
	TEMP=Q(I,J,NSLICE/2+1)
	DO    K=NSLICE/2+1,NSLICE-1
	Q(I,J,K)=Q(I,J,K+1)
	ENDDO
	Q(I,J,NSLICE)=TEMP
	ENDDO
	ENDDO
	ENDIF	
C
	NSC=NNNN/2-1
	NSL=NSLICE/2
	IF(IFND)  THEN
	IF(IFNL)  THEN
	KB=2
	DO    I=1,NSC
	II=NNNN-I
	Q(I,1,1)=Q(II,1,1)
	ENDDO
	ELSE
	KB=1
	ENDIF
	JB=2
	DO    K=KB,NSLICE
	KK=NSLICE-K+KB
	DO    I=1,NSC
	II=NNNN-I
	Q(I,1,K)=Q(II,1,KK)
	ENDDO
	ENDDO
	ELSE
	JB=1
	ENDIF
	IF(IFNL)  THEN
	KB=2
	DO    J=JB,NROW
	JJ=NROW-J+JB
	DO    I=1,NSC
	II=NNNN-I
	Q(I,J,1)=Q(II,JJ,1)	
	ENDDO
	ENDDO
	ELSE
	KB=1
	ENDIF
	DO    K=KB,NSLICE
	KK=NSLICE-K+KB
	DO    J=JB,NROW
	JJ=NROW-J+JB
	DO    I=1,NSC
	II=NNNN-I
	Q(I,J,K)=Q(II,JJ,KK)
	ENDDO
	ENDDO
	ENDDO
C
	IF(MODE.EQ.'L')  CALL  AL10(Q,NNNN*NROW*NSLICE)
C
C         IF(MODE.NE.'L')  Q(NSAM/2+1,NROW/1+1,NSLICE/2+1)=0.0
C
C	DO  3  K=1,NSLICE
C	DO  3  J=1,NROW
C	NR=J+(K-1)*NROW
C3	CALL  WRTLIN(LUN2,Q(1,J,K),NSAM,NR)
	END
