        SUBROUTINE QALI(MAXMEM,MODE)
c  3D orientation search  02/14/9d
c     rotation matrix corrected
c     Rotation around arbitrary point MODE='A'
        INCLUDE 'CMBLOCK.INC'
        COMMON  DUMMY(80),BUF(1024),Q(1)
        CHARACTER*80  FILNAM
        CHARACTER*1  NULL,MODE
        COMMON  /DIMSPEC/  NSM,NRM,NLM,KLX,KNX,R,L1,L2,L3,L4
     &				,KLY,KNY,KLZ,KNZ
        COMMON  /PARM/  NT,PIT(4)
        DATA  LUN1,LUN2/77,78/
CNO_SAVE
C
C  ASK FOR DATA FILE
C
        NT=NOUT
        NULL=CHAR(0)
      CALL FILERD(FILNAM,NLETI,NULL,'Reference 3D',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 5
        CALL  OPENFB(BUF,FILNAM,LUN1,NSAM,NROW,'O',NF,NSLICE)
      GOTO (130,110),NF
110   IF(IFORM.NE.3
     &  .OR.(.NOT.(NSAM.EQ.NROW .AND. NROW.EQ.NSLICE))
     &    )  THEN
        CALL  ERRT(1,'OR 3Q ',NE)
        GOTO  5
        ENDIF
        IF(2*NSAM*NROW*NSLICE.GT.MAXMEM)  THEN
        CALL  ERRT(6,'OR 3Q  ',NE)
        GOTO  5
        ENDIF
      CALL FILERD(FILNAM,NLETI,NULL,'Second',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 5
        CALL  OPENFB(BUF,FILNAM,LUN2,NSM,NRW,'O',NF,NSL)
      GOTO (130,210),NF
210     IF(NSAM.NE.NSM.OR.NROW.NE.NRW.OR.NSLICE.NE.NSL)  THEN
        CALL  ERRT(1,'OR 3Q ',NE)
        GOTO 5
        ENDIF
        CALL  RDPRMI(NRAD,NDUMP,NLOOP,ILOOP,'Radius of the mask')
        R=NRAD
	IF(MODE.EQ.'A')  THEN
        CALL  RDPRMI(NX,NY,NLOOP,ILOOP,'Center of rotation NX, NY')
        CALL  RDPRMI(NZ,NDUMP,NLOOP,ILOOP,'Center of rotation NZ')
	ENDIF
        WRITE(NOUT,*) ' Initial Eulerian angles'
        CALL  RDPRM2(PIT(1),PIT(2),NLOOP,ILOOP,'Phi, Theta')
        CALL  RDPRM(PIT(3),NLOOP,ILOOP,'Psi')
        L1=1104+1
        L2=L1+NSAM*NROW*NSLICE
        MEMTOT=L2+NSAM*NROW*NSLICE
C
        WRITE (NDAT,2500)  MAXMEM , MEMTOT
        IF (MEMTOT .LE. MAXMEM)  THEN
        NSM=NSAM
        NRM=NROW
        NLM=NSLICE
	IF(MODE.EQ.'A')  THEN
        KLX=-NX+1
        KNX=NSAM-NX
        KLY=-NY+1
        KNY=NROW-NY
        KLZ=-NZ+1
        KNZ=NSLICE-NZ
	ELSE
        KLX=-NSAM/2
        IF(MOD(NSAM,2).EQ.0)  THEN
        KNX=NSAM/2-1
        ELSE
        KNX=-KLX
        ENDIF
        KLY=-NROW/2
        IF(MOD(NROW,2).EQ.0)  THEN
        KNY=NROW/2-1
        ELSE
        KNY=-KLY
        ENDIF
        KLZ=-NSLICE/2
        IF(MOD(NSLICE,2).EQ.0)  THEN
        KNZ=NSLICE/2-1
        ELSE
        KNZ=-KLZ
        ENDIF
	ENDIF
        CALL  QALI_P(LUN1,LUN2,NSAM,NROW,NSLICE,Q(L1),Q(L2))
        IF(NSEL(1).NE.0) PARAM(NSEL(1))=PIT(1)
        IF(NSEL(2).NE.0) PARAM(NSEL(2))=PIT(2)
        IF(NSEL(3).NE.0) PARAM(NSEL(3))=PIT(3)
        IF(NSEL(4).NE.0) PARAM(NSEL(4))=PIT(4)
        WRITE (NDAT,2600)
        RETURN
        ENDIF
5       CLOSE(LUN1)
        CLOSE(LUN2)
        RETURN
130     CALL  ERRT(4,'OR 3Q ',NE)
        GOTO  5
C
 2500 FORMAT (/,'  MEMORY RESERVATION: YOU HAVE',
     #    ' RESERVED ',I8,',  YOU NEED  ',I8 / )
 2600 FORMAT (//' ',80('-')//' ',
     #      'END OF COMPUTATION',//' ',80('-'))
        END
