
	SUBROUTINE QFACT(LUN1,LUN2,LUNQ,MAXDIM)
	INCLUDE 'CMBLOCK.INC'
	PARAMETER  (IMAX=1200,LBUF=4200)
	COMMON DUM(80),BUF2(LBUF),NUMBER(IMAX),Q(1)
        COMMON /COMMUN/ FILNAM,FILA,FILQ,FILPAT,NLET
        CHARACTER *81 FILNAM,FILA,FILQ,FILPAT
        CHARACTER *1  NULL
	INTEGER   HREF,KREF
CNO_SAVE
        NULL=CHAR(0)
C       FIRST GET FOURIER TO DETERMINE DIMENSIONS
        WRITE(NOUT,*) ' FOR IMAGES:'
        CALL FILSEQP(FILPAT,NLET,NUMBER,IMAX,NUMT, 
     $  'FILE PREFIX OR TEMPLATE (EG. PIC****)' ,IRTFLG)
     
	IF(IRTFLG .NE. 0)RETURN

	CALL FILGET(FILPAT,FILNAM,NLET,NUMBER,IRTFLG)
	CALL OPENFB(BUF2,FILNAM,LUN2,NSAM,NROW,'O',NF,NSLICE)
	IF(NF.NE.2)	RETURN
	CLOSE(LUN2)
	IF(NSAM.NE.2**LOG2(NSAM) .OR. NROW.NE.2**LOG2(NROW)) GOTO  950
	IF(IFORM.NE.1)	GO TO 980
	IF(NSLICE.GT.1) GO TO 990
	NROWH=NROW/2
	NSAMH=NSAM/2

c  Memory needed

C   K1   1                         FA          Complex
C   K2   1+(NSAM+2)*NROW           FABS
C   K3                             CBUF        Complex

	K1=1
	K2=K1+(NSAM+2)*NROW
	K3=K2+(NSAM/2+1)*NROW
	K4=K3+(NSAM+2)*NROW
	IF (K3.GT.MAXDIM-LBUF-IMAX)  THEN
           CALL  ERRT(6,'QFACT ',NE)
           RETURN
	ENDIF

	CALL FILERD(FILA,NLETA,NULL,'AVERAGE',IRTFLG)
	IF (IRTFLG .NE. 0) RETURN
	IFORM=1
	CALL OPENFB(BUF2,FILA,LUN1,NSAM,NROW,'UNKNOWN',NF,1)
	IF (NF.NE.2)GO TO 970

	CALL FILERD(FILQ,NLETQ,NULL,'Q FACTOR',IRTFLG)
	IF (IRTFLG .NE. 0) RETURN
	IFORM=1
	CALL OPENFB(BUF2,FILQ,LUNQ,NSAM,NROW,'UNKNOWN',NF,1)
	IF (NF.NE.2)GO TO 970

C ENTER FOURIER INDEX FOR VECTOR LISTING (0,0=NO LISTING)

	CALL RDPRMI(HREF,KREF,NLOOP,ILOOP,'INDICES FOR VECTOR LISTING')

	CALL  QFACT_P(LUN1,LUN2,LUNQ,BUF2,Q(K3),NUMBER,NUMT,Q(K1),Q(K2),
     &		NSAM,NROW,HREF,KREF)
	CLOSE(LUNQ)
	CLOSE(LUN1)
	RETURN

950	IER=10
	GOTO  990

970	IER=2
	GO TO 990

980	IER=4
990	CALL ERRT(IER,'QFACT ',NE)
	END
