 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE rcaver
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: rcaver'
       RETURN
       END
 
#else
 
C++*******************************************************************
C
C $$ RCAVER.FOR
C
C $$ RCAVER:    CUTS OUT A RECTANGULAR IMAGE SECTION AND DETERMINES AVERAGE
C
C       THIS SUBROUTINE CUTS OUT A RECTANGULAR IMAGE SECTION FROM
C       PICTURE 1 WITH A SPECIFIED SIZE NSAM2,NROW2 AT A SPECIFIED
C       LOCATION NSAMW1,NROWW1 AND DETERMINES AVERAGE.
C
C       CALL RCAVER(LUN1,BUF,NSAM,NROW,NSAMW1,NROWW1,NSAM2,NROW2,AVER)
C         LUN1           LOGICAL UNIT NUMBER OF INPUT IMAGE
C         BUF            BUFFER ARRAY OF SIZE NSAM + NSAM2
C         NSAM,NROW      DIMENSIONS OF INPUT PICTURE
C         NSAMW1,NROWW1  COORDINATES, WITH RESPECT TO INPUT IMAGE, OF
C                        TOP LEFT CORNER OF WINDOW
C         NSAM2,NROW2    DIMENSIONS OF WINDOW = DIMENSIONS AREA FOR AVERAGE
C
C PROGRAM BASED ON WINDOW.FOR
C--*******************************************************************


      SUBROUTINE RCAVER(LUN1,NSAM,NROW,NSAMW1,NROWW1,
     1 NSAM2,NROW2,AVER)
      COMMON DUMMY(40),BUF(2900)
      AVER=0
      NROWW2 = NROWW1+NROW2-1
      NS = NROWW1
      NE = NROWW2
      IF(NE.GT.NROW) NE=NROW
      FNRM=(NE-NS+1)*NSAM2
      DO 500 I = NS,NE
      CALL REDLIN(LUN1,BUF,NSAM,I)
      IEND=NSAMW1+NSAM2-1
      DO 501 II=NSAMW1,IEND
      AVER=AVER+BUF(II)
501   CONTINUE
500   CONTINUE
      AVER=AVER/FNRM
      RETURN
      END
 
#endif
 
