
C-----------------------------------------------------------------------
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C
C* MODIFIED VERSION TO INTERFACE WITH SPIDER J.F. 2/5/86
C
C NGRI=LOGICAL UNIT NUMBER OF CLUSTER FILE, SUPPOSED TO BE OPEN
C MAXMEM=BUFFER SIZE AVAILABLE
C
C*-----------------------------------------------------------------

	SUBROUTINE RCLU(NGRI,NGUS,MAXMEM)

	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

	COMMON Q(1)
        COMMON /ENSOR/ LEC, IMP

C       MAXIMUM NUMBER OF FACTORS
	PARAMETER (LFA=16)
        INTEGER   KV(LFA)

	LEC = NIN
	IMP = NDAT

	REWIND NGRI                                                                        
        READ (NGRI)  ICARD, NFAC, NKLA, KFAC, (KV(K), K=1, KFAC)                  
        NK    = 1                                                                 
        NI    = NK + ICARD                                                        
        NPK   = NI + ICARD                                                        
        NGT   = NPK   + NKLA                                                      
        NIV   = NGT   + NKLA * KFAC                                               
        MEM   = NIV   + NKLA                                                      
        CALL RGRI(ICARD, KFAC, NKLA,                                              
     #          Q(NK),Q(NI),Q(NPK),Q(NGT),Q(NIV), NGRI,NGUS)
        CLOSE(NGRI)
	CLOSE(NGUS)

	RETURN
        END                                                                       
