
C                                 LONG FILE NAMES FEB 89 al
C
C J.F. PROGRAM TO TRANSFER CLUSTER COORDINATES TO A DOCUMENT FILE
C

	SUBROUTINE RDCLUS

	INCLUDE 'CMBLOCK.INC' 
        COMMON /COMMUN/ CLUST,FILNAM

        CHARACTER *81 CLUST,FILNAM
        CHARACTER     NULL

	INTEGER   NITEM,NFAC,NSAM,NROW,IIII
	COMMON DLIST(1)

        NULL=CHAR(0)

	CLUST = 'IMC***'// NULL

	LUNS=14

	CALL RDPRMI(NCODE,NFACT,NLOOP,ILOOP,
     &     'CLUSTER FILE CODE, NUMBER OF FACTORS$')

        NLET = 6
	CALL FILGET(CLUST,FILNAM,NLET,NCODE,IRTFLG)
        IF (IRTFLG .NE.0) RETURN

	CALL FILCAN(FILNAM,NFN,NULL,NULL,FILNAM,DATEXC,IER)
	OPEN(FILE=FILNAM,UNIT=LUNS,STATUS='OLD',FORM='UNFORMATTED')

C READ HEADER
C NITEM -- NUMBER OF IMAGES
C NFAC  -- NUMBER OF FACTORS USED IN THE ANALYSIS
C NSAM, NROW -- NUMBER OF SAMPLES AND ROWS IN THE UNMASKED IMAGE
C
	READ(LUNS)NITEM,NFAC,NSAM,NROW

C CHECK IF NFACT REQUESTED EXCEEDS NFAC SUPPLIED

	IF(NFACT.GT.NFAC)THEN
		NFACT=NFAC
		WRITE(NOUT,11)NFAC
11		FORMAT(' *** WARNING: ONLY ',I2,' FACTORS SUPPLIED')
	ENDIF

	NDOC=15
	NLIST=NFACT+1

	DO  I=1,NITEM
           READ(LUNS)(DLIST(K),K=2,NFAC+1),RWGT,DIO,IIII
           DLIST(1)=IIII
C          KEY= IMAGE NUMBER

           CALL SAVD(NDOC,DLIST,NLIST,IRTFLG)
	ENDDO

	CALL SAVDC
	CLOSE(NDOC)
        CLOSE(LUNS)
	RETURN
	END
