	SUBROUTINE  repr2_s(BCKE,BCN,nsam,lcyl,nslice,
     &	nrowl,nrowh,nang,ipcube,nn,PROJ,PRN,iri,LTB,LTBN,aba,inpic)
        INCLUDE 'CMBLOCK.INC' 
	DIMENSION   BCKE(Nsam*nslice*3),BCN(Nsam*nslice)
	dimension   PROJ(NSAM,NANG),PRN(NSAM,NANG)
	dimension  ipcube(5,nn)
	double precision  aba
C
	logical*1    active_min,active_max,endit,dodo,dod
c
	data  IOFF/6/
CNO_SAVE
	CALL  RDPRM2(ALA,aim,NLOOP,ILOOP,'Lambda, Correction limit')
	CALL  RDPRMI(maxit,inter,NLOOP,ILOOP,
     &	'Iteration limit, Number of internal steps')
	CALL  RDPRMI(MODE,idum,NLOOP,ILOOP,'Mode')
	CALL  RDPRM2(tmin,tmax,NLOOP,ILOOP,'Minimum, maximum')
	tmin=tmin-aba
	tmax=tmax-aba
	write(nout,2059) tmin,tmax
2059	format(' Minimum and maximum after average subtraction',/,
     &	2(5x,1pe10.3))
	CALL  RDPRM(t,NLOOP,ILOOP,'Smoothing constant')
	t=amin1(amax1(t,0.0),1.0)
c
	if(.not.
     &		(mode.eq.1.or.mode.eq.3.or.mode.eq.6.or.mode.eq.8)) then
	if(maxit.gt.1)  then
	inter=inter*maxit
	maxit=1
	dodo=.false.
	write(nout,6066)  inter
6066	format(/
     &	' Since no smoothing was requested iteration limit was set to 1'
     &  ,/,' and number of internal set was set to =',i5)
	else
	dodo=.true.
	endif
	endif
c
	nmat=nsam*nslice
		active_min=.false.
		active_max=.false.
		sqold=1.e23
		endit=.false.
                ITER = 0
999             ITER = ITER + 1
                   WRITE(NOUT,971) ITER
971                FORMAT(/' ITERATION ',I5)
c
	sq=0.0
	do    ls=nrowl,nrowh
	if(ITER.gt.1)  then
	do    irc=1,nslice
	irb=1+(irc-1)*nsam
	call  redlin(inpic,bcke(irb),nsam,(irc-1)*lcyl+ls-nrowl+1)
	enddo
	else
	do    i=1,nmat
	  bcke(i)=0.0
	enddo
	endif
c
c  get the projection data
c
	do    j=1,nang
	  call  redlin(IOFF+j,proj(1,j),nsam,ls)
	enddo
c
c remove average
c
	do    j=1,nang
	do    i=1,nsam
	  proj(i,j)=proj(i,j)-aba
	enddo
	enddo
		sqint=1.0e23
		do    itr=1,inter
		if(ITER.eq.1.and.itr.eq.1)  then
c$doacross  local(i,j)
		do    j=1,nang
		do    i=1,nsam
		  prn(i,j)=proj(i,j)
		enddo
		enddo
		goto  981
		endif
c   bcke -> prn
	call  prjs2
	if(dodo) then
	dod=itr.eq.inter
	else
	dod=.true.
	endif
c  
	if(dod)  then
			call  fmin_s(prn,ltbn,gmin)
			call  fmax_s(prn,ltbn,gmax)
		write(nout,2062) ls,gmin,gmax
2062	format(' Min Max in slice #',i3,' =',2(1x,1pe10.3) )
	endif
	if((mode.eq.2.or.mode.eq.3.or.mode.eq.7.or.mode.eq.8)
     &		.and. .not.active_min .and. dod)  then
			if(gmin.lt.tmin)  then
			call  bmin_s(bcke,nmat,ipcube,nn,bmin)
			write(nout,2051)  bmin
2051	format(' Min constraint activated, value in 3D =',1pe10.3)
			active_min=.true.
			endif
	endif
c
	if((mode.eq.5.or.mode.eq.6.or.mode.eq.7.or.mode.eq.8) 
     &		.and. .not.active_max .and. dod)  then
			if(gmax.gt.tmax)  then
			call  bmax_s(bcke,nmat,ipcube,nn,bmax)
			write(nout,2052)  bmax
2052	format(' Max constraint activated, value in 3D =',1pe10.3)
			active_max=.true.
			endif
	endif
c                         
c$doacross  local(i,j)
		do    j=1,nang
		do    i=1,nsam
		  prn(i,j)=proj(i,j)-prn(i,j)
		enddo
		enddo
c
981		sqt=0.0
c$doacross  local(i,j),reduction(sqt)
		do    j=1,nang
		do    i=1,nsam
		  sqt=sqt+prn(i,j)*prn(i,j)
		enddo
		enddo
		if(sqt.gt.sqint)  then
		endit=.true.
		goto  5078
		else
		sqint=sqt
		endif
		if(dod)  sq=sq+sqt
c
c   prn  -> bcn
	call  bprj2
c
		call  docorr3_s(bcke,bcn,nmat,ipcube,nn,ala,sbq)
 	write(nout,*) '  Squared correction of the structure ',ls,itr,sbq
		if(mode.eq.0)  goto  821
		if(active_min)  call   domin3_s(bcke,nmat,ipcube,nn,bmin)
		if(active_max)  call   domax3_s(bcke,nmat,ipcube,nn,bmax)
821		continue
c
		enddo
c
5078	continue
	do    irc=1,nslice
	irb=1+(irc-1)*nsam
	call  wrtlin(inpic,bcke(irb),nsam,(irc-1)*lcyl+ls-nrowl+1)
	enddo
c
	enddo
c
	write(nout,*)  '  Squared discrepancies between projections ',sq
	if(mode.eq.1.or.mode.eq.3.or.mode.eq.6.or.mode.eq.8) then
		do    ls=nrowl+1,nrowh-1
			if(ls.eq.nrowl+1)  then
			do    irc=1,nslice
			irb=1+(irc-1)*nsam
	call  redlin(inpic,bcke(irb),nsam,(irc-1)*lcyl+ls-1-nrowl+1)
			enddo
			do    irc=1,nslice
			irb=1+(irc-1)*nsam+nsam*nslice
	call  redlin(inpic,bcke(irb),nsam,(irc-1)*lcyl+ls-nrowl+1)
			enddo
			endif
		do    irc=1,nslice
		irb=1+(irc-1)*nsam+2*nsam*nslice
	call  redlin(inpic,bcke(irb),nsam,(irc-1)*lcyl+ls+1-nrowl+1)
		enddo
	call   smt3(t,bcke,bcn,nsam,nslice,ipcube,nn)
		do    irc=1,nslice
		irb=1+(irc-1)*nsam
	call  wrtlin(inpic,bcn(irb),nsam,(irc-1)*lcyl+ls-nrowl+1)
		enddo
	call  cppb(bcke(nsam*nslice+1),bcke,2*nsam*nslice)
	enddo
	endif
	if(endit)  return
	if(sq.gt.aim .and. iter.lt.maxit)  then
	if(iter.eq.1)  then
	goto  999
	elseif(sq.lt.sqold)  then
	sqold=sq
	goto  999
	endif
	endif
C
        END         
