C++************************************************************************
C
C $$ RT3L.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ RT3L.FOR
C
C
      SUBROUTINE ROTAL3(MAXMEM)
      INCLUDE 'CMBLOCK.INC' 
      DIMENSION Q(1)
      POINTER   (IPQ,Q) 
      LOGICAL  RUNTIME
      COMMON   BUF(1024),X1(3),X2(3),KAF(1)
 
      CHARACTER *81 FILNAM
      CHARACTER *1  NULL
	DATA  LUN1,LUN2/8,9/
CNO_SAVE

	NULL=CHAR(0)
	
C  3-D  ROTATION
      CALL FILERD(FILNAM,NLETI,NULL,'INPUT',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 5
      CALL OPENFB(BUF,FILNAM,LUN1,NSAM,NROW,'O',NF,NSLICE)
      GOTO (130,110),NF
110   IF(IFORM.NE.3)  GOTO 145
      MEMWANT=NSAM*(NROW*NSLICE+1)
      CALL CHKMEM( MEMWANT, KAF, MAXMEM-(1030), 
     &	    RUNTIME,IPQ,IRTFLG)
      IF(IRTFLG.NE.0) THEN 
         CALL ERRT(6,'RT 3A ',NE)
         GOTO  5
         ENDIF
      CALL FILERD(FILNAM,NLETO,NULL,'OUTPUT',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 4
      CALL OPENFB(BUF,FILNAM,LUN2,NSAM,NROW,'UNKNOWN',NF,NSLICE)
      GOTO (130,951),NF
C
951	CONTINUE
	CALL  RDPRM(ALPHA,NLOOP,ILOOP,'Alpha')
	CALL  RDPRM2(X1(1),X1(2),NLOOP,ILOOP,
     &	'First point defining rotation axis X, Y')
	CALL  RDPRM(X1(3),NLOOP,ILOOP,
     &	'First point defining rotation axis Z')
	CALL  RDPRM2(X2(1),X2(2),NLOOP,ILOOP,
     &	'Second point defining rotation axis X, Y')
	CALL  RDPRM(X2(3),NLOOP,ILOOP,
     &	'Second point defining rotation axis Z')
	DO    J=1,NROW*NSLICE
  	CALL  REDLIN(LUN1,Q(1+(J-1)*NSAM),NSAM,J)
	ENDDO
	KK=1+NSAM*NROW*NSLICE
C
	CALL  ROTL3
     &	(LUN2,Q,Q(KK),NSAM,NROW,NSLICE,X1,X2,ALPHA)
4	CONTINUE 
      if (runtime) CALL ALLOCIT(0,RUNTIME,IPQ,'RT 3L',IRTFLG) 
C
5       CLOSE(LUN1)
	CLOSE(LUN2)
	RETURN
130   CALL ERRT(4,'RT 3L ',NE)
      GOTO 5
145   CALL ERRT(2,'RT 3L ',NE)
      GOTO 5
        END
