C++************************************************************************
C
C $$ ROUT.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ ROUT.FOR
C
         SUBROUTINE  ROUT(NOUT,NDOC,OPT,PEAK,NPC,RPC,NCTR,ML,NTAB)
         DIMENSION  NPC(3,ML),RPC(3,ML),PEAK(ML),NCTR(3)
         CHARACTER*1 OPT
         DIMENSION    DLIST(9)
CNO_SAVE
         WRITE(NOUT,299)
299      FORMAT(/' NO ',' NSAM NROW  NSL ','  NX   NY   NZ ',
     &   'C.of.g.: X     Y     Z    ',
     &   '  VALUE    RATIO')
         RTA=PEAK(NTAB)
         IF(RTA.EQ.0.0)  RTA=1.0
         DO  N=1,ML
         DO  M=1,3
         NPC(M,N)=NPC(M,N)-NCTR(M)
         RPC(M,N)=RPC(M,N)-NCTR(M)
         ENDDO
         WRITE(NOUT,701)
     &   N,(NPC(M,N)+NCTR(M),M=1,3),
     &   (NPC(M,N),M=1,3),(RPC(M,N),M=1,3),PEAK(N),PEAK(N)/RTA
701      FORMAT(1x,i3,6i5,3(1x,f8.2),2(1x,g9.2))
         IF (OPT .EQ. 'D') THEN
         DLIST(1) = N
         DLIST(2) = NPC(1,N)
         DLIST(3) = NPC(2,N)
         DLIST(4) = NPC(3,N)
         DLIST(5) = RPC(1,N)
         DLIST(6) = RPC(2,N)
         DLIST(7) = RPC(3,N)
         DLIST(8) = PEAK(N)
         DLIST(9) = PEAK(N)/RTA
         CALL SAVD(NDOC,DLIST,9,IRTFLG)
         ENDIF
         ENDDO
         WRITE(NOUT,*)
         CALL  SAVDC
         CLOSE(NDOC)
         END
