	SUBROUTINE  RPRQ(N,B,CUBE,IPCUBE,NN,PHI,THETA,PSI,DM,RI)
	DIMENSION  B(N,N),CUBE(N*N*N)
	INTEGER   IPCUBE(5,NN)
	DOUBLE PRECISION  CPHI,SPHI,CTHE,STHE,CPSI,SPSI
 	DIMENSION  DM(9)
	COMMON /PAR/  LDP,NM,LDPNM
CNO_SAVE
C
C IPCUBE: 1 - beginning
C         2 - end
C         3 - ix
C         4 - iy
C         5 - iz
C
	R=RI*RI
C
	CPHI=DCOSD(DBLE(PHI))
	SPHI=DSIND(DBLE(PHI))
	CTHE=DCOSD(DBLE(THETA))
	STHE=DSIND(DBLE(THETA))
	CPSI=DCOSD(DBLE(PSI))
	SPSI=DSIND(DBLE(PSI))
C
	DM(1)=CPHI*CTHE*CPSI-SPHI*SPSI
	DM(2)=SPHI*CTHE*CPSI+CPHI*SPSI
	DM(3)=-STHE*CPSI
	DM(4)=-CPHI*CTHE*SPSI-SPHI*CPSI
	DM(5)=-SPHI*CTHE*SPSI+CPHI*CPSI
	DM(6)=STHE*SPSI
        DM(7)=STHE*CPHI
        DM(8)=STHE*SPHI
        DM(9)=CTHE     
C
c$doacross local(i,j,xb,yb,xbb,ybb,iqx,iqy,dipx,dipy)
	DO    I=1,NN
	XB=(IPCUBE(3,I)-LDP)*DM(1)+(IPCUBE(4,I)-LDP)*DM(2)+
     &	  (IPCUBE(5,I)-LDP)*DM(3)
	YB=(IPCUBE(3,I)-LDP)*DM(4)+(IPCUBE(4,I)-LDP)*DM(5)+
     &	  (IPCUBE(5,I)-LDP)*DM(6)
	DO    J=IPCUBE(1,I),IPCUBE(2,I)
C
	XBB=(J-IPCUBE(1,I))*DM(1)+XB
	IQX=IFIX(XBB+FLOAT(LDPNM))
	IF(IQX.LT.1 .OR. IQX.GE.N)  THEN
	PRINT  *,'  IQNX out of range - reduce the radius!'
	STOP
	ENDIF
	YBB=(J-IPCUBE(1,I))*DM(4)+YB
	IQY=IFIX(YBB+FLOAT(LDPNM))
	IF(IQY.LT.1 .OR. IQY.GE.N)  THEN
	PRINT  *,'  IQNY out of range - reduce the radius!'
	STOP
	ENDIF
	DIPX=XBB+LDPNM-IQX
	DIPY=YBB+LDPNM-IQY

	CUBE(J)=CUBE(J)
c     1                 +(1.0-DIPX)*(1.0-DIPY)*B(MAP(IQX,IQY))
c     2                 +     DIPX *(1.0-DIPY)*B(MAP(IQX+1,IQY))
c     3                 +(1.0-DIPX)*     DIPY *B(MAP(IQX,IQY+1))
c     4                 +     DIPX *     DIPY *B(MAP(IQX+1,IQY+1))
C faster version :
     1	   +B(IQX,IQY)+DIPY*(B(IQX,IQY+1)-B(IQX,IQY))
     2	   +DIPX*(B(IQX+1,IQY)-B(IQX,IQY)
     3		+DIPY*(B(IQX+1,IQY+1)-B(IQX+1,IQY)
     4		-B(IQX,IQY+1)+B(IQX,IQY)))
C
	ENDDO
	ENDDO
c	XB=XB+DM(1)
c1	YB=YB+DM(4)
	END
