C++************************************************************************
C
C $$ SAQB_F.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ SAQB_F.FOR
C
         SUBROUTINE  SAQB_F(BUF,LSD,NSAM,NROW,NIMA,NGRP,JACUP,
     &   CKOT,SHIFT,ENE,A,B,C,D,X,DIST,CNEW)
         PARAMETER  (NLIST=7)
         INCLUDE 'CMBLOCK.INC'
         DIMENSION  X(LSD,NROW,NIMA),CNEW(LSD,NROW)
         DIMENSION  A(LSD,NROW),B(LSD,NROW),C(LSD,NROW),D(LSD,NROW)
         DOUBLE PRECISION  SOLD,SNEW,EAV,ENE(NIMA),ENFR_2
         LOGICAL    CKOT(NIMA)
         DIMENSION  DLIST(NLIST),BUF(1024)
         DIMENSION  DIST(NIMA),SHIFT(2,NIMA)
         COMMON  /FISPEC/  FINPAT,NLET,FINPIC,DOCFIL,NLETI
         CHARACTER*80  FINPAT,DOCFIL,FINPIC
         LOGICAL*1  CH_POS
         CHARACTER*8  ZEIT
         CHARACTER*1  NULL
         DATA  IOUTMP/77/
         DATA  INPIC/77/,NDOC/55/,NDOUT/56/
CNO_SAVE
	NULL=CHAR(0)
C
         NSNR=LSD*NROW
         SOLD=8.0D0*DATAN(1.0D0)/360.0D0
         REWIND NDOC
         K1=1
         KT1=1
         KT2=1
         IMI=0
778      LERR=-1
         CALL  UNSAV(DOCFIL,KT1,NDOC,K1,DLIST,4,LERR,KT2)
         IF(LERR.NE.0)  GOTO  788
         K1=K1+1
         IF(IFIX(DLIST(4)).NE.NGRP)  GOTO  778
         IMI=IMI+1
C     AN(IMI)=DLIST(2)
         L=DLIST(1)
         CALL  FILGET(FINPAT,FINPIC,NLET,L,INTFLAG)
         CALL  OPENFB(BUF,FINPIC,INPIC,NSAMT,NROWT,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,*)  ' FILE NOT FOUND:',FINPIC
         RETURN
         ENDIF
         DO    K2=1,NROW
           CALL  REDLIN(INPIC,A(1,K2),NSAM,K2)
	 ENDDO
         CLOSE(INPIC)
         CALL  RTQ_Q(A,X(1,1,IMI),LSD,NSAM,NROW,DLIST(2))
         INS=1
         CALL  FMRS_2(X(1,1,IMI),NSAM,NROW,INS)
         IF(INS.EQ.0)  THEN
		CALL  ERRT(38,'AP SA',NE)
         RETURN
         ENDIF
         GOTO  778
788      CONTINUE
C
c$doacross local(imi)
         DO    IMI=1,NIMA
           ENE(IMI)=ENFR_2(X(1,1,IMI),LSD,NSAM,NROW)
	 ENDDO
C
C  Build first average
C
C
         CALL  TIME(ZEIT)
         ISEED=MOD(ICHAR(ZEIT(4:4))+100*ICHAR(ZEIT(5:5))
     &   +1000*ICHAR(ZEIT(7:7))+10000*ICHAR(ZEIT(8:8)),340189)
C
C  Two estimation of initial average are used
C  Only one !!!  11/06/91
C
         DO    ICR=1,1
C
C  DIST  is used here for the random choosing of images
C
c$doacross local(imi)
         DO    IMI=1,NIMA
           DIST(IMI)=0.0
	 ENDDO
         IMI=MIN0(NIMA,MAX0(1,INT(RAND_P(ISEED)*NIMA+0.5)))
C
         DIST(IMI)=1.0
         CKOT(IMI)=.FALSE.
         SHIFT(1,IMI)=0.0
         SHIFT(2,IMI)=0.0
         CALL  COP(X(1,1,IMI),C,NSNR)
C
         DO    KTN=2,NIMA
C
804      M=MIN0(NIMA,MAX0(1,INT(RAND_P(ISEED)*(NIMA-KTN+1)+0.5)))
         IMI=0
         DO  809  I=1,NIMA
         IF(DIST(I).EQ.1.0)  GOTO  809
         IMI=IMI+1
         IF(IMI.EQ.M)  GOTO  810
809      CONTINUE
         GOTO  804
810      IMI=I
         DIST(IMI)=1.0
C
         CALL  CCRS_2R(C,X(1,1,IMI),D,LSD/2,NSAM,NROW)
         CALL  FINDMX(D,LSD,NSAM,NROW,CMX1,SX1,SY1,JACUP)
C
         SHIFT(1,IMI)=SX1
         SHIFT(2,IMI)=SY1
         CALL  SHFC_2(X(1,1,IMI),A,LSD/2,NSAM,NROW,SX1,SY1)
         CALL  UPDTF(C,A,NSNR,KTN)
	 ENDDO
         SOLD=ENFR_2(C,LSD,NSAM,NROW)
         WRITE(NOUT,2055)  ICR,SOLD
2055     FORMAT('  Initial estimation #',I1,
     &   '   Squared sum=',1PE12.5)
C     WRITE(NOUT,2001)  (SHIFT(1,J),SHIFT(2,J),J=1,NIMA)
2001     FORMAT(4(2X,2(1X,F8.3)))
C
         IF(ICR.EQ.1)  THEN
	 CALL  COP(C,CNEW,NSNR)
         ELSE
         CALL  CCRS_2R(C,CNEW,D,LSD/2,NSAM,NROW)
         CALL  FINDMX(D,LSD,NSAM,NROW,CMX1,SX1,SY1,JACUP)
         CALL  SHFM_2(CNEW,LSD/2,NSAM,NROW,SX1,SY1)
         CALL  UPDTF(C,CNEW,NSNR,2)
         SOLD=ENFR_2(C,LSD,NSAM,NROW)
         WRITE(NOUT,2065)  SOLD
2065     FORMAT('  Initial average.  Squared sum=',1PE12.5)
c$doacross local(imi)
         DO    IMI=1,NIMA
         SHIFT(1,IMI)=0.0
         SHIFT(2,IMI)=0.0
	 ENDDO
         ENDIF
	 ENDDO
C
C  Iterations to get better approximation
C
         ITER=0
901      CONTINUE
         ITER=ITER+1
         CH_POS=.FALSE.
C
C
         DO    IMI=1,NIMA
C Subtract from the average ...
         CALL  SHFC_2
     &   (X(1,1,IMI),B,LSD/2,NSAM,NROW,SHIFT(1,IMI),SHIFT(2,IMI))
         CALL  SUBAF(C,B,A,NSNR,NIMA)
C
         CALL  CCRS_2R(A,X(1,1,IMI),D,LSD/2,NSAM,NROW)
         CALL  FINDMX(D,LSD,NSAM,NROW,CMX1,SX1,SY1,JACUP)
C
         IF(SHIFT(1,IMI).NE.SX1.OR.SHIFT(2,IMI).NE.SY1) THEN
         CH_POS=.TRUE.
         SHIFT(1,IMI)=SX1
         SHIFT(2,IMI)=SY1
         CALL  SHFC_2(X(1,1,IMI),B,LSD/2,NSAM,NROW,SX1,SY1)
         ENDIF
         CALL  UPDTF(CNEW,B,NSNR,IMI)
	 ENDDO
         SNEW=ENFR_2(CNEW,LSD,NSAM,NROW)
         WRITE(NOUT,2066)  ITER,SNEW
2066     FORMAT('  Iteration #',I4,
     &   '   Squared sum=',1PE12.5)
         IF(SNEW.GE.SOLD.AND.CH_POS)  THEN
         CALL  COP(CNEW,C,NSNR)
         SOLD=SNEW
         GOTO  901
         ENDIF
C
         WRITE(NOUT,2001)  (SHIFT(1,J),SHIFT(2,J),J=1,NIMA)
C
C
         REWIND NDOC
         K1=1
         KT1=1
         KT2=1
         NIM=0
978      LERR=-1
         CALL  UNSAV(DOCFIL,KT1,NDOC,K1,DLIST,4,LERR,KT2)
         IF(LERR.NE.0)  GOTO  988
         K1=K1+1
         IF(IFIX(DLIST(4)).NE.NGRP)  GOTO  978
         NIM=NIM+1
         DO    I=5,2,-1
           DLIST(I)=DLIST(I-1)
	 ENDDO
C Calculate distances ...
         CALL  SHFC_2
     &   (X(1,1,NIM),B,LSD/2,NSAM,NROW,SHIFT(1,NIM),SHIFT(2,NIM))
         CALL  SUBAF(C,B,A,NSNR,NIMA)
C
         CALL  CCRS_2R(A,X(1,1,NIM),D,LSD/2,NSAM,NROW)
         CALL  FINDMX(D,LSD,NSAM,NROW,CMX1,SX1,SY1,JACUP)
         EAV=ENFR_2(A,LSD,NSAM,NROW)
         SNEW=EAV+ENE(NIM)-2*CMX1
C
         DLIST(1)=NIM
         DLIST(5)=SHIFT(1,NIM)
         DLIST(6)=SHIFT(2,NIM)
         DLIST(7)=SNEW
         CALL  SAVD(NDOUT,DLIST,NLIST,IRTFLG)
         GOTO  978
988      CALL  SAVDC
         CLOSE(NDOUT)
         END
