
C *NAME* = SCLASSY.FOR                 31-JAN-86      13:23:03 
C                                      LONG FILE NAMES JAN 89 al
C----------------------------------=*=----------------------------------        
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*---------------------------------------------------------------------*        
C*                          C L A S S Y                                *        
C*         PERFORMS IN A FIRST STEP AN AUTOMATIC CLUSTERING OF THE     *        
C*         OBJECTS BY AGGREGATION AROUND MOBILE CENTERS AND IN A SECOND*        
C*         STEP, A HIERARCHIC ASCENDENT CLASSIFICATION OF THE GRAVITY  *        
C*         CENTERS OF THE CLUSTERS DETERMINED IN THE FIRST STEP.       *        
C*                                                                     *        
C*WARNING: THIS IS A TEMPLATE PROGRAM FOR DEMONSTRATION AND TESTING.   *        
C*         IT SHOULD BE REWRITTEN TO FIT IN YOUR LOCAL IMAGE PROCESSING*        
C*         SYSTEM.                                                     *        
C*---------------------------------------------------------------------*        

      SUBROUTINE SCLASSY(NBASE,NITER,NCLAS,NKLA,KFAC,
     &           LECA,IMPA,KV,FILIN,FILOU,NGUS,NGRI,MAXMEM)

      COMMON DUMMY(2),Q(1)
      COMMON /ENSOR/ LEC, IMP                                                   

      INTEGER    KV(16)

      CHARACTER *(*) FILIN,FILOU
                                                                               
      DATA LTMP  / 14/    

        LEC=LECA
        IMP=IMPA

C       KLUDGE TO MAKE SURE IMC IS NOT OPEN UPON 2ND CALL TO CA CLA
        CLOSE(NGRI)
        CLOSE(NGUS)
        CLOSE(LTMP)

        OPEN(NGUS,FILE=FILIN,STATUS='OLD',FORM='UNFORMATTED')             
        CALL REW(NGUS, 0)                                                       
        READ (NGUS) NUMIM, NFAC, NOC, NOR                                       

        OPEN(LTMP,STATUS='SCRATCH',FORM='UNFORMATTED')                     
        CALL RDFC(NUMIM, NFAC, KFAC, KV, NACT, Q, NGUS, LTMP)                   
        LUNT = NGUS
        NGUS = LTMP                                                             
        OPEN(NGRI,FILE=FILOU,STATUS='NEW',FORM='UNFORMATTED')             

	MODE=5

        CALL SEMIS(Q, MAXMEM, NGUS, NGRI, MODE,
     #            NACT, NFAC, KFAC, KV, NBASE, NITER, NCLAS, NKLA)

C       LEAVE NGRI AND NGUS OPEN FOR SUBSEQUENT CALL TO RCLU
        CLOSE(LUNT)

        RETURN
        END
