C++************************************************************************
C
C $$ SHFI_2.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ SHFI_2.FOR
C
         SUBROUTINE  SHFI_2(X,OUT,NSAM,NROW,ISHX,ISHY)
         DIMENSION  X(NSAM,NROW),OUT(NSAM,NROW)
         INTEGER  RN2,SN2,RW2,RS2,XI,YI,SHX,SHY,YOLD,XOLD
CNO_SAVE
C
         SHX=MOD(ISHX,NSAM)
         SHY=MOD(ISHY,NROW)
         ICENT=NROW/2+1
         KCENT=NSAM/2+1
         RN2=-NROW/2
         SN2=-NSAM/2
         RW2=-RN2
         RS2=-SN2
         IF(MOD(NSAM,2).EQ.0)  RW2=RW2-1
         IF(MOD(NROW,2).EQ.0)  RS2=RS2-1
c$doacross local(i,k,yi,yold,xi,xold)
         DO    I=1,NROW
         YI=I-ICENT-SHY
         IF(YI.LT.RN2)  YI=MIN0(RW2+YI-RN2+1,RW2)
         IF(YI.GT.RW2)  YI=MAX0(RN2+YI-RW2-1,RN2)
         YOLD=YI+ICENT
         DO    K=1,NSAM
         XI=K-KCENT-SHX
         IF(XI.LT.SN2)  XI=MIN0(RS2+XI-SN2+1,RS2)
         IF(XI.GT.RS2)  XI=MAX0(SN2+XI-RS2-1,SN2)
         XOLD=XI+KCENT
         OUT(K,I)=X(XOLD, YOLD)
	 ENDDO
	 ENDDO
         END
