	SUBROUTINE  SHIFT_PF(X,NNNN,NSAM,NROW,NSLICE,SX,SY,SZ)
C
C  Shift (2)3-D in Fourier space
C  If SX and SY and SZ equal zero then no shift
C
	COMPLEX  X(NNNN,NROW,NSLICE)
	DOUBLE PRECISION  PI2
CNO_SAVE
	IF(SX.EQ.0.0  .AND.  SY.EQ.0.0 .AND.  SZ.EQ.0.0)  RETURN
	PI2=8.0*DATAN(1.0D0)
c$doacross local(i,j,k,arg,argy,argz,iz,iy,ix)
	DO    K=1,NSLICE
	IZ=K-1
	IF(IZ.GT.NSLICE/2)  IZ=IZ-NSLICE
	ARGZ=PI2*SZ*IZ/FLOAT(NSLICE)
	DO    J=1,NROW
	IY=J-1
	IF(IY.GT.NROW/2)  IY=IY-NROW
	ARGY=PI2*SY*IY/FLOAT(NROW)+ARGZ
	DO    I=1,NNNN
	IX=I-1
	ARG=PI2*SX*IX/FLOAT(NSAM)+ARGY
	X(I,J,K)=X(I,J,K)*CMPLX(COS(ARG),SIN(ARG))
	ENDDO
	ENDDO
	ENDDO
	END
