

C++*************************************************************************
C
C $$ SSUPCAS.FOR  -- CREATED AUG 86 
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1986 , DIVISION OF LABORATORIES AND                      *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE DIVISION OF    *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE DIVISION OF LABORATORIES AND RESEARCH			   *
C **************************************************************************
C
C
C $$ SSUPCAS(STRING)
C
C    PURPOSE:  CONVERTS LOWER CASE STRINGS TO UPPER CASE
C
C    PARAMETERS:             STRING     STRING TO BE CONVERTED
C
C    CALLED BY:              SSINP0
C 
C--*************************************************************************

      SUBROUTINE SSUPCAS(STRING)

      CHARACTER *(*) STRING

      DATA IOFF/-32/

      ILEN = LEN(STRING)
      
      DO  I=1,ILEN
        IF (STRING(I:I) .GE. 'a' .AND. STRING(I:I) .LE. 'z') THEN
          STRING(I:I) = CHAR(ICHAR(STRING(I:I)) + IOFF)
        ENDIF
      ENDDO

      RETURN
      END

