#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE tdfrepl
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: tdfrepl'
       RETURN
       END
 
#else
 
       SUBROUTINE TDFREPL(LUN1,LUN2,LUN3)
       parameter (line=2048)
       parameter (linh=1025)
#ifdef SP_UNIX
       INCLUDE 'CMBLOCK.INC'
#else
       INCLUDE 'COMMON1:CMBLOCK.INC'
#endif
       COMMON BUF(line),CA(line),CB(line),CC(line)
       CHARACTER*81 FILN1,FILN2,FILN3
       CHARACTER*1 NULL
       COMPLEX CA,CB,CC
       NULL=CHAR(0)
       CALL FILERD(FILN1,NLET,NULL,'INPUT$',IRTFLG)
       CALL OPENFB(BUF,FILN1,LUN1,NSAM,NROW,'OLD',NF,NSLICE)
       CALL FILERD(FILN2,NLET,NULL,'REFERENCE$',IRTFLG)
       CALL OPENFB(BUF,FILN2,LUN2,NSAM2,NROW2,'OLD',NF,NSLICE)
       IF(NSAM2.NE.NSAM.OR.NROW2.NE.NROW) THEN
       CLOSE (LUN1)
       CLOSE (LUN2)
       WRITE(NOUT,*) '** DIMENSIONS INCONSISTENT **'
       RETURN
       ENDIF 
       CALL FILERD(FILN3,NLET,NULL,'OUTPUT$',IRTFLG)
       CALL OPENFB(BUF,FILN3,LUN3,NSAM2,NROW2,'U',NF,NSLICE)
100    CALL RDPRMI(IOPT,IDUM,NLOOP,ILOOP,
     $ '(1)GAUSS,(2)LINEAR$')
       GOTO(100,101,102) IOPT+1
101    CALL RDPRM(HW,NLOOP,ILOOP,'HALFWIDTH$')
       HW=HW**2
       GOTO 200
102    CALL RDPRM(HW,NLOOP,ILOOP,'RADIUS$')
       RAD=HW*NSAM
200    CONTINUE       
       NS2=NSAM2/2
       NR2=NROW2/2
       XMRAD2=NSAM**2
       YMRAD2=NROW**2
       DO 1 I=1,NS2+1
       CALL RDF_Q(LUN1,CA,NSAM,CA,2*NROW,I)
       CALL RDF_Q(LUN2,CB,NSAM,CB,2*NROW,I)
       IX=I-1
        DO 2 J=1,NROW
        IY=J-1
        IF(IY.GT.NR2) IY=IY-NROW
         GOTO(301,302),IOPT
301      FF= EXP(-( FLOAT(IX*IX)/XMRAD2+FLOAT(IY*IY)/YMRAD2)/HW)
         CC(J)=CA(J)*(1-FF)+FF*CB(J)
         GOTO 2
302      FF=1.-1./RAD*SQRT(FLOAT(IX*IX)+FLOAT(IY*IY))
         IF(FF.LT.0.) FF=0.
         CC(J)=CA(J)*(1-FF)+FF*CB(J)
2        CONTINUE
       CALL RDF_Q(LUN3,CC,NSAM,CC,2*NROW,-I)
1      CONTINUE
       CLOSE(LUN1)
       CLOSE(LUN2)
       CLOSE(LUN3)
       RETURN
       END
 
#endif
 
