C++*************************************************************************
C
C    THRESH.FOR  
C                
C **************************************************************************
C *  COPYRIGHT (C)1985 & 1987, WADSWORTH CENTER FOR LABORATORIES AND       *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    THRESH
C
C    PURPOSE:  TO THRESHOLD AN IMAGE FILE
C
C    CALLED BY:   UTIL2
C
C--********************************************************************

	SUBROUTINE THRESH(LUN1,LUN2,NSAM,NROW,NSLICE)

	COMMON BUF(1)

	INCLUDE 'CMBLOCK.INC'

        CHARACTER   ANS,NULL
	REAL        B(2,2)

	DATA B/0.0,1.0,1.0,0.0/
CNO_SAVE
C       OPT RESETS BATCH MODE  FEB 88 al

        IF (FCHAR(4:4) .EQ. 'M') THEN
           CALL RDPRMC(ANS,NCHAR,.TRUE.,
     &     'BLANK OUT  (A)BOVE OR (B)ELOW THRESHOLD? (A/B)',NULL,IRT)

        ELSE
          CALL RDPRMC(ANS,NCHAR,.TRUE.,
     &   'ALTER (A)BOVE THRESHOLD, (B)ELOW, OR (C) BOTH SIDES (A/B/C)',
     &     NULL,IRT)
        ENDIF
        IF (IRT .NE. 0) RETURN

	IF (ANS .EQ. 'C')  GOTO 200
	CALL RDPRM(THR,NLOOP,ILOOP,'THRESHOLD')
	IF (FCHAR(4:4) .EQ. 'M')  GOTO 5
	IF (ANS .EQ. 'B')  THEN
	   TH2=THR
	   TH1=1.E23
	ELSE
	   TH1=THR
	   TH2=-1.E23
	ENDIF
	GOTO 205


5	ISW=1
	IF (ANS .EQ. 'A') ISW=2
        DO  J=1, NSLICE     
	   DO  I=1,NROW
	      CALL REDLIN(LUN1,BUF,NSAM,(J-1)*NROW+I)
	      DO  K=1,NSAM
	         IF (BUF(K).LT.THR) THEN 
	            BUF(K)=B(1,ISW)
	         ELSE 
	           BUF(K)=B(2,ISW)
	         END IF
	      ENDDO
           CALL WRTLIN(LUN2,BUF,NSAM,(J-1)*NROW+I)
	   ENDDO
	ENDDO
	RETURN


200	CALL RDPRM2(TH1,TH2,NLOOP,ILOOP,'UPPER, LOWER THRESHOLD')
205	FIX1=TH1
	FIX2=TH2
	IF (FCHAR(4:4) .EQ. 'F')  THEN
	   CALL RDPRM(FIX1,NLOOP,ILOOP,'FIXUP DENSITY')
	   FIX2=FIX1
	ENDIF
	DO  J=1,NSLICE
	   DO  I=1,NROW
	      CALL REDLIN(LUN1,BUF,NSAM,(J-1)*NROW+I)
	      DO  K=1,NSAM
	         IF (BUF(K) .GE. TH1)  THEN
	            BUF(K)=FIX1
	         ELSEIF (BUF(K) .LE. TH2)  THEN
	            BUF(K)=FIX2
	         ENDIF
	      ENDDO
	   CALL WRTLIN(LUN2,BUF,NSAM,(J-1)*NROW+I)
	   ENDDO
	ENDDO

	END
