
	SUBROUTINE TILTANG(X0,Y0,XT,YT,NPOINT,THETA,IAREA,B)
C
C   PROGRAM TO CALCULATE THE TILTANGLE BETWEEN TWO IMAGES
C
#ifdef SP_UNIX
        INCLUDE 'CMBLOCK.INC' 
#else
        INCLUDE 'COMMON1:CMBLOCK.INC' 
#endif

        DIMENSION B(1)
        CHARACTER ANS,NULL
	DIMENSION X0(1),Y0(1),XT(1),YT(1)

        NULL = CHAR(0)

        CALL RDPRM(ALIM,NLOOP,ILOOP,
     $  'MINIMUM AREA FOR TILTANGLE TRIANGULATION$')

C   CALCULATE TRIANGLES:
	PI=3.14159
        SUM=0.
        IAREA=0
        DO 1 I=1,NPOINT
        DO 2 K=I+1,NPOINT-1
C   AREA IN UNTILTED IMAGE:
        X01=X0(K)-X0(I)
        Y01=Y0(K)-Y0(I)
        X02=X0(K+1)-X0(I)
        Y02=Y0(K+1)-Y0(I)
        A0=ABS(X01*Y02-X02*Y01)        
C       WRITE(NOUT,5) A0
        IF (A0.LT.ALIM) GOTO 2
        XT1=XT(K)-XT(I)
        YT1=YT(K)-YT(I)
        XT2=XT(K+1)-XT(I)
        YT2=YT(K+1)-YT(I)
        AT=ABS(XT1*YT2-XT2*YT1)        
C       WRITE(NOUT,4)AT
        IF (AT.LT.ALIM) GOTO 2
        W=AT/A0
        IF (W.LE.1.) GOTO 10
        WRITE(NOUT,6) I+2,K+2,A0,AT,X0(I),
     $ Y0(I),X0(K),Y0(K),X0(K+1),Y0(K+1),
     $ X01,Y01,X02,Y02,
     $ XT(I),YT(I),XT(K),YT(K),XT(K+1),YT(K+1),
     $ XT1,YT1,XT2,YT2
6       FORMAT(1H ,'WARNING, ARGUMENT OF ARCCOS GT. 1,'
     $ ,' CHECK DOC-FILE KEYS ',I3,' AND ',I3, 
     $ /1X,'AREA IN 0 DEG. IMAGE: ',F12.4,'  AREA IN TILTED IMAGE: '
     $ ,F12.4,/1X,'COORDINATES IN 0 DEG. IMAGE:',/1X,
     $ 3(' X: ',F12.4,' Y: ',F12.4)
     $ /1X,'DIFFERENCE VECTORS:',2(' X: ',F12.4,' Y: ',F12.4)
     $ /1X,'COORDINATES IN TILTED IMAGE:',/1X,
     $ 3(' X: ',F12.4,' Y: ',F12.4)
     $ /1X,'DIFFERENCE VECTORS:',2(' X: ',F12.4,' Y: ',F12.4))
        CALL RDPRMC(ANS,NCHAR,.TRUE.,
     $   'CONTINUE ANYWAY (Y/N)?$',NULL,IRTFLG)
        IF (ANS .NE. 'Y') RETURN
        GOTO 2
10      THETA=ACOS(W)
C       WRITE(NOUT,3) IAREA,(THETA/PI*180.)
3       FORMAT(1H ,I6,'TH TILTANGLE',F12.4)
        IAREA=IAREA+1
        SUM=SUM+THETA
        B(IAREA)=THETA/PI*180.
2       CONTINUE
1       CONTINUE
        THETA=SUM/FLOAT(IAREA)
        THETA=THETA/PI*180.
4       FORMAT(1H ,'AT:',F12.4)
5       FORMAT(1H ,'A0:',F12.4)
        RETURN
        END       

                                      
