
C++*************************************************************************
C
C TITLE.FOR -- CREATED NOV 9 1987            LONG FILE NAMES FEB 89 al
C
C **************************************************************************
C *  AUTHOR:  ARDEAN LEITH                                                 *
C *  PART OF SPIDER - MODULAR IMAGE PROCESSING SYSTEM.                     *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C     TITLE(LUN,NSAM)
C
C     PURPOSE:   ALTER TITLE OF SPIDER FILE
C
C     PARAMETERS:     LUN       LOGICAL UNIT NUMBER OF OPENED FILE
C                     NSAM      FILE RECORD LENGTH 
C
C--*******************************************************************

        SUBROUTINE TITLE(LUN,NSAM)

	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

        COMMON BUF(17000)
 
C       THE 160 CHAR. TITLE NEEDS 40 FLOATING POINT VARIABLES IN BUF
        CHARACTER *160 LLINE
        EQUIVALENCE    (BUF(217),LLINE)

C       READ HEADER INTO BUF
        CALL REDHED(LUN,BUF,17000,NSAM,0,IRTFLG)

C       THE TITLE IS READ INTO CTIT BY A PREVIOUS SEQUENCE


#if defined(__osf__) && defined(osf_ieee)
C       ALPHA OSF (UNIX)
C       NOTE:  ALPHA NUMERICAL DATA (ABCD) WILL BE WRITTEN (DCBA)
        CALL FLIPBYTES(CTIT,160,IRTFLG)
#endif

C       COPY CTIT INTO CORRECT LOCATION OF HEADER BUFFER
        DO  I = 1,160
           LLINE(I:I) = CTIT(I:I)
        ENDDO

C       REPLACE THE HEADER BACK IN THE FILE
        CALL WRTHED(LUN,BUF,NSAM,IRTFLG)

c       LENTIT = lnblnk(LLINE)
c       IF (LENTIT .LE. 0) LENTIT = LEN(LLINE)

c       WRITE(NOUT,90)(LLINE(I:I),I=1,LENTIT)
90      FORMAT(' NEW TITLE: ',40A1,:,/,1X,80A1,:,/,1X,40A1,/)

        RETURN
        END

