C++************************************************************************
C
C $$ TRAFD.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ TRAFD.FOR
C
         SUBROUTINE TRAFD(LUN)
         INCLUDE 'CMBLOCK.INC'
         COMMON B
         COMMON /COMMUN/ FILNAM
         CHARACTER *81 FILNAM
         CHARACTER     NULL,ANS,Y,D,E,S
         REAL          B(512),LAMBDA,KM
         DATA Y/'Y'/,D/'D'/,E/'E'/,S/'S'/,PI/3.14159/
C
CNO_SAVE
         NULL=CHAR(0)
C
         CALL FILERD(FILNAM,NLET,NULL,'OUTPUT',IRTFLG)
         IF (IRTFLG .NE. 0) RETURN
         CALL RDPRM(CS,NLOOP,ILOOP,'CS(MM)')
         CALL RDPRM2(DZ,LAMBDA,NLOOP,ILOOP,
     &   'DEFOCUS(ANGSTROEMS), LAMBDA(ANGSTROEMS)')
         CALL RDPRMI(NSAM,NDUM,NLOOP,ILOOP,'NUMBER OF SP.FREQ.PTS')
         CALL RDPRM(KM,NLOOP,ILOOP,'MAXIMUM SPATIAL FREQUENCY[A-1]')
         CALL RDPRM2(Q,DS,NLOOP,ILOOP,
     &   'SOURCE SIZE[A-1], DEFOCUS SPREAD[A]')
      CALL RDPRM2(DZA,AZZ,NLOOP,ILOOP,'ASTIGMATISM[A], AZIMUTH[DEG]')
         CALL RDPRM2(WGH,ENV,NLOOP,ILOOP,
     &   'Ampl contrast ratio [0-1], Gaussian env halfw [Fou units]')
         ENV=1./ENV**2
         IFORM = 1
         NROW=NSAM
	NSLICE=1
         CALL OPENF(FILNAM,LUN,NSAM,NROW,'UNKNOWN',NF,NSLICE)
         SC=KM/FLOAT(NSAM/2)
         CALL RDPRMC(ANS,NCHAR,.TRUE.,
     &   '(D)IFFRACTOGRAM / (E)NVELOPE / (S)TRAIGHT$',
     &   NULL,IRTFLG)
         IE=0
         IF (ANS.EQ.E)IE=1
         NS1=(NSAM/2+1)
         DO  I=1,NROW
         DO  K=1,NSAM
C
         AK = SQRT(FLOAT(K-NS1)**2 + FLOAT(I-NS1)**2)*SC
         AZ = PI/2.
         IF(K.EQ.NS1) GOTO 5
         AZ=ATAN2(FLOAT(I-NS1),FLOAT(K-NS1))
5        AZR=AZZ*(PI/180.)
         DZZ=DZ+DZA/2*SIN(2*(AZ-AZR))
C
         CALL TFD(B(K),CS,DZZ,LAMBDA,KM,NSAM,Q,DS,IE,AK,WGH,ENV)
         IF(ANS .NE. S) B(K)=B(K)*B(K)
	 ENDDO
12       CALL WRTLIN(LUN,B,NSAM,I)
	 ENDDO
         END
