#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE trinter
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: trinter'
       RETURN
       END
 
#else
 

        SUBROUTINE TRINTER(LUNO,LUNN,
     $  OLDIMX,OLDIMY,OLDIMZ,NEWDIMX,NEWDIMY,NEWDIMZ)
        COMMON BUF(1)
C------------------------------------------------------------------------------
C       SUBROUTINE TO DO A BILINEAR INTERPOLATION USING ONLY
C       THREE POINTS OF A FACET.
C       M.RADERMACHER, JUNE 1984
C       IN PARTS BASED ON SUBROUTINE GENINT, AUTHOR: R.SMITH 1983
C------------------------------------------------------------------------------
        INTEGER OLDIMX,OLDIMY,OLDIMZ,ZCOLD,XCOLD,YCOLD,YLINE,XLINE
        INTEGER YLINEO,XLINEO,YLINE2,XLINE2
CNO_SAVE
        NS1=1
        NS2=OLDIMX+1
        NS3=NS2+OLDIMX
	WRITE(6,100)LUNO,LUNN,OLDIMX,OLDIMY,OLDIMZ,NEWDIMX,NEWDIMY,
     $  NEWDIMZ,NS1,NS2,NS3
100     FORMAT(1H ,11I5)
        FACZ=FLOAT(OLDIMZ)/FLOAT(NEWDIMZ)
        FACX=FLOAT(OLDIMX)/FLOAT(NEWDIMX)
        FACY=FLOAT(OLDIMY)/FLOAT(NEWDIMY)
        DO 1 I=1,NEWDIMZ
        ZCOO=FLOAT(I)*FACZ
        ZCOLD=INT(ZCOO)
        ZDIF=AMOD(ZCOO,1.)
        ZLINE=(ZCOLD-1)*OLDIMY
        DO 2 K=1,NEWDIMY
        YLINEO=YLINE
        YLINEO2=YLINE2
        YCOO=FLOAT(K)*FACY
        YCOLD=INT(YCOO)
        YLINE=ZLINE+YCOLD
        YLINE2=YLINE+1
        IF(YLINE2.GT.(ZLINE+OLDIMY)) YLINE2=YLINE
        IF(YLINE.EQ.ZLINE) YLINE=YLINE2
        YDIF=AMOD(YCOO,1.)
        IF(YLINE.NE.YLINEO) THEN 
            
          IF(YLINE.EQ.YLINEO2) THEN
            
            NS1P=NS1
            NS1=NS2
            NS2=NS1P
            CALL REDLIN(LUNO,BUF(NS2),OLDIMX,YLINE2) 
          ELSE
            CALL REDLIN(LUNO,BUF(NS1),OLDIMX,YLINE)
            CALL REDLIN(LUNO,BUF(NS2),OLDIMX,YLINE2)        
          ENDIF
        ENDIF
        DO 3 L=1,NEWDIMX
        XCOO=FLOAT(L)*FACX
        XCOLD=INT(XCOO)       
C  FIRST SOLVE THE TWODIMENSIONAL PROBLEM:
        XDIF=AMOD(XCOO,1.)
        IC1=NS1+XCOLD
        IC2=IC1+1
        IC3=NS2+XCOLD
        IC4=IC3+1
        Z1=BUF(IC1)
        Z2=BUF(IC2)
        Z3=BUF(IC3)
        Z4=BUF(IC4)
        Z5=Z2-Z1
        Z6=Z4-Z3
        Z7=Z4-Z2
        Z8=Z1-Z3
        IF(ABS(Z1-Z4)-ABS(Z2-Z3).LT.0) GOTO 21
        IF(XDIF+YDIF.GT.1) GOTO 22
        Z=Z1+XDIF*Z5-YDIF*Z8
        GOTO 200
22      Z=Z4+(XDIF-1.)*Z6+(YDIF-1)*Z7
        GOTO 200
21      IF(XDIF.GT.YDIF) GOTO 23
        Z=Z3+Z8*(1-YDIF)+Z6*XDIF
        GOTO 200
23      Z=Z2+Z5*(XDIF-1.)+Z7*YDIF
200     BUF(NS3+L)=Z
3       CONTINUE
C       WRITE(6,100)K
        CALL WRTLIN(LUNN,BUF(NS3),NEWDIMX,K)
2       CONTINUE
1       CONTINUE
        END
 
#endif
 
