
#ifdef SP_SUN4 
 
C   THIS ROUTINE FAILED TO COMPILE ON SUN
 
       SUBROUTINE tvwn1(MAXDIM)
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: tvwn1'
       RETURN
       END
#else 
#ifndef SP_ALWAYS
C   THIS ROUTINE HAS PROBLEMS ?????
 
       SUBROUTINE tvwn1(MAXDIM)
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: tvwn1'
       RETURN
       END
#else

C++************************************************* 6/23/80 ** VAX 9/15/81
C
C  TVWN1.FOR
C                                    LONG FILE NAMES JAN 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C TVWN1:    TV WINDOW WITHOUT THE TV
C
C !!! 9/26/79 : ALL NOISE DISCRIMINATION REMOVED !!!
C !!! THESE STATEMENTS CARRY 'CCC' IN FRONT
C
C      DB:[200,300]TVWN1S.FTN  RECIPROCAL LATTICE SEARCH AND REFINEMENT
C THIS IS A MODIFIED VERSION OF TVWN1: REAL WINDOWING IS LEFT OUT, AND
C NO TV IS NEEDED FOR THE LATTICE INDEXING. POSITIONS OF THREE OR MORE
C REFLECTIONS HAVE TO BE MEASURED BEFORE PROGRAM IS STARTED.
C THE PROGRAM IS ONE OF THE ATTEMPTS TO OVERCOME THE FRUSTRATION OVER
C THE ABSENCE OF TV DISPLAY FOR A PERIOD OF 9 MONTHS. J.FRANK 9/20/79.
C       
C--*******************************************************************

        SUBROUTINE TVWN1(MAXDIM)
        INCLUDE 'CMBLOCK.INC'

C       PEAK ARRAY SIZE
        PARAMETER (NREFLM =  200)

C       WARNING:  MAXF ALSO USES UNLABELED COMMON
        COMMON BUFF(1)

        CHARACTER *80  FILNAM
        CHARACTER      NULL
        REAL           FINT(NREFLM),KX(NREFLM),KY(NREFLM)
        COMPLEX        C(NREFLM),CC
        INTEGER        HIND(NREFLM),KIND(NREFLM)

	DATA     PI/3.14159/,CX/0./,CY/0./

        NULL   = CHAR(0)

        LUN1   = 10
	LUN2   = 8
	LUN3   = 9
        WGT    = 1.0
	IDM    = 0
	IF (FCHAR(4:4) .EQ. 'D') IDM = 1

	WRITE(NDAT,47)
47      FORMAT(' *** WT : AUTOMATIC LATTICE INDEXING. VERSION 2/13/89 ',
     & '***      WEIGHTING USED: AMP'/) 

	CALL FILERD(FILNAM,NLET,NULL,'POWER SPECTRUM',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	CALL OPENF(FILNAM,LUN1,NSAM1,NROW1,'OLD',NF,IDUM)
        CALL PDATES(FILNAM,0)
        WRITE(NDAT,49)
49      FORMAT('+',85X,'= POWER SPECTRUM'/)

	IF (NF .EQ. 1) THEN
           CALL ERRT(4,'TVWN1',NE)
           GOTO 920

        ELSEIF (IFORM .LT. 0) THEN
C         NOT A POWER SPECTRUM FILE
          CALL ERRT(2,'TVWN1',NE)
          GOTO 919
        ENDIF

	CALL FILERD(FILNAM,NLET,NULL,'FOURIER',IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 919

	CALL OPENF (FILNAM,LUN2,NSAM3,NROW3,'OLD',NF,IDUMMY)
        CALL PDATES(FILNAM,0)
        WRITE(NDAT,61)
61      FORMAT('+',85X,'= FOURIER TRANSFORM'/)
        WRITE(NDAT,62)
62      FORMAT('+',60X,' AMPL     PHASE   ENERGY      WEIGHT'/)
	WRITE(NDAT,9132)
9132    FORMAT(6X,' REFL.NO.     H        K     KX COMP.   KY COMP.')

	IF (NF .EQ. 1) THEN
           CALL ERRT(4,'TVWN1',NE)
           GOTO 919

        ELSEIF (IFORM .GE. 0) THEN
C         NOT A FOURIER FILE
          CALL ERRT(2,'TVWN1',NE)
          GOTO 918
        ENDIF

100     CRIT = 1.0
        R    = 100.

C COPY F00 FOR USE IN FILTER FILE
        CALL REDLIN(LUN2,BUFF,NSAM3,1)
	F00 = BUFF(1)

C***************************************************
C BEGINNING OF WINDOW SELECTION LOOP
C***************************************************

150	CALL RDPRMI(IXB,IXB1,NLOOP,ILOOP,'WINDOW SIZES(SEARCH,FILT)')
	IF (IXB1 .EQ. 0) IXB1 = IXB
	IYB = IXB

        NSAMD2 = NSAM1 / 2
        NROWD2 = NROW1 / 2

C       FOURIER MAX SEGMENT
	NREFL = 1
200	CALL RDPRMI(HIND(NREFL),KIND(NREFL),NLOOP,ILOOP,
     &             'LATTICE INDICES(H,K)')
	IF (HIND(NREFL).EQ.0.AND.KIND(NREFL).EQ.0) GOTO 905

	CALL RDPRMI(KXPOS,KYPOS,NLOOP,ILOOP,'FOURIER POSITIONS(KX,KY)')

        KT    = KXPOS
        KXPOS = KYPOS - NROWD2
        KYPOS = KT    - NSAMD2

        KXI   = KXPOS
        KYI   = KYPOS

   	CALL MAXF(LUN1,LUN2, NSAM1,NROW1, NSAM3,NROW3,
     &      IXB,IYB, KXPOS,KYPOS, C(NREFL),FINT(NREFL),IDM,R,CRIT)

	WRITE(NOUT,2099) KXI,KYI, KXPOS,KYPOS
2099	FORMAT('+',15X,'(TRANSFORMED:: ',2I5,')  (EXACT: ',2I5,')')

	KX(NREFL) = KXPOS
	KY(NREFL) = KYPOS
C       WGT = CABS(C(NREFL))*SQRT(FLOAT(KX(NREFL)**2+KY(NREFL)**2))
        WGT = CABS(C(NREFL))
        IF (FINT(NREFL) .LT. 0.0) GOTO 200
        IF (NREFL.EQ.1) CALL LATCEN(IERR,0,,,,,,,,,,,)

        CALL LATCEN(IERR,1,HIND(NREFL),KIND(NREFL),KX(NREFL),
     &        KY(NREFL),WGT,CX,CY,,,,)
        CC  = C(NREFL)
        AMP = CABS(CC)
        PH  = ATAN2(AIMAG(CC),REAL(CC))*180./PI

        WRITE(NDAT,9111)NREFL,HIND(NREFL),KIND(NREFL), KX(NREFL),
     1     KY(NREFL), AMP,PH,FINT(NREFL),WGT
        NREFL = NREFL + 1
	GO TO 200


C*********************************************************
C END OF WINDOW SELECTION LOOP
C*********************************************************


C*********************************************************
C PROG JUMPS HERE  AFTER LAST REFLECTION ENTERED IN
C INTERACTIVE SELECTION
C*********************************************************

905	CONTINUE
911     NREFL=NREFL-1
        CALL LATCEN(IERR,2,NDUM,NDUM,DUM,DUM,WGT,CX,CY,AX,AY,BX,BY)
	IF (IERR .NE. 0) GOTO 917
912     FORMAT(' UNIT VECTORS BASED ON ',I3,' REFLECTIONS'//12X,
     1  'LENGTH     ANGLE     KX COMP.   KY COMP.'/)
C GENERATE ALL LATTICE POSITIONS WITHIN RESOLUTION RANGE
        CALL RDPRMI(NRESOL,NDUM,NLOOP,ILOOP,
     1    'ENTER MAXIMUM RESOLUTION DISTANCE') 
        IF (NRESOL.EQ.0) GOTO 9145

        RES2 = FLOAT(NRESOL)**2
C DETERMINE LIMITING INDEX POSITIONS
        NRUN = 1
        NACC = NREFL
C NRUN = 1 IS THE INTERACTIVE SEARCH, NRUN = 2 THE REFINEMENT RUN
C***********************************************************
C CALCULATE AND PRINT LENGTHS AND ANGLES OF UNIT VECTORS
C***********************************************************
9121    DISTA2 = AX**2 + AY**2
        DISTB2 = BX**2 + BY**2
        DISTA = SQRT(DISTA2)
        DISTB = SQRT(DISTB2)
        IF (AY.NE.0.) PHIA = ATAN2(AX,AY)*180./PI
        IF (AY.EQ.0.) PHIA = SIGN(90.,AX)
        IF (BY.NE.0.) PHIB = ATAN2(BX,BY)*180./PI
        IF (BY.EQ.0.) PHIB = SIGN(90.,BX)

        WRITE(NOUT,912) NACC
        IF (NDAT.NE.NOUT) WRITE(NDAT,912) NACC
        WRITE(NOUT,913) DISTA,PHIA,AX,AY
913     FORMAT(8X,4F10.2)
        IF (NDAT.NE.NOUT) WRITE(NDAT,913) DISTA,PHIA,AX,AY
        WRITE(NOUT,913) DISTB,PHIB,BX,BY
        IF (NDAT.NE.NOUT) WRITE(NDAT,913) DISTB,PHIB,BX,BY
        DPHI = PHIB - PHIA
        WRITE(NOUT,9131) CX,CY,DPHI
        IF (NDAT.NE.NOUT) WRITE(NDAT,9131) CX,CY,DPHI
9131    FORMAT('0ORIGIN AT (',F8.2,',',F8.2,')   DIFF.ANGLE ',F8.2)
        KA1 = 0
        KA2 = FLOAT(NRESOL)/DISTA
        KB1L = -FLOAT(NRESOL)/DISTB
        KB2 = -KB1L
CCC SAVE REFLECTION COUNT OF FIRST RUN
CCC     NPREV = NREFL
        NREFL = 1
C***********************************************************
C NOW CREATE ALL LATTICE POSITIONS WITHIN RESOLUTION RANGE
        IF (NRUN.EQ.1)WRITE(NDAT,9051)
9051    FORMAT('0EXTRAPOLATED RECIPROCAL LATTICE'/)
        IF (NRUN.EQ.2)WRITE(NDAT,9052)
9052    FORMAT('0REFINED RECIPROCAL LATTICE'/)
C***********************************************************
C
        WRITE(NDAT,9132)
        DO  KA = KA1,KA2
          KB1 = KB1L
C         IF (KA.EQ.0) KB1 = 1
          DO 9105 KB = KB1,KB2
            HIND(NREFL) = KA
            KIND(NREFL) = KB
            KX(NREFL) = KA*AX + KB*BX
            KY(NREFL) = KA*AY + KB*BY
            RES = KX(NREFL)**2+KY(NREFL)**2
            IF (RES.LE.RES2) GOTO 9100
            GOTO 9105
9100        IF (KA.EQ.0.AND.KB.EQ.0)GOTO 9105
            WRITE(NDAT,9111)NREFL,KA,KB,KX(NREFL),KY(NREFL)
C           IF (NOUT.NE.NDAT)WRITE(NDAT,9111)NREFL,KA,KB,KX(NREFL),KY(NREFL)
            IF (NRUN.EQ.2.AND.FINT(NREFL).LT.0.) WRITE(NDAT,9098)
9098        FORMAT('+',57X,'*')
9111        FORMAT(1X,3I10,2F10.2,7X,G12.4,F8.2,2G12.4)
            NREFL = NREFL+1
            IF (NREFL.GT.NREFLM) THEN
              CALL ERRT(6,'TVWN1',NE)
              GOTO 917
            ENDIF
9105      CONTINUE
	ENDDO

        IF (NRUN.EQ.2)WRITE(NDAT,9097)
9097    FORMAT(' REFLECTIONS MARKED WITH "*" WERE OMITTED IN THE',
     1  ' REFINEMENT RUN'/)
        NREFL = NREFL-1

        GOTO (9112,9145),NRUN
C CONTINUE HERE FOR REFINEMENT (NRUN=1); SKIP THIS SECTION
C AFTER REFINEMENT IS DONE
9112    CALL LATCEN(IERR,0,,,,,,,,,,,)

C*********************************************************
C REDEFINE WINDOW SIZES IXB,IYB IF NECESSARY
C*********************************************************
        NRUN = 2
        WRITE(NDAT,9133)
9133    FORMAT('0REFLECTION MAXIMA FOUND'/)
        WRITE(NDAT,9132)
        WRITE(NDAT,62)
        NACC = 0
        DO 914 I = 1,NREFL
C POWER SPECTRUM CENTERED AT (NSAM1/2+1,NROW1/2)
C*********************************************************
C HERE NEW TOP LEFT COOS OF WINDOW ARE CALCULATED
C*********************************************************
C !!!! DEBUG !!!!
C         WRITE(NDAT,9999)LUN1,LUN2,NSAM1,NROW1,NSAM3,NROW3,
C	1 IXB,IYB,KX(I),KY(I),C(I),FINT(I)
C9999	  FORMAT(1X,10I6,3G12.2)
	  KXPOS = KX(I)+0.5
	  IF (KX(I).LT.0.)KXPOS=KX(I)-0.5
	  KYPOS = KY(I)+0.5
	  IF (KY(I).LT.0.) KYPOS=KY(I)-0.5
          CALL MAXF(LUN1,LUN2,NSAM1,NROW1,NSAM3,NROW3,
     1    IXB,IYB,KXPOS,KYPOS,C(I),FINT(I),IDM,R,CRIT)
	  KX(I) = KXPOS
	  KY(I) = KYPOS
          AMP = CABS(C(I))
C         WGT = AMP*SQRT(FLOAT(KX(I))**2+FLOAT(KY(I))**2)
          WGT = AMP
          PH = ATAN2(AIMAG(C(I)),REAL(C(I)))
          WRITE(NDAT,9111)I,HIND(I),KIND(I),KX(I),
     1    KY(I),AMP,PH,FINT(I),WGT
CCC       IF (FINT(I).LT.0.) GOTO 914
CCC       NACC = NACC+1
          CALL LATCEN(IERR,1,HIND(I),KIND(I),KX(I),KY(I),
     1    WGT,CX,CY,,,,)
914     CONTINUE
        CALL LATCEN(IERR,2,NDUM,NDUM,DUM,DUM,WGT,CX,CY,AX,AY,BX,BY)
	IF (IERR.NE.0)GOTO 917

C GO TO CALCULATION AND PRINTOUT OF LENGTHS AND ANGLES
        GOTO 9121

9145    IF (NRESOL.EQ.0) GOTO 920
C*********************************************************
C NOW PUT REFLECTIONS INTO DATA FILE
C*********************************************************
        CALL FILERD(FILNAM,NLET,NULL,'FILTER',IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 920
        IFORM  = 0
        IDUMMY = 1

        CALL OPENF(FILNAM,LUN3,20,NREFL,'UNKNOWN',NF,IDUMMY)
        CALL PDATES(FILNAM,0)
        WRITE(NDAT,9146)
9146    FORMAT('+',85X,'= FILTER FILE'/)
        IF (NF.EQ.1) THEN
          CALL ERRT(4,'TVWN1 ',NE)
          GOTO 920
        ENDIF

C IACC COUNTS ACCEPTED REFLECTIONS

        DO  I = 1,NREFL

C THIS CALL TO MAXF TO GET CORRECTLY ASSIGNED FOU AMPLITUDES
C (THEY MAY BE OUT OF STEP IN THE REFLECTION COUNTING BECAUSE
C THE REFINEMENT MAY THROW SOME REFLECTIONS OUT OR ENTER NEW
C ONES)
          KXPOS = KX(I)+0.5
          IF (KX(I).LT.0.)KXPOS=KX(I)-0.5
          KYPOS = KY(I)+0.5
          IF (KY(I).LT.0.)KYPOS=KY(I)-0.5
          CALL MAXF(LUN1,LUN2,NSAM1,NROW1,NSAM3,NROW3,
     1    IXB1,IXB1,KXPOS,KYPOS,C(I),FINT(I),IDM,R,CRIT)
          BUFF(1)  = I
          BUFF(4)  = HIND(I)
          BUFF(5)  = KIND(I)
          BUFF(2)  = KX(I)
          BUFF(3)  = KY(I)
9156      BUFF(6)  = 1.
          BUFF(7)  = 0.
          BUFF(8)  = REAL(C(I))
          BUFF(9)  = AIMAG(C(I))
          BUFF(10) = CABS(C(I))
          BUFF(11) = F00
          BUFF(12) = DISTA
          BUFF(13) = DISTB
          BUFF(14) = DPHI
          CALL WRTLIN(LUN3,BUFF,20,I)
	ENDDO

917     CLOSE(LUN3)
918     CLOSE(LUN2)
919     CLOSE(LUN1)

920     RETURN
        END

#endif
#endif
