
C++*************************************************************************
C
C VMS.F                         
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   VMS  SOLICTS SYSTEM COMMAND AND THEN RUNS THAT COMMAND 
C
C--*******************************************************************

	SUBROUTINE VMS
CNO_SAVE
	INCLUDE 'CMBLOCK.INC' 

	COMMON    COMMAN

#ifdef SP_VMS
	INTEGER   * 4   LIB$SPAWN
#endif
	CHARACTER * 160 COMMAN
        CHARACTER * 1   NULL

	NULL = CHAR(0)

C       DO NOT UPPERCASE THE INPUT LINE
        IRTFLG = -999
	CALL RDPRMC(COMMAN,NC,.TRUE.,'SYSTEM COMMAND',NULL,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

#ifdef SP_VMS
	I4 = LIB$SPAWN(COMMAN(1:NC))
	IF (I4 .NE. 1) WRITE(NOUT,*)' ERROR CODE;', I4
#else

C       CHECK FOR PRESENCE OF $DATEXT IN COMMAND -----------------
        IDATEXT = INDEX(COMMAN(1:NC),'$DATEXT')
        IF (IDATEXT .LE. 0) IDATEXT = INDEX(COMMAN(1:NC),'$datext')

        DO WHILE (IDATEXT .GT. 0) 
C          SUBSTITUTE CURRENT DATEXC FOR $DATEXT
           COMMAN = COMMAN(1:IDATEXT-1) // DATEXC(1:3) // 
     &              COMMAN(IDATEXT+7:NC)
           NC      = NC - 4 
           IDATEXT = INDEX(COMMAN(1:NC),'$DATEXT')
           IF (IDATEXT .LE. 0) IDATEXT = INDEX(COMMAN(1:NC),'$datext')
        END DO

C       CHECK FOR PRESENCE OF $PRJEXT IN COMMAND -----------------
        IPRJEXT = INDEX(COMMAN(1:NC),'$PRJEXT')
        IF (IPRJEXT .LE. 0) IPRJEXT = INDEX(COMMAN(1:NC),'$prjext')

        DO WHILE (IPRJEXT .GT. 0) 
C          SUBSTITUTE CURRENT PRJEXC FOR $PRJEXT
           COMMAN = COMMAN(1:IPRJEXT-1) // PRJEXC(1:3) // 
     &              COMMAN(IPRJEXT+7:NC)
           NC      = NC - 4 
           IPRJEXT = INDEX(COMMAN(1:NC),'$PRJEXT')
           IF (IPRJEXT .LE. 0) IPRJEXT = INDEX(COMMAN(1:NC),'$prjext')
        END DO
 
C       SUBSTITUTE FOR STRINGS WITHIN {...} PORTION(S) OF COMMAND
        CALL FILNAMSUB(COMMAN,NC,.FALSE.,0,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	IRET = system(COMMAN(1:NC))

#endif

        RETURN
	END
