C++************************************************************************
C
C $$ VOMD.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ VOMD.FOR
C
         SUBROUTINE VOMD(MAXMEM)
C  Create angular document file from the AP MD output  07/12/93
         INCLUDE 'CMBLOCK.INC'
         COMMON  DUMMY(1024),X(3),Y(0:3),AAA(3,1)
         CHARACTER*81  DOCFIL
         CHARACTER*1  NULL
         DATA  NDOC,NDOUT/55,56/
CNO_SAVE
         NULL=CHAR(0)
C
         CALL  FILERD(DOCFIL,NLETI,NULL,'Angular document',IRTFLG)
         IF(IRTFLG.EQ.-1)  RETURN
C
         K=0
         K2=1
778      LERR=-1
         KP1=K+1
         CALL  UNSAV(DOCFIL,K,NDOC,KP1,AAA(1,KP1),3,LERR,K2)
         IF(LERR.EQ.0)  THEN
         K=K+1
         GOTO  778
         ENDIF
         CLOSE(NDOC)
         LPL=K
C
         CALL  FILERD
     &   (DOCFIL,NLETI,NULL,'Output from AP MD document',IRTFLG)
         IF(IRTFLG.EQ.-1)  RETURN
         NLIST=4
         K=0
         K2=1
779      LERR=-1
         KP1=K+1
         CALL  UNSAV(DOCFIL,K,NDOC,KP1,X,3,LERR,K2)
         IF(LERR.EQ.0)  THEN
         MM=X(1)
         IF(MM.LE.LPL) THEN
         Y(1)=X(3)
         Y(2)=AAA(2,MM)
         Y(3)=AAA(3,MM)
         ELSE
         MM=MM-LPL
         Y(1)=X(3)
         Y(2)=AAA(2,MM)
         Y(3)=AAA(3,MM)
         Y(2)=180.0-Y(2)
         Y(1)=Y(1)+180
         Y(3)=Y(3)+180
         IF(Y(1).GE.360.0)  Y(1)=Y(1)-360.0
         IF(Y(3).GE.360.0)  Y(3)=Y(3)-360.0
         ENDIF
         K=K+1
         Y(0)=K
         CALL  SAVD(NDOUT,Y,NLIST,IRTFLG)
         IF(IRTFLG.EQ.-1) GOTO  5
         GOTO  779
         ENDIF
5        CALL  SAVDC
         CLOSE(NDOUT)
         CLOSE(NDOC)
         END
