#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE vtil3
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: vtil3'
       RETURN
       END
 
#else
 

C************************************************  6/23/80 *** VAX 9/15/81
C
C $$ VTIL3.FOR                         
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  $$ VTIL3
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*******************************************************************

        SUBROUTINE VTIL3
        INCLUDE 'CMBLOCK.INC'
	PARAMETER (NFUNC=7)
        CHARACTER *(NFUNC*3)  FUNC
	DATA MAXDIM/1300/
	DATA FUNC/'SF SC PH TA SI CR SP'/
CNO_SAVE
        LUN1   = 8
        LUN2   = 10
	LUN3   = 7

        IFUNC = (INDEX(FUNC,FCHAR(1:2)) /3) +1
        IF (IFUNC .LE. 0) RETURN

        GOTO (100,200,300,400,500,600,700),IFUNC

100	CALL  ERRT(41,'VTIL3',NE)
	IF (FCHAR(4:4).EQ.' ') THEN
C          CALL FSTACK(LUN1,LUN2)
        ELSE
C          CALL FSTADD(LUN1,LUN2,FCHAR(4:))
        ENDIF
        GOTO 5

200	CONTINUE
	CALL  ERRT(41,'VTIL3',NE)
C	CALL FSTSC1(LUN1,LUN2)
	GOTO 5

300	CONTINUE
	CALL  ERRT(41,'VTIL3',NE)
C	CALL APPLSH(LUN1,MAXDIM)
	GOTO 5

400     CONTINUE
	CALL TILT(LUN1)
        GOTO 5

500	CONTINUE
	CALL  ERRT(41,'VTIL3',NE)
C	CALL FSTINT(LUN1,LUN2,FCHAR(4:))
	GOTO 5

600	CONTINUE
	CALL  ERRT(41,'VTIL3',NE)
C	CALL FSTREF(LUN1,LUN2,LUN3)
        GOTO 5

700	CALL DIFF1O(IRTFLG)
        GOTO 6

5       CLOSE(LUN1)
	CLOSE(LUN2)
	CLOSE(LUN3)

6       FCHAR(1:1) = ';'
        END

 
#endif
 
