	SUBROUTINE WEIGHTF(A,NSAM,NROW,L,IST)
C  FOURIER TRANSFORM IMAGE, MULTIPLY THE TRANSFORM BY X* OR Y* 
C  DEPENDING ON L (SEE WEIFU)
C  AUTHOR: M.RADERMACHER
        DIMENSION A(1),N(3)
        N(1)=NSAM
        N(2)=NROW
        N(3)=1
        NTOT1=(NSAM+2)*NROW
        NTOT2=(NSAM)*NROW
        SCF1=SQRT(FLOAT(NTOT2/4))
        SCF2=SQRT(FLOAT(NTOT2))
C  IN CORE FOURIER TRANSFORM:
        CALL FOUR2(A,N,2,-1,0)
        DO  I=1,NTOT1
          A(I)=A(I)/SCF2
	ENDDO
10      FORMAT(' ',/,2(32F4.0/1X))
C  DO THE MULTIPLICATION
        CALL WEIFU(A,N,L,IST)
C       WRITE(NOUT,10) (A(I),I=1,NTOT1)
C  IN CORE BACK TRANSFORM:
        CALL FOUR2(A,N,2,+1,-1)
        DO  I=1,NTOT2
          A(I)=A(I)/SCF1
	ENDDO
        RETURN
        END
