C++************************************************************************
C
C  WRITPRO.F
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C--************************************************************************

         SUBROUTINE WRITPRO
     &      (PROJ,NSAM,NROW,NUMTH,QUBE,ANG,LTB,IPCUBE,NN,RI)

CNO_SAVE

         INCLUDE 'CMBLOCK.INC'

         DIMENSION       PROJ(NSAM,NROW,NUMTH),QUBE(LTB),ANG(3,NUMTH)
         DIMENSION       IPCUBE(5,NN),IMAL(100)
         COMMON          BUF(1024)
         CHARACTER*80    FINPIC,FINPAT,FINDOC,FINP
         COMMON /F_SPEC/ FINPAT,FINPIC,FINDOC,NLET,NLETI

         DATA  INPIC/99/,INPAT/98/,INDOC/97/

C        READ ANGLES FROM THE DOCUMENT FILE.
C        ORDER IN THE DOCUMENT FILE IS PSI, THETA, PHI AND ANGLES ARE 
C        IN DEGREES! IN ANG ARRAY IT IS OTHER WAY AROUND

         K    = 0
         KA   = 0
         K2   = 1
         K2A  = 1
         NANG = 0
778      L_TH = 0
801      IF (L_TH.EQ.NUMTH)  GOTO  802
         LERR = -1
         KP1  = K+1
         CALL UNSAV(FINDOC,K,INDOC,KP1,BUF,1,LERR,K2)
         IF (LERR .EQ. 0)  THEN
            L_TH = L_TH+1
            IMAL(L_TH)=BUF(1)
            K = K+1

            CALL  UNSAV(FINPIC,KA,INPIC,IMAL(L_TH),BUF,3,LERR,K2A)
            IF (LERR .NE. 0) THEN
		REWIND INPIC
		LERR = -1
                CALL  UNSAV(FINPIC,KA,INPIC,IMAL(L_TH),BUF,3,LERR,K2A)
                IF (LERR.NE.0) GOTO 779
	    ENDIF
            ANG(3,L_TH) = BUF(1)
            ANG(2,L_TH) = BUF(2)
            ANG(1,L_TH) = BUF(3)
            KA          = KA+1
         ELSE
            IF (L_TH .EQ. 0)  THEN
               GOTO  779
            ELSE
               GOTO 802
            ENDIF
         ENDIF
         GOTO 801

802      CONTINUE
c$doacross local(i),mp_schedtype=simple
         DO I=1,L_TH
            CALL  WPRO(PROJ(1,1,I),NSAM,NROW,QUBE,LTB,IPCUBE,NN,
     &                 ANG(1,I),ANG(2,I),ANG(3,I),RI)
     	 ENDDO

         DO I=1,L_TH
            WRITE(NOUT,333)  IMAL(I),(ANG(J,I),J=3,1,-1)
333         FORMAT(' PROJECTION #',I5,
     &             '  PSI=',F6.1,' THETA=',F6.1,' PHI=',F6.1)
            CALL FILGET(FINPAT,FINP,NLET,IMAL(I),INTFLAG)
            IFORM = 1
            NSL   = 1
            MAXIM = 0
            CALL OPFIL(.FALSE.,FINP,INPAT,'U',NSAM,NROW,NSL,
     &  	       MAXIM,' ',.FALSE.,IRTFLG)

            DO J=1,NROW
               CALL WRTLIN(INPAT,PROJ(1,J,I),NSAM,J)
	    ENDDO
            CLOSE(INPAT)
	 ENDDO
         GOTO 778

C        CLOSE DOCUMENT FILE
779      CLOSE(INPIC)
         CLOSE(INDOC)

         RETURN
         END

