
C++*************************************************************************
C
C WRTSEQ8.F                                    NEW JULY 97 ArDean Leith                 
C                                      
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C     WRTSEQ8:    WRITE A LINE OF 8 BIT INTEGERS INTO A SEQUENTIAL FILE
C
C     CALL WRTSEQ8(LUN,LBUF,NB,IRTFLG)
C
C        LUN      LOGICAL UNIT NUMBER OF FILE TO BE WRITTEN TO (INPUT)
C        BBUF     BYTE BUFFER CONTAINING DATA                  (INPUT)   
C        NB       NUMBER OF BYTES TO BE WRITTEN                (INPUT)
C        IRTFLG   ERROR FLAG (ZERO IS NORMAL)                  (OUTPUT)
C
C        0         2         3         4         5         6         7     
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

      SUBROUTINE   WRTSEQ8(LUN,BBUF,NB,IRTFLG)

CNO_SAVE
      COMMON /UNITS/LUND,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

      INTEGER * 1    BBUF(NB)

      WRITE(LUN,ERR=999) BBUF

      IRTFLG = 0
C     WRITE(NOUT,*)' BYTES WRITTEN:',NB
      RETURN

999   WRITE(NOUT,*)' WRTSEQ8 ERROR, UNIT:',LUN,' LENGTH:',NB
      IRTFLG = 1
      RETURN
      END

