
PARTICLES--Random Conical Tilt Series Interactive Particle Selection        
                                                            11/26/93

PURPOSE:  Select marker/image coordinates from a tilted/untilted 
          pair of micrographs (Single exposure random conical tilt
          series), determine tiltangle (the sign of the tiltangle
          is not determined) and tiltaxis directions in 0 degree and 
          tilted image.

 USAGE:   

          Display untilted image.

          Display tilted image.

          Give number for document files that are created / read.
          (Currently these doc. files must be in same directory as
           the current directory) If these files already exist they
          are read in and particle picking starts with the next
          particle in the series.

          Pick particle from untilted image using the left button. 
 
          Pick corresponding particle location from tilted (right)
          image using left button. At least 5 particle pairs have
          to be selected (seven pairs is preferable). The last
          selected particle can be undone using the right button.

          Use middle button to:
             Shift image to view hidden portions.
             Erase markers from image (not from doc files).
             Draw marker locations on images.
             Draw marker numbers on images.
             Fit markers.

             To fit markers:
                Give key number for origin.
                Determine tilt angle, theta, using origin and 
                    area limit.
                Fit angles using calculated or input tilt angle.
                Draw fitted points.
                Save angles in doc file dcb??? when satisfied with
                  fitting parameters.

          Continue picking particles.  After selecting location in
          untilted image, the predicted location in the tilted (right)
          image will be indicated and the user may select the point. 
          At any time a new tilt axis can be determined using all of 
          the selected points.


           Example of operation sequence:

           display    display an image pair.

       ---->pick      determine particle / marker coordinates.
      |
      |                After at least 5 such coordinates (better 7)
      |                are determined:
      |     fit        Set key for origin
      |                Determine tilt angle, theta parameters using 
      |                a least square fit.
      |                Can later be run again at any time when more 
      |                coordinates are measured
      |
      |                                 |
      |                                 V
      ---------------------------------                               

            draw       Can be used any time to display selected 
                       coordinates. 


       The program creates 3 output document files. The names are:
          dcunum  Selected particle coordinates in untilted image
          dctnum  Selected particle coordinates in tilted image
          dcbnum  Data common to both  images (tilt angle, etc.)


dcunum:  (coordinates in untilted image)
 ; MI/MIX   11-FEB-93 AT 16:14:34   DCU005.MIX
 ; 
   1 6    1.000000  234.000000 1098.000000   78.000000  366.000000    1.000000
   2 6    2.000000  633.000000  870.000000  211.000000  290.000000    1.000000
   3 6    3.000000  765.000000  552.000000  255.000000  184.000000    1.000000
 key=      image    coords. in large image  coords. in reduced image   flag
 coord.#
------------------------------------------------------------------------------

dctnum:  (coordinates in tilted image)
 ; MI/MIX   11-FEB-93 AT 16:14:53   DCT005.MIX
 ; 
   1 6    1.000000  300.000000 1086.000000  100.000000  362.000000    1.000000
   2 6    2.000000  714.000000  906.000000  238.000000  302.000000    1.000000
   3 6    3.000000  858.000000  693.000000  286.000000  231.000000    1.000000
 key=      image    coords. in large image  coords. in reduced image   flag
 coord.#
------------------------------------------------------------------------------

dcbnum  (data common to the tilt pair)

 ; MI/MIX   11-FEB-87 AT 18:32:08   DCB005.MIX
 ; 
 0121 6    0.000000    0.000000    0.000000    0.000000    0.000000    0.000000

 ; IFIT=1 AFTER FIT, IGFLAG=1 IF PARAMS DETERM. BEFORE
 0122 2    0.000000    0.000000  

 ; X0,Y0 ORIG. IN 0 DEG IM., XS0,YS0 ORIG. IN TILTED IMAGE.
 0123 5          53         375      73.263      378.56           1   

 ; TILTANGLE, AXIS DIR IN UNTILTED IMAGE
 0124 3      51.367     -77.826     -77.217
-------------------------------------------------------------------------------


Subroutines: fitdoc, pickp, pickmen, fitmen, fitorigin, fitsav,
             pickdraw, fitdocmen, spoutfile

