
/*$Header: /net/ithaca/usr1/web/src/RCS/clearover.c,v 1.2 1995/02/07 19:42:17 liy Exp $*/
/*
C++*************************************************************************
C
C WID_CLEAROVER.FOR -- CREATED MAY 91
C clearover.c                  NOV 92
C
C **************************************************************************
C    AUTHOR:  ArDean Leith
C *  COPYRIGHT (C)1990 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    CLEAROVER
C
C    PURPOSE:         CLEARS OVERLAY PLANE
C
C    PARAMETERS:    
C
c++*************************************************************************
*/


#include "x.h"
#include "std.h"

 extern Display        *idispl;
 extern Drawable       iwin,  imagsav;
 extern unsigned int   iwidex, ihighx;
 extern GC             icontx, icontxb;
 extern int            icolorxb;

 extern int    wisetplanes  (Display *, GC, int);

 /********************  clearover  ****************************/

 extern void clearover(Widget iw_temp, caddr_t data, caddr_t call_data)
 {

 XGCValues    gcval;

 if (icontxb <= (GC)0)
   { /* need to create a new graphics context for blanking */
   icontxb = XCreateGC(idispl,iwin,0,&gcval);
   XCopyGC(idispl, icontx, 0, icontxb);
   }

 /* set mask so image in first 7 planes and text overlay plane 8 */
 wisetplanes(idispl, icontxb, 128);

 if (icolorxb < 1)
    icolorxb = 0;

 XSetForeground(idispl, icontxb, icolorxb);

 XFillRectangle(idispl, imagsav, icontxb, 0,0, iwidex,ihighx);
 
 XClearWindow(idispl,iwin);

 XFlush(idispl);

 /* set mask in icontxb to all planes */
 wisetplanes(idispl, icontxb, -1);

 return;
 }


