/*$Header: /net/ithaca/usr1/web/src/RCS/closefilep.c,v 1.1 1995/08/09 16:06:49 leith Exp $*/
/*
 *************************************************************************
 *
 * closefilep.c
 *
 *************************************************************************
 * AUTHOR: A. LEITH
 * COPYRIGHT (C)1981,1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF
 * THE CENTER FOR LABORATORIES AND RESEARCH
 **************************************************************************
 *
 * PURPOSE:
 *
 * RETURNS:
 *
 * PARAMETERS:   
 *              
 *********************************************************************/

#include "files.h"

 int closefilep(FILEDATA **fileptr)
 {
 if (fclose((**fileptr).fp)) 
     {
     printf(" *** Error closing file. \n");
     return FALSE;
     }


 /* free the line buffer in the structure */
 if ((**fileptr).buf) free((**fileptr).buf);

 /* free the whole structure */
 free (*fileptr);
 
 *fileptr = NULL;

 return TRUE;
 }
