/*
*****************************************************************************
** comapmen5.c		8/93
**
** Purpose:   Display menu for image data in a file.
**
**
** WID_COMAPMEN5.FOR transported to UNIX
**
** **************************************************************************
** *   AUTHOR:  Mahieddine Ladjadj                                          *
** *  COPYRIGHT (C)1990 , WADSWORTH CENTER FOR LABORATORIES AND             *
** *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
** *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
** *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
** *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
** *    THE CENTER FOR LABORATORIES AND RESEARCH			    *
** **************************************************************************
*****************************************************************************
*/

#include "common.h"
#include "std.h"
#include "x.h"
#include <Xm/Text.h>
#include "routines.h"

  extern char   datexc[4];         /* file extension           */

  static Widget iw_im = (Widget)0;
  char imnamm[81] = "avgimg001"; 
  extern Widget iw_comapmen2;
  void     comapmen5_buta  (Widget iw_t, caddr_t itag, caddr_t call_data);
                                                                         
/********************** comapmen5 ***********************************/

void comapmen5(Widget iw_t, caddr_t itag, caddr_t callpar)
  {
  /* create a text box for image name input */
  iw_im = wid_text(iw_win, iw_im, "New Average Image", imnamm,
                   *comapmen5_buta,(caddr_t) NULL,20,20);
  }
                                                               
/********************** comapmen5_buta ***********************************/

void comapmen5_buta(Widget iw_t, caddr_t itag, caddr_t call_data)
  {
  XmSelectionBoxCallbackStruct * cbs;

  cbs = (XmSelectionBoxCallbackStruct *) call_data;
  strcpy(imnamm,extractstr(cbs -> value));

  if (strlen(imnamm) == 0)
      { spout(" *** WARNING: no doc file name: imnamm "); return; }
 
  /* remove menu widget */
  XtUnmanageChild(iw_comapmen2);
 
  /* refresh screen */
  expos_cb(NULL,NULL,NULL);

  /* start comap doc saving and averaging routine */
  comapsav(3);

  }
