
/*$Header: /net/alwyn/usr1/web/src/RCS/extractstr.c,v 1.2 95/01/23 10:23:00 leith Exp $*/
/*
C++*************************************************************************
C
C extractstr -- CREATED July 92
C                                                                     
C **************************************************************************
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH	        		   *
C **************************************************************************
C
C    extractstr
C
C    PARAMETERS:   compstring           compound string
C
C    RETURNS:      STRING               ASCII STRING
C
C    PURPOSE:      GETS ASCII STRING FROM A COMPOUND STRING
C
C    CALLS:        MOTIF
C
C    CALLED BY:    
C
C--********************************************************************
*/

#include "x.h"
#include "std.h"

void spout(char *);

char *extractstr(XmString compstring)

 {

 XmStringContext    context;
 XmStringCharSet    charset;
 XmStringDirection  direction;
 Boolean            separator, it;
 static char        *string;

 it = XmStringInitContext (&context,compstring);
 if (it == TRUE)
    {
    /* extract segment from the string */
    it = XmStringGetNextSegment (context,&string,
			  &charset,&direction,&separator);
    if (it == FALSE)
       spout("*** Can not get segment in extractstr");
    }
 else
    spout("*** Can not initialize context in extractstr");

 XmStringFreeContext (context);

 return ((char *) string);
}
