
/*$Header: /alwyn/usr1/web/RCS/itoa.c,v 1.1 93/11/10 10:11:43 leith Exp $*/
/*
C **********************************************************************
C
C ITOA
C        
C
C **************************************************************************
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND           *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C itoa(ivalue)
C
C PURPOSE:  convert integer to a char string
C
C PARAMETERS:  
C      IVALUE    INPUT NUMBER
C
C ************************************************************************
*/

#include "std.h"

 extern int numdig(int, int);

 /************************* itoa *******************************/

 char * itoa(int ivalue)

 {
 int leni;
 char * cval;

 leni = numdig(ivalue,1) ;

 if ((cval = (char *) malloc((leni + 1) * sizeof(char))) == 
     (char *) NULL)  return (char *) 0;

 sprintf(cval,"%*d",leni,ivalue);
 return cval; 
 }  
