
/*$Header: /net/ithaca/usr1/web/src/RCS/newext.c,v 1.5 1995/11/07 19:59:19 mladjadj Exp $*/

/***********************************************************************
 *
 * newext.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 * 
 * PURPOSE:  Change datexc     
 * 
 * PARAMETERS:	Widget 		iw_temp		pushbutton (not used)
 *		caddr_t		data		label text string
 *		caddr_t		call_data	not used 
 *
 ***********************************************************************
*/

#include "common.h"
#include "routines.h"


 /* internal functions */
 void            newext_cb   (Widget, caddr_t, caddr_t);


 /* file variables */
 static char       label_string[] = "Enter file extension";  
 static Widget     iw_text=(Widget) 0;
 static int        ixtext;           /* x coord for text       */
 static int        iytext;           /* y coord for text       */
 

/************************  newext  ***********************************/

 void newext(Widget iw_temp, caddr_t data, caddr_t call_data)
 {

 /* create text input box */
 iw_text = wid_text(iw_win, iw_text, label_string, (char *) NULL,
                       *newext_cb, NULL, ixtext, iytext);

 }


 /**********************  newext_cb  *********************************/

 void newext_cb(Widget iw_temp, caddr_t data, caddr_t call_data)
 {
 XmString    txt_string;
 int         n;
 
 XmSelectionBoxCallbackStruct *cbs =
      (XmSelectionBoxCallbackStruct *) call_data;
 
 txt_string = cbs -> value;
 strncpy(datexc,extractstr(cbs -> value),3);
 
#ifdef VMS
   /* vms has only uppercase filenames */
   n = 0;
   while(datexc[n])
       { /* is char in the range a-z ? */
       if( toascii((int) datexc[n]) >= 97 && 
          toascii((int) datexc[n]) <= 122 ) 
	  datexc[n] = (char) toupper((int) datexc[n]);
       n++;
       }
#endif


 if (txt_string) XmStringFree(txt_string);
 }

