
/*$Header: /net/alwyn/usr1/web/src/RCS/numdig.c,v 1.3 94/11/15 08:52:10 leith Exp $*/
/*
C **********************************************************************
C
C NUMDIG
C        CONVERTED TO C OCT 92 al
C
C **************************************************************************
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C NUMDIG(IVALUE,MINVAL)
C
C PURPOSE:  FIND NUMBER OF DIGITS IN IVALUE (adds one if negative)
C           THE NUMBER IS >=1 AND >= MINVAL.
C
C PARAMETERS:  
C      IVALUE    INPUT NUMBER
C      MINVAL    MIN. VALUE RETURNED FOR IVALUE
C
C ************************************************************************
*/

#include "std.h"

 int numdig(int ivalue, int minval)
 {
 int leni, lent, minus;

 minus = 0;
 if (ivalue < 0)
    {
    minus  = 1;
    ivalue = - ivalue;
    }

 leni = 1;
 lent = 9;

 while(ivalue > lent)
    {
    lent = 9 * pow((double)10.0,(double)leni) + lent;
    leni++;
    }

 leni = leni + minus;
 return (MYMAX(leni,minval));
 }  
