
/*$Header: /net/ithaca/usr1/web/src/RCS/rdprxc.c,v 1.3 1996/05/14 15:48:06 leith Exp $*/
/*
C++************************************************************************
C
C RDPRXC
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C RDPRXC
C
C PURPOSE:         GET STRING VALUE FROM TEXT WIDGET 
C
C PARAMETERS:      
C
C CALLED BY:       
C
C***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/Text.h>

extern void   spout         (char *);
extern void   spouts        (char *);
extern void   spouti        (int);


 /******************  rdprxc  *******************************/

 int rdprxc(Widget iw_t, char * astring, int slen)

 {  
 char * astringt;
 size_t slent;

 if (iw_t == (Widget) 0) 
    {
    spout("*** Pgm error, ivalid Widget in rdprxc!");
    return 0;
    }

 astringt = XmTextGetString(iw_t);
 slent    = strlen(astringt);

 /* slen is available length including null for astring */
 if (slent >= slen)
    {
    spouts("*** Sring length limited to: "); spouti(slen-1);
    XtFree(astringt);
    return 0;
    }

 strcpy(astring,astringt);

 XtFree(astringt);
 return (int) slent;
 }
 
