
/*$Header: /net/ithaca/usr1/web/src/RCS/setamap.c,v 1.5 1994/03/29 15:10:44 leith Exp $*/
/*
C***************************************************************************
C
C    setamap -- created DEC 92
C
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1992,  WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    setamap(mapt)
C
C    PURPOSE:       to set a colormap
C
C
C    PARAMETERS:    MAPT    COLORMAP WANTED
C
C    CALLED BY:     gold
C
C--********************************************************************
*/

#include "std.h"
#include "x.h"

 extern Display   *idispl;
 extern Window    iwin, iwtop;
 extern Widget    iw_win, iw_top;

 /**************************  setamap   *****************************/

 void setamap(Colormap mapt) 
 {
 Arg           args[2];
 Colormap      imap;

 Window          win_list[2];
 XSetWindowAttributes  xswa;

#ifdef VMS

  XSetWindowColormap(idispl, iwin, mapt);

  win_list[0] = iwin;
  win_list[1] = iwtop;
  XSetWMColormapWindows(idispl,iwtop,win_list,2); 

/*****************
  XtSetArg(args[0], XmNcolormap, mapt);
  XtSetValues(iw_win,args,1);
  xswa.colormap = mapt;
  XChangeWindowAttributes (idispl, iwtop, CWColormap, &xswa);
  XChangeWindowAttributes (idispl, iwin, CWColormap, &xswa);
  XFlush(idispl);
  XtSetArg(args[0], XmNcolormap, &imap);
  XtGetValues(iw_top,args,1);
  printf("iw_top colormap:        %6d \n",imap);
  XtGetValues(iw_win,args,1);
  printf("iw_win colormap:        %6d \n",imap);
************************/

#else
  XSetWindowColormap(idispl, iwin, mapt);

  win_list[0] = iwin;
  win_list[1] = iwtop;
  XSetWMColormapWindows(idispl,iwtop,win_list,2); 
#endif

 XFlush(idispl);

 return ;
 }

