
/*$Header: /alwyn/usr1/web/src/RCS/wid_stdbut.c,v 1.2 94/07/23 17:22:24 odesanya Exp $*/
/*
C++*************************************************************************
C
C  WID_STDBUT -- CREATED MAY 91
C                CONVERTED TO C -- JULY 92 AL
C **************************************************************************
C    AUTHOR:  ArDean Leith              
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C    WID_STDBUT(iw_parent, iw_pushs, iw_pushc,iw_pusha, type, 
C               cbs, cbc,  cba, data)
C
C    PARAMETERS:   iw_parent     parent for this box
C                  iw_pushs      stop button widget   
C                  iw_pushc      cancel button widget
C                  iw_pusha      accept button widget                 
C                  type          type of buttons wanted (SCAF)
C                  cbs           stop button callback
C                  cba           accept button callback
C                  cbc           cancel button callback
C                  data          accept button data
C                  
C--*********************************************************************
*/

#include "x.h"
#include "std.h"

 extern void web_man ( Widget, caddr_t, caddr_t );

 extern Widget wid_pushg  (Widget, Widget, char *, void (*)(), 
                           char *, int, int);
 extern Widget wid_rowcol (Widget, char , int, int);

/************************************************************/

 Widget wid_stdbut(Widget iw_parent, Widget iw_bigparent,
                 Widget *iw_pushs, Widget *iw_pushc,  Widget *iw_pusha,
                 char * type,
                 void (*cbs)(), void (*cbc)(), void (*cba)(), 
                 char * data)
 { 
 Widget  iw_rowcol, iw_pushh;

         /*  printf("Creating iw_rowcol \n"); */

 iw_rowcol  = wid_rowcol(iw_parent,'h',-1,-1);

 if (strchr(type,'s') != NULL  || strchr(type,'S') != NULL)
    {   /* make a push button for stop */
    *iw_pushs = wid_pushg(iw_rowcol, 0, "   STOP   ",   cbs, 
                        (char *) iw_bigparent, 0,0);
    }
         /** printf("Created iw_pushs \n"); */

 if (strchr(type,'c') != NULL  || strchr(type,'C') != NULL)
    {   /* make a push button for cancel */
    *iw_pushc = wid_pushg(iw_rowcol, 0, "  CANCEL  ",   cbc,
                        (char *) iw_bigparent ,0,0);
    }

 if (strchr(type,'a') != NULL || strchr(type,'A') != NULL)
    {   /* make a push button for accept */
    *iw_pusha = wid_pushg(iw_rowcol, 0, "  ACCEPT  ",   cba, 
                         data, 0,0);
     }

 if (strchr(type,'f') != NULL || strchr(type,'F') != NULL)
    {   /* make a push button for finished (uses callback a !!) */
    *iw_pusha = wid_pushg(iw_rowcol, 0, " FINISHED ", cba, 
                        (char *) iw_bigparent, 0,0);
    }

 if (strchr(type,'h') != NULL || strchr(type,'H') != NULL)
    {   /* make a push button for help (uses fixed callback web_man !!) */
    iw_pushh = wid_pushg(iw_rowcol, 0, " HELP ", web_man, 
                        data, 0, 0);
    }

 return  iw_rowcol;
 }
