
/*$Header: /net/ithaca/usr1/web/src/RCS/widean.c,v 1.6 1995/10/24 20:22:13 liy Exp $*/
/*
C++*************************************************************************
C
C WID_DEAN.FOR -- CREATED JUNE 91
C widean.c                NOV  92
C **************************************************************************
C    AUTHOR:  ArDean Leith
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C  widean
C
C    PARAMETERS:    
C
C--*********************************************************************
*/

#include "common.h"
#include <Xm/Text.h>
#include <Xm/ToggleBG.h>


 /* function prototypes */
 extern Widget wid_rowcol   (Widget, char , int, int);
 extern Widget wid_textboxb (Widget, Widget, char *, char *,  int);
 extern Widget wid_dialog   (Widget, Widget, char *, int, int);
 extern Widget wid_pushg    (Widget, Widget, char *, void (*) (), 
                             char *,int,int);
 extern void   spout        (char *);


 /* internal function prototypes */
 void     widean_cb   (Widget, caddr_t, caddr_t);

 Widget iw_deant;
 char   cval[12] = "b0123456789";

 /***********************   widean   ****************************/
  
 Widget widean(Widget iw_parent, Widget iw_dean, 
               char * label, char * string, int ix, int iy, int icol)

 { 
 int    i;
 Widget iw_pb[11], iw_rowcolh;
 char   ctemp[2];

 if (iw_dean <= (Widget)0)
    {   /* create dean widget first */
 
    iw_dean     = wid_dialog(iw_parent, 0, label, ix, iy);
    iw_rowcolh  = wid_rowcol(iw_dean, 'h', -1, -1);

    ctemp[1] = '\0';
    for (i=0; i< 11; i++)
       {
       strncpy(&ctemp[0],&cval[i],1);
       iw_pb[i] = wid_pushg(iw_rowcolh, (Widget)0, ctemp,
                  widean_cb, &cval[i], -1,-1);
       }

    /*  create the text input part of the box */
    iw_deant = wid_textboxb(iw_rowcolh,0,"",string,icol);
    }

 XtManageChild(iw_dean);
 return iw_dean;
 }

/***********************  widean_cb ************************/

 void widean_cb(Widget iw_temp, caddr_t data, caddr_t call_data)
 {
 char opert[2];
 int    ip;

 strncpy(opert,data,1);
 /* opert[1] = '\0'; */

 /*    spout("value$"); spout(opert); */

 if (*opert == 'b')
    {
    /* clear the text box string */
    XmTextSetString(iw_deant,"0");
    }
 else
    {
    /*       append this digit to text in text box */

    /*      get present string length */
    ip = (int) XmTextGetLastPosition(iw_deant);

    /*    find insertion point for new text 
    if (*opert != '-' || ip == 0)
       {
       XmTextReplace(iw_deant,ip,ip,opert);            
       }*/
    }
 return;
 }
        
