
/*$Header: /net/ithaca/usr1/web/src/RCS/widpos.c,v 1.2 1996/03/21 15:47:36 leith Exp $*/
/*
 * widpos.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * widpos(ix *,iy *)
 * 
 * PURPOSE:	finds position for widget from position in draw window
 *
 * RETURNS:	void
 * 
 * PARAMETERS:  int *	ix		x coord of ulh corner
 *		int *	iy		y coord of ulh corner
 *
 ***********************************************************************
*/

#include "x.h"
#include "std.h"
#include "common.h"

 /***************************** widpos *****************************/

 void widpos(int * ix, int * iy)
 {
 Position  ixr, iyr;

 XtTranslateCoords(iw_win, (Position) *ix, (Position) *iy, &ixr, &iyr);

 *ix = ixr;
 *iy = iyr;
 }
