/*$Header: /net/alwyn/usr1/web/src/RCS/wiline.c,v 1.4 94/09/12 15:54:44 leith Exp $*/
/*
C++*************************************************************************
C
C WILINE                        
C        CONVERTED TO C -- SEPT 92
C **************************************************************************
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C WILINE(IWIN,ICONTX,IXS,IYS,IXE,IYE,INTEN,IPEN,LINTP)
C
C CALLED BY:   
C
C***********************************************************************
*/

#include "common.h"
#include "routines.h"

 /**********************  wiline  ********************************/

 void wiline(Drawable win, GC icontxt, int ixs, int iys,
             int ixe, int iye, int inten, int ipen, int linetype)
 {
 int ici;
 int iwide;

 /*  FUTURE set line width, even number line types are single thickness */


 /****************
  iwide = linetype % 2;
  XSetLineAttributes(idispl,icontx,iwide,LineSolid,CapButt,JoinMiter);
 ***************/

 if (inten >= 0)
    {
    /* set color for line */
    if (ipen < 0) 
       ici = -ipen;
    else
       ici = colorgo + ipen * 10 + inten;

    wicolor(icontxt,ici);
    }
   
 /* draw line on screen */
 XDrawLine(idispl,win,icontxt,ixs,iys,ixe,iye);

 /* draw line on backing store */
 XDrawLine(idispl,imagsav,icontxt,ixs,iys,ixe,iye);

 }
