/*$Header: /net/alwyn/usr1/web/src/RCS/wilines.c,v 1.2 94/09/12 14:22:49 leith Exp $*/
/*
C++*********************************************************************
C
C wilines
C
C **********************************************************************
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND          *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C WILINE
C
C CALLED BY:   cntplot
C
C***********************************************************************
*/

#include "common.h"
#include "routines.h"

 
 /**********************  wilines  ********************************/

 int wilines(GC icontxt, XPoint * points, int npoints,
              int inten, int ipen, int linetype)
 {
 int      ici;
 unsigned int      iwide;

 /* FUTURE set line width, even number line types are single thickness */

 /****************/ 
 iwide = linetype % 2;
 XSetLineAttributes(idispl,icontxt,iwide,LineSolid,CapButt,JoinMiter);
 /***************/

 if (inten >= 0)
    {
    /* set color for line */
    if (ipen < 0) 
       ici = -ipen;
    else
       ici = colorgo + ipen * 10 + inten;

    wicolor(icontxt,ici);
    }

   
 /* draw line on screen */
 XDrawLines(idispl,iwin,icontxt,points,npoints,CoordModeOrigin);

 /* draw line on backing store */
 XDrawLines(idispl,imagsav,icontxt,points,npoints,CoordModeOrigin);

 return TRUE;
 }
