
/*$Header: /net/alwyn/usr1/web/src/RCS/winsel.c,v 1.6 94/10/05 13:28:08 leith Exp $*/
/*

C++*************************************************************************
C
C  WID_WINSEL.FOR -- CREATED MAY 91 al
C                    CONVERTED TO C -- SEPT 92 al 
C **************************************************************************
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C WID_WINSEL
C
C PURPOSE:       SELECTS WINDOWED OPERATIONS 
C
C PARAMETERS:    
C
C CALLED BY:     
C
C--*********************************************************************
*/

#include "common.h"
#include "routines.h"

 /* global variables */
 extern int iwintyp;


 /****************************  winsel  *******************************/

 void winsel(void)
 {
 if (ioper > 9) ioper = ioper / 10;

 if       (ioper == 4) 
   {     /* window from a source file */
   winfile();
   }

 else if  (ioper == 5) 
   {     /* draw box(s) */
   winbox(iwintyp);
   }

 else if (ioper == 6) 
   {     /* record area command */
   winread();
   }

 else if (ioper == 7) 
   {     /* move area command */
   movearea();
   }

 else if (ioper == 8) 
   {     /* power spectrum command */
   powermen();
   }
 }
