
/*$Header: /alwyn/usr1/web//RCS/wrtvol.c,v 1.2 93/12/30 15:37:51 leith Exp $*/

/*
C**************************************************************************
C
C   WRTVOL.C  -- CREATED NOV 13 1993
C             
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND RESEARCH     *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C  WRTVOL(filedata,  float * data)
C           
C
C  PURPOSE:     WRITES SPIDER IMAGE INTO 8 / OR 32 BIT ARRAY .
C
C  PARAMETERS:  filedata           image file structure pointer
C               data               floating point data
C
C  RETURNS:     TRUE OR FALSE 
C
C--*********************************************************************
*/

#include "files.h"

 /* external function prototypes */
 extern int   wrtlin    (FILEDATA *, float *, int, int);


 /*************************   wrtvol   ****************************/

 int wrtvol(FILEDATA *filedata,  float * fptr)

 {
 int       nsam, iloc, irec;
 
 nsam  = filedata -> nsam;

 iloc  = 0;

 for (irec = 1; irec <= (filedata -> nslice) * (filedata -> nrow);irec++)
    {
    if (!wrtlin(filedata, &fptr[iloc], nsam, irec)) return FALSE;
    iloc += nsam;
    }

 return TRUE;
 }




